SystemOrganization addCategory: #Exupery!
SystemOrganization addCategory: #'Exupery-Intermediate'!
SystemOrganization addCategory: #'Exupery-Plugin'!
SystemOrganization addCategory: #'Exupery-Customer Tests'!
SystemOrganization addCategory: #'Exupery-Programmer Tests'!
SystemOrganization addCategory: #'Exupery-Inspectors'!

TestCase subclass: #TestExuperyPlugin
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Customer Tests'!

!TestExuperyPlugin methodsFor: 'Test - Common Sends' stamp: 'wbk 2/14/2004 15:06'!
testNew
	self compileCode: ' OrderedCollection new'.
	self assert: self example class = OrderedCollection.! !

!TestExuperyPlugin methodsFor: 'Example Methods' stamp: 'wbk 11/23/2003 23:37'!
sendAt: anInteger Put: anObject to: anArray
	^ anArray 
		at: anInteger
		put: anObject.! !

!TestExuperyPlugin methodsFor: 'Test - Return Bytecodes' stamp: 'wbk 4/20/2003 17:06'!
returnSelf
	|answer|
	answer := self.
	^ answer! !

!TestExuperyPlugin methodsFor: 'Test - Bitwise Operators' stamp: 'wbk 2/9/2004 22:26'!
testBitShiftNegative3
	self compileCode: '2 bitShift: -512'.
	self assert: self example = 0.! !

!TestExuperyPlugin methodsFor: 'Test - Common Sends' stamp: 'wbk 3/20/2004 14:54'!
testAtEnd
	self compileCode: '(ReadStream on: #()) atEnd'.
	self assert: self example = true! !

!TestExuperyPlugin methodsFor: 'Test - Arithmatic' stamp: 'wbk 2/7/2004 19:54'!
testMod3
	self compileCode: '-10 \\ 4'.
	self should: [self example = 2]! !

!TestExuperyPlugin methodsFor: 'Example Methods' stamp: 'wbk 7/11/2003 11:25'!
pushConstantZero
	" The shuffle through a temporary is so we actually use the push constant zero bytecode
	rather than the fast return 0 primitive"
	|a|
	a := 0.
	^ a! !

!TestExuperyPlugin methodsFor: 'Test - Bitwise Operators' stamp: 'wbk 2/2/2004 21:47'!
testAnd3
	self compileCode: ' 5 bitAnd: 3'.
	self assert: self example = 1! !

!TestExuperyPlugin methodsFor: 'Test - Bitwise Operators' stamp: 'wbk 2/4/2004 23:43'!
testOr
	self compileCode: ' 1 bitOr: 2'.
	self assert: self example = 3! !

!TestExuperyPlugin methodsFor: 'Example Methods' stamp: 'wbk 4/11/2003 18:12'!
iterativeFactorial
	|acc n|
	n := 3.
	acc := 1.
	1
		to: n
		do: [:each| acc := acc * each].
	^ acc! !

!TestExuperyPlugin methodsFor: 'Test - Comparision' stamp: 'wbk 1/14/2004 22:18'!
testNotEqualsSendingEqual
	self compileCode: '5.0 ~= 5.0'.
	self should: [self example = false]! !

!TestExuperyPlugin methodsFor: 'Test - Multiple Methods' stamp: 'wbk 4/18/2004 22:19'!
testTwoReturns
	Exupery
		compileMethod: #sendReturn4
		into: #sendReturn4Hook
		forClass: TestExuperyPlugin.
	Exupery
		compileMethod: #sendReturn6
		into: #sendReturn6Hook
		forClass: TestExuperyPlugin.
	self assert: self sendReturn4Hook = 14.
	self assert: self sendReturn6Hook = 16.! !

!TestExuperyPlugin methodsFor: 'Test - Bitwise Operators' stamp: 'wbk 2/8/2004 22:37'!
testBitShiftOverflows3
	"this makes sure that we handle overflows correctly. It's possible that the generic wrapper
	code will handle overflows by one bit. This overflows by a lot. As a 32 bit number, the
	result should be zero, so unless we resort to the primitive it will fail."
	self compileCode: '1024 bitShift: 30'.
	self assert: self example = 1099511627776.! !

!TestExuperyPlugin methodsFor: 'Test - Comparision' stamp: 'wbk 1/14/2004 22:16'!
testLessThanEqualArgumentNotInteger
	self compileCode: '5 <= 6.0'.
	self should: [self example = true]! !

!TestExuperyPlugin methodsFor: 'Test - Memory Management (GC)' stamp: 'wbk 11/24/2003 20:25'!
testAtPutBothYoung
	| newObject array |
	self 
		compile: #sendAt:Put:to:
		into: #sendAt:Put:to:.

	Smalltalk garbageCollect.
	newObject := 'A new string' copy.
	array := Array 
		with: 10
		with: 20
		with: 30.

	array
		at: 1
		put: 11. "Prime the atCache"
	self checkIsNotRootObject: array.
	self
		sendAt: 1
		Put: newObject
		to: array.

	self checkIsNotRootObject: array.
	self assert: array = #( 'A new string' 20 30)! !

!TestExuperyPlugin methodsFor: 'Example Methods' stamp: 'wbk 7/31/2003 16:12'!
sendAtPut: anArray
	^ anArray 
		at: 3
		put: 50.! !

!TestExuperyPlugin methodsFor: 'Test - Jumps' stamp: 'wbk 2/14/2004 13:19'!
longJumpIfTrueOnFalse
	false ifFalse:
		[^ 1+2.].
	^ 42! !

!TestExuperyPlugin methodsFor: 'Test - Common Sends' stamp: 'wbk 2/22/2004 14:09'!
testSize
	self compileCode: '#abcd size'.
	self assert: self example = 4.! !

!TestExuperyPlugin methodsFor: 'Extended Send' stamp: 'wbk 6/16/2004 22:21'!
method16
	^ 1! !

!TestExuperyPlugin methodsFor: 'Example Methods' stamp: 'wbk 10/4/2003 18:47'!
pushConstantMinusOne
	"The variable a is used to avoid a quick return method. This way we use the desired bytecode
	rather than the short-cut primitive"
	| a |
	a := -1.
	^ a! !

!TestExuperyPlugin methodsFor: 'Test - Bitwise Operators' stamp: 'wbk 2/9/2004 22:31'!
testBitShift5
	"Test a shift of more than one byte. To check some Intel instruction set weirdness"
	self compileCode: '5 bitShift: 32'.
	self assert: self example = 21474836480.! !

!TestExuperyPlugin methodsFor: 'Test - Common Sends' stamp: 'wbk 2/28/2004 17:34'!
testPointX2
	self compileCode: '(15 @ 20) x'.
	self assert: self example = 15! !

!TestExuperyPlugin methodsFor: 'Test - Memory Management (GC)' stamp: 'wbk 8/11/2003 22:20'!
testSendAtPutDouble
	"Double because of the atCache, the first time primes the cache"
	| answer array |
	array := Array 
		with: 10 
		with: 20 
		with: 30.
	self 
		compile: #sendAtPut:
		into: #sendAtPut:.
	answer := self sendAtPut: array.
	answer := self sendAtPut: array.
	self assert: answer = #50.
	self assert: array = #(10 20 50).
	! !

!TestExuperyPlugin methodsFor: 'Test - Jumps' stamp: 'wbk 2/28/2004 16:11'!
shortUnconditionalJump
^ 20 = 20 ifFalse: [^ 15 + 20].! !

!TestExuperyPlugin methodsFor: 'Test - Comparision' stamp: 'wbk 1/14/2004 22:15'!
testGreaterThanWhenGreater
	self compileCode: '7 > 6'.
	self should: [self example = true]! !

!TestExuperyPlugin methodsFor: 'Test - Jumps' stamp: 'wbk 2/28/2004 15:12'!
testShortUnconditionalJump
	self 
		compile: #shortUnconditionalJump
		into: #shortUnconditionalJump.
	self assert: self shortUnconditionalJump = nil
! !

!TestExuperyPlugin methodsFor: 'Test - Stack' stamp: 'wbk 7/11/2003 11:24'!
testPushConstantZero
	self 
		compile: #pushConstantZero
		into: #pushConstantZero.
	self should: [self pushConstantZero = 0]! !

!TestExuperyPlugin methodsFor: 'Test - Comparision' stamp: 'wbk 1/14/2004 22:14'!
testGreaterThanEqualSendingLess
	self compileCode: '4.0 >= 5.0'.
	self should: [self example = false]! !

!TestExuperyPlugin methodsFor: 'Test - Multiple Methods' stamp: 'wbk 4/9/2004 15:58'!
return5
	^ 5! !

!TestExuperyPlugin methodsFor: 'Test - Multiple Methods' stamp: 'wbk 4/17/2004 21:20'!
sendReturn4
	^ self return4 + 10! !

!TestExuperyPlugin methodsFor: 'Example Methods' stamp: 'wbk 7/19/2003 22:31'!
sendPrimAt: anArray
	^ anArray at: 2! !

!TestExuperyPlugin methodsFor: 'Test - Sends' stamp: 'wbk 6/16/2004 22:39'!
testExtendedSend
	self 
		compile: #extendedSend
		into: #extendedSend.
	self assert: self extendedSend = 42! !

!TestExuperyPlugin methodsFor: 'Example Methods' stamp: 'wbk 7/6/2003 14:36'!
basicTarget
	^ 2 + 3! !

!TestExuperyPlugin methodsFor: 'Extended Send' stamp: 'wbk 6/16/2004 22:20'!
method9
	^ 1! !

!TestExuperyPlugin methodsFor: 'Test - Stack' stamp: 'wbk 7/15/2004 23:33'!
testPushReceiverLarge3
	"The push bytecode overflows at 8 rather than 16 as with pops. This tests
	the smallest compact bytecodes decoding"

	| variables |
	Exupery 
		compileMethod: #i8:
		class: ExuperyInstanceVariables.
	variables := ExuperyInstanceVariables new.
	variables i8: 42.
	self assert: variables i8 = 42! !

!TestExuperyPlugin methodsFor: 'Extended Send' stamp: 'wbk 6/16/2004 22:20'!
method10
	^ 1! !

!TestExuperyPlugin methodsFor: 'Test - Bitwise Operators' stamp: 'wbk 2/2/2004 21:45'!
testAnd2
	self compileCode: ' 3 bitAnd: 1'.
	self assert: self example = 1! !

!TestExuperyPlugin methodsFor: 'Test - Common Sends' stamp: 'wbk 2/28/2004 17:36'!
testPointY2
	self compileCode: '(10 @ 25) y'.
	self assert: self example = 25! !

!TestExuperyPlugin methodsFor: 'Test - Bitwise Operators' stamp: 'wbk 2/4/2004 23:43'!
testOr2
	self compileCode: ' 8 bitOr: 3'.
	self assert: self example = 11! !

!TestExuperyPlugin methodsFor: 'Test - Common Sends' stamp: 'wbk 7/19/2003 20:09'!
testBytecodePrimSendWithArg
	| answer |
	self 
		compile: #bytecodePrimSendWithArg
		into: #bytecodePrimSendWithArg.
	answer := self bytecodePrimSendWithArg.
	self should: [answer class = Array].
	self assert: answer size = 5.
	! !

!TestExuperyPlugin methodsFor: 'Test - Method Registering' stamp: 'wbk 4/18/2004 22:19'!
testRegisterFunction
	Exupery
		register: self pointerToReturn42
		method: (TestExuperyPlugin compiledMethodAt: #returnNumber).
	#returnNumber flushCache.
	self should: [self returnNumber = 41]! !

!TestExuperyPlugin methodsFor: 'Misc' stamp: 'wbk 4/18/2004 22:19'!
compile: sourceMethod into: targetMethod class: aClass
	| code bytes method |
	method := (aClass compiledMethodAt: sourceMethod).
	bytes := Exupery 
				compileMethod: method.
	code := Exupery loadCode: bytes.
	Exupery
		register: code
		method: (aClass compiledMethodAt: targetMethod).
	#returnNumber flushCache.! !

!TestExuperyPlugin methodsFor: 'Test - Real Methods' stamp: 'wbk 7/15/2004 23:33'!
testBenchmarkLarge
	Exupery 
		compileMethod: #benchmark
		class: Integer.
	self assert: 10 benchmark = 1028! !

!TestExuperyPlugin methodsFor: 'Test - Bitwise Operators' stamp: 'wbk 2/8/2004 16:44'!
testBitShiftReceiverLarge3
	self compileCode: '5000000001 bitShift: 4'.
	self assert: self example = 80000000016! !

!TestExuperyPlugin methodsFor: 'Test - Multiple Methods' stamp: 'wbk 4/14/2004 21:39'!
return9
	^ 9! !

!TestExuperyPlugin methodsFor: 'Test - Arithmatic' stamp: 'wbk 1/17/2004 22:36'!
testDivideReceiverNotInteger
	self compileCode: '6.0 / 2'.
	self should: [self example = 3.0]! !

!TestExuperyPlugin methodsFor: 'Test - Comparision' stamp: 'wbk 1/14/2004 22:16'!
testLessThanEqualSendingAndGreater
	self compileCode: '5 <= 4.0'.
	self should: [self example = false]! !

!TestExuperyPlugin methodsFor: 'Test - Memory Management (GC)' stamp: 'wbk 7/31/2003 16:13'!
testSendAtPut
	| answer array |
	array := Array 
		with: 10 
		with: 20 
		with: 30.
	self 
		compile: #sendAtPut:
		into: #sendAtPut:.
	answer := self sendAtPut: array.
	self assert: answer = #50.
	self assert: array = #(10 20 50).
	! !

!TestExuperyPlugin methodsFor: 'Extended Send' stamp: 'wbk 6/16/2004 22:20'!
method3
	^ 1! !

!TestExuperyPlugin methodsFor: 'Test - Sends' stamp: 'wbk 7/6/2003 14:29'!
basicSend
	^ self basicTarget + 1! !

!TestExuperyPlugin methodsFor: 'Test - Comparision' stamp: 'wbk 4/17/2003 10:41'!
testLessThanEqualsWhenLess
	self
		compile: #lessThanEqualsWhenLess
		into: #returnNumber.
	self should: [self returnNumber = true]! !

!TestExuperyPlugin methodsFor: 'Test - Comparision' stamp: 'wbk 1/14/2004 22:14'!
testGreaterThanEqualWhenGreater
	self compileCode: '6 >= 5'.
	self should: [self example = true]! !

!TestExuperyPlugin methodsFor: 'Test - Arithmatic' stamp: 'wbk 2/5/2004 21:50'!
testDivReceiverNotInteger
	self compileCode: '11000000001 // 2'.
	self should: [self example = 5500000000]! !

!TestExuperyPlugin methodsFor: 'Test - Memory Management (GC)' stamp: 'wbk 8/10/2003 18:05'!
testSendPrimAtDouble
	| answer array |
	"Tests that the cache works, the first call will prime the atCache and the second call
	should use the cache"
	array := Array 
		with: 10 
		with: 20 
		with: 30.
	self 
		compile: #sendPrimAt:
		into: #sendPrimAt:.
	answer := self sendPrimAt: array.
	self assert: answer = 20.
	answer := self sendPrimAt: array.
	self assert: answer = 20.
	! !

!TestExuperyPlugin methodsFor: 'Test - Common Sends' stamp: 'wbk 2/28/2004 17:52'!
testClass5
	self compileCode: '#aSymbol class'.
	self assert: self example = Symbol! !

!TestExuperyPlugin methodsFor: 'Test - Common Sends' stamp: 'wbk 2/9/2004 21:58'!
testMakePoint
	self compileCode: ' 7 @ 13'.
	self assert: self example = (7 @ 13).! !

!TestExuperyPlugin methodsFor: 'Example Methods' stamp: 'wbk 3/20/2004 14:55'!
testAtFirst
	| array answer |
	array := Array 
		with: 10 
		with: 20 
		with: 30.
	array
		at: 1. "Prime the atCache"
	self 
		compile: #sendAt:to:
		into: #sendAt:to:.
	answer := self 
		sendAt: 1
		to: array.
	self assert: answer = 10.
	self assert: array = #(10 20 30).
	! !

!TestExuperyPlugin methodsFor: 'Test - Bitwise Operators' stamp: 'wbk 2/8/2004 18:48'!
testBitShiftZero
	self compileCode: '5 bitShift: 0'.
	self assert: self example = 5.! !

!TestExuperyPlugin methodsFor: 'Test - Memory Management (GC)' stamp: 'wbk 11/22/2003 17:10'!
testBasicRememberSets
	| object newObject |
	object := ExuperyInstanceVariables new.
	self 
		compile: #a:b:
		into: #a:b:
		class: ExuperyInstanceVariables.

	Smalltalk garbageCollect.
	newObject := 'A new string' copy.

	object
		a: newObject
		b: 20.

	self checkIsRootObject: object.
	self assert: object getA = newObject.
	self assert: object getB = 20.! !

!TestExuperyPlugin methodsFor: 'Example Methods' stamp: 'wbk 10/4/2003 19:19'!
pushConstantTrue
	| a |
	a :=  true.
	^ a! !

!TestExuperyPlugin methodsFor: 'Test - Memory Management (GC)' stamp: 'wbk 10/4/2003 18:15'!
testStoreAndPopReceiverVariables
	| object |
	object := ExuperyInstanceVariables new.
	self 
		compile: #a:b:
		into: #a:b:
		class: ExuperyInstanceVariables.
	object
		a: 10
		b: 20.
	self assert: object a = 10.
	self assert: object b = 20.! !

!TestExuperyPlugin methodsFor: 'Misc' stamp: 'wbk 10/11/2003 22:31'!
compileCode: aString into: aSymbol 
	self class
		compile: aSymbol, ' ^ ', aString
		classified: 'Generated'.
	self
		compile: aSymbol
		into: aSymbol! !

!TestExuperyPlugin methodsFor: 'Misc' stamp: 'wbk 11/22/2003 17:49'!
checkIsNotRootObject: anExuperyInstanceVariables 
	self 
		should: [self checkIsRootObject: anExuperyInstanceVariables]
		raise: Error! !

!TestExuperyPlugin methodsFor: 'Primitive Support' stamp: 'wbk 4/18/2003 15:54'!
pointerToReturn42
	<primitive: 'pointerToReturn42' module: 'ExuperyPlugin'>
	TestFailure signal! !

!TestExuperyPlugin methodsFor: 'Test - Return Bytecodes' stamp: 'wbk 10/18/2003 12:27'!
returnNil
	'Forcing a returnNil bytecode rather than a quick return primitive'.
	^ nil! !

!TestExuperyPlugin methodsFor: 'Test - Stack' stamp: 'wbk 7/15/2004 23:33'!
testStoreTempExtended
	| variables |
	Exupery 
		compileMethod: #storeTempExtended
		class: ExuperyInstanceVariables.
	variables := ExuperyInstanceVariables new.
	self assert: variables storeTempExtended = 30! !

!TestExuperyPlugin methodsFor: 'Test - Sends' stamp: 'wbk 7/2/2003 15:52'!
sendWithTemporaries
	| a b |
	a := 4.
	b := 5.
	^ self basicTarget + 1 + a + b! !

!TestExuperyPlugin methodsFor: 'Test - Return Bytecodes' stamp: 'wbk 11/27/2003 19:52'!
testReturnFalse
	self 
		compile: #returnFalse
		into: #returnFalse.
	self assert: self returnFalse = false! !

!TestExuperyPlugin methodsFor: 'Test - Stack' stamp: 'wbk 7/15/2004 23:33'!
testExtendedTemporaries
	| variables |
	Exupery 
		compileMethod: #basicTemps
		class: ExuperyInstanceVariables.
	variables := ExuperyInstanceVariables new.
	self assert: variables basicTemps = 35! !

!TestExuperyPlugin methodsFor: 'Extended Send' stamp: 'wbk 6/16/2004 22:21'!
extendedSend
	self method1.
	self method2.
	self method3.
	self method4.
	self method5.
	self method6.
	self method7.
	self method8.
	self method9.
	self method10.
	self method11.
	self method12.
	self method13.
	self method14.
	self method15.
	self method16.
	^ self method17.! !

!TestExuperyPlugin methodsFor: 'Test - Method Registering' stamp: 'wbk 4/18/2004 22:20'!
testRegisterMachineCode
	" Load return42 as machine code"
	| code |
	code := Exupery
				loadCode: #(85 137 229 139 69 8 139 80 4 139 66 12 131 192 2 137 66 12 193 248 1 199 68 130 24 85 0 0 0 93 195) 
						asByteArray.
	Exupery 
		register: code
		method: (TestExuperyPlugin compiledMethodAt: #returnNumber).
	#returnNumber flushCache.
	self should: [self returnNumber = 42]! !

!TestExuperyPlugin methodsFor: 'Test - Arithmatic' stamp: 'wbk 3/20/2004 14:55'!
testSubtractReceiverNotInteger
	self compileCode: '5.0 - 2'.
	self should: [self example = 3.0]! !

!TestExuperyPlugin methodsFor: 'Test - Arithmatic' stamp: 'wbk 2/5/2004 21:50'!
testDivReceiverNotInteger2
	self compileCode: '-21000000001 // 2'.
	self should: [self example = -10500000001]! !

!TestExuperyPlugin methodsFor: 'Test - Arithmatic' stamp: 'wbk 2/2/2004 21:27'!
testDivideOverFlow
	| answer |
	self compileCode: 'SmallInteger minVal / -1'.
	answer := self example.
	self assert: answer = (SmallInteger minVal * -1).
	self assert: (answer isKindOf: LargePositiveInteger)! !

!TestExuperyPlugin methodsFor: 'Test - Memory Management (GC)' stamp: 'wbk 1/24/2004 15:34'!
testBasicRememberSetsBothYoung
	| object newObject |
	Smalltalk garbageCollect.
	object := ExuperyInstanceVariables new.
	self 
		compile: #a:b:
		into: #a:b:
		class: ExuperyInstanceVariables.

	newObject := 'A new string' copy.

	object
		a: newObject
		b: 20.

	self checkIsNotRootObject: object.
	self assert: object getA = newObject.
	self assert: object getB = 20.! !

!TestExuperyPlugin methodsFor: 'Test - Memory Management (GC)' stamp: 'wbk 11/24/2003 23:10'!
testAtBefore
	| array answer |
	array := Array 
		with: 10 
		with: 20 
		with: 30.
	array
		at: 1. "Prime the atCache"
	self 
		compile: #sendAt:to:
		into: #sendAt:to:.
	self
		should:
			[answer := self 
				sendAt: 0
				to: array]
		raise: Error.
	self assert: answer = nil.
	self assert: array = #(10 20 30).
	! !

!TestExuperyPlugin methodsFor: 'Test - Comparision' stamp: 'wbk 1/14/2004 22:14'!
testGreaterThanEqualWhenEquals
	self compileCode: '5 >= 5'.
	self should: [self example = true]! !

!TestExuperyPlugin methodsFor: 'Test - Common Sends' stamp: 'wbk 2/28/2004 16:57'!
testEquivilent2
	self compileCode: '10 == 20 '.
	self assert: self example = false! !

!TestExuperyPlugin methodsFor: 'Test - Common Sends' stamp: 'wbk 2/28/2004 17:54'!
testClass
	"There are three cases to concider. First, the class is an integer. Second, the class is
	a compact class. Third, the class has a full class header"
	
	self compileCode: '10 class'.
	self assert: self example = SmallInteger! !

!TestExuperyPlugin methodsFor: 'Example Methods' stamp: 'wbk 7/11/2003 22:34'!
pushLiteralVariable
	^ Array! !

!TestExuperyPlugin methodsFor: 'Test - Multiple Methods' stamp: 'wbk 4/17/2004 22:24'!
sendReturn4Hook
	^ self return4 + 20! !

!TestExuperyPlugin methodsFor: 'Extended Send' stamp: 'wbk 6/16/2004 22:21'!
method14
	^ 1! !

!TestExuperyPlugin methodsFor: 'Test - Common Sends' stamp: 'wbk 2/9/2004 23:02'!
testMakePointFloat
	self compileCode: ' 7.5 @ 13'.
	self assert: self example = (7.5 @ 13).! !

!TestExuperyPlugin methodsFor: 'Extended Send' stamp: 'wbk 6/16/2004 22:21'!
method17
	^ 42! !

!TestExuperyPlugin methodsFor: 'Test - Stack' stamp: 'wbk 7/31/2003 16:22'!
testPushFalse
	| answer |
	self 
		compile: #pushFalse
		into: #pushFalse.
	answer := self pushFalse.
	self assert: answer = false.
	! !

!TestExuperyPlugin methodsFor: 'Test - Memory Management (GC)' stamp: 'wbk 11/24/2003 23:10'!
testAtAfter
	| array answer |
	array := Array 
		with: 10 
		with: 20 
		with: 30.
	array
		at: 1. "Prime the atCache"
	self 
		compile: #sendAt:to:
		into: #sendAt:to:.
	self
		should:
			[answer := self 
				sendAt: 4
				to: array]
		raise: Error.
	self assert: answer = nil.
	self assert: array = #(10 20 30).
	! !

!TestExuperyPlugin methodsFor: 'Test - Assembling Methods' stamp: 'wbk 4/17/2003 10:38'!
testAssembledReturn43
	self 
		compile: #return43
		into: #returnNumber.
	self should: [self returnNumber = 43]! !

!TestExuperyPlugin methodsFor: 'Example Methods' stamp: 'wbk 4/7/2003 18:46'!
lessThanEqualsWhenLess
	^ 2 <= 3! !

!TestExuperyPlugin methodsFor: 'Test - Stack' stamp: 'wbk 6/11/2004 20:49'!
testRecursiveStackTracing
	self compileCode: 
		'false 
			ifTrue: [5] 
			ifFalse: [false 
				ifTrue: [10]
				ifFalse: [15]]'.
	self assert: self example = 15.! !

!TestExuperyPlugin methodsFor: 'Extended Send' stamp: 'wbk 6/16/2004 22:20'!
method7
	^ 1! !

!TestExuperyPlugin methodsFor: 'Test - Arithmatic' stamp: 'wbk 2/7/2004 23:50'!
testMod5
	self compileCode: '-30 \\ -7'.
	self should: [self example = -2]! !

!TestExuperyPlugin methodsFor: 'Test - Return Bytecodes' stamp: 'wbk 10/16/2003 22:23'!
returnSelfBytecode
	'Just making sure that we really generate a returnReceiver bytecode'.
	^ self! !

!TestExuperyPlugin methodsFor: 'Example Methods' stamp: 'wbk 7/30/2003 18:01'!
pushFalse
	| a |
	a := false.
	^ a! !

!TestExuperyPlugin methodsFor: 'Test - Comparision' stamp: 'wbk 1/14/2004 22:13'!
testEqualsWhenLess
	self compileCode: '4 = 5'.
	self should: [self example = false]! !

!TestExuperyPlugin methodsFor: 'Example Methods' stamp: 'wbk 8/15/2003 14:04'!
sendAtOutsideTheArray: anArray
	^ anArray at: 4! !

!TestExuperyPlugin methodsFor: 'Test - Multiple Methods' stamp: 'wbk 4/17/2004 21:21'!
sendReturn6
	^ self return6 + 10! !

!TestExuperyPlugin methodsFor: 'Test - Comparision' stamp: 'wbk 1/14/2004 22:18'!
testLessThanWhenGreater
	self compileCode: '4 < 3'.
	self should: [self example = false]! !

!TestExuperyPlugin methodsFor: 'Test - Jumps' stamp: 'wbk 2/13/2004 23:10'!
longJumpIfTrue
	true ifFalse:
		[^ 1+2.].
	^ 42! !

!TestExuperyPlugin methodsFor: 'Test - Comparision' stamp: 'wbk 1/14/2004 22:12'!
testEqualsSendingEqual
	self compileCode: '5.0 = 5.0'.
	self should: [self example = true]! !

!TestExuperyPlugin methodsFor: 'Test - Stack' stamp: 'wbk 7/31/2003 16:22'!
testPopStack
	self compile: #popStack into: #popStack.
	self assert: self popStack = 5! !

!TestExuperyPlugin methodsFor: 'Test - Arithmatic' stamp: 'wbk 1/17/2004 22:20'!
testSubtractArgumentNotInteger
	self compileCode: '5 - 4.0'.
	self should: [self example = 1.0]! !

!TestExuperyPlugin methodsFor: 'Test - Comparision' stamp: 'wbk 1/14/2004 22:13'!
testEqualsSendingGreater
	self compileCode: '6.0 = 5.0'.
	self should: [self example = false]! !

!TestExuperyPlugin methodsFor: 'Test - Arithmatic' stamp: 'wbk 1/17/2004 22:20'!
testMultiplicationReceiverNotInteger
	self compileCode: '2.0 * 5'.
	self should: [self example = 10.0]! !

!TestExuperyPlugin methodsFor: 'Test - Arithmatic' stamp: 'wbk 3/20/2004 14:51'!
testAdditionReceiverNotInteger
	self compileCode: '3.0 + 2'.
	self should: [self example = 5.0]! !

!TestExuperyPlugin methodsFor: 'Example Methods' stamp: 'wbk 4/11/2003 17:40'!
threeTimesFour
	^ 3 * 4! !

!TestExuperyPlugin methodsFor: 'Test - Stack' stamp: 'wbk 7/15/2004 23:33'!
testPopReceiverLarge
	| variables |
	Exupery 
		compileMethod: #i16
		class: ExuperyInstanceVariables.
	variables := ExuperyInstanceVariables new.
	variables i16: 42.
	self assert: variables i16 = 42! !

!TestExuperyPlugin methodsFor: 'Test - Comparision' stamp: 'wbk 4/17/2003 10:40'!
testLessThanEqualsWhenGreater
	self
		compile: #lessThanEqualsWhenGreater
		into: #returnNumber.
	self should: [self returnNumber = false]! !

!TestExuperyPlugin methodsFor: 'Misc' stamp: 'wbk 1/14/2004 22:11'!
compileCode: aString 
	self
		compileCode: aString
		into: #example! !

!TestExuperyPlugin methodsFor: 'Test - Stack' stamp: 'wbk 9/29/2003 21:04'!
testPushReceiverVariables2
	| object |
	object := ExuperyInstanceVariables new.
	self
		compile: #b
		into: #b
		class: ExuperyInstanceVariables.
	object
		a: 10
		b: 20.
	self assert: object b = 20.! !

!TestExuperyPlugin methodsFor: 'Test - Bitwise Operators' stamp: 'wbk 2/4/2004 23:44'!
testOrReceiverLarge
	self compileCode: ' 5000000000 bitOr: 3'.
	self assert: self example = 5000000003! !

!TestExuperyPlugin methodsFor: 'Test - Stack' stamp: 'wbk 5/31/2004 20:46'!
testStackTracing2
	self compileCode: 'false ifTrue: [5] ifFalse: [10]'.
	self assert: self example = 10.! !

!TestExuperyPlugin methodsFor: 'Extended Send' stamp: 'wbk 6/16/2004 22:20'!
method1
	^ 1! !

!TestExuperyPlugin methodsFor: 'Test - Common Sends' stamp: 'wbk 3/20/2004 14:54'!
testAtEnd2
	self compileCode: '(ReadStream on: #(1 2 3 4)) atEnd'.
	self assert: self example = false! !

!TestExuperyPlugin methodsFor: 'Test - Bitwise Operators' stamp: 'wbk 2/2/2004 21:48'!
testAndReceiverOverflow
	self compileCode: ' 50000000002 bitAnd: 3'.
	self assert: self example = 2! !

!TestExuperyPlugin methodsFor: 'Test - Memory Management (GC)' stamp: 'wbk 1/24/2004 15:35'!
testBasicRememberSetsFromYoungToOld
	| object newObject |
	self 
		compile: #a:b:
		into: #a:b:
		class: ExuperyInstanceVariables.

	newObject := 'A new string' copy.
	Smalltalk garbageCollect.
	object := ExuperyInstanceVariables new.

	object 
		a: newObject
		b: 20.

	self checkIsNotRootObject: object.
	self assert: object getA = newObject.
	self assert: object getB = 20! !

!TestExuperyPlugin methodsFor: 'Test - Arithmatic' stamp: 'wbk 5/16/2004 22:35'!
testDiv
	self compileCode: '7 // 2'.
	self should: [self example = 3]! !

!TestExuperyPlugin methodsFor: 'Test - Bitwise Operators' stamp: 'wbk 2/8/2004 22:12'!
testBitShift3
	self compileCode: '5 bitShift: 1'.
	self assert: self example = 10.! !

!TestExuperyPlugin methodsFor: 'Test - Bitwise Operators' stamp: 'wbk 2/8/2004 16:34'!
testBitShift2
	self compileCode: '5 bitShift: 3'.
	self assert: self example = 40.! !

!TestExuperyPlugin methodsFor: 'Test - Multiple Methods' stamp: 'wbk 4/9/2004 15:58'!
return6
	^ 6! !

!TestExuperyPlugin methodsFor: 'Test - Comparision' stamp: 'wbk 1/14/2004 22:13'!
testEqualsSendingLess
	self compileCode: '4.0 = 5.0'.
	self should: [self example = false]! !

!TestExuperyPlugin methodsFor: 'Test - Memory Management (GC)' stamp: 'wbk 3/20/2004 14:55'!
testAtLast
	| array answer |
	array := Array 
		with: 10 
		with: 20 
		with: 30.
	array
		at: 1. "Prime the atCache"
	self 
		compile: #sendAt:to:
		into: #sendAt:to:.
	answer := self 
		sendAt: 3
		to: array.
	self assert: answer = 30.
	self assert: array = #(10 20 30).
	! !

!TestExuperyPlugin methodsFor: 'Test - Return Bytecodes' stamp: 'wbk 4/17/2003 10:49'!
testReturnArgument
 	self
		compile: #returnArgument:
		into: #returnArgument:.
	self should: [(self returnArgument: 3) = 6].
	self should: [(self returnArgument: 4) = 8]! !

!TestExuperyPlugin methodsFor: 'Test - Comparision' stamp: 'wbk 1/14/2004 22:15'!
testGreaterThanWhenLess
	self compileCode: '5 > 6'.
	self should: [self example = false]! !

!TestExuperyPlugin methodsFor: 'Test - Comparision' stamp: 'wbk 1/14/2004 22:25'!
testNotEqualsSendingLess
	self compileCode: '4.0 ~= 5.0'.
	self should: [self example = true]! !

!TestExuperyPlugin methodsFor: 'Test - Sends' stamp: 'wbk 7/4/2003 12:56'!
sendWithArg1: arg1 arg2: arg2
	| a b |
	a := 4.
	b := 5.
	^ self basicTarget + 1 + a + b + arg1 + arg2! !

!TestExuperyPlugin methodsFor: 'Test - Multiple Methods' stamp: 'wbk 4/9/2004 15:58'!
return7
	^ 7! !

!TestExuperyPlugin methodsFor: 'Test - Common Sends' stamp: 'wbk 2/28/2004 17:34'!
testPointX
	self compileCode: '(10 @ 20) x'.
	self assert: self example = 10! !

!TestExuperyPlugin methodsFor: 'Example Methods' stamp: 'wbk 4/11/2003 16:29'!
lessThanEqualsWhenEquals
	^ 2 <= 2! !

!TestExuperyPlugin methodsFor: 'Test - Common Sends' stamp: 'wbk 2/28/2004 16:58'!
testEquivilent3
	self compileCode: '20 == 20 '.
	self assert: self example = true! !

!TestExuperyPlugin methodsFor: 'Test - Stack' stamp: 'wbk 7/15/2004 23:33'!
testPopReceiverLarge2
	| variables |
	Exupery 
		compileMethod: #i17
		class: ExuperyInstanceVariables.
	variables := ExuperyInstanceVariables new.
	variables i17: 42.
	self assert: variables i17 = 42! !

!TestExuperyPlugin methodsFor: 'Test - Common Sends' stamp: 'wbk 2/22/2004 19:39'!
testEquivilent
	self compileCode: '10 == 20 ifFalse: [^ #failed]'.
	self assert: self example = #failed! !

!TestExuperyPlugin methodsFor: 'Test - Comparision' stamp: 'wbk 1/14/2004 22:15'!
testGreaterThanSendingGreater
	self compileCode: '6.0 > 5.0'.
	self should: [self example = true]! !

!TestExuperyPlugin methodsFor: 'Test - Bitwise Operators' stamp: 'wbk 5/15/2004 22:51'!
testBitShift
	self compileCode: '5 bitShift: 2'.
	self assert: self example = 20.! !

!TestExuperyPlugin methodsFor: 'Test - Bitwise Operators' stamp: 'wbk 2/8/2004 19:01'!
testBitShiftNegativeNumber
	self compileCode: '-1 bitShift: -5'.
	self assert: self example = -1.! !

!TestExuperyPlugin methodsFor: 'Extended Send' stamp: 'wbk 6/16/2004 22:20'!
method11
	^ 1! !

!TestExuperyPlugin methodsFor: 'Test - Jumps' stamp: 'wbk 2/14/2004 13:40'!
testLongJumpIfTrueOnNonInteger
	self 
		compile: #longJumpIfTrueOnNonInteger
		into: #longJumpIfTrueOnNonInteger.
	self 
		should: [self longJumpIfTrueOnNonInteger]
		raise: ExuperyTestException
! !

!TestExuperyPlugin methodsFor: 'Test - Arithmatic' stamp: 'wbk 2/7/2004 19:58'!
testModReceiverNotInteger
	self compileCode: '-10000000001 \\ 4'.
	self should: [self example = 3]! !

!TestExuperyPlugin methodsFor: 'Test - Memory Management (GC)' stamp: 'wbk 11/23/2003 21:40'!
testBasicRememberSetsBothOld
	| object newObject |
	object := ExuperyInstanceVariables new.
	self 
		compile: #a:b:
		into: #a:b:
		class: ExuperyInstanceVariables.

	newObject := 'A new string' copy.
	Smalltalk garbageCollect.

	object
		a: newObject
		b: 20.

	self checkIsNotRootObject: object.
	self assert: object getA = newObject.
	self assert: object getB = 20.! !

!TestExuperyPlugin methodsFor: 'Test - Comparision' stamp: 'wbk 1/14/2004 22:14'!
testGreaterThanSendingEquals
	self compileCode: '5.0 > 5.0'.
	self should: [self example = false]! !

!TestExuperyPlugin methodsFor: 'Test - Arithmatic' stamp: 'wbk 2/7/2004 19:54'!
testMod2
	self compileCode: '10 \\ 4'.
	self should: [self example = 2]! !

!TestExuperyPlugin methodsFor: 'Example Methods' stamp: 'wbk 10/4/2003 19:19'!
pushConstantNil
	| a |
	a :=  nil.
	^ a! !

!TestExuperyPlugin methodsFor: 'Test - Comparision' stamp: 'wbk 1/14/2004 22:14'!
testGreaterThanEqualWhenLess
	self compileCode: '4 >= 5'.
	self should: [self example = false]! !

!TestExuperyPlugin methodsFor: 'Test - Comparision' stamp: 'wbk 1/14/2004 22:19'!
testNotEqualsWhenGreater
	self compileCode: '6 ~= 5'.
	self should: [self example = true]! !

!TestExuperyPlugin methodsFor: 'Test - Comparision' stamp: 'wbk 1/14/2004 22:19'!
testNotEqualsSendingGreater
	self compileCode: '6.0 ~= 5.0'.
	self should: [self example = true]! !

!TestExuperyPlugin methodsFor: 'Test - Common Sends' stamp: 'wbk 2/22/2004 14:58'!
testNext
	self compileCode: '(Month month: 2 year: 2000) next'.
	self assert: self example asString = 'March 2000'.! !

!TestExuperyPlugin methodsFor: 'Test - Return Bytecodes' stamp: 'wbk 4/7/2003 16:12'!
returnString
	^ 'Hello World'! !

!TestExuperyPlugin methodsFor: 'Test - Arithmatic' stamp: 'wbk 10/11/2003 17:20'!
testAdditionOverflow
	self 
		compile: #additionOverflow
		into: #additionOverflow.
	self should: [self additionOverflow = 2000000000]! !

!TestExuperyPlugin methodsFor: 'Test - Memory Management (GC)' stamp: 'wbk 11/24/2003 00:06'!
testAtPutFromOldToYoung
	| newObject array |
	self 
		compile: #sendAt:Put:to:
		into: #sendAt:Put:to:.

	array := Array 
		with: 10
		with: 20
		with: 30.
	Smalltalk garbageCollect.
	newObject := 'A new string' copy.

	array
		at: 1
		put: 11. "Prime the atCache"
	self checkIsNotRootObject: array.
	self
		sendAt: 1
		Put: newObject
		to: array.

	self checkIsRootObject: array.
	self assert: array = #( 'A new string' 20 30)! !

!TestExuperyPlugin methodsFor: 'Test - Bitwise Operators' stamp: 'wbk 2/8/2004 16:43'!
testBitShiftReceiverLarge2
	self compileCode: '5000000001 bitShift: 2'.
	self assert: self example = 20000000004! !

!TestExuperyPlugin methodsFor: 'Extended Send' stamp: 'wbk 6/16/2004 22:20'!
method4
	^ 1! !

!TestExuperyPlugin methodsFor: 'Example Methods' stamp: 'wbk 11/24/2003 23:09'!
sendAt: anInteger to: anArray
	^ anArray 
		at: anInteger.! !

!TestExuperyPlugin methodsFor: 'Test - Comparision' stamp: 'wbk 1/14/2004 22:13'!
testEqualsWhenEquals
	self compileCode: '6 = 6'.
	self should: [self example = true]! !

!TestExuperyPlugin methodsFor: 'Test - Comparision' stamp: 'wbk 1/14/2004 22:15'!
testGreaterThanWhenEquals
	self compileCode: '5 > 5'.
	self should: [self example = false]! !

!TestExuperyPlugin methodsFor: 'Test - Return Bytecodes' stamp: 'wbk 10/16/2003 22:13'!
testReturnSelf
	self 
		compile: #returnSelf
		into: #returnSelf.
	self assert: self returnSelf = self! !

!TestExuperyPlugin methodsFor: 'Example Methods' stamp: 'wbk 12/28/2002 17:05'!
returnNumber
	"This method will be overridden by a compiled method that returns 42"
	^ 5! !

!TestExuperyPlugin methodsFor: 'Test - Comparision' stamp: 'wbk 1/14/2004 22:18'!
testLessThanSendingGreater
	self compileCode: '4 < 3.0'.
	self should: [self example = false]! !

!TestExuperyPlugin methodsFor: 'Test - Stack' stamp: 'wbk 7/15/2004 23:33'!
testPushReceiverLarge2
	| variables |
	Exupery 
		compileMethod: #i17:
		class: ExuperyInstanceVariables.
	variables := ExuperyInstanceVariables new.
	variables i17: 42.
	self assert: variables i17 = 42! !

!TestExuperyPlugin methodsFor: 'Test - Real Methods' stamp: 'wbk 7/15/2004 23:33'!
testBenchFib
	Exupery 
		compileMethod: #benchFib
		class: Integer.
	self assert: 1 benchFib = 1.
	self assert: 2 benchFib = 3.
	self assert: 3 benchFib = 5! !

!TestExuperyPlugin methodsFor: 'Test - Real Methods' stamp: 'wbk 7/15/2004 23:33'!
testBenchmark
	Exupery 
		compileMethod: #benchmark
		class: Integer.
	self assert: 0 benchmark = nil.
	self assert: 1 benchmark = 1028.
	self assert: 3 benchmark = 1028! !

!TestExuperyPlugin methodsFor: 'Test - Memory Management (GC)' stamp: 'wbk 11/24/2003 22:50'!
testAtPutAfter
	| array |
	array := Array 
		with: 10 
		with: 20 
		with: 30.
	array
		at: 1
		put: 11. "Prime the atCache"
	self 
		compile: #sendAt:Put:to:
		into: #sendAt:Put:to:.
	self
		should:
			[self 
				sendAt: 4
				Put: 50
				to: array]
		raise: Error.
	self assert: array = #(11 20 30).
	! !

!TestExuperyPlugin methodsFor: 'Test - Memory Management (GC)' stamp: 'wbk 8/11/2003 22:21'!
testSendPrimAt
	| answer array |
	array := Array 
		with: 10 
		with: 20 
		with: 30.
	self 
		compile: #sendPrimAt:
		into: #sendPrimAt:.
	answer := self sendPrimAt: array.
	self should: [answer = 20].
	! !

!TestExuperyPlugin methodsFor: 'Test - Sends' stamp: 'wbk 7/15/2003 22:38'!
testBasicSend2
	self 
		compile: #sendStringConcatenate
		into: #sendStringConcatenate.
	self assert: self sendStringConcatenate = 'abcdef'! !

!TestExuperyPlugin methodsFor: 'Test - Multiple Methods' stamp: 'wbk 4/18/2004 22:19'!
testMultipleMethods
	Exupery
		compileMethod: #return4
		into: #return5
		forClass: TestExuperyPlugin.
	Exupery
		compileMethod: #return6
		into: #return7
		forClass: TestExuperyPlugin.
	Exupery
		compileMethod: #return8
		into: #return9
		forClass: TestExuperyPlugin.
	self assert: self return5 = 4.
	self assert: self return7 = 6.
	self assert: self return9 = 8.! !

!TestExuperyPlugin methodsFor: 'Test - Sends' stamp: 'wbk 4/12/2004 15:32'!
testSendWithArguments
	" Checks that rematerialising the stack doesn't trash arguments and temporaries. Temporaries
	  occur just before the stack in the frame."
	self 
		compile: #sendWithArg1:arg2:
		into: #sendWithArg1:arg2:.
	self assert: (self 
		sendWithArg1: 100
		arg2: 200) = 315! !

!TestExuperyPlugin methodsFor: 'Test - Real Methods' stamp: 'wbk 7/15/2004 23:33'!
testBenchFibLarge
	"A large number of calls to compiled methods used to blow the C stack.
	The problem was caused by some recursion used to handle re-entering compiled
	code from compiled code. This will also occur if a lot of primitives are called from
	a compiled method."

	Exupery 
		compileMethod: #benchFib
		class: Integer.
	self assert: 30 benchFib = 2692537! !

!TestExuperyPlugin methodsFor: 'Example Methods' stamp: 'wbk 3/30/2003 21:09'!
threePlusFour
	^ 3 + 4! !

!TestExuperyPlugin methodsFor: 'Test - Arithmatic' stamp: 'wbk 2/7/2004 20:00'!
testModArgumentNotInteger
	self compileCode: '1000 \\ 5000000000'.
	self should: [self example = 1000]! !

!TestExuperyPlugin methodsFor: 'Test - Bitwise Operators' stamp: 'wbk 2/8/2004 16:35'!
testBitShiftNegative2
	self compileCode: '100 bitShift: -1'.
	self assert: self example = 50.! !

!TestExuperyPlugin methodsFor: 'Test - Method Registering' stamp: 'wbk 7/17/2004 18:43'!
testLoadOverflow
	self
		should: 
			[[true] whileTrue: [Exupery loadCode: (ByteArray new: 10000)]]
		raise: Exception.
	! !

!TestExuperyPlugin methodsFor: 'Test - Return Bytecodes' stamp: 'wbk 11/27/2003 19:52'!
returnFalse
	'Forcing a returnNil bytecode rather than a quick return primitive'.
	^ false! !

!TestExuperyPlugin methodsFor: 'Test - Arithmatic' stamp: 'wbk 4/17/2003 10:50'!
testThreeTimesFour
	self 
		compile: #threeTimesFour
		into: #returnNumber.
	self should: [self returnNumber = 12]! !

!TestExuperyPlugin methodsFor: 'Test - Arithmatic' stamp: 'wbk 1/17/2004 22:26'!
testDivideCreatingFraction
	self compileCode: '5 / 2'.
	self should: [self example = (5/2)]! !

!TestExuperyPlugin methodsFor: 'Test - Multiple Methods' stamp: 'wbk 4/18/2004 22:19'!
testTwoMethods
	Exupery
		compileMethod: #return4
		into: #return5
		forClass: TestExuperyPlugin.
	Exupery
		compileMethod: #return6
		into: #return7
		forClass: TestExuperyPlugin.
	self assert: self return5 = 4.
	self assert: self return7 = 6.! !

!TestExuperyPlugin methodsFor: 'Misc' stamp: 'wbk 4/18/2004 22:20'!
setUp
	Exupery initialiseExupery! !

!TestExuperyPlugin methodsFor: 'Test - Common Sends' stamp: 'wbk 7/19/2003 16:26'!
bytecodePrimSendWithArg
	^ Array new: 5! !

!TestExuperyPlugin methodsFor: 'Test - Arithmatic' stamp: 'wbk 1/17/2004 22:26'!
testDivide
	self compileCode: '6 / 2'.
	self should: [self example = 3]! !

!TestExuperyPlugin methodsFor: 'Test - Comparision' stamp: 'wbk 1/14/2004 22:19'!
testNotEqualsWhenEquals
	self compileCode: '5 ~= 5'.
	self should: [self example = false]! !

!TestExuperyPlugin methodsFor: 'Test - Bitwise Operators' stamp: 'wbk 2/8/2004 19:01'!
testBitShiftNegativeNumber2
	self compileCode: '-1 bitShift: 1'.
	self assert: self example = -2.! !

!TestExuperyPlugin methodsFor: 'Test - Stack' stamp: 'wbk 7/31/2003 16:22'!
testPushLiteralVariable
	self 
		compile: #pushLiteralVariable
		into: #pushLiteralVariable.
	self assert: self pushLiteralVariable = Array
	! !

!TestExuperyPlugin methodsFor: 'Test - Jumps' stamp: 'wbk 2/14/2004 13:28'!
longJumpIfFalseOnNonInteger
	TestExuperyPlugin new
		ifTrue: [^ 1 + 2].
	^ 42! !

!TestExuperyPlugin methodsFor: 'Example Methods' stamp: 'wbk 4/11/2003 14:27'!
lessThanEqualsWhenGreater
	^ 3 <= 2! !

!TestExuperyPlugin methodsFor: 'Test - Common Sends' stamp: 'wbk 2/14/2004 15:06'!
testNew2
	self compileCode: ' Array new'.
	self assert: self example class = Array.! !

!TestExuperyPlugin methodsFor: 'Test - Stack' stamp: 'wbk 9/29/2003 21:04'!
testPushReceiverVariables
	| object |
	object := ExuperyInstanceVariables new.
	self 
		compile: #a
		into: #a
		class: ExuperyInstanceVariables.
	object
		a: 10
		b: 20.
	self assert: object a = 10.! !

!TestExuperyPlugin methodsFor: 'Test - Sends' stamp: 'wbk 7/14/2003 15:18'!
testBasicSend
	self 
		compile: #basicSend
		into: #basicSend.
	self assert: self basicSend = 6! !

!TestExuperyPlugin methodsFor: 'Test - Comparision' stamp: 'wbk 1/14/2004 22:13'!
testEqualsWhenGreater
	self compileCode: '6 = 5'.
	self should: [self example = false]! !

!TestExuperyPlugin methodsFor: 'Test - Comparision' stamp: 'wbk 1/14/2004 22:15'!
testGreaterThanSendingLess
	self compileCode: '4.0 > 5.0'.
	self should: [self example = false]! !

!TestExuperyPlugin methodsFor: 'Extended Send' stamp: 'wbk 6/16/2004 22:21'!
method15
	^ 1! !

!TestExuperyPlugin methodsFor: 'Test - Bitwise Operators' stamp: 'wbk 2/8/2004 16:35'!
testBitShiftNegative
	self compileCode: '100 bitShift: -3'.
	self assert: self example = 12.! !

!TestExuperyPlugin methodsFor: 'Test - Arithmatic' stamp: 'wbk 2/7/2004 19:53'!
testMod
	self compileCode: '7 \\ 2'.
	self should: [self example = 1]! !

!TestExuperyPlugin methodsFor: 'Test - Bitwise Operators' stamp: 'wbk 2/9/2004 22:47'!
testBitShift7
	"Test a shift of more than one byte. To check some Intel instruction set weirdness"
	self compileCode: '5 bitShift: 256'.
	self assert: self example class = LargePositiveInteger.! !

!TestExuperyPlugin methodsFor: 'Test - Comparision' stamp: 'wbk 1/14/2004 22:16'!
testLessThanEqualReceiverNotInteger
	self compileCode: '5.0 <= 6'.
	self should: [self example = true]! !

!TestExuperyPlugin methodsFor: 'Test - Jumps' stamp: 'wbk 2/15/2004 12:20'!
mustBeBoolean
	ExuperyTestException signal! !

!TestExuperyPlugin methodsFor: 'Test - Memory Management (GC)' stamp: 'wbk 11/24/2003 20:25'!
testAtPutFromYoungToOld
	| newObject array |
	self 
		compile: #sendAt:Put:to:
		into: #sendAt:Put:to:.

	newObject := 'A new string' copy.
	Smalltalk garbageCollect.
	array := Array 
		with: 10
		with: 20
		with: 30.

	array
		at: 1
		put: 11. "Prime the atCache"
	self checkIsNotRootObject: array.
	self
		sendAt: 1
		Put: newObject
		to: array.

	self checkIsNotRootObject: array.
	self assert: array = #( 'A new string' 20 30)! !

!TestExuperyPlugin methodsFor: 'Test - Arithmatic' stamp: 'wbk 2/5/2004 21:46'!
testDiv3
	self compileCode: '-11 // 2'.
	self should: [self example = -6]! !

!TestExuperyPlugin methodsFor: 'Test - Comparision' stamp: 'wbk 1/14/2004 22:13'!
testGreaterThanEqualSendingGreater
	self compileCode: '6.0 >= 5.0'.
	self should: [self example = true]! !

!TestExuperyPlugin methodsFor: 'Test - Sends' stamp: 'wbk 7/2/2003 11:03'!
sendStringConcatenate
	^ 'abc', 'def'! !

!TestExuperyPlugin methodsFor: 'Test - Bitwise Operators' stamp: 'wbk 2/9/2004 22:26'!
testBitShift4
	"Test a shift of more than one byte. To check some Intel instruction set weirdness"
	self compileCode: '5 bitShift: 512'.
	self assert: self example class = LargePositiveInteger.! !

!TestExuperyPlugin methodsFor: 'Test - Bitwise Operators' stamp: 'wbk 2/4/2004 23:45'!
testOrArgumentLarge
	self compileCode: ' 11 bitOr: 5000000000'.
	self assert: self example = 5000000011! !

!TestExuperyPlugin methodsFor: 'Test - Common Sends' stamp: 'wbk 2/22/2004 14:58'!
testNext2
	self compileCode: '(Month month: 6 year: 2000) next'.
	self assert: self example asString = 'July 2000'.! !

!TestExuperyPlugin methodsFor: 'Test - Return Bytecodes' stamp: 'wbk 10/18/2003 13:39'!
testReturnNil
	self 
		compile: #returnNil
		into: #returnNil.
	self assert: self returnNil = nil! !

!TestExuperyPlugin methodsFor: 'Test - Arithmatic' stamp: 'wbk 1/18/2004 18:39'!
testDivideNegativeNumber
	"The Intel x86 CPU uses two registers to represent the dividend. The top register
	needs to be the sign extended version of the bottom register. This means that clearing
	the top register (EDX) would work for positive numbers but not negative numbers. Thus
	we need to check negatives for division but not for other arithmatic operations"

	self compileCode: '-6 / 2'.
	self should: [self example = -3]! !

!TestExuperyPlugin methodsFor: 'Test - Real Methods' stamp: 'wbk 6/2/2004 22:29'!
testRegisterPressure
	self compileCode: '1 + (2 + (3 + (4 + (5 + (6 + (7 + 8))))))'.
		
	self assert: self example = 36! !

!TestExuperyPlugin methodsFor: 'Test - Stack' stamp: 'wbk 10/4/2003 21:44'!
testPushConstantNill
	self 
		compile: #pushConstantNil
		into: #pushConstantNil.
	self should: [self pushConstantNil = nil]! !

!TestExuperyPlugin methodsFor: 'Test - Arithmatic' stamp: 'wbk 1/17/2004 22:20'!
testSubtractOverflow
	self compileCode: '-1000000000 - 1000000000'.
	self should: [self example = -2000000000]! !

!TestExuperyPlugin methodsFor: 'Test - Comparision' stamp: 'wbk 1/14/2004 22:16'!
testLessThanEqualSendingAndEquals
	self compileCode: '5 <= 5.0'.
	self should: [self example = true]! !

!TestExuperyPlugin methodsFor: 'Extended Send' stamp: 'wbk 6/16/2004 22:20'!
method8
	^ 1! !

!TestExuperyPlugin methodsFor: 'Test - Return Bytecodes' stamp: 'wbk 4/11/2003 18:42'!
returnArgument: anInteger
	^ anInteger * 2! !

!TestExuperyPlugin methodsFor: 'Test - Jumps' stamp: 'wbk 2/13/2004 21:48'!
testLongJumpIfTrue
	self 
		compile: #longJumpIfTrue
		into: #longJumpIfTrue.
	self assert: self longJumpIfTrue = 42
! !

!TestExuperyPlugin methodsFor: 'Test - Comparision' stamp: 'wbk 4/17/2003 10:39'!
testLessThanEqualsWhenEquals
	self
		compile: #lessThanEqualsWhenEquals
		into: #returnNumber.
	self should: [self returnNumber = true]! !

!TestExuperyPlugin methodsFor: 'Test - Multiple Methods' stamp: 'wbk 4/9/2004 15:58'!
return4
	^ 4! !

!TestExuperyPlugin methodsFor: 'Test - Memory Management (GC)' stamp: 'wbk 8/15/2003 14:06'!
testSendAtOutsideTheArray
	| array |
	array := Array 
		with: 10 
		with: 20 
		with: 30.
	self 
		compile: #sendAtOutsideTheArray:
		into: #sendAtOutsideTheArray:.
	
	self 
		should: [self sendAtOutsideTheArray: array.]
		raise: Error
		description: 'Array out of bounds failing'.
	self 
		should: [self sendAtOutsideTheArray: array.]
		raise: Error
		description: 'Array out of bounds failing'.
	! !

!TestExuperyPlugin methodsFor: 'Test - Comparision' stamp: 'wbk 1/14/2004 22:18'!
testLessThanWhenEquals
	self compileCode: '5 < 5'.
	self should: [self example = false]! !

!TestExuperyPlugin methodsFor: 'Generated' stamp: 'wbk 8/2/2004 23:24'!
example ^ 5.0 - 2! !

!TestExuperyPlugin methodsFor: 'Test - Arithmatic' stamp: 'wbk 4/17/2003 10:50'!
testThreePlusFour
	self 
		compile: #threePlusFour
		into: #returnNumber.
	self should: [self returnNumber = 7]! !

!TestExuperyPlugin methodsFor: 'Misc' stamp: 'wbk 8/30/2003 20:25'!
compile: sourceMethod into: targetMethod
	self
		compile: sourceMethod
		into: targetMethod
		class: self class.! !

!TestExuperyPlugin methodsFor: 'Test - Arithmatic' stamp: 'wbk 2/7/2004 23:53'!
testMod6
	self compileCode: '30 \\ -7'.
	self should: [self example = -5]! !

!TestExuperyPlugin methodsFor: 'Test - Memory Management (GC)' stamp: 'wbk 11/24/2003 22:49'!
testAtPutBefore
	| array |
	array := Array 
		with: 10 
		with: 20 
		with: 30.
	array
		at: 1
		put: 11. "Prime the atCache"
	self 
		compile: #sendAt:Put:to:
		into: #sendAt:Put:to:.
	self
		should:
			[self 
				sendAt: 0
				Put: 50
				to: array]
		raise: Error.
	self assert: array = #(11 20 30).
	! !

!TestExuperyPlugin methodsFor: 'Test - Bitwise Operators' stamp: 'wbk 2/9/2004 22:44'!
testBitShift6
	"Test a shift of more than one byte. To check some Intel instruction set weirdness"
	self compileCode: '5 bitShift: 33'.
	self assert: self example = 42949672960.! !

!TestExuperyPlugin methodsFor: 'Test - Arithmatic' stamp: 'wbk 1/17/2004 22:23'!
testDivide2
	self compileCode: '6 / 3'.
	self should: [self example = 2]! !

!TestExuperyPlugin methodsFor: 'Test - Jumps' stamp: 'wbk 2/28/2004 16:12'!
shortUnconditionalJump2
^ 20 = 20 ifFalse: [^ #success]! !

!TestExuperyPlugin methodsFor: 'Test - Comparision' stamp: 'wbk 1/14/2004 22:18'!
testLessThanWhenLess
	self compileCode: '4 < 5'.
	self should: [self example = true]! !

!TestExuperyPlugin methodsFor: 'Test - Arithmatic' stamp: 'wbk 1/17/2004 22:36'!
testDivideArgumentNotInteger
	self compileCode: '6 / 2.0'.
	self should: [self example = 3.0]! !

!TestExuperyPlugin methodsFor: 'Test - Method Registering' stamp: 'wbk 7/15/2004 23:33'!
testRegisterFunctionTwice
	Exupery 
		compileMethod: #returnNumber
		class: TestExuperyPlugin.
	Exupery 
		compileMethod: #returnNumber
		class: TestExuperyPlugin.
	self should: [self returnNumber = 5]! !

!TestExuperyPlugin methodsFor: 'Test - Common Sends' stamp: 'wbk 2/22/2004 14:09'!
testSize2
	self compileCode: '''abcde'' size'.
	self assert: self example = 5.! !

!TestExuperyPlugin methodsFor: 'Test - Return Bytecodes' stamp: 'wbk 4/17/2003 10:49'!
testReturnString
	self
		compile: #returnString
		into: #returnString.
	self should: [self returnString = 'Hello World']! !

!TestExuperyPlugin methodsFor: 'Test - Bitwise Operators' stamp: 'wbk 2/2/2004 21:45'!
testAnd
	self compileCode: ' 3 bitAnd: 3'.
	self assert: self example = 3! !

!TestExuperyPlugin methodsFor: 'Test - Common Sends' stamp: 'wbk 2/28/2004 17:36'!
testPointY
	self compileCode: '(10 @ 20) y'.
	self assert: self example = 20! !

!TestExuperyPlugin methodsFor: 'Test - Arithmatic' stamp: 'wbk 1/17/2004 22:19'!
testMultiplicationOverflow
	self compileCode: '1000000000 * 2'.
	self should: [self example = 2000000000]! !

!TestExuperyPlugin methodsFor: 'Test - Comparision' stamp: 'wbk 1/14/2004 22:24'!
testLessThanEqualSendingAndLess
	self compileCode: '4 <= 5.0'.
	self should: [self example = true]! !

!TestExuperyPlugin methodsFor: 'Test - Return Bytecodes' stamp: 'wbk 10/16/2003 22:24'!
testReturnSelfBytecode
	self 
		compile: #returnSelfBytecode
		into: #returnSelfBytecode.
	self assert: self returnSelfBytecode = self! !

!TestExuperyPlugin methodsFor: 'Test - Multiple Methods' stamp: 'wbk 4/14/2004 21:39'!
return8
	^ 8! !

!TestExuperyPlugin methodsFor: 'Test - Comparision' stamp: 'wbk 1/14/2004 22:19'!
testNotEqualsWhenLess
	self compileCode: '4 ~= 5'.
	self should: [self example = true]! !

!TestExuperyPlugin methodsFor: 'Extended Send' stamp: 'wbk 6/16/2004 22:20'!
method2
	^ 1! !

!TestExuperyPlugin methodsFor: 'Test - Bitwise Operators' stamp: 'wbk 2/8/2004 16:42'!
testBitShiftReceiverLarge
	self compileCode: '5000000000 bitShift: 2'.
	self assert: self example = 20000000000! !

!TestExuperyPlugin methodsFor: 'Test - Jumps' stamp: 'wbk 2/15/2004 12:20'!
testLongJumpIfFalseOnNonInteger
	self 
		compile: #longJumpIfFalseOnNonInteger
		into: #longJumpIfFalseOnNonInteger.
	self 
		should: [self longJumpIfFalseOnNonInteger]
		raise: ExuperyTestException
! !

!TestExuperyPlugin methodsFor: 'Test - Bitwise Operators' stamp: 'wbk 2/8/2004 18:52'!
testBitShiftOverflows
	self compileCode: '1000000000 bitShift: 1'.
	self assert: self example = 2000000000.! !

!TestExuperyPlugin methodsFor: 'Test - Arithmatic' stamp: 'wbk 1/31/2004 18:10'!
testDivideNegativeNumber2
	"The Intel x86 CPU uses two registers to represent the dividend. The top register
	needs to be the sign extended version of the bottom register. This means that clearing
	the top register (EDX) would work for positive numbers but not negative numbers. Thus
	we need to check negatives for division but not for other arithmatic operations"

	self compileCode: '-6000 / 3000'.
	self should: [self example = -2]! !

!TestExuperyPlugin methodsFor: 'Test - Jumps' stamp: 'wbk 2/28/2004 15:12'!
testShortUnconditionalJump2
	self 
		compile: #shortUnconditionalJump2
		into: #shortUnconditionalJump2.
	self assert: self shortUnconditionalJump2 = nil
! !

!TestExuperyPlugin methodsFor: 'Test - Stack' stamp: 'wbk 7/15/2004 23:33'!
testStoreInstanceExtended
	| variables |
	Exupery 
		compileMethod: #storeInstanceExtended2
		class: ExuperyInstanceVariables.
	variables := ExuperyInstanceVariables new.
	self assert: variables storeInstanceExtended2 = 20! !

!TestExuperyPlugin methodsFor: 'Test - Arithmatic' stamp: 'wbk 1/17/2004 22:19'!
testMultiplicationArgumentNotInteger
	self compileCode: '2 * 3.0'.
	self should: [self example = 6.0]! !

!TestExuperyPlugin methodsFor: 'Test - Jumps' stamp: 'wbk 2/14/2004 13:20'!
testLongJumpIfTrueOnFalse
	self 
		compile: #longJumpIfTrueOnFalse
		into: #longJumpIfTrueOnFalse.
	self assert: self longJumpIfTrueOnFalse = 3
! !

!TestExuperyPlugin methodsFor: 'Test - Common Sends' stamp: 'wbk 2/22/2004 15:40'!
testNextPut
	self compileCode: '((WriteStream on: Array new) nextPut: #abcd) contents'.
	self assert: self example  = #(abcd).! !

!TestExuperyPlugin methodsFor: 'Test - Assembling Methods' stamp: 'wbk 4/17/2003 10:39'!
testIterativeFactorial
	self
		compile: #iterativeFactorial
		into: #returnNumber.
	self should: [self returnNumber = 6]! !

!TestExuperyPlugin methodsFor: 'Extended Send' stamp: 'wbk 6/16/2004 22:20'!
method12
	^ 1! !

!TestExuperyPlugin methodsFor: 'Test - Return Bytecodes' stamp: 'wbk 11/24/2003 23:14'!
testReturnTrue
	self 
		compile: #returnTrue
		into: #returnTrue.
	self assert: self returnTrue = true! !

!TestExuperyPlugin methodsFor: 'Test - Bitwise Operators' stamp: 'wbk 2/8/2004 20:07'!
testBitShiftOverflows2
	"this makes sure that we handle overflows correctly. It's possible that the generic wrapper
	code will handle overflows by one bit. This overflows by a lot. As a 32 bit number, the
	result should be zero, so unless we resort to the primitive it will fail."
	self compileCode: '1000000000 bitShift: 15'.
	self assert: self example = 32768000000000.! !

!TestExuperyPlugin methodsFor: 'Test - Stack' stamp: 'wbk 7/19/2003 20:54'!
testPushConstantTrue
	| answer |
	self 
		compile: #pushConstantTrue
		into: #pushConstantTrue.
	answer := self pushConstantTrue.
	self should: [answer = true].
	! !

!TestExuperyPlugin methodsFor: 'Test - Arithmatic' stamp: 'wbk 2/5/2004 21:49'!
testDivArgumentNotInteger
	self compileCode: '2001 // 7000000000'.
	self should: [self example = 0]! !

!TestExuperyPlugin methodsFor: 'Test - Arithmatic' stamp: 'wbk 2/7/2004 21:51'!
testMod4
	self compileCode: '-30 \\ 7'.
	self should: [self example = 5]! !

!TestExuperyPlugin methodsFor: 'Test - Arithmatic' stamp: 'wbk 2/5/2004 21:45'!
testDiv2
	self compileCode: '11 // 2'.
	self should: [self example = 5]! !

!TestExuperyPlugin methodsFor: 'Test - Stack' stamp: 'wbk 10/4/2003 18:45'!
testPushConstantMinusOne
	self 
		compile: #pushConstantMinusOne
		into: #pushConstantMinusOne.
	self should: [self pushConstantMinusOne = -1]! !

!TestExuperyPlugin methodsFor: 'Example Methods' stamp: 'wbk 3/30/2003 21:09'!
return43
	^ 43! !

!TestExuperyPlugin methodsFor: 'Test - Arithmatic' stamp: 'wbk 3/6/2004 21:17'!
testAdditionArgumentNotInteger
	self compileCode: '3 + 4.0'.
	self should: [self example = 7.0]! !

!TestExuperyPlugin methodsFor: 'Test - Common Sends' stamp: 'wbk 3/3/2004 22:30'!
testClass2
	| answer |
	self compileCode: 'Array new class'.
	answer := self example.
	self assert: answer = Array! !

!TestExuperyPlugin methodsFor: 'Extended Send' stamp: 'wbk 6/16/2004 22:20'!
method13
	^ 1! !

!TestExuperyPlugin methodsFor: 'Test - Bitwise Operators' stamp: 'wbk 2/2/2004 21:51'!
testAndArgumentOverflow
	self compileCode: ' 5 bitAnd: 50000000006'.
	self assert: self example = 4! !

!TestExuperyPlugin methodsFor: 'Test - Common Sends' stamp: 'wbk 2/28/2004 17:47'!
testClass3
	self compileCode: 'Set new class'.
	self assert: self example = Set! !

!TestExuperyPlugin methodsFor: 'Misc' stamp: 'wbk 11/12/2003 21:36'!
checkIsRootObject: anExuperyInstanceVariables 
	<primitive: 'checkIsRootObject' module: 'ExuperyPlugin'>
	Error signal.
! !

!TestExuperyPlugin methodsFor: 'Test - Comparision' stamp: 'wbk 1/14/2004 22:13'!
testGreaterThanEqualSendingEqual
	self compileCode: '5.0 >= 5.0'.
	self should: [self example = true]! !

!TestExuperyPlugin methodsFor: 'Test - Jumps' stamp: 'wbk 2/14/2004 13:27'!
longJumpIfTrueOnNonInteger
	TestExuperyPlugin new
		ifFalse: [^ 1 + 2].
	^ 42! !

!TestExuperyPlugin methodsFor: 'Test - Arithmatic' stamp: 'wbk 1/31/2004 18:42'!
testDivideByZero
	self compileCode: '6 / 0'.
	self 
		should: [self example]
		raise: ZeroDivide! !

!TestExuperyPlugin methodsFor: 'Test - Comparision' stamp: 'wbk 1/14/2004 22:18'!
testLessThanSendingEquals
	self compileCode: '5.0 < 5.0'.
	self should: [self example = false]! !

!TestExuperyPlugin methodsFor: 'Extended Send' stamp: 'wbk 6/16/2004 22:20'!
method5
	^ 1! !

!TestExuperyPlugin methodsFor: 'Test - Stack' stamp: 'wbk 7/15/2004 23:33'!
testPushReceiverLarge
	| variables |
	Exupery 
		compileMethod: #i16:
		class: ExuperyInstanceVariables.
	variables := ExuperyInstanceVariables new.
	variables i16: 42.
	self assert: variables i16 = 42! !

!TestExuperyPlugin methodsFor: 'Test - Memory Management (GC)' stamp: 'wbk 11/24/2003 20:25'!
testAtPutBothOld
	| newObject array |
	self 
		compile: #sendAt:Put:to:
		into: #sendAt:Put:to:.

	newObject := 'A new string' copy.
	array := Array 
		with: 10
		with: 20
		with: 30.
	Smalltalk garbageCollect.

	array
		at: 1
		put: 11. "Prime the atCache"
	self checkIsNotRootObject: array.
	self
		sendAt: 1
		Put: newObject
		to: array.

	self checkIsNotRootObject: array.
	self assert: array = #( 'A new string' 20 30)! !

!TestExuperyPlugin methodsFor: 'Test - Sends' stamp: 'wbk 7/7/2003 13:02'!
testSendWithTemporaries
	" Checks that rematerialising the stack doesn't trash temporaries. Temporaries
	  occur just before the stack in the frame."
	self 
		compile: #sendWithTemporaries
		into: #sendWithTemporaries.
	self assert: self sendWithTemporaries = 15! !

!TestExuperyPlugin methodsFor: 'Example Methods' stamp: 'wbk 10/11/2003 17:19'!
additionOverflow
	^ 1000000000 + 1000000000! !

!TestExuperyPlugin methodsFor: 'Test - Memory Management (GC)' stamp: 'wbk 11/24/2003 22:48'!
testAtPutFirst
	| answer array |
	array := Array 
		with: 10 
		with: 20 
		with: 30.
	self 
		compile: #sendAt:Put:to:
		into: #sendAt:Put:to:.
	array
		at: 1
		put: 11. "Prime the atCache"
	answer := self 
		sendAt: 1
		Put: 50
		to: array.
	self assert: answer = #50.
	self assert: array = #(50 20 30).
	! !

!TestExuperyPlugin methodsFor: 'Test - Common Sends' stamp: 'wbk 2/28/2004 17:49'!
testClass4
	self compileCode: 'TestExuperyPlugin new class'.
	self assert: self example = TestExuperyPlugin! !

!TestExuperyPlugin methodsFor: 'Test - Return Bytecodes' stamp: 'wbk 11/24/2003 23:18'!
returnTrue
	'Forcing a returnNil bytecode rather than a quick return primitive'.
	^ true! !

!TestExuperyPlugin methodsFor: 'Test - Stack' stamp: 'wbk 5/31/2004 20:45'!
testStackTracing
	"The origional stack tracing code did not handle tracing the stack across jumps. These
	tests cover the stack being non empty across jumps."
	self compileCode: 'true ifTrue: [5] ifFalse: [10]'.
	self assert: self example = 5.! !

!TestExuperyPlugin methodsFor: 'Test - Multiple Methods' stamp: 'wbk 4/17/2004 22:25'!
sendReturn6Hook
	^ self return6 + 20! !

!TestExuperyPlugin methodsFor: 'Extended Send' stamp: 'wbk 6/16/2004 22:20'!
method6
	^ 1! !

!TestExuperyPlugin methodsFor: 'Example Methods' stamp: 'wbk 7/31/2003 17:24'!
popStack
	1 printString.
	^ 5! !

!TestExuperyPlugin methodsFor: 'Test - Arithmatic' stamp: 'wbk 1/31/2004 20:05'!
testDivideCreatingFraction2
	self compileCode: '12 / 7'.
	self should: [self example = (12/7)]! !

!TestExuperyPlugin methodsFor: 'Test - Comparision' stamp: 'wbk 1/14/2004 22:18'!
testLessThanSendingLess
	self compileCode: '4.0 < 5'.
	self should: [self example = true]! !

TestCase subclass: #ExuperyTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Programmer Tests'!

ExuperyTests subclass: #IntermediateEmissionTests
	instanceVariableNames: 'machine generator emitter result mockEmitter state'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Programmer Tests'!

!IntermediateEmissionTests methodsFor: 'Tests - Sends' stamp: 'wbk 7/24/2004 11:23'!
testReloadStack
	emitter emitReloadStack: { 
				machine registerNamed: #t1}.
	self should: 
			[generator method intermediateForm = #(#(#block 1 #(#mov currentContext #t2) #(#mov #(#mem #(#add #t2 28)) #t1)))]! !

!IntermediateEmissionTests methodsFor: 'Tests - Stack' stamp: 'wbk 5/3/2004 15:06'!
testStackRegisterSameSlot
	| s1a s1b |
	s1a := emitter stackRegister: 1.
	s1b := emitter stackRegister: 1.
	self assert: s1a = s1b.! !

!IntermediateEmissionTests methodsFor: 'Tests' stamp: 'wbk 3/6/2004 21:12'!
testEmitConvertLessOrEqualToBoolean
	result := emitter 
				emitConvertComparisionToBoolean: (MedArithmatic 
						operator: #sub
						arg1: (MedLiteral literal: 2)
						arg2: (MedLiteral literal: 1))
				jumpType: #jg.
	self should: 
		[generator method intermediateForm = 
			#(#(#block 1 
				#(#jg #block2 #(#sub 2 1)) 
				#(#mov #(#mem #trueObj) #t1) 
				#(#jmp #block3)) 
			#(#block 2 
				#(#mov #(#mem #falseObj) #t1) 
				#(#jmp #block3)) 
			#(#block 3))	"Push True"	"push false"	"Push False"].
	self should: [result intermediateForm = #t1].
	self should: [emitter currentBlock blockName = #block3]! !

!IntermediateEmissionTests methodsFor: 'Tests - Jumps' stamp: 'wbk 8/8/2003 20:31'!
testEmitJumpTo
	| failureBlock |
	failureBlock := emitter method newBlock.
	result := emitter 
		jumpType: #jumpType
		to: failureBlock
		dependingOn: (MedLiteral literal: #instruction).
	self assert: result intermediateForm = #(jumpType block2 instruction) ! !

!IntermediateEmissionTests methodsFor: 'Tests - Basic' stamp: 'wbk 11/21/2003 00:02'!
testEmitOr
	result := emitter 
		emit: (MedLiteral literal: 10)
		or: (MedLiteral literal: 20).
	self assert: result intermediateForm = #(or 10 20)! !

!IntermediateEmissionTests methodsFor: 'Tests - Addresses' stamp: 'wbk 11/20/2003 23:37'!
testEmitRootTableCountAddress
	result := emitter emitRootTableCountAddress.
	self should: [result intermediateForm = #rootTableCount]! !

!IntermediateEmissionTests methodsFor: 'Tests - Stack' stamp: 'wbk 4/29/2004 20:11'!
testStackRegister
	| variable |
	variable := emitter stackRegister: 1.
	self assert: variable name = #s1.
	self assert: (variable isKindOf: MedTemporaryRegister).
	variable := emitter stackRegister: 2.
	self assert: variable name = #s2.! !

!IntermediateEmissionTests methodsFor: 'Tests - Basic' stamp: 'wbk 3/7/2004 23:33'!
testEmitMultiply
	result := emitter 
				emit: (MedLiteral literal: 1)
				multiply: (MedLiteral literal: 2)
				failTo: emitter newBlock.
	self assert: result intermediateForm = #(#jo #block2 #(#mul 1 2))! !

!IntermediateEmissionTests methodsFor: 'Misc' stamp: 'wbk 4/26/2004 22:31'!
setUp
	machine := MockExuperyPlugin new.
	generator := IntermediateGenerator for: machine.
	emitter := IntermediateEmitter 
		machine: machine 
		jumpTargets: #().
	state := ExuperyStack 
		newPC: 10
		emitter: emitter.
	emitter state: state.
	generator emitter: emitter.! !

!IntermediateEmissionTests methodsFor: 'Tests - Sends' stamp: 'wbk 5/31/2004 23:27'!
testSendWithStack2
	| answer |
	mockEmitter := MockIntermediateEmitter new.
	emitter emitter: mockEmitter.
	mockEmitter anyOrder.
	mockEmitter addExpectedEmission: #(#emitRestoreContext 11 #s1 #s2 #s3 #arg4 #arg5 #arg6).
	mockEmitter addExpectedEmission: #(#emitSetUpMessageSend #(#emitSpecialSelector 29) 2).
	mockEmitter addExpectedEmission: #(#emitMoveToEax 0).
	mockEmitter addExpectedEmission: #(#emitRet).
	mockEmitter addExpectedEmission: #(#emitLabel).
	mockEmitter addExpectedEmission: #(#emitReloadStack #s1 #s2 #s3 #t1).
	mockEmitter 
		expectRegisterEntryPointPC: 23
		blockNumbered: #(#emitLabel).	"An encoded SmallInteger"
	state heightTo: 3.
	answer := emitter 
				emitSendSelector: (mockEmitter emitSpecialSelector: 29)
				arguments: #(#arg4 #arg5 #arg6).
	self assert: (answer isKindOf: MedLanguage).	"This is inadiquate. What I really should do is check
												  that the answer is a reasonable type/object"
	self verify! !

!IntermediateEmissionTests methodsFor: 'Tests - Basic' stamp: 'wbk 8/8/2003 20:35'!
testEmitAdd
	result := emitter 
		emit: (MedLiteral literal: 10)
		add: (MedLiteral literal: 20).
	self assert: result intermediateForm = #(add 10 20)! !

!IntermediateEmissionTests methodsFor: 'Tests - Stack' stamp: 'wbk 6/27/2004 23:04'!
testMultiplePop
	| stack answer |
	mockEmitter := MockIntermediateEmitter newWith: MachineX86 new.
	mockEmitter expectEmission: 
		#( (block1
				(mov firstValue s1)
				(mov secondValue s2))).
	stack := ExuperyStack 
		newPC: 1
		emitter: mockEmitter.
		
	stack push: #firstValue.
	stack push: #secondValue.

	answer := stack pop: 2.
	self assert: (answer at: 1) name = #s1.
	self assert: (answer at: 2) name = #s2.
	mockEmitter verify.
	! !

!IntermediateEmissionTests methodsFor: 'Tests - Sends' stamp: 'wbk 8/6/2003 12:23'!
testSetUpMessageSend
	result := emitter emitSetUpMessageSendFor: (MedLiteral literal: #receiver)
				argumentCount: (MedLiteral literal: 1).
	self assert: 
			generator method intermediateForm 
				= #(#(#block 1 #(#push 1) #(#push #receiver) #(#mov #exuperySetupMessageSend #t1) #(#call #t1) #(#mov #(#add 8 #esp) #esp)))! !

!IntermediateEmissionTests methodsFor: 'Tests - Basic' stamp: 'wbk 2/8/2004 15:59'!
testEmitDiv
	result := emitter 
		emitDiv: (MedLiteral literal: 13)
		with: (MedLiteral literal: 5)
		failTo: emitter newBlock.
	self assert: generator method intermediateForm =
		#((block 1 
			(je block2 (sub 0 5))
			(mov (div 13 5 t2) t1)
			(jge block3 (sub t1 0)) 
			(je block3 (sub 0 t2) )
			(mov (sub t1 1) t1) 
			(jmp block3) ) 		"t2 is the remander"
		(block 2)
		(block 3) ) .
	self assert: result intermediateForm = #t1.
	self assert: emitter currentBlock blockName = #block3
! !

!IntermediateEmissionTests methodsFor: 'Tests - Jumps' stamp: 'wbk 2/15/2004 12:37'!
testEmitJumpIfTrueTo
	| target |
	mockEmitter := MockIntermediateEmitter new.
	emitter emitter: mockEmitter.
	mockEmitter expectEmission:
			#( 	(block1			
					(je block2 (sub anExpression (mem trueObj) ))
					(jne block3 (sub anExpression (mem falseObj)))
					(jmp block4))
				(block2) 
				(block3 
					(emitSend (emitSpecialObject 25) anExpression)
					(jmp block4))
				(block4) ).
	target := mockEmitter newBlock.
	emitter 
		emitJumpIfTrueTo: target
		onBoolean: (MedLiteral literal: #anExpression).
	self verify.
	self assert: mockEmitter currentBlock = #block4! !

!IntermediateEmissionTests methodsFor: 'Tests' stamp: 'wbk 3/6/2004 19:00'!
testFetchVariableAddress
	result := emitter 
		emitFetchVariableAddress: (MedLiteral literal: #index)
		ofObject: (MedLiteral literal: #object).
	self assert: result intermediateForm = #(#mem (add object (add (sal  index 2) 4)))! !

!IntermediateEmissionTests methodsFor: 'Tests - Addresses' stamp: 'wbk 11/20/2003 23:58'!
testEmitRootTableAddress
	result := emitter emitRootTableAddress.
	self should: [result intermediateForm = #rootTable]! !

!IntermediateEmissionTests methodsFor: 'Tests' stamp: 'wbk 3/4/2004 21:38'!
testEmitConvertToSmallInteger
	result := emitter 
				emitConvertToSmallInteger: (MedLiteral literal: 42)
				failTo: emitter newBlock.
	self should: [generator method intermediateForm = #(#(#block 1) #(#block 2))].
	self should: [result intermediateForm = #(#add 1 #(#jo #block2 #(#sal 42 1)))].
	self should: [emitter currentBlock blockName = #block1]! !

!IntermediateEmissionTests methodsFor: 'Tests - Stack' stamp: 'wbk 6/27/2004 23:05'!
testStackPeek
	| stack |
	mockEmitter := MockIntermediateEmitter newWith: MachineX86 new.
	mockEmitter expectEmission: 
		#( (block1
				(mov firstValue s1)
				(mov secondValue s2))).
	stack := ExuperyStack 
		newPC: 1
		emitter: mockEmitter.
		
	stack push: #firstValue.
	stack push: #secondValue.

	self assert: stack peek name = #s2.
	self assert: stack peek name = #s2.
	mockEmitter verify.
	! !

!IntermediateEmissionTests methodsFor: 'Tests' stamp: 'wbk 8/8/2003 22:25'!
testSetCurrentBlock
	| block |
	block := emitter method newBlock.
	emitter currentBlock: block.
	self assert: emitter currentBlock = block.
	self assert: emitter method intermediateForm = #((block 1) (block 2))! !

!IntermediateEmissionTests methodsFor: 'Tests' stamp: 'wbk 8/8/2003 19:15'!
testEmitCheckIsNotInteger
	| failureBlock |
	failureBlock := emitter method newBlock.
	result := emitter 
		emitCheckIsNotInteger: (MedLiteral literal: 10)
		failTo: failureBlock.
	self assert: generator method intermediateForm = #((block 1 (jnz block2 (and 1 10)) ) (block 2))! !

!IntermediateEmissionTests methodsFor: 'Tests' stamp: 'wbk 3/4/2004 21:37'!
testEmitBeRootIfNessisary
	mockEmitter := MockIntermediateEmitter newWith: emitter machine.
	emitter emitter: mockEmitter.
	mockEmitter expectEmission:
		#((block1 
			(emitCheckIsNotInteger #pointedTo block2)
			(jl block2 (sub pointedTo (mem (emitYoungStartAddress))) )
			(jge block2 (sub root (mem (emitYoungStartAddress))) )
			"An old object is receiving a pointer to a young object"
			(mov (mem root) t1)
			(jnz block2 (and t1 16r40000000) )
			" Now record the object as a new root"
			(mov (add 1 (mem (emitRootTableCountAddress))) t2)
			(mov t2 (mem (emitRootTableCountAddress)))
			(mov root (mem (add (emitRootTableAddress) (sal t2 2))))
			(mov (or t1 16r40000000) (mem root))
			(jmp block2)
		)) .
			

	result := emitter 
		emitBeRoot: #root
		ifNeededBy: #pointedTo.

	self assert: mockEmitter currentBlock = #block2.
	self verify.! !

!IntermediateEmissionTests methodsFor: 'Tests' stamp: 'wbk 1/10/2004 13:06'!
testConditionalByteCode
	mockEmitter := MockIntermediateEmitter new.
	emitter emitter: mockEmitter.
	mockEmitter addExpectedEmission: 
		#(emitWithFailTo (emitConvertComparisionToBoolean jge (sub 
			(emitIntegerValueOf block2 3) 
			(emitIntegerValueOf block2 5)))
			2 3 5).

	result := emitter 
		emitConditionalBytecodeArg1: (MedLiteral smallInteger: 1)
		arg2: (MedLiteral smallInteger: 2)
		withJump: #jge
		failureSelector: 2.

	self verify! !

!IntermediateEmissionTests methodsFor: 'Tests - Addresses' stamp: 'wbk 7/19/2003 21:58'!
testEmitTrueAddress
	result := emitter emitTrueAddress.
	self should: [result intermediateForm = #(mem trueObj )]! !

!IntermediateEmissionTests methodsFor: 'Tests - Sends' stamp: 'wbk 7/24/2004 11:31'!
testRestoreContextWithTemporaries
	emitter numberOfTemporaries: 1.
	result := emitter emitRestoreContextWithPC: 0 stack: {MedLiteral literal: #abc}.
	self
		should: [generator method intermediateForm = #(#(#block 1 
			#(#mov 1 #(#mem #(#add currentContext 8))) 
			#(#mov 5 #(#mem #(#add currentContext 12))) 
			#(#mov currentContext #t1) 
			#(#mov #abc #(#mem #(#add #t1 32)))) )]! !

!IntermediateEmissionTests methodsFor: 'Tests - Basic' stamp: 'wbk 5/28/2004 22:19'!
testEmitBitShift
	result := emitter 
				emit: (MedLiteral literal: 13)
				bitShift: (MedLiteral literal: 5)
				failingTo: emitter newBlock.
	self assert: generator method intermediateForm = 
		#(	(block 1 
				(jl block3 (sub 5 0)) 
				(jl block2 (sub 31 5))
				(mov (sal 13 5) t1) 
				(jnz block2 (sub 13 (sar t1 5))) 
				(jmp block4))
			(block 2) "The failure block"
			(block 3 
				(jl block2 (sub 5 -31))
				(mov (sar  13  (neg 5)) t1) 
				(jmp block4)) 
			#(#block 4)).	"t2 is the remander"
	self assert: result intermediateForm = #t1.
	self assert: emitter currentBlock blockName = #block4! !

!IntermediateEmissionTests methodsFor: 'Tests - Basic' stamp: 'wbk 8/8/2003 19:18'!
testEmitMove
	result := emitter 
		emitMoveFrom: (MedLiteral literal: 1)
		to: (MedLiteral literal: 2).
	self assert: generator method intermediateForm = #((block 1 (#mov 1 2) ))! !

!IntermediateEmissionTests methodsFor: 'Tests - Basic' stamp: 'wbk 2/4/2004 23:38'!
testEmitAnd
	result := emitter 
		emit: (MedLiteral literal: 10)
		and: (MedLiteral literal: 20).
	self assert: result intermediateForm = #(and 10 20)! !

!IntermediateEmissionTests methodsFor: 'Tests - Jumps' stamp: 'wbk 6/20/2003 18:03'!
testEmitJumpTarget
	|  targetBlock |
	targetBlock := emitter newBlock.
	emitter emitUnconditionalJumpTo: targetBlock.
	self should: [generator method intermediateForm = #((block 1 (jmp block2)) (block 2) )].! !

!IntermediateEmissionTests methodsFor: 'Tests' stamp: 'wbk 11/20/2003 22:06'!
testEmitWithFailTo
	mockEmitter := MockIntermediateEmitter new.
	emitter emitter: mockEmitter.
	mockEmitter expectEmission:
		#((block1 
			(mov 
				(aMethod block2) t1) 
			(jmp block3))
		(block2 
			(mov (emitSend (emitSpecialSelector 100) arg1 arg2) t1)
			(jmp block3)) 
		(block3)).

	result := emitter 
		emitWithFailTo: [:failureBlock| mockEmitter check: {#aMethod. failureBlock blockName}]
		failureSpecialSelector: 100
		arguments: #(arg1 arg2).

	self should: [result intermediateForm = #t1].
	self should: [mockEmitter currentBlock = #block3].! !

!IntermediateEmissionTests methodsFor: 'Tests - Basic' stamp: 'wbk 2/8/2004 15:59'!
testEmitMod
	result := emitter 
		emitMod: (MedLiteral literal: 13)
		with: (MedLiteral literal: 5)
		failTo: emitter newBlock.
	self assert: generator method intermediateForm =
		#((block 1 
			(je block2 (sub 0 5))
			(mov (div 13 5 t2) t1)
			(jge block3 (sub t1 0)) 
			(je block3 (sub 0 t2) )
			(mov (add t2 5) t2) 
			(jmp block3) ) 		"t2 is the remander"
		(block 2)
		(block 3) ) .
	self assert: result intermediateForm = #t2.
	self assert: emitter currentBlock blockName = #block3
! !

!IntermediateEmissionTests methodsFor: 'Tests - Basic' stamp: 'wbk 11/21/2003 00:00'!
testEmitSal
	result := emitter 
		emit: (MedLiteral literal: 10)
		sal: (MedLiteral literal: 20).
	self assert: result intermediateForm = #(sal 10 20)! !

!IntermediateEmissionTests methodsFor: 'Tests - Stack' stamp: 'wbk 6/27/2004 23:04'!
testBasicStack
	| stack |
	mockEmitter := MockIntermediateEmitter newWith: MachineX86 new.
	mockEmitter expectEmission: 
		#( (block1
				(mov firstValue s1)
				(mov secondValue s2))).
	stack := ExuperyStack 
		newPC: 1
		emitter: mockEmitter.
		
	stack push: #firstValue.
	stack push: #secondValue.

	self assert: stack pop name = #s2.
	self assert: stack pop name = #s1.
	mockEmitter verify.
	! !

!IntermediateEmissionTests methodsFor: 'Tests' stamp: 'wbk 6/20/2003 18:04'!
testEmitLabelForByteCode
	emitter := IntermediateEmitter 
		machine: machine 
		jumpTargets: #(5 10).
	generator emitter: emitter.
	result := emitter emitLabelForByteCode: 10.
	self should: [result class = MedBlock].
	self should: [result blockName = #block3]! !

!IntermediateEmissionTests methodsFor: 'Tests - Addresses' stamp: 'wbk 7/24/2004 11:17'!
testEmitSelfAddress
	result := emitter emitReceiverAddress.
	self assert: result intermediateForm = #(mem (add currentContext 24))! !

!IntermediateEmissionTests methodsFor: 'Tests - Basic' stamp: 'wbk 2/7/2004 19:26'!
testEmitDivide
	result := emitter 
		emitDivide: (MedLiteral literal: 13)
		with: (MedLiteral literal: 5)
		failTo: emitter newBlock.
	self assert: generator method intermediateForm =
		#((block 1 
			(je block2 (sub 0 5))
			(mov (div 13 5 t2) t1) 		"t2 is the remander"
			(jne block2 (sub 0 t2)))
		(block 2)) .
	self assert: result intermediateForm = #t1
! !

!IntermediateEmissionTests methodsFor: 'Tests - Sends' stamp: 'wbk 8/19/2003 15:18'!
testSendMessage
	| answer |
	mockEmitter := MockIntermediateEmitter new.
	emitter emitter: mockEmitter.
	mockEmitter anyOrder.
	mockEmitter addExpectedEmission: #(#emitRestoreContext 13 #receiver #arg1 #arg2).
	mockEmitter addExpectedEmission: #(#emitSetUpMessageSend #(#emitLiteralAddress 3) 2).
	mockEmitter addExpectedEmission: #(#emitMoveToEax 0).
	mockEmitter addExpectedEmission: #(#emitRet).
	mockEmitter addExpectedEmission: #(#emitLabel).
	mockEmitter addExpectedEmission: #(#emitReloadStack #t1).
	mockEmitter 
		expectRegisterEntryPointPC: 27
		blockNumbered: #(#emitLabel).	"An encoded SmallInteger"
	state pc: 12.
	answer := emitter 
				emitSendSelector: (mockEmitter emitLiteralAddress: 3)
				arguments: #(#receiver #arg1 #arg2).
	self assert: (answer isKindOf: MedMachineRegister).	"This is inadiquate. What I really should do is check
												  that the answer is a reasonable type/object"
	self verify! !

!IntermediateEmissionTests methodsFor: 'Misc' stamp: 'wbk 7/16/2003 15:26'!
verify
	mockEmitter ifNotNil: [mockEmitter verify].! !

!IntermediateEmissionTests methodsFor: 'Tests - Addresses' stamp: 'wbk 11/20/2003 23:17'!
testEmitYoungStartAddress
	result := emitter emitYoungStartAddress.
	self should: [result intermediateForm = #youngStart]! !

!IntermediateEmissionTests methodsFor: 'Tests - Sends' stamp: 'wbk 7/24/2004 11:30'!
testRestoreContextWithStack2
	result := emitter 
		emitRestoreContextWithPC: 0 
		stack: {MedLiteral literal: #abc. MedLiteral literal: #def}.
	self should: 
			[generator method intermediateForm 
				= #(#(#block 1 #(#mov 1 
									#(#mem #(#add currentContext 8)) )
								(mov 5
									(mem (add currentContext 12))) 
								(mov currentContext t1) 
								(mov #abc (mem (add t1 28)))
								(mov #def (mem (add t1 32))) ))]! !

!IntermediateEmissionTests methodsFor: 'Tests - Basic' stamp: 'wbk 2/7/2004 19:27'!
testEmitSubtract
	result := emitter 
		emit: (MedLiteral literal: 1)
		minus: (MedLiteral literal: 2).
	self should: [result intermediateForm = #(#sub 1 2)]! !

!IntermediateEmissionTests methodsFor: 'Tests - Object Access' stamp: 'wbk 3/7/2004 12:56'!
testClass
	mockEmitter := MockIntermediateEmitter newWith: emitter machine.
	emitter emitter: mockEmitter.
	mockEmitter expectEmission: 
		#(	(block1 
				(emitCheckIsInteger theReceiver block2)
			 	(mov (emitSpecialObject 5) t1)
				(jmp block4) ) 
			(block2 
				(mov (and  16r1F (sar (mem theReceiver) 12)) t2)
				(je block3 (sub 0 t2 ))
				(mov (emitFetchVariableAddress (sub t2 1) (emitSpecialObject 28)) t1)
				(jmp block4) )
			(block3
				(mov (and 4294967292 (mem (sub theReceiver 4))) t1)
				(jmp block4))
			(block4 )).
	result := emitter
				emitClassOf: (MedLiteral literal: #theReceiver).
	self verify.
	self assert: result name = #t1.
	self assert: mockEmitter currentBlock = #block4! !

!IntermediateEmissionTests methodsFor: 'Tests' stamp: 'wbk 3/4/2004 21:10'!
testEmitAtElementAddressWithOffset
	| answer |
	mockEmitter := MockIntermediateEmitter new.
	emitter emitter: mockEmitter.
	mockEmitter expectEmission: 
		#(#	(#block1 
				#(#emitCheckIsNotInteger #receiver #failureBlock) 
				#(#emitCheckIsInteger #elementNumber #failureBlock) 
				#(#mov (add #(#and #receiver 28) 32) #t1) 
				#(#jnz #failureBlock #(sub #receiver #(#emitAtCacheEntry 1 #t1))) 
				#(#jl #failureBlock 
					#(#sub #(#emitAtCacheEntry 2 #t1) #(#sar #elementNumber 1))) 
				#(#jg #failureBlock #(#sub #(#emitAtCacheEntry 3 #t1) 4)))).
	"Check receiver and index are correct types (not integer and integer"
	"Get atIndex"
	"check atIndex caches the receiver"
	"** Get the address of the element"
	"Check index is inside the object (array bounds check)"
	"Check fmt <= 4 (currently only handling pointer objects"
	"get address of element"
	"***** The following expression is not added to the block, it is returned and should
				be used by the calling expression"
	mockEmitter addExpectedEmission: 
		#(emitFetchVariableAddress 
			(sub (add (sar elementNumber 1) (emitAtCacheEntry 4 t1)) 1)
			receiver).
	answer := emitter 
				emitAtElementAddressFor: #receiver
				with: (MedLiteral literal: #elementNumber)
				failTo: #failureBlock
				cacheOffset: 32.
	self verify.
	self assert: answer = 
		#(#emitFetchVariableAddress 
			(#sub #(#add #(#sar  #elementNumber 1) #(#emitAtCacheEntry 4 #t1)) 1)
			receiver)! !

!IntermediateEmissionTests methodsFor: 'Tests - Sends' stamp: 'wbk 11/17/2003 22:02'!
testEmitSpecialSelector
	mockEmitter := MockIntermediateEmitter new.
	emitter emitter: mockEmitter.
	mockEmitter addExpectedEmission: #(#emitFetchAddress 10 #(#emitFetchAddress 23 #(#mem #specialObjectsOop))).
	result := emitter emitSpecialSelector: 5.
	self assert: 
			result = #(#emitFetchAddress 10 #(#emitFetchAddress 23 #(#mem #specialObjectsOop))).
	self verify! !

!IntermediateEmissionTests methodsFor: 'Tests - Sends' stamp: 'wbk 7/24/2004 10:49'!
testRegisterEntryPoint
	| block |
	block := emitter newBlock.
	emitter 
		registerEntryPointWithPC: (MedLiteral literal: 5)
		label: block.
	emitter createProlog.
	
	self should: 
			[generator method intermediateForm 
				= #((block 3
						"Load current context into a register"
						(mov (mem (add ebp 8)) currentContext)
						"Load PC into a register"
						(mov #(#mem #(#add  currentContext 8)) t1)
						"Compare PC with entry point"
						(mov 5 t2)
						(jz block2 (sub t2 t1)) )
					(block 1)
					(block 2) )]! !

!IntermediateEmissionTests methodsFor: 'Tests' stamp: 'wbk 3/4/2004 21:37'!
testEmitAtCacheEntry
	result := emitter 
		emitAtCacheEntryEntry: 10
		index: (MedLiteral literal: 20).
	self assert: result intermediateForm = #(mem (add atCache (sal (add 10 20) 2)))! !

!IntermediateEmissionTests methodsFor: 'Tests - Addresses' stamp: 'wbk 3/4/2004 21:07'!
testEmitAtElementAddress
	| answer |
	mockEmitter := MockIntermediateEmitter new.
	emitter emitter: mockEmitter.
	mockEmitter expectEmission: 
		#(#	(#block1 
				#(#emitCheckIsNotInteger #receiver #failureBlock) 
				#(#emitCheckIsInteger #elementNumber #failureBlock) 
				#(#mov (add #(#and #receiver 28) 0) #t1) 
				#(#jnz #failureBlock #(#sub #receiver #(#emitAtCacheEntry 1 #t1))) 
				#(#jl #failureBlock 
					#(#sub #(#emitAtCacheEntry 2 #t1) #(#sar #elementNumber 1))) 
				#(#jg #failureBlock #(#sub #(#emitAtCacheEntry 3 #t1) 4)))).
	"Check receiver and index are correct types (not integer and integer"
	"Get atIndex"
	"check atIndex caches the receiver"
	"** Get the address of the element"
	"Check index is inside the object (array bounds check)"
	"Check fmt <= 4 (currently only handling pointer objects"
	"get address of element"
	"***** The following expression is not added to the block, it is returned and should
				be used by the calling expression"
	mockEmitter addExpectedEmission: 
		#(emitFetchVariableAddress 
			(sub (add (sar elementNumber 1) (emitAtCacheEntry 4 t1)) 1)
			receiver).
	answer := emitter 
				emitAtElementAddressFor: #receiver
				with: (MedLiteral literal: #elementNumber)
				failTo: #failureBlock
				cacheOffset: 0.
	self verify.
	self assert: answer = 
		#(#emitFetchVariableAddress 
			(#sub #(#add #(#sar  #elementNumber 1) #(#emitAtCacheEntry 4 #t1)) 1)
			receiver)! !

!IntermediateEmissionTests methodsFor: 'Tests - Sends' stamp: 'wbk 8/5/2003 20:35'!
testBytecodePrimNewWithArg
	| answer |
	mockEmitter := MockIntermediateEmitter new.
	emitter emitter: mockEmitter.
	mockEmitter anyOrder.
	mockEmitter addExpectedEmission: #(#emitRestoreContext 2 4 5).
	mockEmitter addExpectedEmission: #(#emitSetUpMessageSend #(#emitSpecialSelector 29) 1).
	mockEmitter addExpectedEmission: #(#emitMoveToEax 0).
	mockEmitter addExpectedEmission: #(#emitRet).
	mockEmitter addExpectedEmission: #(#emitLabel).
	mockEmitter addExpectedEmission: #(#emitReloadStack #t1).
	mockEmitter 
		expectRegisterEntryPointPC: 5
		blockNumbered: #(#emitLabel).	"An encoded SmallInteger"
	state pc: 1.
	answer := emitter 
				emitSendSelector: (mockEmitter emitSpecialSelector: 29)
				arguments: #(4 5).
	self assert: (answer isKindOf: MedLanguage).	"This is inadiquate. What I really should do is check
												  that the answer is a reasonable type/object"
	self verify! !

!IntermediateEmissionTests methodsFor: 'Tests - Addresses' stamp: 'wbk 7/30/2003 18:51'!
testEmitFalseAddress
	result := emitter emitFalseAddress.
	self should: [result intermediateForm = #(mem falseObj )]! !

!IntermediateEmissionTests methodsFor: 'Tests - Sends' stamp: 'wbk 5/31/2004 23:23'!
testSendWithStack
	| answer |
	mockEmitter := MockIntermediateEmitter new.
	emitter emitter: mockEmitter.
	mockEmitter anyOrder.
	mockEmitter addExpectedEmission: #(#emitRestoreContext 11 #s1 #s2 #arg4 #arg5).
	mockEmitter addExpectedEmission: #(#emitSetUpMessageSend #(#emitSpecialSelector 29) 1).
	mockEmitter addExpectedEmission: #(#emitMoveToEax 0).
	mockEmitter addExpectedEmission: #(#emitRet).
	mockEmitter addExpectedEmission: #(#emitLabel).
	mockEmitter addExpectedEmission: #(#emitReloadStack #s1 #s2 #t1).
	mockEmitter 
		expectRegisterEntryPointPC: 23
		blockNumbered: #(#emitLabel).	"An encoded SmallInteger"
	state heightTo: 2.
	answer := emitter 
				emitSendSelector: (mockEmitter emitSpecialSelector: 29)
				arguments: #(#arg4 #arg5).
	self assert: (answer isKindOf: MedLanguage).	"This is inadiquate. What I really should do is check
												  that the answer is a reasonable type/object"
	self verify! !

!IntermediateEmissionTests methodsFor: 'Tests' stamp: 'wbk 3/4/2004 21:25'!
testEmitIntegerValueOf
	result := emitter 
		emitIntegerValueOf: (MedLiteral literal: 42)
		failTo: (emitter newBlock).
	self should: 
		[generator method intermediateForm = #( (block 1 (jz block2 (and 1 42)) ) (block 2) )].
	self should: [result intermediateForm = #(sar 42 1)].
	self should: [emitter currentBlock blockName = #block1].! !

!IntermediateEmissionTests methodsFor: 'Tests - Basic' stamp: 'wbk 8/17/2003 18:00'!
testEmitMoveToTemp
	result := emitter 
		emitMoveToTemp: (MedLiteral literal: 10).
	self assert: generator method intermediateForm = #((block 1 (#mov 10 t1) )).
	self assert: result intermediateForm = #t1.! !

!IntermediateEmissionTests methodsFor: 'Tests - Basic' stamp: 'wbk 8/8/2003 19:17'!
testEmitMem
	result := emitter 
		emitMem: (MedLiteral literal: #address).
	self assert: result intermediateForm = #(#mem address)! !

!IntermediateEmissionTests methodsFor: 'Tests - Stack' stamp: 'wbk 4/29/2004 20:40'!
testStackRegisterWithTemps
	| variable |
	variable := emitter stackRegister: 1.
	variable := emitter stackRegister: 2.
	self assert: emitter createTemporaryRegister name = #t1.! !

!IntermediateEmissionTests methodsFor: 'Tests' stamp: 'wbk 7/6/2003 18:12'!
testEmitLabel
	| oldBlock answer |
	oldBlock := emitter currentBlock.
	answer := emitter emitLabel.
	self assert: oldBlock ~= emitter currentBlock.
	self assert: (generator method intermediateForm = #((block 1 (jmp block2)) (block 2) )).
	self assert: (answer isKindOf: MedLanguage)! !

!IntermediateEmissionTests methodsFor: 'Tests - Sends' stamp: 'wbk 7/24/2004 11:23'!
testReloadStack2
	emitter emitReloadStack: {machine registerNamed: #t1.
		machine registerNamed: #t2.
		machine registerNamed: #t3}.

	self should: 
			[generator method intermediateForm 
				= #((block 1
								(mov currentContext t4) 
								(mov (mem (add t4 28)) t1) 
								(mov (mem (add t4 32)) t2) 
								(mov (mem (add t4 36)) t3) ))]! !

!IntermediateEmissionTests methodsFor: 'Tests - Basic' stamp: 'wbk 3/7/2004 23:33'!
testEmitSar
	result := emitter 
				emit: (MedLiteral literal: 10)
				sar: (MedLiteral literal: 20).
	self assert: result intermediateForm = #(#sar 10 20)! !

!IntermediateEmissionTests methodsFor: 'Tests - Addresses' stamp: 'wbk 10/4/2003 20:16'!
testEmitNilAddress
	result := emitter emitNilAddress.
	self should: [result intermediateForm = #(mem nilObj )]! !

!IntermediateEmissionTests methodsFor: 'Tests - Jumps' stamp: 'wbk 2/15/2004 12:38'!
testEmitJumpIfFalseTo
	| target |
	mockEmitter := MockIntermediateEmitter new.
	emitter emitter: mockEmitter.
	mockEmitter expectEmission:
			#( 	(block1			
					(je block2 (sub anExpression (mem falseObj) ))
					(jne block3 (sub anExpression (mem trueObj)))
					(jmp block4))
				(block2) 
				(block3 
					(emitSend (emitSpecialObject 25) anExpression)
					(jmp block4))
				(block4) ).
	target := mockEmitter newBlock.
	emitter 
		emitJumpIfFalseTo: target
		onBoolean: (MedLiteral literal: #anExpression).
	self verify.
	self assert: mockEmitter currentBlock = #block4.! !

!IntermediateEmissionTests methodsFor: 'Tests - Sends' stamp: 'wbk 7/24/2004 11:24'!
testRestoreContext
	result := emitter emitRestoreContextWithPC: 1 stack: #().
	self should: 
			[generator method intermediateForm 
				= #(#(#block 1 #(#mov 3 
									#(#mem #(#add currentContext 8)) )
								(mov 1
									(mem (add currentContext 12))) 
								(mov currentContext t1) "not needed for this test but all sends will need
															to save at least the receiver so it should 															always be needed in practice" ))]! !

!IntermediateEmissionTests methodsFor: 'Tests - Sends' stamp: 'wbk 7/24/2004 11:25'!
testRestoreContextWithStack
	result := emitter 
		emitRestoreContextWithPC: 0 
		stack: {MedLiteral literal: #abc}.
	self should: 
			[generator method intermediateForm 
				= #((block 1 (mov 1 
									(mem (add currentContext 8)) )
								(mov 3
									(mem (add currentContext 12))) 
								(mov currentContext t1) 
								(mov abc (mem (add t1 28))) ))]! !

ExuperyTests subclass: #JumpTargetTests
	instanceVariableNames: 'generator method'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Programmer Tests'!

!JumpTargetTests methodsFor: 'Tests - Jumps' stamp: 'wbk 5/30/2004 23:49'!
testShortUnconditionalJump
	self
		findTargetsFor: #shortUnconditionalJump
		inClass: ByteCodeReaderTests.
	self should: [generator targets asArray = #(17 19)]! !

!JumpTargetTests methodsFor: 'Tests - Arithmatic' stamp: 'wbk 7/9/2004 20:49'!
testFindJumpTargetsFoSimpleMinus
	self
		checkNoTargetsForMethod: #simpleMinus
		in: ByteCodeReaderTests! !

!JumpTargetTests methodsFor: 'Tests - Jumps' stamp: 'wbk 5/30/2004 23:48'!
testLongJumpIfTrue
	self
		findTargetsFor: #longJumpIfTrue
		inClass: ByteCodeReaderTests.
	self should: [generator targets asArray = #(16)]! !

!JumpTargetTests methodsFor: 'Tests - Arithmatic' stamp: 'wbk 2/5/2004 22:03'!
testDiv
	self
		checkNoTargetsForMethod: #div
		in: ByteCodeReaderTests! !

!JumpTargetTests methodsFor: 'Tests - Arithmatic' stamp: 'wbk 7/9/2004 20:52'!
testFindJumpTargetsForReturnAddSmallInt
	self
		checkNoTargetsForMethod: #returnAddSmallInt
		in: ByteCodeReaderTests! !

!JumpTargetTests methodsFor: 'Tests - Comparision' stamp: 'wbk 1/14/2004 21:15'!
testGreaterThanEqual
	self
		checkNoTargetsForMethod: #greaterThanEqual
		in: ByteCodeReaderTests! !

!JumpTargetTests methodsFor: 'Tests - Jumps' stamp: 'wbk 7/9/2004 20:50'!
testFindJumpTargetsForIterativeFactorial
	self
		findTargetsFor: #iterativeFactorial:
		inClass: ByteCodeReaderTests.
	self should: [generator targets asArray = #(24 9)]! !

!JumpTargetTests methodsFor: 'Tests - Stack' stamp: 'wbk 10/12/2003 22:31'!
testJumpTargetsInPushInstanceVariable
	self 
		checkNoTargetsForMethod: #a
		in: ExuperyInstanceVariables! !

!JumpTargetTests methodsFor: 'Tests - Stack' stamp: 'wbk 1/24/2004 15:31'!
testFindJumpTargetsForPushFalse
	self
		checkNoTargetsForMethod: #popStack
		in: ByteCodeReaderTests! !

!JumpTargetTests methodsFor: 'Tests - Common Sends' stamp: 'wbk 2/14/2004 15:11'!
testNew
	self
		checkNoTargetsForMethod: #sendNew
		in: ByteCodeReaderTests! !

!JumpTargetTests methodsFor: 'Tests - Sends' stamp: 'wbk 10/12/2003 21:54'!
testJumpTargetsInSendLiteralSelector
	self
		checkNoTargetsForMethod: #basicSend
		in: TestExuperyPlugin! !

!JumpTargetTests methodsFor: 'Tests - Stack' stamp: 'wbk 1/24/2004 15:31'!
testFindJumpTargetsForPushNil
	self
		checkNoTargetsForMethod: #pushNil
		in: ByteCodeReaderTests! !

!JumpTargetTests methodsFor: 'Tests - Comparision' stamp: 'wbk 1/17/2004 18:58'!
testNotEquals
	self
		checkNoTargetsForMethod: #notEquals
		in: ByteCodeReaderTests! !

!JumpTargetTests methodsFor: 'Tests - Jumps' stamp: 'wbk 6/6/2004 16:42'!
testStackTracingForBenchmark
	self
		findTargetsFor: #benchmark
		inClass: Integer.
	self should: [generator stackTrace asArray = #(0 0 0 0 0 0 0)]! !

!JumpTargetTests methodsFor: 'Tests - Arithmatic' stamp: 'wbk 2/7/2004 20:32'!
testMod
	self
		checkNoTargetsForMethod: #mod
		in: ByteCodeReaderTests! !

!JumpTargetTests methodsFor: 'Tests - Comparision' stamp: 'wbk 1/12/2004 21:47'!
testGreaterThan
	self
		checkNoTargetsForMethod: #greaterThan
		in: ByteCodeReaderTests! !

!JumpTargetTests methodsFor: 'Tests - Jumps' stamp: 'wbk 5/30/2004 23:47'!
testFindJumpTargets
	self
		findTargetsFor: #ifTrueIfFalse
		inClass: ByteCodeReaderTests.
	method := ByteCodeReaderTests compiledMethodAt: #ifTrueIfFalse.
	self should: [generator targets asArray = #(11)]! !

!JumpTargetTests methodsFor: 'Tests - Common Sends' stamp: 'wbk 3/1/2004 19:06'!
testClass
	self
		checkNoTargetsForMethod: #sendClass
		in: ByteCodeReaderTests! !

!JumpTargetTests methodsFor: 'Tests - Sends' stamp: 'wbk 1/24/2004 15:30'!
testFindJumpTargetsForBytecodePrimSendWithArg
	self
		checkNoTargetsForMethod: #bytecodePrimSendWithArg
		in: ByteCodeReaderTests! !

!JumpTargetTests methodsFor: 'Tests - Stack' stamp: 'wbk 1/24/2004 15:31'!
testJumpTargetsInPushTrue
	self
		checkNoTargetsForMethod: #pushConstantTrue
		in: ByteCodeReaderTests! !

!JumpTargetTests methodsFor: 'Tests - Arithmatic' stamp: 'wbk 2/5/2004 20:40'!
testBitOr
	self
		checkNoTargetsForMethod: #bitOr
		in: ByteCodeReaderTests! !

!JumpTargetTests methodsFor: 'Tests - Return' stamp: 'wbk 1/17/2004 22:04'!
testReturnNil
	self
		checkNoTargetsForMethod: #returnNil
		in: ByteCodeReaderTests! !

!JumpTargetTests methodsFor: 'Tests - Common Sends' stamp: 'wbk 2/22/2004 15:06'!
testNext
	self
		checkNoTargetsForMethod: #sendNext
		in: ByteCodeReaderTests! !

!JumpTargetTests methodsFor: 'Tests - Common Sends' stamp: 'wbk 1/24/2004 15:32'!
testFindJumpTargetsForSendAtPut
	self
		checkNoTargetsForMethod: #atPutSend
		in: ByteCodeReaderTests! !

!JumpTargetTests methodsFor: 'Tests - Comparision' stamp: 'wbk 1/6/2004 22:37'!
testLessThan
	self
		checkNoTargetsForMethod: #lessThan
		in: ByteCodeReaderTests! !

!JumpTargetTests methodsFor: 'Tests - Common Sends' stamp: 'wbk 2/4/2004 20:17'!
testBitAnd
	self
		checkNoTargetsForMethod: #bitAnd
		in: ByteCodeReaderTests! !

!JumpTargetTests methodsFor: 'Tests - Jumps' stamp: 'wbk 5/30/2004 23:44'!
testBenchFibStackTracing
	self
		findTargetsFor: #benchFib
		inClass: Integer.
	self should: [generator stackTrace asArray = #(0 1)]! !

!JumpTargetTests methodsFor: 'Tests - Arithmatic' stamp: 'wbk 1/18/2004 17:21'!
testDivide
	self
		checkNoTargetsForMethod: #divide
		in: ByteCodeReaderTests! !

!JumpTargetTests methodsFor: 'Tests - Common Sends' stamp: 'wbk 2/14/2004 15:11'!
testMakePoint
	self
		checkNoTargetsForMethod: #makePoint
		in: ByteCodeReaderTests! !

!JumpTargetTests methodsFor: 'Tests - Stack' stamp: 'wbk 10/12/2003 21:53'!
testJumpTargetsInPushSelf
	self
		checkNoTargetsForMethod:  #returnSelf
		in: TestExuperyPlugin! !

!JumpTargetTests methodsFor: 'Tests - Arithmatic' stamp: 'wbk 2/8/2004 18:56'!
testBitShift
	self
		checkNoTargetsForMethod: #bitShift
		in: ByteCodeReaderTests! !

!JumpTargetTests methodsFor: 'Misc' stamp: 'wbk 5/30/2004 23:45'!
findTargetsFor: aSymbol inClass: aClass
	method := aClass compiledMethodAt: aSymbol.
	generator := JumpTargetRecorder new.
	ByteCodeReader 
		newMethod: method
		using: generator
		jumpTargets: #()
		stackHeights: #().! !

!JumpTargetTests methodsFor: 'Misc' stamp: 'wbk 5/30/2004 23:37'!
checkNoTargetsForMethod: methodName in: className 
	method := className compiledMethodAt: methodName.
	generator := JumpTargetRecorder new.
	ByteCodeReader 
		newMethod: method
		using: generator
		jumpTargets: #()
		stackHeights: #().
	self should: [generator targets size = 0]! !

!JumpTargetTests methodsFor: 'Tests - Common Sends' stamp: 'wbk 1/24/2004 15:32'!
testJumpTargetsInSendAt
	self
		checkNoTargetsForMethod: #atSend
		in: ByteCodeReaderTests! !

!JumpTargetTests methodsFor: 'Tests - Comparision' stamp: 'wbk 1/14/2004 21:33'!
testEquals
	self
		checkNoTargetsForMethod: #equals
		in: ByteCodeReaderTests! !

!JumpTargetTests methodsFor: 'Tests - Jumps' stamp: 'wbk 6/11/2004 22:01'!
testFindStackTracing
	self
		findTargetsFor: #recursivefTrueIfFalse
		inClass: ByteCodeReaderTests.
	self assert: generator stackTrace asArray = #(0 1 0 1).
	self assert: generator targets asArray = #(21 26 25 26).! !

!JumpTargetTests methodsFor: 'Tests - Jumps' stamp: 'wbk 5/30/2004 23:46'!
testFindEmptyStackTracing
	self
		findTargetsFor: #return4
		inClass: ByteCodeReaderTests.
	self should: [generator stackTrace asArray = #()]! !

!JumpTargetTests methodsFor: 'Tests - Return' stamp: 'wbk 1/17/2004 22:04'!
testReturnTrue
	self
		checkNoTargetsForMethod: #returnTrue
		in: ByteCodeReaderTests! !

!JumpTargetTests methodsFor: 'Tests - Common Sends' stamp: 'wbk 2/22/2004 13:15'!
testSize
	self
		checkNoTargetsForMethod: #sendSize
		in: ByteCodeReaderTests! !

!JumpTargetTests methodsFor: 'Tests - Stack' stamp: 'wbk 1/24/2004 15:31'!
testFindJumpTargetsForStoreAndPopReceiverVariables
	self
		checkNoTargetsForMethod: #storeAndPopReceiverVariable
		in: ByteCodeReaderTests! !

!JumpTargetTests methodsFor: 'Tests - Common Sends' stamp: 'wbk 2/27/2004 21:22'!
testEquivilent
	self
		checkNoTargetsForMethod: #sendEquivilent
		in: ByteCodeReaderTests! !

!JumpTargetTests methodsFor: 'Tests - Stack' stamp: 'wbk 10/12/2003 21:52'!
testJumpTargetsInPushLiteralVariable
	self
		checkNoTargetsForMethod: #pushLiteralVariable
		in: TestExuperyPlugin! !

!JumpTargetTests methodsFor: 'Tests - Return' stamp: 'wbk 1/17/2004 22:04'!
testReturnFalse
	self
		checkNoTargetsForMethod: #returnFalse
		in: ByteCodeReaderTests! !

!JumpTargetTests methodsFor: 'Tests - Stack' stamp: 'wbk 1/24/2004 15:31'!
testFindJumpTargetsForPushMinusOne
	self
		checkNoTargetsForMethod: #pushMinusOne
		in: ByteCodeReaderTests! !

!JumpTargetTests methodsFor: 'Tests - Jumps' stamp: 'wbk 5/30/2004 23:47'!
testFindNestedStackTracing
	self
		findTargetsFor: #nestedIfTrueIfFalse
		inClass: ByteCodeReaderTests.
	self should: [generator stackTrace asArray = #(0 1)]! !

ExuperyTests subclass: #InterferenceGraphGenerationTests
	instanceVariableNames: 'allocator machine'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Programmer Tests'!

!InterferenceGraphGenerationTests methodsFor: 'Tests' stamp: 'wbk 6/23/2003 13:29'!
testSpecialRegisterInterferance
	self prepare: #((block 1 (add ebp t1) )).
	allocator buildInterferenceGraph.

	self shouldnt:
		[allocator interferenceGraph includesKey: (machine registerNamed: #ebp)].! !

!InterferenceGraphGenerationTests methodsFor: 'Tests' stamp: 'wbk 7/5/2003 14:38'!
testPushInterference
	self prepare: #((block 1 (mov 1 t1) (mov 2 t2) (push t1)  (push t2) )).
	allocator buildInterferenceGraph.

	self assert: (allocator
			interferes: (machine registerNamed: #t1)
			with: (machine registerNamed: #t2))
! !

!InterferenceGraphGenerationTests methodsFor: 'Verification Methods' stamp: 'wbk 3/13/2003 14:26'!
verifyInterferes: firstString with: secondString
	self should:
		[allocator
			interferes: (machine registerNamed: firstString)
			with: (machine registerNamed: secondString)].! !

!InterferenceGraphGenerationTests methodsFor: 'Tests' stamp: 'wbk 2/9/2004 20:17'!
testNegate

	self prepare: #((block 1
					(add t1 t1) 
					(neg t2)
					(mov t3 t4) )).
	allocator buildInterferenceGraph.
	self should:
		[allocator
			interferes: (machine registerNamed: #t2)
			with: (machine registerNamed: #t3)].
	self should:
		[allocator
			interferes: (machine registerNamed: #t2)
			with: (machine registerNamed: #t1)].! !

!InterferenceGraphGenerationTests methodsFor: 'Tests' stamp: 'wbk 6/23/2003 13:25'!
testMovToIndirectRegisterInterferance
	self prepare: #((block 1 (mov 1 t1) (mov 2 t2) (mov t1 (t2)))).
	allocator buildInterferenceGraph.

	self should:
		[allocator
			interferes: (machine registerNamed: #t1)
			with: (machine registerNamed: #t2)].! !

!InterferenceGraphGenerationTests methodsFor: 'Tests' stamp: 'wbk 6/23/2003 13:29'!
testSingleRegisterInterferance
	self prepare: #((block 1 (mov 1 t1) (mov 2 t2) (add t1 t2))).
	allocator buildInterferenceGraph.

	self should:
		[allocator
			interferes: (machine registerNamed: #t1)
			with: (machine registerNamed: #t2)].
	self should:
		[allocator
			interferes: (machine registerNamed: #t2)
			with: (machine registerNamed: #t1)].! !

!InterferenceGraphGenerationTests methodsFor: 'Tests' stamp: 'wbk 6/24/2003 10:28'!
testPush
	self prepare: #((block 1 (push 1) )).
	allocator buildInterferenceGraph.
! !

!InterferenceGraphGenerationTests methodsFor: 'Tests' stamp: 'wbk 6/23/2003 13:26'!
testReturn42Interferance
	self prepare: #(#(#block 1 #(#mov 8 't3') #(#add #ebp 't3') #(#mov #('t3') 't4') #(#mov #('t4') 't5')
			 #(#mov 't5' 't1') #(#mov 8 't6') #(#add 't1' 't6') #(#mov #('t6') 't7') #(#mov 1 't8') 
			#(#add 't7' 't8') #(#mov 't8' 't2') #(#mov 8 't9') #(#add 't1' 't9') #(#mov 't2' #('t9')) 
			#(#mov 4 't10') #(#mul 't2' 't10') #(#mov 't10' 't11') #(#add 't1' 't11') #(#mov 24 't12') 
			#(#add 't11' 't12') #(#mov 85 #('t12')) #(#ret))).
	allocator buildInterferenceGraph.

	self verifyInterferenceGraph.
	self 
		verifyDoesntInterfere: #t3
		with: #t4! !

!InterferenceGraphGenerationTests methodsFor: 'Misc' stamp: 'wbk 6/23/2003 13:22'!
prepare: anArray
	|source |
	machine := MachineX86 new.
	source := MedMethod 
		createAssembly: anArray
		for: machine.	
	allocator := ColouringRegisterAllocator new
		initialiseSource: source 
		machine: machine.
	allocator analyseLiveness.! !

!InterferenceGraphGenerationTests methodsFor: 'Tests' stamp: 'wbk 7/5/2003 14:39'!
testCallInterference
	self prepare: #((block 1 (mov 1 t1) (mov 2 t2) (call t1) (call t2) )).
	allocator buildInterferenceGraph.

	self assert: (allocator
			interferes: (machine registerNamed: #t1)
			with: (machine registerNamed: #t2))! !

!InterferenceGraphGenerationTests methodsFor: 'Tests' stamp: 'wbk 6/23/2003 13:25'!
testMovRegisterInterferance
	self prepare: #((block 1 (mov 1 t1) (mov t1 t2) (add t1 t1))).
	allocator buildInterferenceGraph.

	self shouldnt:
		[allocator
			interferes: (machine registerNamed: #t1)
			with: (machine registerNamed: #t2)].! !

!InterferenceGraphGenerationTests methodsFor: 'Tests' stamp: 'wbk 6/23/2003 13:24'!
testMachineRegisterInterferance
	"Reproduces a bug, ebp wasn't being placed in the the interference graph
	throwing it into the debugger"
	"Interestingly it is only created if ebp is an indirect argument"
	self prepare: #((block 1 (mov t1 t2) (mov (ebp) t6) )).
	allocator buildInterferenceGraph.! !

!InterferenceGraphGenerationTests methodsFor: 'Tests' stamp: 'wbk 6/24/2003 11:34'!
testCall
	self prepare: #((block 1 (call 12345) )).
	allocator buildInterferenceGraph.
! !

!InterferenceGraphGenerationTests methodsFor: 'Tests' stamp: 'wbk 6/23/2003 13:27'!
testSimpleJumpRegisterInterferance
	self prepare: #((block 1 (jz block2) (jo block2) (jmp block2) (jg block2) (je block2) ) (block 2) ).
	allocator buildInterferenceGraph.
! !

!InterferenceGraphGenerationTests methodsFor: 'Tests' stamp: 'wbk 2/2/2004 21:02'!
testCDQ

	self prepare: #((block 1 
				(cdq)
				(add t1 t2)
				(add t3 t4))).
	allocator buildInterferenceGraph.
	self should:
		[allocator
			interferes: (machine registerNamed: #t1)
			with: (machine registerNamed: #edx)].
	self should:
		[allocator
			interferes: (machine registerNamed: #t2)
			with: (machine registerNamed: #edx)].
	self should:
		[allocator
			interferes: (machine registerNamed: #t3)
			with: (machine registerNamed: #edx)].! !

!InterferenceGraphGenerationTests methodsFor: 'Tests' stamp: 'wbk 6/23/2003 13:22'!
testRetInterferance
	self prepare: #((block 1 (mov 1 t1) (mov 2 t2) (add t1 t2) (ret) )).
	allocator buildInterferenceGraph.

	self should:
		[allocator
			interferes: (machine registerNamed: #t1)
			with: (machine registerNamed: #t2)].
	self should:
		[allocator
			interferes: (machine registerNamed: #t2)
			with: (machine registerNamed: #t1)].! !

!InterferenceGraphGenerationTests methodsFor: 'Tests' stamp: 'wbk 6/23/2003 13:23'!
testJumpInterferance
	self prepare: #((block 1 (mov 1 t3) (mov 1 t1) (mov 2 t2) (add t1 t2) (jmp block2) ) 
			(block 2 (add t3 t2) ) ).
	allocator buildInterferenceGraph.

	self should:
		[allocator
			interferes: (machine registerNamed: #t3)
			with: (machine registerNamed: #t1)].! !

!InterferenceGraphGenerationTests methodsFor: 'Tests' stamp: 'wbk 6/28/2004 22:42'!
testDoubleRegisterInterferance
	self prepare: #((block 1 (mov 1 t2) (add 1 t2) (mov t2 1)  (mov 1 t4) (mov 1 t3) 
							(add t2 t4) (add t3 t4) (mov t4 1) )).
	allocator buildInterferenceGraph.

	self assert:
		(allocator
			interferes: (machine registerNamed: #t2)
			with: (machine registerNamed: #t3)).
	self assert:
		(allocator
			interferes: (machine registerNamed: #t2)
			with: (machine registerNamed: #t4)).
	self assert:
		(allocator
			interferes: (machine registerNamed: #t3)
			with: (machine registerNamed: #t4)).! !

!InterferenceGraphGenerationTests methodsFor: 'Tests' stamp: 'wbk 1/31/2004 14:41'!
testDivide
	"This test checks that when building the interference graph we add edges from all
	live variables in live-out to both eax and edx Eax and edx are the two registers set in 
	the divide instruction."
	self prepare: #((block 1 
				(div t1)
				(mov eax t2)
				(mov edx t3)
				(add t1 t1))).
	allocator buildInterferenceGraph.
	self should:
		[allocator
			interferes: (machine registerNamed: #t1)
			with: (machine registerNamed: #eax)].
	self should:
		[allocator
			interferes: (machine registerNamed: #t1)
			with: (machine registerNamed: #edx)].
	self shouldnt:
		[allocator
			interferes: (machine registerNamed: #eax)
			with: (machine registerNamed: #t2)].! !

!InterferenceGraphGenerationTests methodsFor: 'Tests' stamp: 'wbk 6/23/2003 13:24'!
testMovFromIndirectRegisterInterferance
	"This test has no register interference but it still needs to allocate registers"
	self prepare: #((block 1 (mov 1 t1) (mov (t1) t2))).
	allocator buildInterferenceGraph.

	"Test the registers are allocated"
	(allocator interferenceNode: (machine registerNamed: #t1)).
	(allocator interferenceNode: (machine registerNamed: #t2)).
	self shouldnt:
		[allocator
			interferes: (machine registerNamed: #t1)
			with: (machine registerNamed: #t2)].! !

!InterferenceGraphGenerationTests methodsFor: 'Verification Methods' stamp: 'wbk 3/13/2003 14:26'!
verifyInterferenceGraph
	allocator interferenceGraph do: 
		[:each| self should: [ each register isRegister]].! !

!InterferenceGraphGenerationTests methodsFor: 'Tests' stamp: 'wbk 7/5/2003 15:49'!
testAddDoesntInterfereWithSelf
	"A register add shouldn't interfer with itself,"
	self prepare: #((block 1 (add 1 t1) (mov (t1) t2))).
	allocator buildInterferenceGraph.

	"Test the registers are allocated"
	(allocator interferenceNode: (machine registerNamed: #t1)).
	(allocator interferenceNode: (machine registerNamed: #t2)).
	self shouldnt:
		[allocator
			interferes: (machine registerNamed: #t1)
			with: (machine registerNamed: #t1)].! !

!InterferenceGraphGenerationTests methodsFor: 'Verification Methods' stamp: 'wbk 3/13/2003 14:26'!
verifyDoesntInterfere: firstString with: secondString
	self shouldnt:
		[allocator
			interferes: (machine registerNamed: firstString)
			with: (machine registerNamed: secondString)].! !

ExuperyTests subclass: #ByteCodeReaderTests
	instanceVariableNames: 'generator method'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Programmer Tests'!

!ByteCodeReaderTests methodsFor: 'Tests - Common Sends' stamp: 'wbk 4/26/2004 23:38'!
testNextPut
	method := ByteCodeReaderTests compiledMethodAt: #sendNextPut.
	generator 
		setExpectedBytecodes: 
			#((returnTop (binarySendWithSpecialSelector 20 (pushConstant abcd ) (pushConstant efgh) ))).
	self execute! !

!ByteCodeReaderTests methodsFor: 'Tests - Stack' stamp: 'wbk 4/26/2004 23:49'!
testStoreAndPopReceiverVariables
	method := ExuperyInstanceVariables compiledMethodAt: #a:.
	generator 
		setExpectedBytecodes: 
			#(	(storeAndPopReceiverVariable 0 (pushTemp 0))
				(returnSelf)  ).
	self execute.! !

!ByteCodeReaderTests methodsFor: 'Tests - Stack' stamp: 'wbk 6/13/2004 10:55'!
testStoreLargeReceiver
	method := ExuperyInstanceVariables compiledMethodAt: #i16:.
	generator 
		setExpectedBytecodes: 
			#((storeAndPopReceiverVariable 15 (pushTemp 0)) (returnSelf)).
	self execute.! !

!ByteCodeReaderTests methodsFor: 'Tests - Stack' stamp: 'wbk 4/26/2004 23:49'!
testPushTemp
	method := ByteCodeReaderTests compiledMethodAt: #pushTemp.
	generator := MockIntermediateGenerator new.
	generator setExpectedBytecodes: #(
		(popIntoTemp 0
			(pushConstant 1))
		(returnSelf)).
	self execute.
	self should: [generator byteCodeString = 'pushConstant 1 popIntoTemp 0 returnSelf']
	! !

!ByteCodeReaderTests methodsFor: 'Tests - Jumps' stamp: 'wbk 4/26/2004 23:50'!
testIfTrueIfFalse
	method := ByteCodeReaderTests compiledMethodAt: #ifTrueIfFalse.
	generator := MockIntermediateGenerator new.
	generator setExpectedBytecodes: #(
		(jumpFalse (sendLessThanEquals (pushConstant 1) (pushConstant 2)) 11) 
		(returnTop (pushConstant 1)) 
		(returnTop (pushConstant 2))).
	self execute.
	self should: [generator byteCodeString = 'pushConstant 1 pushConstant 2 sendLessThanEquals jumpFalse 11 pushConstant 1 returnTop pushConstant 2 returnTop']! !

!ByteCodeReaderTests methodsFor: 'Tests - Jumps' stamp: 'wbk 5/29/2004 23:54'!
nestedIfTrueIfFalse
	^ 1 <= 2
		ifTrue: [10]
		ifFalse: [20].! !

!ByteCodeReaderTests methodsFor: 'Tests - Common Sends' stamp: 'wbk 7/29/2003 11:41'!
atSend
	^ 1 at: 2! !

!ByteCodeReaderTests methodsFor: 'Tests - Stack' stamp: 'wbk 6/13/2004 11:44'!
testLoadLargeReceiver
	method := ExuperyInstanceVariables compiledMethodAt: #i17.
	generator 
		setExpectedBytecodes: 
			#((returnTop (sendPlus (pushInstanceVariable 16) (pushConstant 0)))).
	self execute.! !

!ByteCodeReaderTests methodsFor: 'Misc' stamp: 'wbk 7/4/2003 12:05'!
setUp
	generator := MockIntermediateGenerator new.! !

!ByteCodeReaderTests methodsFor: 'Sample Methods' stamp: 'wbk 7/9/2004 20:48'!
simpleMultiply
	^ 2 * 3! !

!ByteCodeReaderTests methodsFor: 'Tests - Common Sends' stamp: 'wbk 2/22/2004 13:14'!
sendSize
	^ #abcd size! !

!ByteCodeReaderTests methodsFor: 'Tests - Comparision' stamp: 'wbk 1/14/2004 21:16'!
greaterThanEqual
	^ 2 >= 3! !

!ByteCodeReaderTests methodsFor: 'Tests - Comparision' stamp: 'wbk 4/26/2004 23:39'!
testNotEquals
	method := ByteCodeReaderTests compiledMethodAt: #notEquals.
	generator 
		setExpectedBytecodes: 
			#(#(#returnTop #(#notEquals 
				(pushConstant 2) 
				(pushConstant 3) ))).
	self execute! !

!ByteCodeReaderTests methodsFor: 'Tests - Arithmatic' stamp: 'wbk 2/7/2004 20:31'!
mod
	^ 6 \\ 3! !

!ByteCodeReaderTests methodsFor: 'Tests - Stack' stamp: 'wbk 6/13/2004 12:39'!
testStoreLargeTemporary
	method := ExuperyInstanceVariables compiledMethodAt: #storeExtendedTemp.
	generator 
		setExpectedBytecodes: 
			#((popIntoTemp 16 (pushConstant 17)) (returnSelf)).
	self execute.! !

!ByteCodeReaderTests methodsFor: 'Tests - Jumps' stamp: 'wbk 4/26/2004 23:50'!
testLongJumpIfTrue
	method := ByteCodeReaderTests compiledMethodAt: #longJumpIfTrue.
	generator 
		setExpectedBytecodes: 
			#((jumpIfTrue (pushTrue) 16)
			   (returnTop (sendPlus (pushConstant 1) (pushConstant 2)))
				(returnTop (pushConstant 42))).
	self execute.! !

!ByteCodeReaderTests methodsFor: 'Tests - Common Sends' stamp: 'wbk 4/26/2004 23:38'!
testNext
	method := ByteCodeReaderTests compiledMethodAt: #sendNext.
	generator 
		setExpectedBytecodes: 
			#((returnTop (sendUnarySelector 19 (pushConstant abcd )))).
	self execute! !

!ByteCodeReaderTests methodsFor: 'Tests - Common Sends' stamp: 'wbk 4/26/2004 23:37'!
testAtSend
	method := ByteCodeReaderTests compiledMethodAt: #atSend.
	generator checkStackSizeOnSend: 0.
	generator 
		setExpectedBytecodes: #(#(#returnTop #(#sendAt (pushConstant 1) #(pushConstant 2) ))).
	self execute! !

!ByteCodeReaderTests methodsFor: 'Sample Methods' stamp: 'wbk 6/11/2004 21:50'!
recursivefTrueIfFalse
	^ false 
		ifTrue: [5] 
		ifFalse: [false 
			ifTrue: [10]
			ifFalse: [15]]! !

!ByteCodeReaderTests methodsFor: 'Tests - Misc' stamp: 'wbk 4/26/2004 23:46'!
testSetNumberOfTemporaries
	method := ByteCodeReaderTests compiledMethodAt: #methodWithTemporaries.
	generator setExpectedTemporaries: 2.
	self execute.
	self verify! !

!ByteCodeReaderTests methodsFor: 'Tests - Stack Tracing' stamp: 'wbk 4/18/2004 22:20'!
testRegisterJumpTargets
	| compiler |
	compiler := Exupery new 
		initializeMethod: (ByteCodeReaderTests compiledMethodAt: #ifTrueIfFalse)
		functionName: #ifTrueIfFalse.
	compiler generateIntermediate.
	self should: [compiler generator jumpTargets asArray = #(11)].! !

!ByteCodeReaderTests methodsFor: 'Sample Methods' stamp: 'wbk 7/9/2004 20:52'!
returnAddSmallInt
	^ 1 + 2! !

!ByteCodeReaderTests methodsFor: 'Misc' stamp: 'wbk 7/4/2003 12:14'!
verify
	generator verify! !

!ByteCodeReaderTests methodsFor: 'Sample Methods' stamp: 'wbk 3/13/2003 13:49'!
pushTemp
	|a|
	a := 1! !

!ByteCodeReaderTests methodsFor: 'Tests - Jumps' stamp: 'wbk 2/28/2004 15:24'!
shortUnconditionalJump
	^ #bool ifFalse: [^ #success].! !

!ByteCodeReaderTests methodsFor: 'Tests - Stack' stamp: 'wbk 4/26/2004 23:49'!
testPushReceiverVariables
	method := ExuperyInstanceVariables compiledMethodAt: #a.
	generator 
		setExpectedBytecodes: 
			#((returnTop (sendPlus 
				(pushInstanceVariable 0) (pushConstant 0) ))).
	self execute.! !

!ByteCodeReaderTests methodsFor: 'Tests - Stack' stamp: 'wbk 4/26/2004 23:49'!
testReturnFalse
	method := ByteCodeReaderTests compiledMethodAt: #returnFalse.
	generator 
		setExpectedBytecodes: #((returnFalse )).
	self execute.
	self verify.! !

!ByteCodeReaderTests methodsFor: 'Tests - Misc' stamp: 'wbk 4/26/2004 23:45'!
testReadByteCodeNumbers
	method := CompilerToys compiledMethodAt: #simpleMethod2.
	generator := MockIntermediateGenerator new.
	generator recordByteCodeNumbers.
	self execute.
	self should: [generator byteCodeString = 'byteCode 5 pushConstant 1 byteCode 6 pushConstant 2 byteCode 7 sendPlus byteCode 8 returnTop']! !

!ByteCodeReaderTests methodsFor: 'Tests - Comparision' stamp: 'wbk 4/26/2004 23:39'!
testGreaterThanEqual
	method := ByteCodeReaderTests compiledMethodAt: #greaterThanEqual.
	generator 
		setExpectedBytecodes: 
			#(#(#returnTop #(#greaterThanEqual 
				(pushConstant 2) 
				(pushConstant 3) ))).
	self execute! !

!ByteCodeReaderTests methodsFor: 'Tests - Jumps' stamp: 'wbk 3/13/2003 13:48'!
ifTrueIfFalse
	1 <= 2
		ifTrue: [^1]
		ifFalse: [^2].! !

!ByteCodeReaderTests methodsFor: 'Sample Methods' stamp: 'wbk 3/13/2003 13:49'!
return4
	^ 4! !

!ByteCodeReaderTests methodsFor: 'Tests - Arithmatic' stamp: 'wbk 2/5/2004 20:39'!
bitOr
	^ 6 bitOr: 3! !

!ByteCodeReaderTests methodsFor: 'Sample Methods' stamp: 'wbk 7/9/2004 20:51'!
iterativeFactorial: n
	|acc|
	acc := 1.
	1
		to: n
		do: [:each| acc := acc * each].
	^ acc! !

!ByteCodeReaderTests methodsFor: 'Tests - Stack' stamp: 'wbk 6/14/2004 22:43'!
testStoreTempExtendedWithoutPopping
	method := ExuperyInstanceVariables compiledMethodAt: #storeTempExtended2.
	self execute.
	self assert: generator byteCodeString = 'pushTrue jumpFalse 15 pushConstant 15 popIntoTemp 15 jumpTo 16 pushNil returnTop'! !

!ByteCodeReaderTests methodsFor: 'Tests - Common Sends' stamp: 'wbk 4/26/2004 23:38'!
testPointX
	method := ByteCodeReaderTests compiledMethodAt: #sendX.
	generator 
		setExpectedBytecodes: 
			#((returnTop (sendUnarySelector 30 (pushConstant abcd )))).
	self execute! !

!ByteCodeReaderTests methodsFor: 'Sample Methods' stamp: 'wbk 10/4/2003 19:15'!
pushMinusOne
	| a |
	a:= -1.
	^ a! !

!ByteCodeReaderTests methodsFor: 'Tests - Stack Tracing' stamp: 'wbk 4/26/2004 23:54'!
testStackTracking
	method := CompilerToys compiledMethodAt: #simpleMethod2.
	generator := MockIntermediateGenerator new.
	generator setExpectedBytecodes: #(
		(returnTop
			(sendPlus
				(pushConstant 1)
				(pushConstant 2)))).
	self execute.
	self should: [generator primitiveNumber = 0].
	self should: [generator byteCodeString = 'pushConstant 1 pushConstant 2 sendPlus returnTop']! !

!ByteCodeReaderTests methodsFor: 'Tests - Common Sends' stamp: 'wbk 3/1/2004 19:05'!
sendClass
	^ 10 class! !

!ByteCodeReaderTests methodsFor: 'Sample Methods' stamp: 'wbk 7/9/2004 20:45'!
simpleMinus
	^ 2 - 1! !

!ByteCodeReaderTests methodsFor: 'Tests - Common Sends' stamp: 'wbk 2/22/2004 19:32'!
sendAtEnd
	^ #abcd atEnd! !

!ByteCodeReaderTests methodsFor: 'Tests - Comparision' stamp: 'wbk 1/14/2004 21:33'!
equals
	^ 2 = 3! !

!ByteCodeReaderTests methodsFor: 'Tests - Common Sends' stamp: 'wbk 7/31/2003 15:34'!
atPutSend
	^ 1 
		at: 2
		put: 3! !

!ByteCodeReaderTests methodsFor: 'Sample Methods' stamp: 'wbk 7/4/2003 12:27'!
methodWithTemporaries
	| a b | 
	^ a + b! !

!ByteCodeReaderTests methodsFor: 'Sample Methods' stamp: 'wbk 11/27/2003 19:36'!
returnTrue
	'Avoid a quick return primitive'.
	^ true! !

!ByteCodeReaderTests methodsFor: 'Tests - Stack' stamp: 'wbk 4/26/2004 23:48'!
testPushConstantTrue
	method := ByteCodeReaderTests compiledMethodAt: #pushConstantTrue.
	generator 
		setExpectedBytecodes: #((popIntoTemp 0 (pushTrue)) #(#returnTop (pushTemp 0)) ).
	self execute.! !

!ByteCodeReaderTests methodsFor: 'Sample Methods' stamp: 'wbk 7/11/2003 22:26'!
pushLiteralVariable
	^ Array! !

!ByteCodeReaderTests methodsFor: 'Tests - Sends' stamp: 'wbk 6/16/2004 22:31'!
testSendExtended
	method := TestExuperyPlugin compiledMethodAt: #extendedSend.
	generator checkStackSizeOnSend: 0.
	generator 
		setExpectedBytecodes: #(#
			(#popStack #(#send #method1 #(#pushSelf)))
			(#popStack #(#send #method2 #(#pushSelf)))
			(#popStack #(#send #method3 #(#pushSelf)))
			(#popStack #(#send #method4 #(#pushSelf)))
			(#popStack #(#send #method5 #(#pushSelf)))
			(#popStack #(#send #method6 #(#pushSelf)))
			(#popStack #(#send #method7 #(#pushSelf)))
			(#popStack #(#send #method8 #(#pushSelf)))
			(#popStack #(#send #method9 #(#pushSelf)))
			(#popStack #(#send #method10 #(#pushSelf)))
			(#popStack #(#send #method11 #(#pushSelf)))
			(#popStack #(#send #method12 #(#pushSelf)))
			(#popStack #(#send #method13 #(#pushSelf)))
			(#popStack #(#send #method14 #(#pushSelf)))
			(#popStack (#send #method15 #(#pushSelf)))
			(#popStack #(#send #method16 #(#pushSelf)))
			(#returnTop #(#send #method17 #(#pushSelf) ))).
	self execute.! !

!ByteCodeReaderTests methodsFor: 'Tests - Common Sends' stamp: 'wbk 2/27/2004 21:22'!
sendEquivilent
	^ #abcd == #efgh! !

!ByteCodeReaderTests methodsFor: 'Tests - Arithmatic' stamp: 'wbk 7/9/2004 20:49'!
testSimpleMultiply
	method := ByteCodeReaderTests compiledMethodAt: #simpleMultiply.
	generator := MockIntermediateGenerator new.
	generator 
		setExpectedBytecodes: #(#(#returnTop #(#sendMultiply #(#pushConstant 2) #(#pushConstant 3)))).
	self execute.
	"self should: [generator stackString = '(returnTop (sendMultiply (literal 2) (literal 3)))' ]."! !

!ByteCodeReaderTests methodsFor: 'Tests - Common Sends' stamp: 'wbk 4/26/2004 23:38'!
testPointY
	method := ByteCodeReaderTests compiledMethodAt: #sendY.
	generator 
		setExpectedBytecodes: 
			#((returnTop (sendUnarySelector 31 (pushConstant abcd )))).
	self execute! !

!ByteCodeReaderTests methodsFor: 'Tests - Arithmatic' stamp: 'wbk 7/9/2004 20:45'!
testSimpleMinus
	method := ByteCodeReaderTests compiledMethodAt: #simpleMinus.
	generator := MockIntermediateGenerator new.
	generator 
		setExpectedBytecodes: #(#(#returnTop #(#sendMinus #(#pushConstant 2) #(#pushConstant 1)))).
	self execute.! !

!ByteCodeReaderTests methodsFor: 'Tests - Comparision' stamp: 'wbk 1/10/2004 15:56'!
greaterThan
	^ 2 > 3! !

!ByteCodeReaderTests methodsFor: 'Tests - Stack Tracing' stamp: 'wbk 5/31/2004 20:40'!
testStackUpdating
	| reader |
	reader := ByteCodeReader
		newMethod: (ByteCodeReaderTests compiledMethodAt: #return4)
		using: generator
		jumpTargets: #(5)
		stackHeights: #(10).
		
	reader byteCodeAddressing: 5.
	self assert: reader stackHeight = 10.! !

!ByteCodeReaderTests methodsFor: 'Sample Methods' stamp: 'wbk 7/11/2003 11:57'!
pushConstantZero
	" The shuffle through a temporary is so we actually use the push constant zero bytecode
	rather than the fast return 0 primitive"
	|a|
	a := 0.
	^ a! !

!ByteCodeReaderTests methodsFor: 'Tests - Comparision' stamp: 'wbk 3/13/2003 13:48'!
lessThanEquals
	^ 1 <= 2! !

!ByteCodeReaderTests methodsFor: 'Tests - Comparision' stamp: 'wbk 4/26/2004 23:45'!
testLessThanEquals
	method := ByteCodeReaderTests compiledMethodAt: #lessThanEquals.
	generator setExpectedBytecodes: 
		#((returnTop
			(sendLessThanEquals
				(pushConstant 1)
				(pushConstant 2)))).
	self execute.
	self should: 
		[generator byteCodeString = 'pushConstant 1 pushConstant 2 sendLessThanEquals returnTop']
	! !

!ByteCodeReaderTests methodsFor: 'Tests - Arithmatic' stamp: 'wbk 2/4/2004 20:16'!
bitAnd
	^ 6 bitAnd: 3! !

!ByteCodeReaderTests methodsFor: 'Tests - Stack' stamp: 'wbk 4/26/2004 23:49'!
testPushNil
	method := ByteCodeReaderTests compiledMethodAt: #pushNil.
	generator 
		setExpectedBytecodes: #((popIntoTemp 0 (pushNil)) #(#returnTop (pushTemp 0)) ).
	self execute.! !

!ByteCodeReaderTests methodsFor: 'Tests - Arithmatic' stamp: 'wbk 4/26/2004 23:47'!
testBitShift
	method := ByteCodeReaderTests compiledMethodAt: #bitShift.
	generator 
		setExpectedBytecodes: 
			#((returnTop (bitShift (pushConstant 6) (pushConstant 3)))).
	self execute.! !

!ByteCodeReaderTests methodsFor: 'Tests - Common Sends' stamp: 'wbk 4/26/2004 23:47'!
testAtEnd
	method := ByteCodeReaderTests compiledMethodAt: #sendAtEnd.
	generator setExpectedBytecodes: #(#(#returnTop #(#sendUnarySelector 21 #(#pushConstant #abcd)))).
	self execute.! !

!ByteCodeReaderTests methodsFor: 'Tests - Comparision' stamp: 'wbk 1/17/2004 18:57'!
notEquals
	^ 2 ~= 3! !

!ByteCodeReaderTests methodsFor: 'Tests - Stack' stamp: 'wbk 4/26/2004 23:48'!
testPopStack
	method := ByteCodeReaderTests compiledMethodAt: #popStack.
	generator 
		setExpectedBytecodes: #( (popStack (send add (pushConstant 1))) #(#returnSelf)).
	self execute.! !

!ByteCodeReaderTests methodsFor: 'Tests - Arithmatic' stamp: 'wbk 4/26/2004 23:47'!
testDivide
	method := ByteCodeReaderTests compiledMethodAt: #divide.
	generator 
		setExpectedBytecodes: 
			#((returnTop (divide (pushConstant 6) (pushConstant 3)))).
	self execute.! !

!ByteCodeReaderTests methodsFor: 'Tests - Stack' stamp: 'wbk 4/26/2004 23:48'!
testPushConstantZero
	method := ByteCodeReaderTests compiledMethodAt: #pushConstantZero.
	generator 
		setExpectedBytecodes: #( (popIntoTemp 0 (pushConstant 0)) #(#returnTop (pushTemp 0))).
	self execute.! !

!ByteCodeReaderTests methodsFor: 'Tests - Common Sends' stamp: 'wbk 4/26/2004 23:38'!
testEquivilent
	method := ByteCodeReaderTests compiledMethodAt: #sendEquivilent.
	generator 
		setExpectedBytecodes: 
			#((returnTop (equivilent (pushConstant abcd ) (pushConstant efgh) ))).
	self execute! !

!ByteCodeReaderTests methodsFor: 'Tests - Stack' stamp: 'wbk 4/26/2004 23:49'!
testReturnNil
	method := ByteCodeReaderTests compiledMethodAt: #returnNil.
	generator 
		setExpectedBytecodes: #((returnNil )).
	self execute.
	self verify.! !

!ByteCodeReaderTests methodsFor: 'Tests - Common Sends' stamp: 'wbk 7/14/2003 07:21'!
bytecodePrimSendWithArg
	^ 4 new: 5! !

!ByteCodeReaderTests methodsFor: 'Sample Methods' stamp: 'wbk 10/18/2003 12:51'!
returnNil
	'Avoid a quick return primitive'.
	^ nil! !

!ByteCodeReaderTests methodsFor: 'Tests - Comparision' stamp: 'wbk 4/26/2004 23:39'!
testGreaterThan
	method := ByteCodeReaderTests compiledMethodAt: #greaterThan.
	generator 
		setExpectedBytecodes: 
			#(#(#returnTop #(#greaterThan 
				(pushConstant 2) 
				(pushConstant 3) ))).
	self execute! !

!ByteCodeReaderTests methodsFor: 'Tests - Arithmatic' stamp: 'wbk 1/18/2004 17:21'!
divide
	^ 6 / 3! !

!ByteCodeReaderTests methodsFor: 'Tests - Stack Tracing' stamp: 'wbk 5/30/2004 23:08'!
testRegisterNestedStackTracing
	| compiler reader |
	compiler := Exupery new 
		initializeMethod: (ByteCodeReaderTests compiledMethodAt: #nestedIfTrueIfFalse)
		functionName: #ifTrueIfFalse.
	reader := compiler generateIntermediate.
	self should: [reader stackHeights asArray = #(0 1)].! !

!ByteCodeReaderTests methodsFor: 'Tests - Arithmatic' stamp: 'wbk 4/26/2004 23:47'!
testBitAnd
	method := ByteCodeReaderTests compiledMethodAt: #bitOr.
	generator 
		setExpectedBytecodes: 
			#((returnTop (bitOr (pushConstant 6) (pushConstant 3)))).
	self execute.! !

!ByteCodeReaderTests methodsFor: 'Tests - Comparision' stamp: 'wbk 1/6/2004 22:39'!
lessThan
	^ 2 < 3! !

!ByteCodeReaderTests methodsFor: 'Tests - Common Sends' stamp: 'wbk 4/26/2004 23:38'!
testClass
	method := ByteCodeReaderTests compiledMethodAt: #sendClass.
	generator 
		setExpectedBytecodes: 
			#((returnTop (class (pushConstant 10 )))).
	self execute! !

!ByteCodeReaderTests methodsFor: 'Tests - Jumps' stamp: 'wbk 2/13/2004 23:45'!
longJumpIfTrue
	true ifFalse:
		[^ 1+2.].
	^ 42! !

!ByteCodeReaderTests methodsFor: 'Sample Methods' stamp: 'wbk 11/27/2003 21:16'!
returnFalse
	'Avoid a quick return primitive'.
	^ false! !

!ByteCodeReaderTests methodsFor: 'Sample Methods' stamp: 'wbk 10/4/2003 19:29'!
pushFalse
	| a |
	a := false.
	^ a! !

!ByteCodeReaderTests methodsFor: 'Tests - Common Sends' stamp: 'wbk 2/22/2004 16:34'!
sendNextPut
	^ #abcd nextPut: #efgh! !

!ByteCodeReaderTests methodsFor: 'Tests - Sends' stamp: 'wbk 4/26/2004 23:50'!
testSendBasic
	method := ByteCodeReaderTests compiledMethodAt: #basicSend.
	generator checkStackSizeOnSend: 0.
	generator 
		setExpectedBytecodes: #(#(#returnTop #(#send #basicTarget #(#pushSelf) ))).
	self execute.! !

!ByteCodeReaderTests methodsFor: 'Tests - Common Sends' stamp: 'wbk 4/26/2004 23:38'!
testBytecodePrimSendWithArg
	method := ByteCodeReaderTests compiledMethodAt: #bytecodePrimSendWithArg.
	generator checkStackSizeOnSend: 0.
	generator setExpectedBytecodes: 
		#(#(#returnTop 
			#(#binarySendWithSpecialSelector 29 
			#(#pushConstant 4) 
			#(#pushConstant 5)))).
	self execute! !

!ByteCodeReaderTests methodsFor: 'Tests - Stack Tracing' stamp: 'wbk 5/31/2004 20:44'!
testStackUpdating2
	| reader |
	reader := ByteCodeReader
		newMethod: (ByteCodeReaderTests compiledMethodAt: #return4)
		using: generator
		jumpTargets: #(2 4 6)
		stackHeights: #(20 40 30).
		
	reader byteCodeAddressing: 2.
	self assert: reader stackHeight = 20.
	
	reader byteCodeAddressing: 3.
	self assert: reader stackHeight = 20.
	
	reader byteCodeAddressing: 4.
	self assert: reader stackHeight = 40.
	
	reader byteCodeAddressing: 6.
	self assert: reader stackHeight = 30! !

!ByteCodeReaderTests methodsFor: 'Tests - Jumps' stamp: 'wbk 4/26/2004 23:50'!
testShortUnconditionalJump
	method := ByteCodeReaderTests compiledMethodAt: #shortUnconditionalJump.
	"The following is commented out because this method does not follow stack discipline strictly
	enough for the mock based tester"
	"generator 
		setExpectedBytecodes: 
			#((jumpFalse (pushConstant bool) 17)
			  (pushNil)
				(jumpTo 19)
			   (returnTop (pushConstant #success))
				(returnTop (pushNil) ))."
	self execute.
	self assert: generator byteCodeString = 'pushConstant bool jumpFalse 17 pushNil jumpTo 19 pushConstant success returnTop returnTop'
! !

!ByteCodeReaderTests methodsFor: 'Tests - Misc' stamp: 'wbk 4/26/2004 23:56'!
testSimpleMethod
	method := CompilerToys compiledMethodAt: #simpleMethod.
	generator := MockIntermediateGenerator new.
	self execute.
	self should: [generator numberOfBytecodes = 0].
	self should: [generator primitiveNumber = 262].
	! !

!ByteCodeReaderTests methodsFor: 'Tests - Arithmatic' stamp: 'wbk 4/26/2004 23:47'!
testDiv
	method := ByteCodeReaderTests compiledMethodAt: #div.
	generator 
		setExpectedBytecodes: 
			#((returnTop (div (pushConstant 6) (pushConstant 3)))).
	self execute.! !

!ByteCodeReaderTests methodsFor: 'Tests - Comparision' stamp: 'wbk 4/26/2004 23:39'!
testLessThan
	method := ByteCodeReaderTests compiledMethodAt: #lessThan.
	generator 
		setExpectedBytecodes:
			#((returnTop (lessThan 
				(pushConstant 2) 
				(pushConstant 3) ))).
	self execute! !

!ByteCodeReaderTests methodsFor: 'Tests - Common Sends' stamp: 'wbk 4/26/2004 23:38'!
testNew
	method := ByteCodeReaderTests compiledMethodAt: #sendNew.
	generator 
		setExpectedBytecodes: 
			#((returnTop (sendUnarySelector 28 (pushLiteralVariable 0 )))).
	self execute! !

!ByteCodeReaderTests methodsFor: 'Tests - Stack' stamp: 'wbk 6/13/2004 12:37'!
testLoadLargeTemporary
	method := ExuperyInstanceVariables compiledMethodAt: #loadExtendedTemp.
	generator 
		setExpectedBytecodes: 
			#((returnTop (pushTemp 16))).
	self execute.! !

!ByteCodeReaderTests methodsFor: 'Tests - Sends' stamp: 'wbk 4/26/2004 23:51'!
testSendStringConcatenate
	method := ByteCodeReaderTests compiledMethodAt: #stringConcatenate.
	generator 
		setExpectedBytecodes: #(#(#returnTop #(#send #, (pushConstant #abc) (pushConstant #def) ))).
	self execute.! !

!ByteCodeReaderTests methodsFor: 'Sample Methods' stamp: 'wbk 10/4/2003 19:29'!
pushNil
	| a |
	a := nil.
	^ a! !

!ByteCodeReaderTests methodsFor: 'Tests - Misc' stamp: 'wbk 4/26/2004 23:46'!
testSimpleMethod2
	method := CompilerToys compiledMethodAt: #simpleMethod2.
	generator := MockIntermediateGenerator new.
	generator setExpectedBytecodes: #(
		(returnTop
			(sendPlus
				(pushConstant 1)
				(pushConstant 2)))).
	self execute.
	self should: [generator numberOfBytecodes = 4].
	self should: [generator primitiveNumber = 0].
	self should: [generator byteCodeString = 'pushConstant 1 pushConstant 2 sendPlus returnTop']! !

!ByteCodeReaderTests methodsFor: 'Sample Methods' stamp: 'wbk 7/31/2003 16:37'!
popStack
	1 add.! !

!ByteCodeReaderTests methodsFor: 'Sample Methods' stamp: 'wbk 4/18/2003 22:45'!
returnString
	^ 'Test String'! !

!ByteCodeReaderTests methodsFor: 'Sample Methods' stamp: 'wbk 10/3/2003 23:01'!
storeAndPopReceiverVariable
	"This method is just a test. It should never be called."
	generator := 10! !

!ByteCodeReaderTests methodsFor: 'Tests - Stack Tracing' stamp: 'wbk 6/14/2004 21:19'!
testExtendedStoreStackTracing
	| compiler reader |
	compiler := Exupery new 
		initializeMethod: (ExuperyInstanceVariables  compiledMethodAt: #storeInstanceExtended2)
		functionName: #tstoreInstanceExtended2.
	reader := compiler generateIntermediate.
	self assert: reader stackHeights asArray = #(0 1).
	self assert: compiler generator jumpTargets asArray = #(15 16).! !

!ByteCodeReaderTests methodsFor: 'Tests - Common Sends' stamp: 'wbk 2/14/2004 15:10'!
sendNew
	^ Array new! !

!ByteCodeReaderTests methodsFor: 'Tests - Arithmatic' stamp: 'wbk 2/8/2004 18:55'!
bitShift
	^ 6 bitShift: 3! !

!ByteCodeReaderTests methodsFor: 'Tests - Sends' stamp: 'wbk 4/18/2003 22:05'!
basicSend
	^ self basicTarget! !

!ByteCodeReaderTests methodsFor: 'Tests - Misc' stamp: 'wbk 5/30/2004 22:43'!
testGenerateProlog
	| emitter |
	generator := IntermediateGenerator 
		for: MachineX86 new
		jumpTargets: #().
	emitter := MockIntermediateEmitter new.
	generator emitter: emitter.
	method := (ByteCodeReaderTests compiledMethodAt: #stringConcatenate).

	self execute.

	self assert: emitter hasCreatedProlog.! !

!ByteCodeReaderTests methodsFor: 'Tests - Stack' stamp: 'wbk 4/26/2004 23:49'!
testPushTemporaryVariable
	method := ByteCodeReaderTests compiledMethodAt: #pushTemporary.
	generator := MockIntermediateGenerator new.
	generator setExpectedBytecodes: #(
		(returnTop
			(pushTemp 0))).
	self execute.
	self should: [generator byteCodeString = 'pushTemp 0 returnTop']! !

!ByteCodeReaderTests methodsFor: 'Tests - Common Sends' stamp: 'wbk 2/22/2004 15:05'!
sendNext
	^ #abcd next! !

!ByteCodeReaderTests methodsFor: 'Tests - Common Sends' stamp: 'wbk 4/26/2004 23:38'!
testSize
	method := ByteCodeReaderTests compiledMethodAt: #sendSize.
	generator 
		setExpectedBytecodes: 
			#((returnTop (sendUnarySelector 18 (pushConstant abcd )))).
	self execute! !

!ByteCodeReaderTests methodsFor: 'Tests - Stack' stamp: 'wbk 4/26/2004 23:48'!
testPushLiteralVariable
	method := ByteCodeReaderTests compiledMethodAt: #pushLiteralVariable.
	generator 
		setExpectedBytecodes: #( (returnTop (pushLiteralVariable 0)) ).
	self execute.! !

!ByteCodeReaderTests methodsFor: 'Tests - Common Sends' stamp: 'wbk 2/28/2004 17:43'!
sendY
	^ #abcd y! !

!ByteCodeReaderTests methodsFor: 'Sample Methods' stamp: 'wbk 7/19/2003 21:11'!
pushConstantTrue
	| a |
	a:=  true.
	^ a! !

!ByteCodeReaderTests methodsFor: 'Sample Methods' stamp: 'wbk 3/13/2003 13:49'!
pushTemporary
	|a|
	^ a! !

!ByteCodeReaderTests methodsFor: 'Tests - Common Sends' stamp: 'wbk 4/26/2004 23:38'!
testMakePoint
	method := ByteCodeReaderTests compiledMethodAt: #makePoint.
	generator 
		setExpectedBytecodes: 
			#((returnTop (makePoint (pushConstant 6) (pushConstant 3)))).
	self execute! !

!ByteCodeReaderTests methodsFor: 'Sample Methods' stamp: 'wbk 7/2/2003 11:25'!
stringConcatenate
	^ 'abc', 'def'! !

!ByteCodeReaderTests methodsFor: 'Tests - Common Sends' stamp: 'wbk 2/13/2004 19:07'!
makePoint
	^ 6 @ 3! !

!ByteCodeReaderTests methodsFor: 'Tests - Stack Tracing' stamp: 'wbk 5/30/2004 23:01'!
testRegisterStackTracing
	| compiler reader |
	compiler := Exupery new 
		initializeMethod: (ByteCodeReaderTests compiledMethodAt: #ifTrueIfFalse)
		functionName: #ifTrueIfFalse.
	reader := compiler generateIntermediate.
	self should: [reader stackHeights asArray = #(0)].! !

!ByteCodeReaderTests methodsFor: 'Tests - Stack' stamp: 'wbk 4/26/2004 23:48'!
testPushConstantMinusOne
	method := ByteCodeReaderTests compiledMethodAt: #pushMinusOne.
	generator 
		setExpectedBytecodes: #( (popIntoTemp 0 (pushConstant -1)) #(#returnTop (pushTemp 0)) ).
	self execute.! !

!ByteCodeReaderTests methodsFor: 'Tests - Common Sends' stamp: 'wbk 2/28/2004 17:39'!
sendX
	^ #abcd x! !

!ByteCodeReaderTests methodsFor: 'Tests - Stack' stamp: 'wbk 6/14/2004 22:35'!
testStoreInstanceExtendedWithoutPopping
	method := ExuperyInstanceVariables compiledMethodAt: #storeInstanceExtended.
	self execute.
	self assert: generator byteCodeString = 'pushTrue jumpFalse 15 pushConstant 10 storeIntoReceiver 15 jumpTo 16 pushNil returnTop'! !

!ByteCodeReaderTests methodsFor: 'Tests - Arithmatic' stamp: 'wbk 2/5/2004 22:03'!
div
	^ 6 // 3! !

!ByteCodeReaderTests methodsFor: 'Tests - Common Sends' stamp: 'wbk 4/26/2004 23:37'!
testAtPutSend
	method := ByteCodeReaderTests compiledMethodAt: #atPutSend.
	generator checkStackSizeOnSend: 0.
	generator 
		setExpectedBytecodes: #(#(#returnTop #(#sendAtPut (pushConstant 1) #(pushConstant 2) (pushConstant 3)))).
	self execute! !

!ByteCodeReaderTests methodsFor: 'Tests - Comparision' stamp: 'wbk 4/26/2004 23:39'!
testEquals
	method := ByteCodeReaderTests compiledMethodAt: #equals.
	generator 
		setExpectedBytecodes: 
			#(#(#returnTop #(#equals 
				(pushConstant 2) 
				(pushConstant 3) ))).
	self execute! !

!ByteCodeReaderTests methodsFor: 'Tests - Stack' stamp: 'wbk 4/26/2004 23:48'!
testPushFalse
	method := ByteCodeReaderTests compiledMethodAt: #pushFalse.
	generator 
		setExpectedBytecodes: #((popIntoTemp 0 (pushFalse)) #(#returnTop (pushTemp 0)) ).
	self execute.! !

!ByteCodeReaderTests methodsFor: 'Misc' stamp: 'wbk 4/26/2004 23:43'!
execute
	ByteCodeReader 
		newMethod: method
		using: generator
		stack: (TestExuperyStack 
			newPC: method initialPC
			emitter: nil)! !

!ByteCodeReaderTests methodsFor: 'Tests - Arithmatic' stamp: 'wbk 4/26/2004 23:47'!
testMod
	method := ByteCodeReaderTests compiledMethodAt: #mod.
	generator 
		setExpectedBytecodes: 
			#((returnTop (mod (pushConstant 6) (pushConstant 3)))).
	self execute.! !

!ByteCodeReaderTests methodsFor: 'Tests - Stack' stamp: 'wbk 4/26/2004 23:49'!
testReturnTrue
	method := ByteCodeReaderTests compiledMethodAt: #returnTrue.
	generator 
		setExpectedBytecodes: #((returnTrue )).
	self execute.
	self verify.! !

ExuperyTests subclass: #TestEndToEnd
	instanceVariableNames: 'source analyser'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Programmer Tests'!

!TestEndToEnd methodsFor: 'Tests' stamp: 'wbk 4/18/2004 22:20'!
testStringConcatenate
	"An end to end test to make sure all the compiler stages hang together"
	Exupery 
		compileMethod: (TestEndToEnd compiledMethodAt: #stringConcatentate).! !

!TestEndToEnd methodsFor: 'Sample Methods' stamp: 'wbk 7/2/2003 12:20'!
stringConcatentate
	^ 'abc', 'def'! !

!TestEndToEnd methodsFor: 'Tests' stamp: 'wbk 4/23/2004 19:16'!
testBenchFib
	"This method is causing a register allocator bug. It fails to compile."
	Exupery 
		compileMethod: (Integer compiledMethodAt: #benchFib).! !

ExuperyTests subclass: #LatticeTests
	instanceVariableNames: 'machine interferenceGraph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Programmer Tests'!

!LatticeTests methodsFor: 'Basic Tests' stamp: 'wbk 6/27/2004 22:20'!
testAddTwoNode2
	| lattice node1 node2 |
	lattice := self newLattice.
	node1 := self newNode: #t1.
	node2 := self newNode: #t2.
	self assert: (lattice includesNode: node1) not.
	lattice addNode: node1.
	self assert: (lattice includesNode: node1).
	self assert: (lattice includesNode: node2) not.
	lattice addNode: node2.
	self assert: (lattice includesNode: node1).
	self assert: (lattice includesNode: node2).! !

!LatticeTests methodsFor: 'Basic Tests' stamp: 'wbk 6/28/2004 23:05'!
testAddNodeTwice
	| lattice node1 |
	lattice := self newLattice.
	node1 := self newNode: #t1.
	self assert: (lattice includesNode: node1) not.
	lattice addNode: node1.
	self assert: (lattice includesNode: node1).
	lattice addNode: node1.
	self assert: (lattice includesNode: node1).! !

!LatticeTests methodsFor: 'Basic Tests' stamp: 'wbk 7/1/2004 21:31'!
testAdd
	| lattice node1 node2 lattice2 answer |
	lattice := self newLattice.
	lattice2 := self newLattice.
	node1 := self newNode: #t1.
	node2 := self newNode: #t2.
	lattice addNode: node1.
	lattice2 addNode: node2.
	
	answer := lattice + lattice2.
		
	self assert: (answer asSet includes: node1).
	self assert: (answer asSet includes: node2).
	self assert: answer asSet size = 2.! !

!LatticeTests methodsFor: 'Basic Tests' stamp: 'wbk 6/27/2004 22:41'!
testCreatingTemporaries
	| lattice node1 node2 |
	lattice := self newLattice.
	node1 := machine createTemporaryRegister.
	node2 := machine createTemporaryRegister.
	self assert: (lattice includesNode: node1) not.
	lattice addNode: node1.
	self assert: (lattice includesNode: node1).
	self assert: (lattice includesNode: node2) not.
	lattice addNode: node2.
	self assert: (lattice includesNode: node1).
	self assert: (lattice includesNode: node2).! !

!LatticeTests methodsFor: 'Misc' stamp: 'wbk 7/8/2004 19:47'!
newNode: aSymbol 
	| register answer |
	register := machine registerNamed: aSymbol.
	answer := InterferenceNode 
				for: register
				with: machine
				interferenceGraph: #().
	interferenceGraph 
		at: register
		put: answer.
	^answer! !

!LatticeTests methodsFor: 'Basic Tests' stamp: 'wbk 7/1/2004 20:48'!
testNodesDo
	| lattice node1 node2 answer |
	lattice := self newLattice.
	node1 := machine createTemporaryRegister.
	node2 := machine createTemporaryRegister.
	interferenceGraph
		at: node1
		put: node1.
	interferenceGraph
		at: node2
		put: node2.
	answer := OrderedCollection new.

	lattice addNode: node1.
	lattice addNode: node2.
	
	lattice nodesDo: [:each| answer add: each].	
	self assert: (answer includes: node1).
	self assert: (answer includes: node2).! !

!LatticeTests methodsFor: 'Basic Tests' stamp: 'wbk 6/28/2004 22:22'!
testAsSet
	| lattice |
	lattice := self newLattice.	
	self assert: lattice asSet class = Set.
	self assert: lattice asSet isEmpty.! !

!LatticeTests methodsFor: 'Misc' stamp: 'wbk 7/1/2004 20:43'!
setUp
	machine := MachineX86 new.
	interferenceGraph := Dictionary new.! !

!LatticeTests methodsFor: 'Basic Tests' stamp: 'wbk 6/28/2004 23:12'!
testAsSet2
	| lattice node1 node2 |
	lattice := self newLattice.
	node1 := self newNode: #t1.
	node2 := self newNode: #t2.
	lattice addNode: node1.
	lattice addNode: node2.
		
	self assert: (lattice asSet includes: node1).
	self assert: (lattice asSet includes: node2).
	self assert: lattice asSet size = 2.! !

!LatticeTests methodsFor: 'Misc' stamp: 'wbk 7/8/2004 21:50'!
newLattice
	^NodeLattice new! !

!LatticeTests methodsFor: 'Basic Tests' stamp: 'wbk 6/27/2004 21:51'!
testAddNode
	| lattice node1 |
	lattice := self newLattice.
	node1 := self newNode: #t1.
	self assert: (lattice includesNode: node1) not.
	lattice addNode: node1.
	self assert: (lattice includesNode: node1)! !

!LatticeTests methodsFor: 'Basic Tests' stamp: 'wbk 6/27/2004 22:43'!
testCreatingStackRegisters
	| lattice node1 node2 |
	lattice := self newLattice.
	node1 := machine stackRegister: 1.
	node2 := machine stackRegister: 2.
	self assert: (lattice includesNode: node1) not.
	lattice addNode: node1.
	self assert: (lattice includesNode: node1).
	self assert: (lattice includesNode: node2) not.
	lattice addNode: node2.
	self assert: (lattice includesNode: node1).
	self assert: (lattice includesNode: node2).! !

!ExuperyTests methodsFor: 'Checking Methods' stamp: 'wbk 3/13/2003 13:47'!
stringShould: aString contain: aSubString
	self should: 
		[(aString 
			indexOfSubCollection: aSubString
			startingAt: 1) ~= 0]! !

ExuperyTests subclass: #LivenessAnalysisTests
	instanceVariableNames: 'source analyser'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Programmer Tests'!

!LivenessAnalysisTests methodsFor: 'Tests' stamp: 'wbk 4/11/2003 12:55'!
testMultipleStatementLivenessAnalysis
	source := MedMethod 
		createAssembly: #((block 1 (add esp t1) (add t2 t3) ))
		for: MachineX86 new.
	analyser := LivenessAnalyser on: source.
	self should: 
		[analyser 
			isLive: #(esp t1 t2 t3)
			at: 1].
	self should: 
		[analyser 
			isLive: #( t2 t3)
			at: 2].! !

!LivenessAnalysisTests methodsFor: 'Tests' stamp: 'wbk 4/11/2003 12:54'!
testIndirectAddressLivenessAnalysis
	source := MedMethod 
		createAssembly: #((block 1 (mov t1 (t2))))
		for: MachineX86 new.
	analyser := LivenessAnalyser on: source.
	self should: 
		[analyser 
			isLive: #(t1 t2)
			at: 1].! !

!LivenessAnalysisTests methodsFor: 'Tests' stamp: 'wbk 2/9/2004 20:13'!
testNeg
	source := MedMethod 
		createAssembly: 
			#((block 1
				(add t2 t2) 
				(neg t2)
				(mov t3 t4)
				))
		for: MachineX86 new.
	analyser := LivenessAnalyser on: source.
	self assert: 
		(analyser 
			isLive: #(t2 t3)
			at: 2).! !

!LivenessAnalysisTests methodsFor: 'Tests' stamp: 'wbk 7/5/2003 14:42'!
testCallRegister
	source := MedMethod 
		createAssembly: #((block 1 (call t1)))
		for: MachineX86 new.
	analyser := LivenessAnalyser on: source.
	self should: 
		[analyser 
			isLive: #(t1)
			at: 1].! !

!LivenessAnalysisTests methodsFor: 'Tests' stamp: 'wbk 6/23/2003 10:43'!
testCall
	source := MedMethod 
		createAssembly: #((block 1 (call 1234)))
		for: MachineX86 new.
	analyser := LivenessAnalyser on: source.
	self should: 
		[analyser 
			isLive: #()
			at: 1].! !

!LivenessAnalysisTests methodsFor: 'Tests' stamp: 'wbk 4/11/2003 12:55'!
testMultipleStatementMovLivenessAnalysis
	source := MedMethod 
		createAssembly: #((block 1 (mov t1 t2) (add t2 t3) ))
		for: MachineX86 new.
	analyser := LivenessAnalyser on: source.
	self should: 
		[analyser 
			isLive: #(t1 t3)
			at: 1].
	self should: 
		[analyser 
			isLive: #( t2 t3)
			at: 2].! !

!LivenessAnalysisTests methodsFor: 'Tests' stamp: 'wbk 4/11/2003 12:54'!
testIndirectAddress2LivenessAnalysis
	source := MedMethod 
		createAssembly: #((block 1 (mov (t1) (t2))))
		for: MachineX86 new.
	analyser := LivenessAnalyser on: source.
	self should: 
		[analyser 
			isLive: #(t1 t2)
			at: 1].! !

!LivenessAnalysisTests methodsFor: 'Tests' stamp: 'wbk 4/11/2003 12:54'!
testIndirectAddressWithArithmaticExpressionLivenessAnalysis
	source := MedMethod 
		createAssembly: #((block 1 (add (t1) (t2))))
		for: MachineX86 new.
	analyser := LivenessAnalyser on: source.
	self should: 
		[analyser 
			isLive: #(t1 t2)
			at: 1].! !

!LivenessAnalysisTests methodsFor: 'Tests' stamp: 'wbk 4/11/2003 12:54'!
testJumpLoopLivenessAnalysis
	source := MedMethod 
		createAssembly: #((block 1 (add t1 t3) (add t2 t3) (mov 1 t1) (mov 1 t2) (mov 1 t3) (jo block1)  )
			(block 2 ))
		for: MachineX86 new.
	analyser := LivenessAnalyser on: source.
	self should: 
		[analyser 
			isLive: #(t1 t2 t3)
			at: 6].
	self should: 
		[analyser 
			isLive: #(t1 t2 t3)
			at: 1].! !

!LivenessAnalysisTests methodsFor: 'Tests' stamp: 'wbk 6/23/2003 11:44'!
testPush
	source := MedMethod 
		createAssembly: #((block 1 (push t1)))
		for: MachineX86 new.
	analyser := LivenessAnalyser on: source.
	self should: 
		[analyser 
			isLive: #(t1)
			at: 1].! !

!LivenessAnalysisTests methodsFor: 'Tests' stamp: 'wbk 1/29/2004 22:09'!
testDivide
	source := MedMethod 
		createAssembly: 
			#((block 1 
				(mov 12 eax)
				(mov 0 edx)
				(div t1)
				(mov eax t2)
				(mov edx t3)
				(add t2 t3)))
		for: MachineX86 new.
	analyser := LivenessAnalyser on: source.
	self assert: 
		(analyser 
			isLive: #(t1)
			at: 1).
	self assert:
		(analyser
			isLive: #(eax edx t1)
			at: 3).! !

!LivenessAnalysisTests methodsFor: 'Tests' stamp: 'wbk 4/11/2003 12:54'!
testMovInstructionLivenessAnalysis
	source := MedMethod 
		createAssembly: #((block 1 (mov t1 t2)))
		for: MachineX86 new.
	analyser := LivenessAnalyser on: source.
	self should: 
		[analyser 
			isLive: #(t1)
			at: 1].! !

!LivenessAnalysisTests methodsFor: 'Tests' stamp: 'wbk 4/11/2003 12:55'!
testSingeBlockLivenessAnalysis
	source := MedMethod 
		createAssembly: #((block 1 
			(mov 5 t1)
			(add 6 t1)
			(mov 7 t2)
			(add t2 t1)
			(mov 10 t3)
			(add 11 t3) ))
		for: MachineX86 new.
	analyser := LivenessAnalyser on: source.

	self should: 
		[analyser 
			isLive: #()
			at: 1].
	self should:
		[analyser
			isLive: #()
			at: 5].! !

!LivenessAnalysisTests methodsFor: 'Tests' stamp: 'wbk 1/31/2004 21:16'!
testCdq
	source := MedMethod 
		createAssembly: 
			#((block 1 
				(cdq)
				(add edx edx)
				))
		for: MachineX86 new.
	analyser := LivenessAnalyser on: source.
	self assert: 
		(analyser 
			isLive: #(eax)
			at: 1).! !

!LivenessAnalysisTests methodsFor: 'Tests' stamp: 'wbk 4/11/2003 12:54'!
testBasicLivenessAnalysis
	source := MedMethod 
		createAssembly: #((block 1 (add esp t1)))
		for: MachineX86 new.
	analyser := LivenessAnalyser on: source.
	self should: 
		[analyser 
			isLive: #(esp t1)
			at: 1].! !

!LivenessAnalysisTests methodsFor: 'Tests' stamp: 'wbk 4/11/2003 12:54'!
testJumpLivenessAnalysis
	source := MedMethod 
		createAssembly: #((block 1 (mov 1 t1) (mov 1 t2) (mov 1 t3) (jo block2) (add t1 t3) )
			(block 2 (add t2 t3) ))
		for: MachineX86 new.
	analyser := LivenessAnalyser on: source.
	self should: 
		[analyser 
			isLive: #(t1 t2 t3)
			at: 4].! !

!LivenessAnalysisTests methodsFor: 'Support' stamp: 'wbk 4/11/2003 09:47'!
verify
	source instructionsDo: 
		[:each| each in do: [:eachRegister| self assert: eachRegister isRegister ].
		each out do: [:eachRegister| self assert: eachRegister isRegister]]! !

!LivenessAnalysisTests methodsFor: 'Tests' stamp: 'wbk 4/11/2003 12:55'!
testNestedLoopLivenessAnalysis
	source := MedMethod 
		createAssembly: #(  (block 1 (mov 1 t6) (add t4 t6) (add t5 t6) (jmp block2) )
							(block 2 (add t1 t3) (add t2 t3) (mov 1 t1) (mov 1 t2) (mov 1 t3) 
								(jo block2)  )
							(block 3 (mov 1 t4)  (mov 1 t5) (jmp block1) ))
		for: MachineX86 new.
	analyser := LivenessAnalyser on: source.
	self should: 
		[analyser 
			isLive: #(t1 t2 t3 t4 t5)
			block: 1
			at: 1].
	self should: 
		[analyser 
			isLive: #(t1 t2 t3)
			block: 1
			at: 4].
	self should: 
		[analyser 
			isLive: #(t1 t2 t3)
			block: 2
			at: 6].
	self should: 
		[analyser 
			isLive: #(t1 t2 t3)
			block: 2
			at: 1].
	self should: 
		[analyser 
			isLive: #(t1 t2 t3)
			block: 3
			at: 1].
	self should: 
		[analyser 
			isLive: #(t1 t2 t3 t4 t5)
			block: 3
			at: 3].! !

ExuperyTests subclass: #InstructionSelectionTests
	instanceVariableNames: 'selector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Programmer Tests'!

!InstructionSelectionTests methodsFor: 'Tests - Arithmatic' stamp: 'wbk 2/9/2004 21:04'!
testNegRegister2
	selector := self selectInstructions: #((block 1 (mov (neg t1) t2) )).
	self should: [selector writtenResult = #((block 1 (mov t1 t3) (neg t3) (mov t3 t2) ))].
	self verifySelector.! !

!InstructionSelectionTests methodsFor: 'Tests' stamp: 'wbk 2/9/2004 21:04'!
testMovSelectsMovClass
	selector := self selectInstructions: #((block 1 (mov 1 t1) )).
	self should: [selector writtenResult = #((block 1 (mov 1 t1) ))].
	self should: 
		[(selector result 
			blockAt: 1
			instructionAt: 1) class = MedMov].
	self verifySelector.! !

!InstructionSelectionTests methodsFor: 'Tests - Arithmatic' stamp: 'wbk 2/9/2004 21:04'!
testNegRegister
	selector := self selectInstructions: #((block 1 (neg t1) )).
	self should: [selector writtenResult = #((block 1 (mov t1 t2) (neg t2) ))].
	self verifySelector.! !

!InstructionSelectionTests methodsFor: 'Tests - Arithmatic' stamp: 'wbk 3/4/2004 21:36'!
testSalRegister
	selector := self selectInstructions: #((block 1 (sal t2 t1 ) )).
	self should: [selector writtenResult = #((block 1 (mov t1 ecx) (mov t2 t3)  (sal ecx t3) ))].
	self verifySelector.! !

!InstructionSelectionTests methodsFor: 'Tests' stamp: 'wbk 2/9/2004 21:03'!
testJumpSelectsJumpClass
	selector := self selectInstructions: #((block 1 (jmp block1) )).
	self should: [selector writtenResult = #((block 1 (jmp block1) ))].
	self should: 
		[(selector result 
			blockAt: 1
			instructionAt: 1) class = MedJump].
	self verifySelector.! !

!InstructionSelectionTests methodsFor: 'Tests' stamp: 'wbk 2/9/2004 21:00'!
testIndirectConstant
	selector := self 
				selectInstructions: #(#(#block 1 #(#mov #(#mem #falseObj) 't1') )).
	self should: 
			[selector writtenResult 
				= #(#(#block 1 (mov falseObj t2) #(#mov (t2) t1) ))].
	self verifySelector! !

!InstructionSelectionTests methodsFor: 'Tests' stamp: 'wbk 2/9/2004 21:02'!
testInstructionSelectionForMemTarget
	selector := self selectInstructions: #((block 1 (mov eax (mem t1)))).
	self should: [selector writtenResult = #((block 1 (mov eax (t1)) ))].
	self verifySelector.! !

!InstructionSelectionTests methodsFor: 'Tests' stamp: 'wbk 2/9/2004 21:03'!
testJumpInstructionSelection
	selector := self selectInstructions: #((block 1 (jo block2 (mov 1 t1)) ) (block 2 (mov 2 t2) )).
	self should: [selector writtenResult = #((block 1 (mov 1 t1) (jo block2) ) (block 2 (mov 2 t2) ))].
	self verifySelector.! !

!InstructionSelectionTests methodsFor: 'Tests - Arithmatic' stamp: 'wbk 2/9/2004 21:01'!
testInstructionArithmaticWithLeftAddressing
	selector := self 
				selectInstructions: #(#(#block 1 #(#add #(#mem #(#add #ebp 8)) #eax))).
	self should: 
			[selector writtenResult 
				= #(#(#block 1 #(#mov #eax #t1) #(#add #(8 #ebp) #t1)))].
	self verifySelector! !

!InstructionSelectionTests methodsFor: 'Tests' stamp: 'wbk 2/9/2004 21:02'!
testInstructionSelection
	selector := self selectInstructions: #((block 1 (mov (add 1 2) eax) (ret))).
	self should: [selector writtenResult = #((block 1 (mov 2 t1) (mov t1 t2) (add 1 t2) (mov t2 eax) (ret) ))].
	self verifySelector.! !

!InstructionSelectionTests methodsFor: 'Tests - Arithmatic' stamp: 'wbk 3/4/2004 20:54'!
testSarRegister
	selector := self selectInstructions: #((block 1 (sar t2  t1 ) )).
	self should: [selector writtenResult = #((block 1 (mov t1 ecx) (mov t2 t3)  (sar ecx t3) ))].
	self verifySelector.! !

!InstructionSelectionTests methodsFor: 'Support' stamp: 'wbk 3/13/2003 14:15'!
selectInstructions: anArray
	| med machine| 
	machine := MachineX86 new.
	med := MedMethod
		createIntermediate: anArray
		for: machine.
	selector := InstructionSelector 
		on: med
		for: machine.
	^ selector! !

!InstructionSelectionTests methodsFor: 'Tests' stamp: 'wbk 2/9/2004 21:03'!
testJumpInsideEpressionSelection
	selector := self selectInstructions: #((block 1 (mov (jo block2 (add 1 2)) t2) ) (block 2 (mov 2 t2) )).
	self should: 
		[selector writtenResult = 
		#((block 1  (mov 2 t3) (mov t3 t4) (add 1 t4) (jo block2) (mov t4 t2)) 
			(block 2 (mov 2 t2) ))].
	self verifySelector.! !

!InstructionSelectionTests methodsFor: 'Tests - Arithmatic' stamp: 'wbk 2/9/2004 21:01'!
testInstructionArithmaticWithRightAddressing
	selector := self 
				selectInstructions: #(#(#block 1 #(#add #eax #(#mem #(#add #ebp 8)) ))).
	self should: 
			[selector writtenResult 
				= #(#(#block 1 #(#mov (8 ebp) #t1) (mov t1 t2) #(#add #eax t2) ))].
	self verifySelector! !

!InstructionSelectionTests methodsFor: 'Tests - Arithmatic' stamp: 'wbk 2/9/2004 21:00'!
testDivide2
	selector := self 
				selectInstructions: #(#(#block 1 (mov #(div (add 1 t1) (add 2 t2) t3) t4) )).
	self should: 
			[selector writtenResult 
				= #(#(#block 1 
						(mov t1 t6)
						(add 1 t6)
						(mov t2 t7)
						(add 2 t7)
						(mov t6 eax) 
						(cdq) 
						(div t7) "This is an X86 division, the rest of the arguments are in EAX:EDX"
						(mov eax t5) 
						(mov edx t3) 
						(mov t5 t4) ))].
	self verifySelector! !

!InstructionSelectionTests methodsFor: 'Tests - Arithmatic' stamp: 'wbk 3/4/2004 21:36'!
testSalConstant
	selector := self selectInstructions: #((block 1 (sal  t2 1) )).
	self should: [selector writtenResult = #((block 1 (mov t2 t3)  (sal 1 t3) ))].
	self verifySelector.! !

!InstructionSelectionTests methodsFor: 'Tests' stamp: 'wbk 2/9/2004 21:02'!
testInstructionSelectionForBasicMem
	selector := self selectInstructions: #((block 1 (mov (mem ebp) eax))).
	self should: [selector writtenResult = #((block 1 (mov (ebp) eax) ))].
	self verifySelector.! !

!InstructionSelectionTests methodsFor: 'Tests' stamp: 'wbk 2/9/2004 20:59'!
testCall
	selector := self selectInstructions: #(#(#block 1 #(call 1234) )).
	self should: 
		[selector writtenResult = #(#(#block 1 #(call 1234) ))].
	self verifySelector! !

!InstructionSelectionTests methodsFor: 'Tests' stamp: 'wbk 2/9/2004 21:00'!
testIPush
	selector := self selectInstructions: #(#(#block 1 #(push eax) )).
	self should: 
		[selector writtenResult = #(#(#block 1 #(push eax) ))].
	self verifySelector! !

!InstructionSelectionTests methodsFor: 'Tests' stamp: 'wbk 2/9/2004 21:02'!
testInstructionMoveWithLeftAddressing
	selector := self selectInstructions: #(#(#block 1 #(#mov #(#mem #(#add #ebp 8)) #eax))).
	self should: [selector writtenResult = #(#(#block 1 #(#mov #(8 #ebp) #eax)))].
	self verifySelector! !

!InstructionSelectionTests methodsFor: 'Tests' stamp: 'wbk 2/9/2004 21:05'!
testPrologBlock
	selector := self selectInstructions: #((block 3) (block 1 ) (block 2) ).
	self should: [selector writtenResult = #((block 3) (block 1 ) (block 2) )].
	self verifySelector.! !

!InstructionSelectionTests methodsFor: 'Tests' stamp: 'wbk 2/9/2004 21:01'!
testInstructionMemWithAddressing
	selector := self selectInstructions: #((block 1 (mem (add ebp 8) ) )).
	self should: [selector writtenResult = #((block 1 (mov (8 ebp) t1) ))].
	self verifySelector.! !

!InstructionSelectionTests methodsFor: 'Tests - Arithmatic' stamp: 'wbk 2/9/2004 21:00'!
testDivide
	selector := self 
				selectInstructions: #(#(#block 1 (mov #(div t1 t2 t3) t4) )).
	self should: 
			[selector writtenResult 
				= #(#(#block 1 
						(mov t1 eax) 
						(cdq)    "Sign extends EAX into EDX:EAX"
						(div t2) "This is an X86 division, the rest of the arguments are in EAX:EDX"
						(mov eax t5) 
						(mov edx t3) 
						(mov t5 t4) ))].
	self verifySelector! !

!InstructionSelectionTests methodsFor: 'Tests - Arithmatic' stamp: 'wbk 3/6/2004 20:16'!
testSub
	"This test is here because subtracts  need their arguments reversed for x86 assembly, this is
	because med uses normal ordering and the assembly is in AT&T order with two arguments"
	
	selector := self selectInstructions: #((block 1 (sub 10 2) )).
	self should: [selector writtenResult = #((block 1  (mov 10 t1) (mov t1 t2) (sub 2 t2) ))].
	self verifySelector.! !

!InstructionSelectionTests methodsFor: 'Tests' stamp: 'wbk 2/9/2004 21:05'!
testPushExpression
	selector := self selectInstructions: #(#(#block 1 #(push (add 1 2)) )).
	self should: 
		[selector writtenResult = #(#(#block 1 (mov 2 t1) (mov t1 t2) (add 1 t2) #(push t2) ))].
	self verifySelector! !

!InstructionSelectionTests methodsFor: 'Tests' stamp: 'wbk 2/9/2004 21:04'!
testMovToMemSelectsMovClass
	selector := self selectInstructions: #((block 1 (mov 1 (mem t1)) )).
	self should: [selector writtenResult = #((block 1 (mov 1 (t1)) ))].
	self should: 
		[(selector result 
			blockAt: 1
			instructionAt: 1) class = MedMov].
	self verifySelector.! !

!InstructionSelectionTests methodsFor: 'Tests' stamp: 'wbk 2/9/2004 21:05'!
testReturnSelectsRetClass
	selector := self selectInstructions: #((block 1 (ret) )).
	self should: [selector writtenResult = #((block 1 (ret) ))].
	self should: 
		[(selector result 
			blockAt: 1
			instructionAt: 1) class = MedRet].
	self verifySelector.! !

!InstructionSelectionTests methodsFor: 'Tests - Arithmatic' stamp: 'wbk 2/9/2004 20:59'!
testArithmaticSelection
	selector := self selectInstructions: #((block 1 (add 1 2) )).
	self should: [selector writtenResult = #((block 1  (mov 2 t1) (mov t1 t2) (add 1 t2) ))].
	self verifySelector.! !

!InstructionSelectionTests methodsFor: 'Support' stamp: 'wbk 3/13/2003 14:15'!
verifySelector
	selector result instructionsDo:
		[:each| each name = #mov ifTrue: [self should: [each class = MedMov]]]! !

!InstructionSelectionTests methodsFor: 'Tests' stamp: 'wbk 2/9/2004 21:01'!
testInstructionMoveWithBothAddressing
	selector := self 
				selectInstructions: #(#(#block 1 (mov (mem eax) (mem (add ebp 8))) )).
	self should: 
			[selector writtenResult 
				= #(#(#block 1 (mov (eax) t1) #(#mov t1 (8 ebp)) ))].
	self verifySelector! !

!InstructionSelectionTests methodsFor: 'Tests' stamp: 'wbk 2/9/2004 21:02'!
testInstructionMoveWithRightAddressing
	selector := self 
				selectInstructions: #(#(#block 1 (mov eax (mem (add ebp 8))) )).
	self should: 
			[selector writtenResult 
				= #(#(#block 1 #(#mov eax (8 ebp)) ))].
	self verifySelector! !

!InstructionSelectionTests methodsFor: 'Tests - Arithmatic' stamp: 'wbk 3/4/2004 20:53'!
testSarConstant
	selector := self selectInstructions: #((block 1 (sar t2 1) )).
	self should: [selector writtenResult = #((block 1 (mov t2 t3)  (sar 1 t3) ))].
	self verifySelector.! !

!InstructionSelectionTests methodsFor: 'Tests' stamp: 'wbk 2/9/2004 21:03'!
testJumpJmpInstructionSelection
	"Tests that we can generate a simple nonconditional jump (jmp)"
	selector := self selectInstructions: #((block 1 (jmp block2 ) ) (block 2  )).
	self should: [selector writtenResult = #((block 1 (jmp block2) ) (block 2 ))].
	self verifySelector.! !

ExuperyTests subclass: #ColouringRegisterAllocatorTests
	instanceVariableNames: 'machine allocator selector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Programmer Tests'!

!ColouringRegisterAllocatorTests methodsFor: 'Support' stamp: 'wbk 11/3/2002 19:14'!
verifyNoSpiltRegisters: allocator
	allocator registerStack do: [:each| self shouldnt: [each isSpilled]]! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Spill' stamp: 'wbk 8/1/2004 15:02'!
testSpillWriteIndirectMove
	self createAllocator: #(#(#block 1 #(#mov 1 (t1)))).
	allocator spiltRegisters: {machine registerNamed: #t1}.

	allocator insertSpills.

	self should: 
			[allocator source intermediateForm =
				#((block 1 
						(mov (-16 ebp) t1v1) 
						(mov 1 (t1v1)) ))].
	self verifyAllocator.! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Coalesce' stamp: 'wbk 7/25/2004 16:05'!
testCoalesceFromPhysicalRegister
	"Tests that when we merge a move with a precoloured node the new merged node is
	also precoloured."
	|  move |
	self createAndPrepareAllocator: 
		#(#	(#block 1 
			(mov eax t1)  )).
			
	move := allocator 
		getMoveFrom: #eax
		to: #t1.
		
	allocator coalesceNode: move.
	self verifyAllocator. "Check everything is OK"
	! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Coalesce' stamp: 'wbk 7/25/2004 16:06'!
testCoalesceToPhysicalRegister
	"Tests that when we merge a move with a precoloured node the new merged node is
	also precoloured."
	|  move |
	self createAndPrepareAllocator: 
		#(#	(#block 1 
			(mov t1 eax)  )).
			
	move := allocator 
		getMoveFrom: #t1
		to: #eax.
		
	allocator coalesceNode: move.
	self verifyAllocator. "Check everything is OK"
	! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Coalesce, origional' stamp: 'wbk 4/24/2004 13:12'!
testCoalesceConstrainsNextMov
	self createAndPrepareAllocator: #((block 1 (mov t1 t2) (mov t2 t3) (mov 1 t1) (mov 2 t3) (add t1 t3))).
	self should: [allocator coalesce].

	self should: [allocator coalescedMoves size = 1].
	self should: [allocator moveWorklist size = 0].
	self should: [allocator simplifyWorklist size = 2].
	self should: [allocator spillWorklist size = 0].
	self verifyAllocator.! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Select' stamp: 'wbk 5/2/2004 18:11'!
testSelectWithPrecolouredRegisters
	| assignments t1 eax t2 |
	self createAndPrepareAllocator: #(#(#block 1 (mov 1 t2) #(#mov 2 #eax) #(#mov 1 #t1)    #(#add #eax #t1 ) (add t2 eax) )).

	allocator simplify.
	allocator registerStack: #(t2 eax t1). "Just to make the test deterministic"
	allocator select.

	assignments := allocator registerAssignments.
	t1 := assignments at: (machine registerNamed: #t1).
	t2 := assignments at: (machine registerNamed: #t2).
	eax := assignments at: (machine registerNamed: #eax).
	self assert: eax name = #eax. "eax must be assigned to eax otherwise after register reallocation
									we will have clashes"
	self assert: t1 ~= eax.
	self assert: t2 ~= eax.
	self assert: t1 ~= t2.
	self verifyAllocator.! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Create Statistics' stamp: 'wbk 8/2/2004 20:58'!
testRegisterCountsBasic
	self createAndPrepareAllocator: #((block 1 (mov 1 t1))).
	
	self assert: (self nodeNamed: #t1) registerCount = 1.
	
	! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Select' stamp: 'wbk 11/9/2002 15:51'!
testSelectDoesntMarkAsSpilled
	self createAllocator: #(#(#block 1 
			#(#mov 8 t3) #(#add #ebp t3) #(#mov #(t3) t4) (mov (t4) t5) (mov t5 t1)
			#(#mov 8 t6) #(#add t1 t6) #(#mov #(t6) t7) #(#mov 1 t8) #(#add t7 t8) 
			#(#mov t8 t2) #(#mov 8 t9) #(#add t1 t9) #(#mov t2 #(t9)) #(#mov 4 t10) 
			#(#mul t2 t10) #(#mov t10 t11) #(#add t1 t11) #(#mov 24 t12) #(#add t11 t12) 
			#(#mov 85 #(t12)) #(#ret))).

	allocator analyseLiveness.
	allocator buildInterferenceGraph.

	allocator registerStack: #(t9 t4 t6 t8 t7 t2 t11 t12 t1 t10 t3 t5).
	allocator select.

	self verifyNoSpiltRegisters: allocator.
	self verifyAllocator.
! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Simplify' stamp: 'wbk 11/9/2002 15:36'!
testSimplifyPickRegisterToSpill
	self createAndPrepareAllocator:  
		#(	#(#block 1 #(#add #t1 #t2) #(#add #t3 #t4) #(#add #t5 #t6) #(#add #t6 #t7) #(#add #t3 #t5) 
						#(#add #t5 #t1) #(#jmp #block1)) 
			#(#block 2 #(#add #t8 #t5))).

	allocator simplify.

	self should: [allocator stackSize = 1].
	allocator spillRegister.
	self should: [allocator stackSize = 2].
	self should: [(allocator registerStack at: 2) isSpilled].
	self verifyAllocator.! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Assign Registers' stamp: 'wbk 6/2/2004 21:46'!
testAssignJump
	self createAllocator: #((block 1 (mov 1 t1) (jz block2) (jo block2) (jmp block2)) 
							(block 2)).

	allocator assignRegisters: (self createAssignments: #((t1 eax) (t2 ebx))).

	self should: 
			[allocator intermediateForm 
				= #((block 1 (mov 1 eax) (jz block2) (jo block2) (jmp block2)) 
					(block 2))].
	self verifyAllocator.! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Simplify' stamp: 'wbk 11/7/2002 13:57'!
testSimpleColouringRegisterAllocation
	| source assignments t1 t2 |
	machine := MachineX86 new.
	source := MedMethod 
		createAssembly: #((block 1 (mov 1 t1) (mov 2 t2) (add t1 t2)))
		for: machine.
	allocator := ColouringRegisterAllocator
		on: source 
		for: machine.

	assignments := allocator registerAssignments.

	t1 := (assignments at: (machine registerNamed: #t1)).
	t2 := (assignments at: (machine registerNamed: #t2)).
	self should: [t1 isMachineRegister].
	self should: [t2 isMachineRegister].
	self should: [t1 ~= t2].
	self verifyAllocator.! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Select' stamp: 'wbk 11/9/2002 15:51'!
testSelectSimple
	| assignments t1 t2 |
	self createAndPrepareAllocator: #(#(#block 1 #(#mov 1 #t1) #(#mov 2 #t2) #(#add #t1 #t2))).

	allocator simplify.
	allocator select.

	assignments := allocator registerAssignments.
	t1 := assignments at: (machine registerNamed: #t1).
	t2 := assignments at: (machine registerNamed: #t2).
	self should: [t1 isMachineRegister].
	self should: [t2 isMachineRegister].
	self should: [t1 ~= t2].
	self verifyAllocator.! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Simplify' stamp: 'wbk 11/9/2002 15:36'!
testSimplifyForSpill
	self createAndPrepareAllocator: #((block 1
									(add t1 t2) (add t3 t4) (add t5 t6) (add t6 t7) 
									(add t3 t5) (add t5 t1)  (jmp block1) )
						(block 2 (add t8 t5) )).

	allocator simplify.

	self should: [allocator unallocated size = 7].
	self should: [allocator stackIncludes: (machine registerNamed: #t8)].
	self verifyAllocator.! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Coalesce' stamp: 'wbk 8/2/2004 21:02'!
testCoalesceDecrementsIndirectCounts2
	"Trying to catch the case in live where a move count isn't properly	 	incremented/decremented.."
	|  movet2t3 movet1t2 movet21t22 movet22t2 movet23t22 |
	self createAndPrepareAllocator: 
		#(#	(#block 1
			(mov t21 t22)
			(mov 0 t23) "Avoiding interference"
			(mov t23 t22)
			(mov t22 t2)
			 
			(mov 0 t1) "Just to avoid interference"
			(mov t1 t2) 
			(mov t2 t3) 
			"(mov t3 t4)"   )).

	
	movet1t2 := allocator 
		getMoveFrom: #t1
		to: #t2.
	movet2t3 := allocator 
		getMoveFrom: #t2 
		to: #t3.
	movet21t22 := allocator 
		getMoveFrom: #t21 
		to: #t22.
	movet22t2 := allocator 
		getMoveFrom: #t22 
		to: #t2.
	movet23t22 := allocator 
		getMoveFrom: #t23 
		to: #t22.

	allocator coalesceNode: movet22t2.
	self assert: (self nodeNamed: #t3) currentMoves = 1.

	allocator coalesceNode: movet2t3.
	self assert: (self nodeNamed: #t3) currentMoves = 3.
	
	allocator coalesceNode: movet1t2.
	self assert: (self nodeNamed: #t3) currentMoves = 2.

	allocator coalesceNode: movet21t22.
	self assert: (self nodeNamed: #t3) currentMoves = 1.
	
	allocator coalesceNode: movet23t22.
	self assert: (self nodeNamed: #t3) currentMoves = 0.
	self verifyAllocator.
	
	! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Coalesce, origional' stamp: 'wbk 11/9/2002 15:33'!
testCoalesceSimple
	self createAndPrepareAllocator: #(#	(#block 1 (mov t1 t2) (add t1 t2) )).

	allocator coalesce.

	self should: [allocator moveWorklist isEmpty].
	self should: [allocator simplifyWorklist size = 1].
	self should: [allocator spillWorklist isEmpty].
	self should: [allocator coalescedMoves size = 1].
	self verifyAllocator.
	! !

!ColouringRegisterAllocatorTests methodsFor: 'Support' stamp: 'wbk 7/25/2004 15:51'!
verifyAllocator
	allocator verify.! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Coalesce, origional' stamp: 'wbk 11/9/2002 15:33'!
testCoalesceFreezeSimple
	allocator := self createAndPrepareAllocator: #(#	(#block 1 (mov t1 t2) (add t1 t2) )).

	self should: [allocator freeze].

	self should: [allocator moveWorklist isEmpty].
	self should: [allocator simplifyWorklist size = 2].
	self should: [allocator spillWorklist isEmpty].
	self should: [allocator coalescedMoves size = 0].
	self verifyAllocator.
	! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Spill' stamp: 'wbk 8/1/2004 15:03'!
testSpillSimple
	self createAllocator: #(#(#block 1 #(#mov 1 #t1))).
	allocator spiltRegisters: {machine registerNamed: #t1}.

	allocator insertSpills.

	self should: 
			[allocator source intermediateForm =
				#(#(#block 1  #(#mov 1 #t1v1) #(#mov #t1v1 #(-16 #ebp))))].
	self verifyAllocator.! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Coalesce, origional' stamp: 'wbk 8/2/2004 21:06'!
testCoalesceSimpleInterferes
	self createAndPrepareAllocator: #(#	(#block 1 (mov 1 t2) (add t1 t2) (mov t2 t3) (mov 1 t4)  (add t4 t3) )).
	allocator coalesce.

	self 
		verifyInterferes: #t1
		with: #t3.
	self 
		verifyInterferes: #t3
		with: #t1.
	self should: [(self nodeNamed: #t2) currentSize = 0].
	self verifyAllocator.! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Coalesce, origional' stamp: 'wbk 11/9/2002 15:30'!
testCoalesceBuildMovWorklistSimple
	self createAndPrepareAllocator: #(#(#block 1 #(#mov t1 #t2) )).

	self should: [allocator moveWorklist size = 1].
	self should: [allocator simplifyWorklist isEmpty].
	self should: [allocator spillWorklist isEmpty].
	self verifyAllocator.! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Assign Registers' stamp: 'wbk 6/2/2004 21:50'!
testPush
	self createAllocator: #((block 1 (push t1))).

	allocator assignRegisters: (self createAssignments: #((t1 eax))).

	self should: 
			[allocator intermediateForm 
				= #((block 1 (push eax) ))].
	self verifyAllocator.! !

!ColouringRegisterAllocatorTests methodsFor: 'Support' stamp: 'wbk 8/2/2004 21:14'!
createAndPrepareAllocator: anArray
	allocator := self createAllocator: anArray.
	allocator setUp.
	^ allocator! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Spill' stamp: 'wbk 8/1/2004 15:02'!
testSpillWriteIndirectMove2
	self createAllocator: #(#(#block 1  #(#mov (t1) 1 ))).
	allocator spiltRegisters: {machine registerNamed: #t1}.

	allocator insertSpills.

	self should: 
			[allocator source intermediateForm =
				#((block 1 
						(mov (-16 ebp) t1v1) 
						(mov (t1v1) 1 ) ))].
	self verifyAllocator.! !

!ColouringRegisterAllocatorTests methodsFor: 'Support' stamp: 'wbk 8/2/2004 20:59'!
nodeNamed: aSymbol 
	^ allocator interferenceGraph at: (machine registerNamed: aSymbol)! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Coalesce, origional' stamp: 'wbk 11/9/2002 15:33'!
testCoalesceFreezeTwoHighDegrees
	self createAndPrepareAllocator: #(#	(#block 1 (mov t1 t2) (add t2 t1) (add t3 t4) (add t4 t5) (add t6 t7) (add t7 t8) )).

	self shouldnt: [allocator freeze].

	self should: [allocator moveWorklist size = 1].
	self should: [allocator simplifyWorklist size = 4].
	self should: [allocator spillWorklist size = 2].
	self should: [allocator coalescedMoves size = 0].
	self verifyAllocator.
	! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Assign Registers' stamp: 'wbk 6/2/2004 21:44'!
testAssignAddressingMode
	self createAllocator: #((block 1 (mov (ebp) t1) (mov 2 t2) (add t1 t2))).

 	allocator assignRegisters: (self createAssignments: #((t1 eax) (t2 ebx))).

	self should: 
			[allocator intermediateForm 
				= #((block 1 (mov (ebp) eax) (mov 2 ebx) (add eax ebx)))].
	self verifyAllocator.! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Spill' stamp: 'wbk 8/1/2004 15:06'!
testSpillWriteIndirectArithmatic2
	self createAllocator: #(#(#block 1 #(#add (t1) 1))).
	allocator spiltRegisters: {machine registerNamed: #t1}.

	allocator insertSpills.

	self should: 
			[allocator source intermediateForm =
				#(#(#block 1 
						#(#mov #(-16 #ebp) #t1v1) 
						#(#add (#t1v1) 1) ))].
	self verifyAllocator.! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Assign Registers' stamp: 'wbk 6/2/2004 21:44'!
testAssignDivide
	self createAllocator: #((block 1 (div t1) )).

 	allocator assignRegisters: (self createAssignments: #((t1 ebx) (t2 ebx))).

	self should: 
			[allocator intermediateForm 
				= #((block 1 (div ebx) ))].
	self verifyAllocator.! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Assign Registers' stamp: 'wbk 6/2/2004 21:47'!
testAssignNeg
	self createAllocator: #((block 1 (neg t1) )).

 	allocator assignRegisters: (self createAssignments: #((t1 ebx) (t2 ecx))).

	self should: 
			[allocator intermediateForm 
				= #((block 1 (neg ebx) ))].
	self verifyAllocator.! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Spill' stamp: 'wbk 8/1/2004 15:04'!
testSpillMultipleSpilling
	self createAllocator: #(#(#block 1 #(#mov #t1 #t2))).
	allocator spiltRegisters:
		{machine registerNamed: #t1.
		machine registerNamed: #t2}.

	allocator insertSpills.

	self should: 
			[allocator source intermediateForm =
				#(#(#block 1 #(#mov #(-16 #ebp) #t1v1)  #(#mov #t1v1 #t2v1)
							  #(#mov #t2v1 #(-20 #ebp))))].
	self verifyAllocator.! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Select' stamp: 'wbk 11/9/2002 15:51'!
testSelectWithSpilling
	self createAllocator: #((block 1
									(add t1 t2) (add t3 t4) (add t5 t6) (add t6 t7) 
									(add t3 t5) (add t5 t1)  (jmp block1) )
						(block 2 (add t8 t5) )).

	allocator analyseLiveness.
	allocator buildInterferenceGraph.
	allocator registerStack: #(  t1 t2 t3 t4 t5 t6 t7 t8).
	(allocator registerStack at: 1) markAsSpilled.

	allocator select.

	self should: [(allocator spiltRegisters at: 1) name = #t1].
	self verifyAllocator.
! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Coalesce' stamp: 'wbk 5/22/2004 22:11'!
testCoalesceMultipleMoves
	"Tests that we handle coalsecing a move to a register that has already been
	coalesced away."
	| movet2t3 movet1t2 |
	self createAndPrepareAllocator: 
		#(#	(#block 1 
			(mov 1 t1)  "Create an interference edge for t1"
			(add t5 t6)
			(mov t1 t2)
			(mov t2 t3)   )).

	
	movet2t3 := allocator 
		getMoveFrom: #t2 
		to: #t3.
	movet1t2 := allocator
		getMoveFrom: #t1
		to: #t2.
	allocator coalesceNode: movet2t3.
	allocator coalesceNode: movet1t2.	
	self verifyAllocator.
		
	"The check is that it didn't raise an error. If it fails then it will try and add to
	an empty array."
	! !

!ColouringRegisterAllocatorTests methodsFor: 'Test - Allocate' stamp: 'wbk 11/9/2002 15:47'!
testAllocateReturn42
	self createAllocator: #(#(#block 1 (mov 8 t3) (add ebp t3) (mov (t3) t4) (mov (t4) t5) 
						(mov t5 t1) (mov 8 t6) (add t1 t6) (mov (t6) t7) (mov 1 t8)
						(add t7 t8) (mov t8 t2) (mov 8 t9) (add t1 t9) (mov t2 (t9))
						(mov 4 t10) (mul t2 t10) (mov t10 t11) (add t1 t11) 
						(mov 24 t12) (add t11 t12) (mov 85 (t12)) (ret))).

	allocator run.

	self should: [allocator hasNoTemporaries].
	self should: [(allocator result blockNumbered: 1) numberOfExpressions = 19].
	self verifyAllocator.! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Coalesce, origional' stamp: 'wbk 8/2/2004 21:04'!
testCoalesceAfterSimplifyInterferes
	self createAndPrepareAllocator: #(#	(#block 1 (mov 1 t2) (add t1 t2) (mov t2 t3) (mov 1 t4)  (add t4 t3) )).
	allocator simplify.
	allocator coalesce.

	self 
		verifyInterferes: #t1
		with: #t3.
	self 
		verifyInterferes: #t3
		with: #t1.
	self should: [(self nodeNamed: #t2) currentSize = 0].
	self verifyAllocator.! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Coalesce, origional' stamp: 'wbk 11/9/2002 15:32'!
testCoalesceFreezeOneHighDegree
	self createAndPrepareAllocator: #(#	(#block 1 (mov t1 t2)  (add t3 t4) (add t4 t5) (add t6 t7) (add t7 t8) )).

	self should: [allocator freeze].

	self should: [allocator moveWorklist isEmpty].
	self should: [allocator simplifyWorklist size = 7].
	self should: [allocator spillWorklist size = 1].
	self should: [(allocator spillWorklist at: 1) register intermediateForm = #t2].
	self should: [allocator coalescedMoves size = 0].
	self verifyAllocator.
	! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Coalesce, origional' stamp: 'wbk 11/9/2002 15:29'!
testCoalesceBuildMovWorklistIndirectAddressing
	self createAndPrepareAllocator: #(#(#block 1 #(#mov (t1) #t2) (mov t1 (t2)) )).

	self should: [allocator moveWorklist isEmpty].
	self should: [allocator simplifyWorklist size = 2].
	self should: [allocator spillWorklist isEmpty].
	self verifyAllocator.! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Coalesce, origional' stamp: 'wbk 8/2/2004 21:04'!
testCoalesceBuildWorklistsMoveCountsSimple
	self createAndPrepareAllocator: #(#(#block 1 #(#mov t1 #t2) )).

	self should: [(self nodeNamed: #t1) currentMoves = 1].
	self should: [(self nodeNamed: #t2) currentMoves = 1].
	self verifyAllocator.! !

!ColouringRegisterAllocatorTests methodsFor: 'Support' stamp: 'wbk 6/2/2004 22:50'!
createAssignments: anArray
	| assignments |
	assignments := Dictionary new.
	anArray do: 
		[:each| assignments
			at: (machine registerNamed: each first)
			put: (machine registerNamed: each last)].
	^ assignments

! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Spill' stamp: 'wbk 8/1/2004 15:03'!
testSpillReadArithmatic
	self createAllocator: #(#(#block 1 #(#add t1 1))).
	allocator spiltRegisters: {machine registerNamed: #t1}.

	allocator insertSpills.

	self should: 
			[allocator source intermediateForm =
				#(#(#block 1 #(#mov #(-16 #ebp) #t1v1) #(#add  #t1v1 1) ))].
	self verifyAllocator.! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Assign Registers' stamp: 'wbk 6/2/2004 21:45'!
testAssignCoalescedMove
	self createAllocator: #((block 1 (mov t1 t2) (add t1 t2))).
	
	allocator assignRegisters: (self createAssignments: #((t1 eax) (t2 eax))).

	self should: 
			[allocator intermediateForm 
				= #(#(#block 1  #(#add #eax #eax)))].
	self verifyAllocator.! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Spill' stamp: 'wbk 8/1/2004 15:03'!
testSpillMultipleRanges
	self createAllocator: #(#(#block 1 #(#mov 1 #t1) #(#mov 2 #t1))).
	allocator spiltRegisters: {machine registerNamed: #t1}.

	allocator insertSpills.

	self should: 
			[allocator source intermediateForm =
				#((block 1  (mov 1 t1v1) (mov t1v1 (-16 ebp)) 
							(mov 2 t1v2) (mov t1v2 (-16 ebp))))].
	self verifyAllocator.! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Coalesce, origional' stamp: 'wbk 4/24/2004 13:14'!
testCoalesceTwoInstructions
	self createAndPrepareAllocator: #(#	(#block 1 (mov t3 t1) (mov t1 t2) (add t1 t2) )).

	allocator coalesce.
	allocator coalesce.

	self should: [allocator moveWorklist isEmpty].
	self should: [allocator simplifyWorklist size = 1].
	self should: [allocator spillWorklist isEmpty].
	self should: [allocator coalescedMoves size = 2].
	self verifyAllocator.
	! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Coalesce' stamp: 'wbk 8/2/2004 21:03'!
testCoalesceMoveCounts
	"Tests that we handle coalsecing a move to a register that has already been
	coalesced away."
	|  movet3t4 |
	self createAndPrepareAllocator: 
		#(#	(#block 1 
			(mov t1 t3) 
			(mov 1 t2) "Avoiding pollution with t1"
			(mov t2 t3) 
			(mov t3 t4)   )).

	
	movet3t4 := allocator 
		getMoveFrom: #t3 
		to: #t4.
		
	allocator coalesceNode: movet3t4.
	
	self assert: (self nodeNamed: #t4) currentMoves = 2.
	self verifyAllocator.
	! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Coalesce, origional' stamp: 'wbk 8/2/2004 21:05'!
testCoalesceBuildWorklistsMoveCountsTwoMoves
	self createAndPrepareAllocator: #(#(#block 1 #(#mov t1 #t2) (mov t2 t3) )).

	self should: [(self nodeNamed: #t1) currentMoves = 1].
	self should: [(self nodeNamed: #t2) currentMoves = 2].
	self should: [(self nodeNamed: #t3) currentMoves = 1].
	self verifyAllocator.! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Assign Registers' stamp: 'wbk 7/6/2003 21:31'!
testAssignKeepsBlocksInOrder
	self createAllocator: #((block 4 (jz block2) ) (block 1 ) (block 2 (jmp block3) ) (block 3)).
	self createAssignments: #((t1 eax) (t2 ebx)).
	allocator assignRegisters.

	self should: 
			[allocator intermediateForm 
				= #((block 4 (jz block2) ) (block 1 ) (block 2 (jmp block3) ) (block 3))].
	self verifyAllocator.! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Coalesce' stamp: 'wbk 8/2/2004 21:00'!
testCoalesceLoop
	"Tests that we handle coalsecing a move to a register that has already been
	coalesced away."
	|  movet1t2 movet2t1 |
	self createAndPrepareAllocator: 
		#(#	(#block 1 
			(mov t1 t2) 
			(mov t2 t1) )).

	
	movet1t2 := allocator 
		getMoveFrom: #t1
		to: #t2.
	movet2t1 := allocator 
		getMoveFrom: #t2
		to: #t1.
		
	allocator coalesceNode: movet1t2.
	self verifyAllocator. "Check everything is OK"
	allocator coalesceNode: movet2t1.
	self verifyAllocator.	"Check that cloaing the loop didn't corrupt us"
	
	self assert: (self nodeNamed: #t1) currentVersion register name = #t2.
	self assert: (self nodeNamed: #t1) currentVersion currentMoves = 0.

	! !

!ColouringRegisterAllocatorTests methodsFor: 'Support' stamp: 'wbk 11/3/2002 19:14'!
usesAllAvailibleRegisters: anAllocator
	| used |
	used := Set new.
	anAllocator result registersDo: 
		[:each| (machine isSpecialRegister: each) ifFalse: [used add: each]].
	^ used size = 6	! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Coalesce' stamp: 'wbk 8/2/2004 21:03'!
testFreezeMoveWatchingCounts
	"Tests that we handle coalsecing a move to a register that has already been
	coalesced away."
	|  movet1t2 movet2t3 |
	self createAndPrepareAllocator: 
		#(#	(#block 1 
			(mov t1 t2)
			(mov t2 t3) )).

	
	movet1t2 := allocator 
		getMoveFrom: #t1 
		to: #t2.
	movet2t3 := allocator 
		getMoveFrom: #t2
		to: #t3.
		
	allocator coalesceNode: movet2t3.
	self assert: (self nodeNamed: #t3) currentMoves = 1.
	
	allocator freezeMove: movet1t2.
	self assert: (self nodeNamed: #t3) currentMoves = 0.
	self verifyAllocator.
	
	! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Assign Registers' stamp: 'wbk 6/2/2004 21:49'!
testAssignSpillCode
	self createAllocator: #((block 1 (mov (-16 ebp) t1) (add 1 t1) 
									(mov t1 (-16 ebp)))).

	allocator assignRegisters: (self createAssignments: #((t1 eax))).

	self should: 
			[allocator intermediateForm 
				= #((block 1 (mov (-16 ebp) eax) (add 1 eax) (mov eax (-16 ebp))))].
	self verifyAllocator.! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Spill' stamp: 'wbk 8/1/2004 15:02'!
testSpilledVariablesNotSpillable
	self createAllocator: #(#(#block 1 #(#mov 1 #t1))).
	allocator spiltRegisters: {machine registerNamed: #t1}.

	allocator insertSpills.

	self assert: (allocator hasSpill:  (machine registerNamed: #t1v1)).
	self verifyAllocator.! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Spill' stamp: 'wbk 8/1/2004 15:02'!
testSpillWriteIndirectArithmatic
	self createAllocator: #(#(#block 1 #(#add 1 (t1)))).
	allocator spiltRegisters: {machine registerNamed: #t1}.

	allocator insertSpills.

	self should: 
			[allocator source intermediateForm =
				#(#(#block 1 
						#(#mov #(-16 #ebp) #t1v1) 
						#(#add  1 (#t1v1)) ))].
	self verifyAllocator.! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Assign Registers' stamp: 'wbk 6/2/2004 21:48'!
testAssignSimple
	self createAllocator: #((block 1 (mov 1 t1) (mov 2 t2) (add t1 t2))).

	allocator assignRegisters: (self createAssignments: #((t1 eax) (t2 ebx))).

	self should: 
			[allocator intermediateForm 
				= #((block 1 (mov 1 eax) (mov 2 ebx) (add eax ebx)))].
	self verifyAllocator.! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Coalesce' stamp: 'wbk 7/25/2004 17:09'!
testCoalesceSelfMove
	"Tests that moving a node onto itself is correctly handled. This does not remove a register,
	it just removes the move. It was a no-op move before we started processing."
	|  move |
	self createAndPrepareAllocator: 
		#(#	(#block 1 
			(mov t1 t1) 
			(mov t1 t3) )).
	move := allocator 
		getMoveFrom: #t1
		to: #t1.
		
	allocator coalesceNode: move.
	self verifyAllocator. "Check everything is OK"
	! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Create Statistics' stamp: 'wbk 8/2/2004 21:06'!
testRegisterCountsBasic2
	self createAndPrepareAllocator: #((block 1 (mov t1 t1))).
	
	self assert: (self nodeNamed: #t1) registerCount = 2.
	
	! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Assign Registers' stamp: 'wbk 6/2/2004 21:47'!
testAssignMachineRegister
	self createAllocator: #((block 1 (mov ebp t1) (mov 2 t2) (add t1 t2))).

	allocator assignRegisters: (self createAssignments: #((t1 eax) (t2 ebx))).

	self should: 
			[allocator intermediateForm 
				= #((block 1 (mov ebp eax) (mov 2 ebx) (add eax ebx)))].
	self verifyAllocator.! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Spill' stamp: 'wbk 8/1/2004 15:05'!
testSpillWithJump
	self createAllocator: #(#(#block 1 #(#jmp #block2)) #(#block 2)).
	allocator spiltRegisters: {machine registerNamed: #t1}.

	allocator insertSpills.

	self should: 
			[(allocator source blockAt: 1 instructionAt: 1) target =
				(allocator source blockNumbered: 2)].
	self verifyAllocator.! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Coalesce' stamp: 'wbk 8/2/2004 21:02'!
testCoalesceInterferingMove
	"This test is an attempt to isolate a bug that's effecting the bitShift"| movet2t3 |
.
	self createAndPrepareAllocator: 
		#(#	(#block 1 (mov 1 t1)  
					(mov t1 t2) (mov t2 t3) (add 2 t3) (mov t1 t4)  (add t4 t4) )).

	movet2t3 := allocator 
		getMoveFrom: #t2 
		to: #t3.
		
	allocator coalesceNode: movet2t3.
	self 
		verifyInterferes: #t1 
		with: #t2.
	self verifyAllocator.
! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Spill' stamp: 'wbk 8/1/2004 15:03'!
testSpillKeepsBlocksInOrder
	self createAllocator: #((block 4 (jz block2) ) (block 1 ) (block 2 (jmp block3) ) (block 3)).
	allocator spiltRegisters: {machine registerNamed: #t1}.

	allocator insertSpills.

	self should: 
			[allocator source intermediateForm =
				#((block 4 (jz block2) ) (block 1 ) (block 2 (jmp block3) ) (block 3))].
	self verifyAllocator.! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Simplify' stamp: 'wbk 11/9/2002 15:52'!
testSimplifySimple
	self createAndPrepareAllocator: #(#(#block 1 #(#mov 1 #t1) #(#mov 2 #t2) #(#add #t1 #t2))).

	allocator simplify.

	self should: [allocator stackIncludes: (machine registerNamed: #t1)].
	self should: [allocator stackIncludes: (machine registerNamed: #t2)].
	self verifyAllocator.! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Assign Registers' stamp: 'wbk 2/2/2004 21:16'!
testAssignCdq
	self createAllocator: #((block 1 (cdq) )).
	self createAssignments: #((t1 ebx) (t2 ebx)).

 	allocator assignRegisters.

	self should: 
			[allocator intermediateForm 
				= #((block 1 (cdq) ))].
	self verifyAllocator.! !

!ColouringRegisterAllocatorTests methodsFor: 'Support' stamp: 'wbk 11/9/2002 15:27'!
createAllocator: med 
	| source |
	machine := MachineX86 new.
	source := MedMethod 
		createAssembly: med 
		for: machine.
	^ allocator := ColouringRegisterAllocator new 
		initialiseSource: source 
		machine: machine! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Assign Registers' stamp: 'wbk 7/5/2003 14:33'!
testAssignRet
	self createAllocator: #((block 1 (ret) )).
	self createAssignments: #((t1 eax) (t2 ebx)).

 	allocator assignRegisters.

	self should: 
			[allocator intermediateForm 
				= #((block 1 (ret) ))].
	self verifyAllocator.! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Coalesce' stamp: 'wbk 11/9/2002 15:34'!
testCoalesceSpillMove
	self createAndPrepareAllocator: #(#	(#block 1 (mov t1 t2) (add t1 t2) )).

	allocator spillMove.

	self should: [allocator moveWorklist isEmpty].
	self should: [allocator simplifyWorklist size = 2].
	self should: [allocator spillWorklist isEmpty].
	self should: [allocator coalescedMoves size = 0].
	self verifyAllocator.
	! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Coalesce' stamp: 'wbk 8/2/2004 21:01'!
testCoalesceDecrementsIndirectCounts
	"When a move is decremented."
	|  movet3t4 movet2t3 movet1t3 |
	self createAndPrepareAllocator: 
		#(#	(#block 1 
			(mov t1 t3) 
			(mov 1 t2) "Avoiding pollution with t1"
			(mov t2 t3) 
			(mov t3 t4)   )).

	
	movet3t4 := allocator 
		getMoveFrom: #t3 
		to: #t4.
	movet2t3 := allocator 
		getMoveFrom: #t2 
		to: #t3.
	movet1t3 := allocator 
		getMoveFrom: #t1 
		to: #t3.

	allocator coalesceNode: movet3t4.
	self assert: (self nodeNamed: #t4) currentMoves = 2.
	
	allocator coalesceNode: movet2t3.
	self assert: (self nodeNamed: #t4) currentMoves = 1.
	
	allocator coalesceNode: movet1t3.
	self assert: (self nodeNamed: #t4) currentMoves = 0.
	self verifyAllocator.
	! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Simplify' stamp: 'wbk 8/2/2004 21:17'!
testSimplifyAndSpill
	self createAndPrepareAllocator: #((block 1
										(add t1 t2) (add t3 t4) (add t5 t6) (add t6 t7) 
										(add t3 t5) (add t5 t1)  (jmp block1) )
									(block 2 (add t8 t5) )).

	allocator simplifyAndSpill.

	self should: [allocator stackSize = 8].
	self verifyAllocator.
! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Select' stamp: 'wbk 8/2/2004 21:18'!
testSelectWithSpills
	self createAndPrepareAllocator: #((block 1
									(add t1 t2) (add t3 t4) (add t5 t6) (add t6 t7) 
									(add t3 t5) (add t5 t1)  (jmp block1) )
						(block 2 (add t8 t5) )).

	allocator simplifyAndSpill.
	allocator select.

	self should: [allocator spiltRegisters size = 1].
	self verifyAllocator.
! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Select' stamp: 'wbk 11/9/2002 15:50'!
testSelectDoNotSpill
	self createAllocator: #(#(#block 1 
			#(#mov 8 t3) #(#add #ebp t3) #(#mov #(t3) t4) (mov (t4) t5) (mov t5 t1)
			#(#mov 8 t6) #(#add t1 t6) #(#mov #(t6) t7) #(#mov 1 t8) #(#add t7 t8) 
			#(#mov t8 t2) #(#mov 8 t9) #(#add t1 t9) #(#mov t2 #(t9)) #(#mov 4 t10) 
			#(#mul t2 t10) #(#mov t10 t11) #(#add t1 t11) #(#mov 24 t12) #(#add t11 t12) 
			#(#mov 85 #(t12)) #(#ret))).

	allocator analyseLiveness.
	allocator buildInterferenceGraph.

	allocator registerStack: #( t9 t12 t11 t6 t3 t10 t7 t4 t2 t1 t5 t8).
	allocator select.

	self should: [allocator spiltRegisters size = 0].
	self verifyAllocator.
! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Coalesce, origional' stamp: 'wbk 8/2/2004 22:50'!
testCoalesceFreezeRegistersUsedInOtherMoves
	self createAndPrepareAllocator: #(#	(#block 1 (mov t1 t2) (mov t2 t3) )).

	self should: [allocator freeze].

	self should: [(self nodeNamed: #t2) currentMoves = 1].
	self should: [(self nodeNamed: #t3) currentMoves = 0].
	self should: [allocator moveWorklist size = 1].
	self should: [allocator simplifyWorklist size = 1].
	self should: [allocator spillWorklist isEmpty].
	self verifyAllocator.
	! !

!ColouringRegisterAllocatorTests methodsFor: 'Test - Allocate' stamp: 'wbk 6/24/2003 12:36'!
testFromSpecialRegister
	self createAllocator: #(#(#block 1 #(mov ebp t1) )).
	allocator run.
	self should: [allocator intermediateForm = #(#(#block 1 #(mov ebp #eax) ))].
	self verifyAllocator.! !

!ColouringRegisterAllocatorTests methodsFor: 'Interference Graph' stamp: 'wbk 3/13/2003 14:40'!
verifyInterferes: firstString with: secondString
	self should:
		[allocator
			interferes: (machine registerNamed: firstString)
			with: (machine registerNamed: secondString)].! !

!ColouringRegisterAllocatorTests methodsFor: 'Test - Allocate' stamp: 'wbk 11/9/2002 15:47'!
testAllocateBasicCoalesce
	self createAllocator: #(#(#block 1 #(#mov #t1 #t2) #(#add #t1 #t2))).
	allocator run.
	self should: [allocator intermediateForm = #(#(#block 1 #(#add #eax #eax)))].
	self verifyAllocator.! !

!ColouringRegisterAllocatorTests methodsFor: 'Test - Allocate' stamp: 'wbk 11/9/2002 15:48'!
testAllocateWithSpills
	allocator := self createAllocator: #(#	(#block 1 #(#add #t1 #t2) #(#add #t3 #t4) #(#add #t5 #t6) #(#add #t6 #t7) 
					(#add #t3 #t5) #(#add #t5 #t1) #(#jmp #block1)) 
				(#block 2 #(#add #t8 #t5))).

	allocator run.

	self should: [allocator hasNoTemporaries].
	self should: [self usesAllAvailibleRegisters: allocator].
	self verifyAllocator.! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Assign Registers' stamp: 'wbk 6/2/2004 21:50'!
testCall
	self createAllocator: #((block 1 (call t1))).

	allocator assignRegisters: (self createAssignments: #((t1 eax))).

	self should: 
			[allocator intermediateForm 
				= #((block 1 (call eax) ))].
	self verifyAllocator.! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Coalesce, origional' stamp: 'wbk 11/9/2002 15:34'!
testCoalesceTooManyHighDegreeNodes
	self createAndPrepareAllocator: #(	(#block 1 (mov t1 t8) (add t1 t2) (add t3 t4) (add t5 t6) (add t1 t7) )).

	allocator coalesce.

	self should: [allocator moveWorklist size = 1].
	self should: [allocator coalescedMoves size = 0].
	self verifyAllocator.
	! !

!ColouringRegisterAllocatorTests methodsFor: 'Support' stamp: 'wbk 5/22/2004 21:52'!
verifyAllocatorMoveCounts
	allocator verify.! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Spill' stamp: 'wbk 8/1/2004 15:02'!
testSpillWriteArithmatic
	self createAllocator: #(#(#block 1 #(#add 1 t1))).
	allocator spiltRegisters: {machine registerNamed: #t1}.

	allocator insertSpills.

	self should: 
			[allocator source intermediateForm =
				#(#(#block 1 
						#(#mov #(-16 #ebp) #t1v1) 
						#(#add  1 #t1v1) 
						(mov t1v1 (-16 ebp))))].
	self verifyAllocator.! !

!ColouringRegisterAllocatorTests methodsFor: 'Test - Allocate' stamp: 'wbk 6/24/2003 13:28'!
testToSpecialRegister
	self createAllocator: #((block 1 (mov t1 ebp) )).
	allocator run.
	self should: [allocator intermediateForm = #((block 1 (mov eax ebp) ))].
	self verifyAllocator.! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Coalesce, origional' stamp: 'wbk 11/9/2002 15:30'!
testCoalesceBuildMovWorklistInterferes
	" A single add does not produce an interference edge, add %eax, %eax is the same assuming
	t1 and t2 are never used again later."
	self createAndPrepareAllocator: #(#(#block 1 #(#mov t1 #t2) (add t1 t2) (add t1 t2) )). 

	self should: [allocator moveWorklist isEmpty].
	self should: [allocator simplifyWorklist size = 2].
	self should: [allocator spillWorklist isEmpty].
	self verifyAllocator.! !

ExuperyTests subclass: #IntermediateGenerationTests
	instanceVariableNames: 'machine generator emitter result'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Programmer Tests'!

!IntermediateGenerationTests methodsFor: 'Tests - Comparision' stamp: 'wbk 1/17/2004 19:14'!
testGenerateNotEquals
	emitter addExpectedEmission: #(#emitConditionalBytecode 3 5 #je 7).
	result := generator 
				prim: (MedLiteral smallInteger: 1)
				notEquals: (MedLiteral smallInteger: 2).
	self verify! !

!IntermediateGenerationTests methodsFor: 'Tests - Arithmatic' stamp: 'wbk 2/8/2004 19:33'!
testDivide
	self
		expectWrappedCallWithFailBlockTo: #emitDivide
		failingTo: 9.
	result := generator 
				generate: (MedLiteral smallInteger: 2)
				divide: (MedLiteral smallInteger: 1).
	self should: [generator method numberOfBlocks = 2].
	self verify! !

!IntermediateGenerationTests methodsFor: 'Tests - Jump' stamp: 'wbk 8/17/2003 18:28'!
testGenerateJumpIfFalse
	emitter addExpectedEmission: #(#emitJumpIfFalse #(#emitLabelForByteCode 42) #anExpression).
	generator 
		jumpIfFalse: #anExpression
		to: 42.
	self verify.! !

!IntermediateGenerationTests methodsFor: 'Tests - Send Generation' stamp: 'wbk 1/10/2004 15:14'!
testSendMessageWithStackValues
	emitter anyOrder.
	emitter addExpectedEmission: #(#emitSend #(#emitLiteralAddress 3) #abc #def).
	result := generator 
				sendSelector: #basicTarget
				inSlot: 3
				arguments: #(#abc #def).
	self checkIsMed: result.
	self verify! !

!IntermediateGenerationTests methodsFor: 'Misc' stamp: 'wbk 3/17/2003 17:59'!
setUp
	emitter := MockIntermediateEmitter new.
	generator := IntermediateGenerator for: MachineX86 new.
	generator emitter: emitter.! !

!IntermediateGenerationTests methodsFor: 'Tests - Arithmatic' stamp: 'wbk 2/8/2004 19:34'!
testGenerateMinusByteCode
	self
		expectIntegerWrappedCallTo: #sub
		failingTo: 1.
	result := generator 
				generate: (MedLiteral smallInteger: 2)
				subtract: (MedLiteral smallInteger: 1).
	self should: [generator method numberOfBlocks = 2].
	self verify! !

!IntermediateGenerationTests methodsFor: 'Tests - Arithmatic' stamp: 'wbk 2/8/2004 19:33'!
testDiv
	self
		expectWrappedCallWithFailBlockTo: #emitDiv
		failingTo: 13.
	result := generator 
				generate: (MedLiteral smallInteger: 2)
				div: (MedLiteral smallInteger: 1).
	self should: [generator method numberOfBlocks = 2].
	self verify! !

!IntermediateGenerationTests methodsFor: 'Tests - Common Sends' stamp: 'wbk 2/28/2004 16:56'!
testEquivilent
	| answer |
	emitter addExpectedEmission: #(#emitConvertComparisionToBoolean jne (sub arg1 arg2) ).
	answer := generator 
				generate: #arg1
				equivilent: #arg2.
	self checkIsMed: answer.
	self verify! !

!IntermediateGenerationTests methodsFor: 'Tests - Return' stamp: 'wbk 11/27/2003 21:22'!
testGenerateReturnFalse
	emitter addExpectedEmission: 
		#(emitReturnValue (emitFalseAddress)).
	generator returnFalse.
	self verify.! !

!IntermediateGenerationTests methodsFor: 'Tests - Misc' stamp: 'wbk 7/24/2004 11:34'!
testIntermediateForReturnString
	|method|
	"(mem (add (mem (add  (mem (add ebp 8)) 12)) 8)) is all that we want to test, the rest is the return byte code"
	method := ByteCodeReaderTests compiledMethodAt: #returnString.
	generator := IntermediateGenerator for: MachineX86 new.
	ByteCodeReader
		newMethod: method
		using: generator
		jumpTargets: #()
		stackHeights: #().
	self should: [generator intermediateString = 
		#((block 2
			(mov (mem (add ebp 8)) currentContext))
		  (block 1 
			#(mov (mem (add (mem (add currentContext 16)) 8)) s1)  	
			#(mov (mem (add currentContext 4)) t1)			"Senders Context"
			#(mov (add (mem (add t1 12)) 2) t2) 					"New Stack Ptr"
			#(mov t2 (mem (add t1 12))) 							"Save Stack Ptr"
			#(mov s1 (mem (add (add t1 (sal t2 1)) 22))) 	"Place literal on callers stack" 
			(mov 1 eax)
			#(ret)))].
	self verify.! !

!IntermediateGenerationTests methodsFor: 'Tests - Arithmatic' stamp: 'wbk 2/8/2004 19:33'!
expectWrappedCallWithFailBlockTo: aSymbol failingTo: anInteger
	emitter addExpectedEmission: 
		{#emitWithFailTo.
			{#emitConvertToSmallInteger. #block2.
				{aSymbol. #block2.
					#(emitIntegerValueOf block2 5).
					#(emitIntegerValueOf block2 3) }}. anInteger. 5. 3}.! !

!IntermediateGenerationTests methodsFor: 'Tests - Common Sends' stamp: 'wbk 1/10/2004 15:14'!
testSendAtPut
	" The emitMov is really coded as part of the block that is wrapped by emitWithFailTo, but
	the mock system can't yet encode this so I've told the emitter to expect it first.
	The problem is that the mock framework doesn't handle block additions that well, it does handle
	code that is built up as an expression."

	emitter addExpectedEmission: #(#emitBeRootIfNeeded #receiver #value).
	emitter addExpectedEmission: #(#mov #value #(#emitAtElementAddress #receiver #location #block2 32)).
	emitter addExpectedEmission: #(#emitWithFailTo #value 17 #receiver #location #value).
	result := generator 
				sendAtPutTo: #receiver
				location: #location
				value: #value.
	self checkIsMed: result.
	self verify! !

!IntermediateGenerationTests methodsFor: 'Tests - Common Sends' stamp: 'wbk 2/13/2004 20:38'!
testMakePoint
	| answer |
	emitter anyOrder.
	emitter addExpectedEmission: #(#emitSend #(#emitSpecialSelector 11) 4 5).
	answer := generator 
				generate: 4
				makePoint: 5.
	self checkIsMed: answer.
	self verify! !

!IntermediateGenerationTests methodsFor: 'Misc' stamp: 'wbk 3/1/2004 20:30'!
checkIsMed: anObject
	(anObject isKindOf: MedLanguage) ifTrue: [^ true].
	anObject isSequenceable ifTrue:
		[^ self assert: (#(emitSend emitWithFailTo emitConvertComparisionToBoolean emitClass) includes: (anObject at: 1))].
	self assert: (anObject isKindOf: MedLanguage).	"This is inadiquate. What I really should do is check
												  that the answer is a reasonable type/object"! !

!IntermediateGenerationTests methodsFor: 'Tests - Jump' stamp: 'wbk 2/14/2004 12:14'!
testGenerateJumpIfTrue
	emitter addExpectedEmission: #(#emitJumpIfTrue #(#emitLabelForByteCode 42) #anExpression).
	generator 
		jumpIfTrue: #anExpression
		to: 42.
	self verify.! !

!IntermediateGenerationTests methodsFor: 'Tests - Stack Generation' stamp: 'wbk 1/10/2004 15:14'!
testPushTrue
	emitter addExpectedEmission: #(#emitMoveToTemp #(#emitTrueAddress)).
	result := generator pushTrue.
	self assert: result = #(#emitMoveToTemp #(#emitTrueAddress)).
	self verify! !

!IntermediateGenerationTests methodsFor: 'Tests - Common Sends' stamp: 'wbk 3/1/2004 20:22'!
testClass
	emitter addExpectedEmission: #(#emitClass #abc).
	result := generator generateClass: #abc.
	self checkIsMed: result.
	self verify! !

!IntermediateGenerationTests methodsFor: 'Tests - Comparision' stamp: 'wbk 1/14/2004 21:23'!
testGenerateGreaterThanEqual
	emitter addExpectedEmission: #(#emitConditionalBytecode 3 7 #jl 5).
	result := generator 
				prim: (MedLiteral smallInteger: 1)
				greaterThanEqual: (MedLiteral smallInteger: 3).
	self verify! !

!IntermediateGenerationTests methodsFor: 'Tests - Comparision' stamp: 'wbk 1/17/2004 20:55'!
testGenerateSendLessThan
	emitter addExpectedEmission: #(#emitConditionalBytecode 3 5 #jge 2).
	result := generator 
				prim: (MedLiteral smallInteger: 1)
				lessThan: (MedLiteral smallInteger: 2).
	self verify! !

!IntermediateGenerationTests methodsFor: 'Tests - Stack Generation' stamp: 'wbk 1/10/2004 15:14'!
testPushFalse
	emitter addExpectedEmission: #(#emitMoveToTemp #(#emitFalseAddress)).
	result := generator pushFalse.
	self verify.
	self assert: result = #(#emitMoveToTemp #(#emitFalseAddress))! !

!IntermediateGenerationTests methodsFor: 'Tests - Stack Generation' stamp: 'wbk 7/24/2004 11:32'!
testGeneratePopIntoTemp2
	generator := IntermediateGenerator for: MachineX86 new.
	generator
		popIntoTemp: (MedLiteral smallInteger: 1)
		slot: 2.
	self should: 
		[generator intermediateString = #( 
			(block 1 
				(mov 3 (mem (add currentContext
									36 )) )))].
	self should: [generator method numberOfBlocks = 1].
	self verify.! !

!IntermediateGenerationTests methodsFor: 'Tests - Comparision' stamp: 'wbk 1/17/2004 22:13'!
testGenerateSendLessOrEqual
	emitter addExpectedEmission: #(#emitConditionalBytecode 3 5 #jg 4).
	result := generator 
				prim: (MedLiteral smallInteger: 1)
				lessThanEquals: (MedLiteral smallInteger: 2).
	self verify! !

!IntermediateGenerationTests methodsFor: 'Tests - Common Sends' stamp: 'wbk 2/22/2004 15:44'!
testBytecodePrimNewWithArg
	| answer |
	emitter anyOrder.
	emitter addExpectedEmission: #(#emitSend #(#emitSpecialSelector 29) 4 5).
	answer := generator 
				generateBinarySelector: 29
				receiver: 4
				argument: 5.
	self checkIsMed: answer.
	self verify! !

!IntermediateGenerationTests methodsFor: 'Tests - Arithmatic' stamp: 'wbk 2/8/2004 19:27'!
expectIntegerWrappedCallTo: aSymbol failingTo: anInteger
	emitter addExpectedEmission: 
		{#emitWithFailTo.
			{#emitConvertToSmallInteger. #block2.
				{aSymbol.
					#(emitIntegerValueOf block2 5).
					#(emitIntegerValueOf block2 3) }}. anInteger. 5. 3}.! !

!IntermediateGenerationTests methodsFor: 'Tests - Arithmatic' stamp: 'wbk 2/8/2004 19:31'!
testGenerateAddByteCode2
	emitter addExpectedEmission: 
		#(#emitWithFailTo 
			#(#emitConvertToSmallInteger #block2 
				#(#add 
					#(#emitIntegerValueOf #block2 3) 
					#(#emitIntegerValueOf #block2 5))) 0 3 5).
	result := generator 
				generate: (MedLiteral smallInteger: 1)
				add: (MedLiteral smallInteger: 2).
	self verify! !

!IntermediateGenerationTests methodsFor: 'Tests - Return' stamp: 'wbk 11/27/2003 19:49'!
testGenerateReturnTrue
	emitter addExpectedEmission: 
		#(emitReturnValue (emitTrueAddress)).

	generator returnTrue.

	self verify.! !

!IntermediateGenerationTests methodsFor: 'Tests - Arithmatic' stamp: 'wbk 2/8/2004 19:28'!
testBitAnd
	self
		expectIntegerWrappedCallTo: #and
		failingTo: 14.
	result := generator 
				generate: (MedLiteral smallInteger: 2)
				bitAnd: (MedLiteral smallInteger: 1).
	self verify! !

!IntermediateGenerationTests methodsFor: 'Tests - Comparision' stamp: 'wbk 1/12/2004 20:38'!
testGenerateGreaterThan
	emitter addExpectedEmission: #(#emitConditionalBytecode 3 5 #jle 3).
	result := generator 
				prim: (MedLiteral smallInteger: 1)
				greaterThan: (MedLiteral smallInteger: 2).
	self verify! !

!IntermediateGenerationTests methodsFor: 'Tests - Return' stamp: 'wbk 10/18/2003 13:49'!
testGenerateReturnSelf
	emitter addExpectedEmission: 
		#(emitReturnValue (emitReceiverAddress)).

	generator returnSelf.

	self verify.! !

!IntermediateGenerationTests methodsFor: 'Tests - Comparision' stamp: 'wbk 1/14/2004 21:42'!
testGenerateEquals
	emitter addExpectedEmission: #(#emitConditionalBytecode 3 5 #jne 6).
	result := generator 
				prim: (MedLiteral smallInteger: 1)
				equals: (MedLiteral smallInteger: 2).
	self verify! !

!IntermediateGenerationTests methodsFor: 'Tests - Send Generation' stamp: 'wbk 1/10/2004 15:14'!
testSendMessage
	emitter anyOrder.
	emitter addExpectedEmission: #(#emitSend #(#emitLiteralAddress 3)).
	result := generator 
				sendSelector: #basicTarget
				inSlot: 3
				arguments: #().
	self checkIsMed: result.
	self verify! !

!IntermediateGenerationTests methodsFor: 'Tests - Jump' stamp: 'wbk 11/20/2003 22:07'!
testGenerateUnconditionalJump
	emitter addExpectedEmission: #(#jmp #(#emitLabelForByteCode 42)).
	generator unconditionalJumpTo: 42.
	self verify.! !

!IntermediateGenerationTests methodsFor: 'Tests - Return' stamp: 'wbk 7/24/2004 11:03'!
testGenerateReturnTop
	|method |
	method := ByteCodeReaderTests compiledMethodAt: #return4.
	generator := IntermediateGenerator for: MachineX86 new.
	ByteCodeReader
		newMethod: method
		using: generator
		jumpTargets: #()
		stackHeights: #().
	self assert: generator intermediateString = 
		#((block 2
			(mov (mem (add ebp 8)) currentContext))
		  (block 1 
			#(mov 9 s1)
			#(mov (mem (add currentContext 4)) t1)  				"Senders Context"
			#(mov (add (mem (add t1 12)) 2) t2) 					"New Stack Ptr"
			#(mov t2 (mem (add t1 12))) 							"Save Stack Ptr"
			#(mov s1 (mem (add (add t1 (sal t2 1)) 22))) 	"Place 4 on callers stack"
			 (mov 1 eax)
			#(ret))).
	self verify.
	! !

!IntermediateGenerationTests methodsFor: 'Tests - Stack Generation' stamp: 'wbk 7/24/2004 11:32'!
testGeneratePopIntoTemp
	generator := IntermediateGenerator for: MachineX86 new.
	generator
		popIntoTemp: (MedLiteral smallInteger: 1)
		slot: 0.
	self should: 
		[generator intermediateString = #( 
			(block 1 
				(mov 3 (mem (add currentContext
									28)) )))].
	self should: [generator method numberOfBlocks = 1].
	self verify.! !

!IntermediateGenerationTests methodsFor: 'Tests - Stack Generation' stamp: 'wbk 1/10/2004 15:14'!
testPushInstanceVariable
	emitter addExpectedEmission: #(#emitMoveToTemp #(#emitFetchAddress 5 #(#emitReceiverAddress))).
	result := generator pushInstanceVariable: 5.
	self verify! !

!IntermediateGenerationTests methodsFor: 'Tests - Return' stamp: 'wbk 10/18/2003 13:49'!
testGenerateReturnNil
	emitter addExpectedEmission: 
		#(emitReturnValue (emitNilAddress)).

	generator returnNil.

	self verify.! !

!IntermediateGenerationTests methodsFor: 'Tests - Send Generation' stamp: 'wbk 1/10/2004 15:14'!
testSendMessageWithStackValues2
	"Tests real stack values as well as arguments"

	emitter anyOrder.
	emitter addExpectedEmission: #(#emitSend #(#emitLiteralAddress 3) #abc #def).
	result := generator 
				sendSelector: #basicTarget
				inSlot: 3
				arguments: #(#abc #def).
	self checkIsMed: result.
	self verify! !

!IntermediateGenerationTests methodsFor: 'Tests - Stack Generation' stamp: 'wbk 11/17/2003 22:05'!
testStoreAndPopInstanceVariable
	emitter addExpectedEmission: #(emitBeRootIfNeeded (emitReceiverAddress) theValue).
	emitter addExpectedEmission: 
		#(mov
			theValue 
			(emitFetchAddress 5 (emitReceiverAddress))).
	generator 
		storeAndPopReceiverVariableIndex: 5
		value: #theValue.
	self verify! !

!IntermediateGenerationTests methodsFor: 'Tests - Arithmatic' stamp: 'wbk 2/8/2004 19:37'!
testGenerateSendMultiply
	self
		expectWrappedCallWithFailBlockTo: #emitMultiply
		failingTo: 8.
	result := generator 
				generate: (MedLiteral smallInteger: 2)
				multiply: (MedLiteral smallInteger: 1).
	self should: [generator method numberOfBlocks = 2].
	self verify! !

!IntermediateGenerationTests methodsFor: 'Tests - Common Sends' stamp: 'wbk 1/10/2004 15:14'!
testSendAt
	"Explicit send and inlined operation must use the same register"

	emitter addExpectedEmission: #(#emitWithFailTo #(#emitAtElementAddress #arg1 #arg2 #block2 0) 16 #arg1 #arg2).
	result := generator 
				sendAtTo: #arg1
				with: #arg2.
	self checkIsMed: result.
	self verify! !

!IntermediateGenerationTests methodsFor: 'Tests - Stack Generation' stamp: 'wbk 1/10/2004 15:14'!
testPushNil
	emitter addExpectedEmission: #(#emitMoveToTemp #(#emitNilAddress)).
	result := generator pushNil.
	self assert: result = #(#emitMoveToTemp #(#emitNilAddress)).
	self verify! !

!IntermediateGenerationTests methodsFor: 'Tests - Stack Generation' stamp: 'wbk 1/10/2004 15:14'!
testPushLiteralVariable
	" The address 1 below is counting from zero. It is accessing the value in the 	ReadOnlyValueBinding 	or Association that holds the variable 'Array'."

	emitter addExpectedEmission: #(#mov #(#emitFetchAddress 1 #(#emitLiteralAddress 5)) #t1).	"could use emitMoveToTemp rather than doing it explicitly"	"Fetching the address get's the value from the variable's holder"
	result := generator 
				pushLiteralVariable: #aName
				slot: 5.
	self assert: result intermediateForm = #t1.
	self verify! !

!IntermediateGenerationTests methodsFor: 'Tests - Arithmatic' stamp: 'wbk 2/8/2004 19:41'!
testMod
	self
		expectWrappedCallWithFailBlockTo: #emitMod
		failingTo: 10.
	result := generator 
				generate: (MedLiteral smallInteger: 2)
				mod: (MedLiteral smallInteger: 1).
	self should: [generator method numberOfBlocks = 2].
	self verify! !

!IntermediateGenerationTests methodsFor: 'Tests - Common Sends' stamp: 'wbk 2/22/2004 14:04'!
testUnarySelector
	| answer |
	emitter addExpectedEmission: #(#emitSend #(#emitSpecialSelector 16) 4).
	answer := generator 
		generateUnarySelector: 16
		receiver: 4.
	self checkIsMed: answer.
	self verify! !

!IntermediateGenerationTests methodsFor: 'Tests - Stack Generation' stamp: 'wbk 7/31/2003 17:12'!
testPopStack
	generator popStack: 5.
	self verify! !

!IntermediateGenerationTests methodsFor: 'Tests - Jump' stamp: 'wbk 5/30/2004 23:05'!
testGenerateJumpTargetLabel
	emitter addExpectedEmission: #(#emitJumpTarget 10).
	generator jumpTargets: #(10).
	generator byteCodeAddress: 10.
	self verify.! !

!IntermediateGenerationTests methodsFor: 'Misc' stamp: 'wbk 3/1/2004 20:31'!
checkIsRegister: anObject 
	anObject isCollection ifTrue: 
		[(anObject at: 1) = #emitConvertLessOrEqualToBoolean ifTrue: [^ self].
		(anObject at: 1) = #emitMoveToTemp ifTrue: [^ self].
		(anObject at: 1) = #emitSend ifTrue: [^ self].
		(anObject at: 1) = #emitWithFailTo ifTrue: [^ self].
		(anObject at: 1) = #emitConditionalBytecode ifTrue: [^ self].
		(anObject at: 1) = #emitClass ifTrue: [^ self]].
	^ self assert: (anObject isKindOf: MedTemporaryRegister)! !

!IntermediateGenerationTests methodsFor: 'Tests - Stack Generation' stamp: 'wbk 1/10/2004 15:14'!
testGeneratePushTemp
	emitter addExpectedEmission: #(#emitMoveToTemp #(#emitTemporaryAddress 0)).
	result := generator pushTempAt: 0.
	self should: [generator method numberOfBlocks = 1].
	self verify! !

!IntermediateGenerationTests methodsFor: 'Tests - Arithmatic' stamp: 'wbk 2/8/2004 19:28'!
testBitOr
	self
		expectIntegerWrappedCallTo: #or
		failingTo: 15.
	result := generator 
				generate: (MedLiteral smallInteger: 2)
				bitOr: (MedLiteral smallInteger: 1).
	self verify! !

!IntermediateGenerationTests methodsFor: 'Misc' stamp: 'wbk 1/10/2004 15:14'!
verify
	emitter verify.
	result ifNotNil: [self checkIsRegister: result]! !

!IntermediateGenerationTests methodsFor: 'Tests - Arithmatic' stamp: 'wbk 2/9/2004 21:44'!
testBitShifts
	self
		expectWrappedCallWithFailBlockTo: #bitShift
		failingTo: 12.
	result := generator 
				generate: (MedLiteral smallInteger: 2)
				bitShift: (MedLiteral smallInteger: 1).
	self verify! !

!IntermediateGenerationTests methodsFor: 'Tests - Stack Generation' stamp: 'wbk 1/10/2004 15:14'!
testPushSelf
	emitter addExpectedEmission: #(#emitMoveToTemp #(#emitReceiverAddress)).
	result := generator pushSelf.
	self verify! !

TestCase subclass: #AssemblerTests
	instanceVariableNames: 'machine intermediate code'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Programmer Tests'!

!AssemblerTests methodsFor: 'Tests - Sal' stamp: 'wbk 3/17/2003 14:35'!
testSalWithConstant
	self basicAssemble: #(#(#block 1 #(#sal 2 #eax))).
	self should: [code = #(193 224 2) asByteArray]! !

!AssemblerTests methodsFor: 'Tests - Move' stamp: 'wbk 3/17/2003 14:35'!
testMoveFromIndirectAddress
	self basicAssemble: #(#(#block 1 #(#mov #(8 #ebx) #eax))).
	self should: [code = #(139 67 8) asByteArray]! !

!AssemblerTests methodsFor: 'Tests - Sal' stamp: 'wbk 2/8/2004 21:22'!
testSalWithRegister
	self basicAssemble: #(#(#block 1 #(#sal #ecx #eax))).
	self should: [code = #(16rD3 16rE0) asByteArray]! !

!AssemblerTests methodsFor: 'Tests - Registers' stamp: 'wbk 4/17/2003 11:01'!
testEdi
	self basicAssemble: #(#(#block 1 #(#mov #eax #edi)) ).
	self should: [code = #(137 16rC7 ) asByteArray]! !

!AssemblerTests methodsFor: 'Tests - Add' stamp: 'wbk 3/21/2003 08:58'!
testAddToIndirection
	self basicAssemble: #(#(#block 1 #(#add #eax #(4 #ebx)))).
	self should: [code = #(1 67 4) asByteArray].! !

!AssemblerTests methodsFor: 'Tests - Jump' stamp: 'wbk 8/10/2003 00:17'!
testForwardJumpFurther
	self basicAssemble: #((block 1 (jz block2) (mov eax ebx)) (block 2) ).
	self assert: code = #(16r0F 16r84 2 0 0 0 137 195 ) asByteArray! !

!AssemblerTests methodsFor: 'Tests - Jump' stamp: 'wbk 8/10/2003 00:17'!
testJumpGreater
	self basicAssemble: #((block 1 (jg block2) (mov eax ebx)) (block 2) ).
	self assert: code = #(16r0F 16r8F 2 0 0 0 137 195 ) asByteArray! !

!AssemblerTests methodsFor: 'Tests - Registers' stamp: 'wbk 4/4/2003 11:19'!
testEsi
	self basicAssemble: #((block 1 (mov eax esi))).
	self should: [code = #(137 16rC6) asByteArray]! !

!AssemblerTests methodsFor: 'Tests - Registers' stamp: 'wbk 4/3/2003 23:20'!
testEcx
	self basicAssemble: #(#(#block 1 #(#mov #eax #ecx))).
	self should: [code = #(137 16rC1) asByteArray]! !

!AssemblerTests methodsFor: 'Tests - Jump' stamp: 'wbk 8/10/2003 00:18'!
testJumpAlways
	self basicAssemble: #(#(#block 1 #(#jmp #block2)) #(#block 2) ).
	self assert: code = #(16rE9 0 0 0 0) asByteArray! !

!AssemblerTests methodsFor: 'Tests - Or' stamp: 'wbk 11/21/2003 22:56'!
testOrFromIndirection
	self basicAssemble: #(#(#block 1 #(#or #(8 #ebx) #eax))).
	self should: [code = #(16r0B 67 8) asByteArray].! !

!AssemblerTests methodsFor: 'Tests - True and False Objects' stamp: 'wbk 4/9/2003 22:44'!
testEncodeTrue
	self 
		basicAssemble: #(#(#block 1 #(mov trueObj ebx)))
		withPlugin: MockExuperyPlugin new.
	self should: [code = #(187 16r56 16r34 16r12 16r40) asByteArray].! !

!AssemblerTests methodsFor: 'Misc' stamp: 'wbk 4/8/2003 12:43'!
basicAssemble: anArray 
	^ self
		basicAssemble: anArray
		withPlugin: TestExuperyPlugin! !

!AssemblerTests methodsFor: 'Tests - Move' stamp: 'wbk 3/17/2003 14:35'!
testMoveToIndirectAddress
	self basicAssemble: #(#(#block 1 #(#mov #eax #(4 #ebx)))).
	self should: [code = #(137 67 4) asByteArray]! !

!AssemblerTests methodsFor: 'Tests - Jump' stamp: 'wbk 1/14/2004 21:50'!
testJumpNotEquals
	self basicAssemble: #(#(#block 1 #(#jne #block2)) #(#block 2) ).
	self assert: code = #(16r0F 16r85 0 0 0 0) asByteArray! !

!AssemblerTests methodsFor: 'Tests - Sub' stamp: 'wbk 4/7/2003 21:12'!
testSubFromConstant
	self basicAssemble: #(#(#block 1 #(#sub 42 #eax))).
	self should: [code = #(16r81 16rE8 42 0 0 0) asByteArray].! !

!AssemblerTests methodsFor: 'Tests - Misc' stamp: 'wbk 6/25/2003 16:23'!
testPushEbx
	self basicAssemble: #(#(#block 1 (push ebx))).
	self assert: code = #(16r53) asByteArray! !

!AssemblerTests methodsFor: 'Tests - Move' stamp: 'wbk 3/17/2003 14:35'!
testMoveFromConstantToIndirect
	self basicAssemble: #(#(#block 1 #(#mov 87 #(28 #eax)))).
	self should: [code = #(199 64 28 87 0 0 0) asByteArray]! !

!AssemblerTests methodsFor: 'Tests - Mul' stamp: 'wbk 4/11/2003 17:52'!
testMulFromIndirection
	self basicAssemble: #(#(#block 1 #(#mul #(8 #ebx) #eax))).
	self should: [code = #(16r0F 16rAF 67 8) asByteArray].! !

!AssemblerTests methodsFor: 'Tests - Cdq' stamp: 'wbk 2/2/2004 21:25'!
testCdq
	self basicAssemble: #(#(#block 1 (cdq) )).
	self should: [code = #(16r99) asByteArray].! !

!AssemblerTests methodsFor: 'Tests - Jump' stamp: 'wbk 8/10/2003 00:18'!
testForwardJump
	self basicAssemble: #(#(#block 1 #(#jz #block2)) #(#block 2) ).
	self assert: code = #(16r0F 16r84 0 0 0 0) asByteArray! !

!AssemblerTests methodsFor: 'Tests - Move' stamp: 'wbk 3/17/2003 14:35'!
testMoveFromConstantToEBX
	self basicAssemble: #(#(#block 1 #(#mov 1 #ebx))).
	self should: [code = #(187 1 0 0 0) asByteArray]! !

!AssemblerTests methodsFor: 'Tests - Misc' stamp: 'wbk 6/25/2003 16:33'!
testCall
	self basicAssemble: #(#(#block 1 (call 16r12345678))).
	self assert: code = #(16rFF 16r15 16r78 16r56 16r34 16r12) asByteArray! !

!AssemblerTests methodsFor: 'Tests - Jump' stamp: 'wbk 8/10/2003 00:21'!
testJumpLess
	self basicAssemble: #(#(#block 1 #(#jl #block2)) #(#block 2) ).
	self assert: code = #(16r0F 16r8C 0 0 0 0) asByteArray! !

!AssemblerTests methodsFor: 'Tests - Jump' stamp: 'wbk 11/21/2003 21:05'!
testJumpGreaterEquals
	self basicAssemble: #(#(#block 1 #(#jge #block2)) #(#block 2) ).
	self assert: code = #(16r0F 16r8D 0 0 0 0) asByteArray! !

!AssemblerTests methodsFor: 'Tests - And' stamp: 'wbk 4/4/2003 14:43'!
testAndFromIndirection
	self basicAssemble: #(#(#block 1 #(#and #(8 #ebx) #eax))).
	self should: [code = #(16r23 67 8) asByteArray].! !

!AssemblerTests methodsFor: 'Tests - Sar' stamp: 'wbk 4/4/2003 15:59'!
testSarWithConstant
	self basicAssemble: #(#(#block 1 #(#sar 2 #eax))).
	self should: [code = #(16rC1 16rF8 2) asByteArray]! !

!AssemblerTests methodsFor: 'Tests - Div' stamp: 'wbk 1/31/2004 18:31'!
testDivide2
	self basicAssemble: #(#(#block 1 (div ecx) )).
	self should: [code = #(16rF7 16rF9) asByteArray].! !

!AssemblerTests methodsFor: 'Tests - Negate' stamp: 'wbk 2/9/2004 21:13'!
testNegate
	self basicAssemble: #(#(#block 1 #(#neg #(8 #ebx)))).
	self should: [code = #(16rF7 16r5B 8) asByteArray ].! !

!AssemblerTests methodsFor: 'Tests - Jump' stamp: 'wbk 8/10/2003 00:18'!
testJumpOverflow
	self basicAssemble: #(#(#block 1 #(#jo #block2)) #(#block 2) ).
	self assert: code = #(16r0F 16r80 0 0 0 0) asByteArray! !

!AssemblerTests methodsFor: 'Tests - Or' stamp: 'wbk 11/21/2003 22:53'!
testOrToIndirection
	self basicAssemble: #(#(#block 1 #(#or #eax #(4 #ebx)))).
	self should: [code = #(16r09 67 4) asByteArray].! !

!AssemblerTests methodsFor: 'Tests - Jump' stamp: 'wbk 8/10/2003 00:18'!
testJumpNotZero
	self basicAssemble: #(#(#block 1 #(#jnz #block2)) #(#block 2) ).
	self assert: code = #(16r0F 16r85 0 0 0 0) asByteArray! !

!AssemblerTests methodsFor: 'Tests - And' stamp: 'wbk 4/4/2003 15:53'!
testAndFromConstant
	self basicAssemble: #(#(#block 1 #(#and 42 #eax))).
	self should: [code = #(16r81 16rE0 42 0 0 0) asByteArray].! !

!AssemblerTests methodsFor: 'Tests - True and False Objects' stamp: 'wbk 4/11/2003 16:12'!
testEncodeFalse
	self 
		basicAssemble: #(#(#block 1 #(mov falseObj ebx)))
		withPlugin: MockExuperyPlugin new.
	self should: [code = #(187 16r57 16r35 16r13 16r41) asByteArray].! !

!AssemblerTests methodsFor: 'Tests - Sar' stamp: 'wbk 3/4/2004 20:52'!
testSarWithRegisterAndIndirection
	self basicAssemble: #(#(#block 1 #(#sar #ecx (8 ebx)))).
	self should: [code = #(16rD3 16r7B 8) asByteArray]! !

!AssemblerTests methodsFor: 'Tests - Add' stamp: 'wbk 3/21/2003 08:58'!
testAddFromIndirection
	self basicAssemble: #(#(#block 1 #(#add #(8 #ebx) #eax))).
	self should: [code = #(3 67 8) asByteArray].! !

!AssemblerTests methodsFor: 'Misc' stamp: 'wbk 4/8/2003 12:42'!
basicAssemble: anArray withPlugin: aPlugin
	intermediate := MedMethod 
		createAssembly: anArray 
		for: machine.
	code := AssemblerExupery 
		basicAssemble: intermediate
		withPlugin: aPlugin! !

!AssemblerTests methodsFor: 'Tests - Move' stamp: 'wbk 3/17/2003 14:35'!
testMoveFromConstant
	self basicAssemble: #(#(#block 1 #(#mov 1 #eax))).
	self should: [code = #(184 1 0 0 0) asByteArray]! !

!AssemblerTests methodsFor: 'Tests - Misc' stamp: 'wbk 6/30/2003 20:21'!
testCallRegister
	self basicAssemble: #(#(#block 1 (call eax))).
	self assert: code = #(16rFF 16rD0) asByteArray! !

!AssemblerTests methodsFor: 'Tests - Misc' stamp: 'wbk 6/25/2003 16:16'!
testPush
	self basicAssemble: #(#(#block 1 (push eax))).
	self assert: code = #(16r50) asByteArray! !

!AssemblerTests methodsFor: 'Tests - Sub' stamp: 'wbk 4/7/2003 20:59'!
testSubToIndirection
	self basicAssemble: #(#(#block 1 #(#sub #eax #(4 #ebx)))).
	self should: [code = #(16r29 67 4) asByteArray].! !

!AssemblerTests methodsFor: 'Tests - Sub' stamp: 'wbk 4/7/2003 20:55'!
testSubFromIndirection
	self basicAssemble: #(#(#block 1 #(sub (8 ebx) eax))).
	self should: [code = #(16r2B 67 8) asByteArray].! !

!AssemblerTests methodsFor: 'Tests - Registers' stamp: 'wbk 4/3/2003 23:22'!
testEdx
	self basicAssemble: #(#(#block 1 #(#mov #eax #edx))).
	self should: [code = #(137 16rC2) asByteArray]! !

!AssemblerTests methodsFor: 'Tests - Sal' stamp: 'wbk 2/8/2004 21:54'!
testSalWithRegisterAndIndirection
	self basicAssemble: #(#(#block 1 #(#sal #ecx (8 ebx)))).
	self should: [code = #(16rD3 16r63 8) asByteArray]! !

!AssemblerTests methodsFor: 'Tests - Misc' stamp: 'wbk 7/30/2004 21:31'!
testPreamble
	intermediate := MedMethod 
		createAssembly: #(#(#block 1 (mov eax ebx))) 
		for: machine.
	code := AssemblerExupery 
		assemble: intermediate
		withPlugin: MockExuperyPlugin.
	self should: [code = #(16r55 16r89 16rE5 16r53 16r56 16r57 16r83 16rEC 64 137 195 ) asByteArray]
! !

!AssemblerTests methodsFor: 'Tests - Jump' stamp: 'wbk 8/10/2003 11:19'!
testJumpLessThanEquals
	self basicAssemble: #(#(#block 1 #(#jle #block2)) #(#block 2) ).
	self assert: code = #(16r0F 16r8E 0 0 0 0) asByteArray! !

!AssemblerTests methodsFor: 'Tests - Registers' stamp: 'wbk 4/4/2003 11:22'!
testEsp
	self basicAssemble: #(#(#block 1 #(#mov #eax #esp))).
	self should: [code = #(137 16rC4) asByteArray]! !

!AssemblerTests methodsFor: 'Tests - Div' stamp: 'wbk 1/31/2004 18:31'!
testDivide
	self basicAssemble: #(#(#block 1 (div ebx) )).
	self should: [code = #(16rF7 16rFB) asByteArray].! !

!AssemblerTests methodsFor: 'Tests - Sar' stamp: 'wbk 2/8/2004 22:10'!
testSarWithRegister
	self basicAssemble: #(#(#block 1 #(#sar #ecx #eax))).
	self should: [code = #(16rD3 16rF8) asByteArray]! !

!AssemblerTests methodsFor: 'Tests - Misc' stamp: 'wbk 3/17/2003 14:35'!
testTrivialAssembling
	self basicAssemble: #(#(#block 1)).
	self should: [code = #() asByteArray]! !

!AssemblerTests methodsFor: 'Tests - Or' stamp: 'wbk 11/21/2003 22:52'!
testOrFromConstant
	self basicAssemble: #(#(#block 1 #(#or 42 #eax))).
	self should: [code = #(16r81 16rC8 42 0 0 0) asByteArray].! !

!AssemblerTests methodsFor: 'Tests - Move' stamp: 'wbk 4/11/2003 13:57'!
testMoveToBasicIndirectAddress
	self basicAssemble: #((block 1 (mov eax (ebx)))).
	self should: [code = #(137 16r03) asByteArray]! !

!AssemblerTests methodsFor: 'Tests - Add' stamp: 'wbk 8/23/2003 15:30'!
testAddFromConstant
	self basicAssemble: #(#(#block 1 #(#add 42 #eax))).
	self should: [code = #(129 192 42 0 0 0) asByteArray].! !

!AssemblerTests methodsFor: 'Tests - Move' stamp: 'wbk 6/2/2004 22:00'!
testMoveToNegative128Offset
	self basicAssemble: #(#(#block 1 #(#mov #eax #(-128 #ebx)))).
	self should: [code = #(137 67 16r80) asByteArray]! !

!AssemblerTests methodsFor: 'Tests - Move' stamp: 'wbk 6/2/2004 21:58'!
testMoveToNegativeOffset
	self basicAssemble: #(#(#block 1 #(#mov #eax #(-1 #ebx)))).
	self should: [code = #(137 67 255) asByteArray]! !

!AssemblerTests methodsFor: 'Tests - And' stamp: 'wbk 4/4/2003 14:55'!
testAndToIndirection
	self basicAssemble: #(#(#block 1 #(#and #eax #(4 #ebx)))).
	self should: [code = #(16r21 67 4) asByteArray].! !

!AssemblerTests methodsFor: 'Tests - Move' stamp: 'wbk 3/17/2003 14:35'!
testSingleMoveAssembling
	self basicAssemble: #(#(#block 1 #(#mov #eax #ebx))).
	self should: [code = #(137 195) asByteArray]! !

!AssemblerTests methodsFor: 'Tests - Move' stamp: 'wbk 3/17/2003 14:35'!
testUsingRegisterEbp
	self basicAssemble: #(#(#block 1 #(#mov #eax #ebp))).
	self should: [code = #(137 197) asByteArray]! !

!AssemblerTests methodsFor: 'Tests - Move' stamp: 'wbk 7/18/2003 12:25'!
testMoveLargeOffsetIndirectAddress
	self basicAssemble: #(#(#block 1 #(#mov #eax #(16rEE #ebx)))).
	self should: [code = #(137 16r83 16rEE 0 0 0) asByteArray]! !

!AssemblerTests methodsFor: 'Tests - Misc' stamp: 'wbk 7/30/2004 21:36'!
testRet
	self basicAssemble: #(#(#block 1 #(#ret))).
	self should: [code = #(16r83 16rC4 64 95 94 91 137 236 93 195) asByteArray]! !

!AssemblerTests methodsFor: 'Tests - Jump' stamp: 'wbk 8/10/2003 00:18'!
testJumpEqual
	self basicAssemble: #(#(#block 1 #(#je #block2)) #(#block 2) ).
	self assert: code = #(16r0F 16r84 0 0 0 0) asByteArray! !

!AssemblerTests methodsFor: 'Tests - Move' stamp: 'wbk 3/17/2003 14:35'!
testSingleMoveDifferentFirstRegisterAssembling
	self basicAssemble: #(#(#block 1 #(#mov #ebx #ebx))).
	self should: [code = #(137 219) asByteArray]! !

!AssemblerTests methodsFor: 'Misc' stamp: 'wbk 3/16/2003 21:21'!
setUp
	machine := MachineX86 new.! !

!Interpreter methodsFor: '*Exupery-Compiler Support' stamp: 'wbk 4/18/2004 20:57'!
exuperyFalseObjAddress
	^self cCode: '&foo->falseObj'! !

!Interpreter methodsFor: '*Exupery-Compiler Support' stamp: 'wbk 11/21/2003 22:37'!
exuperyRootTableAddress
	^  self cCode: '&rootTable'! !

!Interpreter methodsFor: '*Exupery-override' stamp: 'wbk 4/18/2004 20:57'!
internalFindNewMethod
	"Find the compiled method to be run when the current messageSelector is sent to the class 'lkupClass', setting the values of 'newMethod' and 'primitiveIndex'."

	| ok |
	self inline: true.
	ok := self 
				lookupInMethodCacheSel: messageSelector
				class: lkupClass.
	ok ifFalse: 
			["entry was not found in the cache; look it up the hard way"

			self externalizeIPandSP.
			self lookupMethodInClass: lkupClass.
			self exuperyLookupMethodHook.
			self internalizeIPandSP.
			self addNewMethodToCache]! !

!Interpreter methodsFor: '*Exupery-Compiler Support' stamp: 'wbk 3/12/2004 19:34'!
exuperyYoungStartAddress
	^  self cCode: '&foo->youngStart'! !

!Interpreter methodsFor: '*Exupery-Compiler Support' stamp: 'wbk 4/18/2004 20:57'!
exuperyLookupMethod
	^newNativeMethod := self cCode: 'compilerHooks[15](foo->newMethod)'! !

!Interpreter methodsFor: '*Exupery-Compiler Support' stamp: 'wbk 3/8/2004 21:30'!
exuperyReturn: aFunction
	| answer activeCntxt |
	self inline: false.
	self var: #aFunction
		declareC: 'int (*aFunction) (int)'.
	activeCntxt := activeContext.
	answer := self cCode: 'aFunction (activeCntxt)'.
	self exuperyCompiledReturn: answer.
! !

!Interpreter methodsFor: '*Exupery-Compiler Support' stamp: 'wbk 11/14/2003 23:42'!
exuperyCheckRootTableFor: object
	| flag |
	self inline: false.
	flag := false.
	1 
		to: rootTableCount
		do:
			[:each| (rootTable at: each) = object ifTrue: [flag := true]].
	^ flag! !

!Interpreter methodsFor: '*Exupery-Compiler Support' stamp: 'wbk 4/18/2004 20:57'!
exuperyLookupMethodHook
	self inline: true.
	(self cCode: 'compilerHooks[15] !!= nullCompilerHook') ifTrue: [^self exuperyLookupMethod]! !

!Interpreter methodsFor: '*Exupery-Compiler Support' stamp: 'wbk 3/12/2004 19:34'!
exuperySpecialObjectsOopAddress
	^  self cCode: '&foo->specialObjectsOop'! !

!Interpreter methodsFor: '*Exupery-Compiler Support' stamp: 'wbk 3/12/2004 19:33'!
exuperyRootTableCountAddress
	^  self cCode: '&foo->rootTableCount'! !

!Interpreter methodsFor: '*Exupery-Compiler Support' stamp: 'wbk 4/18/2004 20:58'!
exuperyRemapObjects
	^self cCode: 'compilerHooks[16]()'! !

!Interpreter methodsFor: '*Exupery-Compiler Support' stamp: 'wbk 6/2/2004 22:22'!
exuperyAtCacheAddress
	^self cCode: '&atCache'! !

!Interpreter methodsFor: '*Exupery-override' stamp: 'wbk 6/4/2004 23:40'!
internalExecuteNewMethod
	| localPrimIndex |
	self inline: true.
	localPrimIndex := primitiveIndex.
	localPrimIndex > 0 ifTrue: 
			[(localPrimIndex > 255 and: [localPrimIndex < 520]) 
				ifTrue: 
					["Internal return instvars"

					localPrimIndex >= 264 
						ifTrue: 
							[^self 
								internalPop: 1
								thenPush: (self 
										fetchPointer: localPrimIndex - 264
										ofObject: self internalStackTop)]
						ifFalse: 
							["Internal return constants"

							localPrimIndex = 256 ifTrue: [^nil	"^ self"].
							localPrimIndex = 257 ifTrue: 
									[^self 
										internalPop: 1
										thenPush: trueObj].
							localPrimIndex = 258 ifTrue: 
									[^self 
										internalPop: 1
										thenPush: falseObj].
							localPrimIndex = 259 ifTrue: 
									[^self 
										internalPop: 1
										thenPush: nilObj].
							^self 
								internalPop: 1
								thenPush: (self integerObjectOf: localPrimIndex - 261)]]
				ifFalse: 
					[self externalizeIPandSP.
					self primitiveResponse.
					self internalizeIPandSP.
					successFlag ifTrue: 
							[self browserPluginReturnIfNeeded.
							^nil]]].

	"if not primitive, or primitive failed, activate the method"
	self internalActivateNewMethod.
	self externalizeIPandSP.
	self exuperyCallMethodHook.
	self internalizeIPandSP.

	"check for possible interrupts at each real send"
	self internalQuickCheckForInterrupts.
	
	! !

!Interpreter methodsFor: '*Exupery-override' stamp: 'wbk 4/18/2004 20:58'!
mapInterpreterOops
	"Map all oops in the interpreter's state to their new values during garbage collection or a become: operation."

	"Assume: All traced variables contain valid oops."

	| oop |
	nilObj := self remap: nilObj.
	falseObj := self remap: falseObj.
	trueObj := self remap: trueObj.
	specialObjectsOop := self remap: specialObjectsOop.
	compilerInitialized ifFalse: 
			[stackPointer := stackPointer - activeContext.	"*rel to active"
			activeContext := self remap: activeContext.
			stackPointer := stackPointer + activeContext.	"*rel to active"
			theHomeContext := self remap: theHomeContext].
	instructionPointer := instructionPointer - method.	"*rel to method"
	method := self remap: method.
	instructionPointer := instructionPointer + method.	"*rel to method"
	receiver := self remap: receiver.
	messageSelector := self remap: messageSelector.
	newMethod := self remap: newMethod.
	methodClass := self remap: methodClass.
	lkupClass := self remap: lkupClass.
	receiverClass := self remap: receiverClass.
	self exuperyRemapObjectsHook.	"Remap objects that the compiler plugin uses"
	1 
		to: remapBufferCount
		do: 
			[:i | 
			oop := remapBuffer at: i.
			(self isIntegerObject: oop) ifFalse: 
					[remapBuffer 
						at: i
						put: (self remap: oop)]]! !

!Interpreter methodsFor: '*Exupery-Compiler Support' stamp: 'wbk 4/18/2004 20:58'!
exuperyRegisterRemapObjects: aFunction 
	^self cCode: 'compilerHooks[16] = aFunction'! !

!Interpreter methodsFor: '*Exupery-Compiler Support' stamp: 'wbk 6/30/2003 18:20'!
exuperySetupMessageSendAddress
	^ self cCode: '& exuperySetupMessageSend'! !

!Interpreter methodsFor: '*Exupery-Compiler Support' stamp: 'wbk 3/13/2004 20:17'!
exuperyReturnHook
	| function |
	self inline: true.

	" Return if active context isn't a compiled method. The current test is very crude but it
	works for a single method and will do for now, until we compile more than one method"
	(self cCode: 'compilerHooks[18] !!= nullCompilerHook') ifFalse: [^ false].

	(self cCode: '(function = compilerHooks [18] (foo->activeContext)) !!= 0') ifTrue: 
		[self exuperyReturn: function.
		^ true].
	^ false! !

!Interpreter methodsFor: '*Exupery-Compiler Support' stamp: 'wbk 4/18/2004 20:56'!
exuperyCallMethodHook
	self inline: true.
	newNativeMethod = nil | (newNativeMethod = nilObj) ifTrue: [^false].
	self exuperyCallMethod.
	^true! !

!Interpreter class methodsFor: '*Exupery-override' stamp: 'wbk 3/12/2004 19:28'!
initializePrimitiveTable 
	"This table generates a C switch statement for primitive dispatching."

	"NOTE: The real limit here is 2047, but our C compiler currently barfs over 700"
	MaxPrimitiveIndex _ 700.
	PrimitiveTable _ Array new: MaxPrimitiveIndex + 1.
	self table: PrimitiveTable from: 
	#(	"Integer Primitives (0-19)"
		(0 primitiveFail)
		(1 primitiveAdd)
		(2 primitiveSubtract)
		(3 primitiveLessThan)
		(4 primitiveGreaterThan)
		(5 primitiveLessOrEqual)
		(6 primitiveGreaterOrEqual)
		(7 primitiveEqual)
		(8 primitiveNotEqual)
		(9 primitiveMultiply)
		(10 primitiveDivide)
		(11 primitiveMod)
		(12 primitiveDiv)
		(13 primitiveQuo)
		(14 primitiveBitAnd)
		(15 primitiveBitOr)
		(16 primitiveBitXor)
		(17 primitiveBitShift)
		(18 primitiveMakePoint)
		(19 primitiveFail)					"Guard primitive for simulation -- *must* fail"

		"LargeInteger Primitives (20-39)"
		"32-bit logic is aliased to Integer prims above"
		(20 39 primitiveFail)

		"Float Primitives (40-59)"
		(40 primitiveAsFloat)
		(41 primitiveFloatAdd)
		(42 primitiveFloatSubtract)
		(43 primitiveFloatLessThan)
		(44 primitiveFloatGreaterThan)
		(45 primitiveFloatLessOrEqual)
		(46 primitiveFloatGreaterOrEqual)
		(47 primitiveFloatEqual)
		(48 primitiveFloatNotEqual)
		(49 primitiveFloatMultiply)
		(50 primitiveFloatDivide)
		(51 primitiveTruncated)
		(52 primitiveFractionalPart)
		(53 primitiveExponent)
		(54 primitiveTimesTwoPower)
		(55 primitiveSquareRoot)
		(56 primitiveSine)
		(57 primitiveArctan)
		(58 primitiveLogN)
		(59 primitiveExp)

		"Subscript and Stream Primitives (60-67)"
		(60 primitiveAt)
		(61 primitiveAtPut)
		(62 primitiveSize)
		(63 primitiveStringAt)
		(64 primitiveStringAtPut)
		(65 primitiveNext)
		(66 primitiveNextPut)
		(67 primitiveAtEnd)

		"StorageManagement Primitives (68-79)"
		(68 primitiveObjectAt)
		(69 primitiveObjectAtPut)
		(70 primitiveNew)
		(71 primitiveNewWithArg)
		(72 primitiveArrayBecomeOneWay)	"Blue Book: primitiveBecome"
		(73 primitiveInstVarAt)
		(74 primitiveInstVarAtPut)
		(75 primitiveAsOop)
		(76 primitiveStoreStackp)					"Blue Book: primitiveAsObject"
		(77 primitiveSomeInstance)
		(78 primitiveNextInstance)
		(79 primitiveNewMethod)

		"Control Primitives (80-89)"
		(80 primitiveBlockCopy)
		(81 primitiveValue)
		(82 primitiveValueWithArgs)
		(83 primitivePerform)
		(84 primitivePerformWithArgs)
		(85 primitiveSignal)
		(86 primitiveWait)
		(87 primitiveResume)
		(88 primitiveSuspend)
		(89 primitiveFlushCache)

		"Input/Output Primitives (90-109)"
		(90 primitiveMousePoint)
		(91 primitiveTestDisplayDepth)			"Blue Book: primitiveCursorLocPut"
		(92 primitiveSetDisplayMode)				"Blue Book: primitiveCursorLink"
		(93 primitiveInputSemaphore)
		(94 primitiveGetNextEvent)				"Blue Book: primitiveSampleInterval"
		(95 primitiveInputWord)
		(96 primitiveObsoleteIndexedPrimitive)	"primitiveCopyBits"
		(97 primitiveSnapshot)
		(98 primitiveStoreImageSegment)
		(99 primitiveLoadImageSegment)
		(100 primitivePerformInSuperclass)		"Blue Book: primitiveSignalAtTick"
		(101 primitiveBeCursor)
		(102 primitiveBeDisplay)
		(103 primitiveScanCharacters)
		(104 primitiveObsoleteIndexedPrimitive)	"primitiveDrawLoop"
		(105 primitiveStringReplace)
		(106 primitiveScreenSize)
		(107 primitiveMouseButtons)
		(108 primitiveKbdNext)
		(109 primitiveKbdPeek)

		"System Primitives (110-119)"
		(110 primitiveEquivalent)
		(111 primitiveClass)
		(112 primitiveBytesLeft)
		(113 primitiveQuit)
		(114 primitiveExitToDebugger)
		(115 primitiveChangeClass)					"Blue Book: primitiveOopsLeft"
		(116 primitiveFlushCacheByMethod)
		(117 primitiveExternalCall)
		(118 primitiveDoPrimitiveWithArgs)
		(119 primitiveFlushCacheSelective)
			"Squeak 2.2 and earlier use 119.  Squeak 2.3 and later use 116.
			Both are supported for backward compatibility."

		"Miscellaneous Primitives (120-127)"
		(120 primitiveCalloutToFFI)
		(121 primitiveImageName)
		(122 primitiveNoop)					"Blue Book: primitiveImageVolume"
		(123 primitiveValueUninterruptably)	"@@@: Remove this when all VMs have support"
		(124 primitiveLowSpaceSemaphore)
		(125 primitiveSignalAtBytesLeft)

		"Squeak Primitives Start Here"

		"Squeak Miscellaneous Primitives (128-149)"
		(126 primitiveDeferDisplayUpdates)
		(127 primitiveShowDisplayRect)
		(128 primitiveArrayBecome)
		(129 primitiveSpecialObjectsOop)
		(130 primitiveFullGC)
		(131 primitiveIncrementalGC)
		(132 primitiveObjectPointsTo)
		(133 primitiveSetInterruptKey)
		(134 primitiveInterruptSemaphore)
		(135 primitiveMillisecondClock)
		(136 primitiveSignalAtMilliseconds)
		(137 primitiveSecondsClock)
		(138 primitiveSomeObject)
		(139 primitiveNextObject)
		(140 primitiveBeep)
		(141 primitiveClipboardText)
		(142 primitiveVMPath)
		(143 primitiveShortAt)
		(144 primitiveShortAtPut)
		(145 primitiveConstantFill)
		"NOTE: When removing the obsolete indexed primitives,
		the following two should go become #primitiveIntegerAt / atPut"
		(146 primitiveObsoleteIndexedPrimitive)	"primitiveReadJoystick"
		(147 primitiveObsoleteIndexedPrimitive)	"primitiveWarpBits"
		(148 primitiveClone)
		(149 primitiveGetAttribute)

		"File Primitives (150-169) - NO LONGER INDEXED"
		(150 164 primitiveObsoleteIndexedPrimitive)
		(165 primitiveIntegerAt)		"hacked in here for now"
		(166 primitiveIntegerAtPut)
		(167 168 primitiveFail)
		(169 primitiveObsoleteIndexedPrimitive)

		"Sound Primitives (170-199) - NO LONGER INDEXED"
		(170 185 primitiveObsoleteIndexedPrimitive)

		"Closure primitives"
		(186 primitiveClosureValue)
		(187 primitiveClosureValueWithArgs)
		(188 primitiveExecuteMethod)

		"Sound Primitives (continued) - NO LONGER INDEXED"
		(189 194 primitiveObsoleteIndexedPrimitive)

		"Unwind primitives"
		(195 primitiveFindNextUnwindContext)
		(196 primitiveTerminateTo)
		(197 primitiveFindHandlerContext)
		(198 primitiveMarkUnwindMethod)
		(199 primitiveMarkHandlerMethod)

		"Networking Primitives (200-229) - NO LONGER INDEXED"
		(200 225 primitiveObsoleteIndexedPrimitive)
		(226 229 primitiveFail)

		"Other Primitives (230-249)"
		(230 primitiveRelinquishProcessor)
		(231 primitiveForceDisplayUpdate)
		(232 primitiveFormPrint)
		(233 primitiveSetFullScreen)
		(234 primitiveObsoleteIndexedPrimitive) "primBitmapdecompressfromByteArrayat"
		(235 primitiveObsoleteIndexedPrimitive) "primStringcomparewithcollated"
		(236 primitiveObsoleteIndexedPrimitive) "primSampledSoundconvert8bitSignedFromto16Bit"
		(237 primitiveObsoleteIndexedPrimitive) "primBitmapcompresstoByteArray"
		(238 241 primitiveObsoleteIndexedPrimitive) "serial port primitives"
		(242 primitiveFail)
		(243 primitiveObsoleteIndexedPrimitive) "primStringtranslatefromtotable"
		(244 primitiveObsoleteIndexedPrimitive) "primStringfindFirstInStringinSetstartingAt"
		(245 primitiveObsoleteIndexedPrimitive) "primStringindexOfAsciiinStringstartingAt"
		(246 primitiveObsoleteIndexedPrimitive) "primStringfindSubstringinstartingAtmatchTable"
		(247 primitiveSnapshotEmbedded)
		(248 primitiveInvokeObjectAsMethod)
		(249 primitiveFail)

		"VM Implementor Primitives (250-255)"
		(250 clearProfile)
		(251 dumpProfile)
		(252 startProfiling)
		(253 stopProfiling)
		(254 primitiveVMParameter)
		(255 primitiveInstVarsPutFromStack) "Never used except in Disney tests.  Remove after 2.3 release."

		"Quick Push Const Methods"
		(256 primitivePushSelf)
		(257 primitivePushTrue)
		(258 primitivePushFalse)
		(259 primitivePushNil)
		(260 primitivePushMinusOne)
		(261 primitivePushZero)
		(262 primitivePushOne)
		(263 primitivePushTwo)

		"Quick Push Const Methods"
		(264 519 primitiveLoadInstVar)

		"MIDI Primitives (520-539) - NO LONGER INDEXED"
		(520 529 primitiveObsoleteIndexedPrimitive)
		(530 539 primitiveFail)  "reserved for extended MIDI primitives"

		"Experimental Asynchrous File Primitives - NO LONGER INDEXED"
		(540 545 primitiveObsoleteIndexedPrimitive)
		(546 547 primitiveFail)

		"Pen Tablet Primitives - NO LONGER INDEXED"
		(548 primitiveObsoleteIndexedPrimitive)
		(549 primitiveObsoleteIndexedPrimitive)

		"Sound Codec Primitives - NO LONGER INDEXED"
		(550 553 primitiveObsoleteIndexedPrimitive)
		(554 569 primitiveFail)

		"External primitive support primitives"
		(570 primitiveFlushExternalPrimitives)
		(571 primitiveUnloadModule)
		(572 primitiveListBuiltinModule)
		(573 primitiveListExternalModule)
		(574 primitiveFail) "reserved for addl. external support prims"

		"Get our methods compiled primitive"
		(575 primitiveUseMethodsToGetThemCompiled)

		"Unassigned Primitives"
		(576 700 primitiveFail)).! !

!Interpreter methodsFor: '*Exupery-Compiler Support' stamp: 'wbk 4/18/2004 20:57'!
exuperyRegisterLookupMethod: aFunction 
	^self cCode: 'compilerHooks[15] = aFunction'! !

!Interpreter methodsFor: '*Exupery-override' stamp: 'wbk 3/13/2004 20:13'!
commonReturn
	"Note: Assumed to be inlined into the dispatch loop."

	| nilOop thisCntx contextOfCaller localCntx localVal unwindMarked |
	self inline: true.
	self sharedCodeNamed: 'commonReturn' inCase: 120.

	nilOop _ nilObj. "keep in a register"
	thisCntx _ activeContext.
	localCntx _ localReturnContext.
	localVal _ localReturnValue.

	"make sure we can return to the given context"
	((localCntx = nilOop) or:
	 [(self fetchPointer: InstructionPointerIndex ofObject: localCntx) = nilOop]) ifTrue: [
		"error: sender's instruction pointer or context is nil; cannot return"
		^self internalCannotReturn: localVal].

	"If this return is not to our immediate predecessor (i.e. from a method to its sender, or from a block to its caller), scan the stack for the first unwind marked context and inform this context and let it deal with it. This provides a chance for ensure unwinding to occur."
	thisCntx _ self fetchPointer: SenderIndex ofObject: activeContext.

	"Just possibly a faster test would be to compare the homeContext and activeContext - they are of course different for blocks. Thus we might be able to optimise a touch by having a different returnTo for the blockreteurn (since we know that must return to caller) and then if active ~= home we must be doing a non-local return. I think. Maybe."
	[thisCntx = localCntx] whileFalse: [
		thisCntx = nilOop ifTrue:[
			"error: sender's instruction pointer or context is nil; cannot return"
			^self internalCannotReturn: localVal].
		"Climb up stack towards localCntx. Break out to a send of #aboutToReturn:through: if an unwind marked context is found"
		unwindMarked _ self isUnwindMarked: thisCntx.
		unwindMarked ifTrue:[
			"context is marked; break out"
			^self internalAboutToReturn: localVal through: thisCntx].
		thisCntx _ self fetchPointer: SenderIndex ofObject: thisCntx.
 ].

	"If we get here there is no unwind to worry about. Simply terminate the stack up to the localCntx - often just the sender of the method"
	thisCntx _ activeContext.
	[thisCntx = localCntx]
		whileFalse:
		["climb up stack to localCntx"
		contextOfCaller _ self fetchPointer: SenderIndex ofObject: thisCntx.

		"zap exited contexts so any future attempted use will be caught"
		self storePointerUnchecked: SenderIndex ofObject: thisCntx withValue: nilOop.
		self storePointerUnchecked: InstructionPointerIndex ofObject: thisCntx withValue: nilOop.
		reclaimableContextCount > 0 ifTrue:
			["try to recycle this context"
			reclaimableContextCount _ reclaimableContextCount - 1.
			self recycleContextIfPossible: thisCntx].
		thisCntx _ contextOfCaller].

	activeContext _ thisCntx.
	(thisCntx < youngStart) ifTrue: [ self beRootIfOld: thisCntx ].

	self internalFetchContextRegisters: thisCntx.  "updates local IP and SP"
	self fetchNextBytecode.
	self internalPush: localVal.
	
	"Returns into a compiled method, if the method is compiled"
	self externalizeIPandSP.
	self exuperyReturnHook ifTrue: 
		[self internalizeIPandSP. 
		self fetchNextBytecode.
		self externalizeIPandSP]. 
	self internalizeIPandSP.
! !

!Interpreter methodsFor: '*Exupery-Compiler Support' stamp: 'wbk 7/18/2004 18:39'!
exuperyAdjustContext: answer 
	| thisCntxt |
	answer ifTrue: 
			[thisCntxt := activeContext.
			activeContext := self 
						fetchPointer: SenderIndex
						ofObject: activeContext.
			activeContext < youngStart ifTrue: [self beRootIfOld: activeContext].
			reclaimableContextCount > 0 ifTrue:
			["try to recycle this context"
			reclaimableContextCount := reclaimableContextCount - 1.
			self recycleContextIfPossible: thisCntxt].].
	self fetchContextRegisters: activeContext	"Could move into compiled return sequence.
											It depends on how message sends end up working."! !

!Interpreter methodsFor: '*Exupery-Compiler Support' stamp: 'wbk 7/29/2004 22:47'!
exuperySetupMessage: selector Send: argumentsInteger
	|rcvr|
	self inline: false.
	" Reload the context here, the interpreter code below depends on it."
	self fetchContextRegisters: activeContext.

	"The send bytecode"
	messageSelector := selector.
	argumentCount := argumentsInteger.

	"normalSend"
	rcvr := self stackValue: argumentCount.
	lkupClass := self fetchClassOf: rcvr.
	receiverClass := lkupClass.
	self findNewMethodInClass: lkupClass.
	self executeNewMethod. "executeNewMethod fetches the new context registers"

	"Load the stackPointer into the active context, it might have changed, e.g. if a primitive
	has been executed"
	self
		storeWord:  StackPointerIndex	
		ofObject: activeContext
		withValue: (self integerObjectOf: (stackPointer - activeContext) / 4 - TempFrameStart).

	"fetchNextBytecode must be done inside the interpreter loop/function"

	^ 123456 "This fake return should be removed"! !

!Interpreter methodsFor: '*Exupery-override' stamp: 'wbk 4/12/2004 00:12'!
initCompilerHooks
	"Initialize hooks for the 'null compiler'"

	self cCode: 'compilerHooks[1]= nullCompilerHook'.
	self cCode: 'compilerHooks[2]= nullCompilerHook'.
	self cCode: 'compilerHooks[3]= nullCompilerHook'.
	self cCode: 'compilerHooks[4]= nullCompilerHook'.
	self cCode: 'compilerHooks[5]= nullCompilerHook'.
	self cCode: 'compilerHooks[6]= nullCompilerHook'.
	self cCode: 'compilerHooks[7]= nullCompilerHook'.
	self cCode: 'compilerHooks[8]= nullCompilerHook'.
	self cCode: 'compilerHooks[9]= nullCompilerHook'.
	self cCode: 'compilerHooks[10]= nullCompilerHook'.
	self cCode: 'compilerHooks[11]= nullCompilerHook'.
	self cCode: 'compilerHooks[12]= nullCompilerHook'.
	self cCode: 'compilerHooks[13]= nullCompilerHook'.
	self cCode: 'compilerHooks[14]= nullCompilerHook'.
	self cCode: 'compilerHooks[15]= nullCompilerHook'.
	self cCode: 'compilerHooks[16]= nullCompilerHook'.
	self cCode: 'compilerHooks[17]= nullCompilerHook'.
	self cCode: 'compilerHooks[18]= nullCompilerHook'.
	self cCode: 'compilerHooks[19]= nullCompilerHook'.

	compilerInitialized _ false! !

!Interpreter methodsFor: '*Exupery-Compiler Support' stamp: 'wbk 4/12/2004 00:15'!
exuperyMarkAndTrace
	^ self cCode: 'compilerHooks[19]()'! !

!Interpreter methodsFor: '*Exupery-Compiler Support' stamp: 'wbk 4/12/2004 00:15'!
exuperyMarkAndTraceHook
	self inline: true.
	(self cCode: 'compilerHooks[19] !!= nullCompilerHook') ifTrue: [^ self exuperyMarkAndTrace] ! !

!Interpreter methodsFor: '*Exupery-Compiler Support' stamp: 'wbk 7/29/2004 22:48'!
exuperyCompiledReturn: answer 
	| aFunction ans |
"self allAccessibleObjectsOkay."
	self 
		var: #aFunction
		declareC: 'int (*aFunction) (int)'.
	self exuperyAdjustContext: answer.
	aFunction := self cCode: ' compilerHooks [18] (foo->activeContext)'.
	[self cCode: '(aFunction) !!= 0'] whileTrue: 
		[(activeContext< youngStart) ifTrue: [ self beRootIfOld: activeContext ].
		ans := self cCode: 'aFunction (foo->activeContext)'.
		self exuperyAdjustContext: ans.
		self cCode: 'aFunction = compilerHooks [18] (foo->activeContext)']! !

!Interpreter methodsFor: '*Exupery-Compiler Support' stamp: 'wbk 4/18/2004 20:57'!
exuperyRegisterCallMethod: aFunction 
	^self cCode: 'compilerHooks[17] = aFunction'! !

!Interpreter methodsFor: '*Exupery-Compiler Support' stamp: 'wbk 4/12/2004 00:21'!
exuperyRegisterMarkObjects: aFunction
	^  self cCode: 'compilerHooks[19] = aFunction'! !

!Interpreter class methodsFor: '*Exupery-override' stamp: 'wbk 4/12/2004 00:11'!
initializeCompilerHooks
	"Interpreter initializeCompilerHooks"

	"compilerHooks[] indices:
	1	void compilerTranslateMethodHook(void)
	2	void compilerFlushCacheHook(CompiledMethod *oldMethod)
	3	void compilerPreGCHook(int fullGCFlag)
	4	void compilerMapHook(int memStart, int memEnd)
	5	void compilerPostGCHook(void)
	6	void compilerProcessChangeHook(void)
	7	void compilerPreSnapshotHook(void)
	8	void compilerPostSnapshotHook(void)
	9	void compilerMarkHook(void)
	10	void compilerActivateMethodHook(void)
	11	void compilerNewActiveContextHook(int sendFlag)
	12	void compilerGetInstructionPointerHook(void)
	13	void compilerSetInstructionPointerHook(void)
	14	void compilerCreateActualMessageHook(void)"

	"Added a few more compiler hooks for Exupery's use"
	CompilerHooksSize _ 25.! !

!Interpreter methodsFor: '*Exupery-Compiler Support' stamp: 'wbk 3/12/2004 19:33'!
exuperyNilObjAddress
	^  self cCode: '&foo->nilObj'! !

!Interpreter methodsFor: '*Exupery-Compiler Support' stamp: 'wbk 4/18/2004 20:58'!
exuperyRemapObjectsHook
	self inline: true.
	(self cCode: 'compilerHooks[16] !!= nullCompilerHook') ifTrue: [^self exuperyRemapObjects]! !

!Interpreter methodsFor: '*Exupery-Compiler Support' stamp: 'wbk 7/29/2004 22:45'!
exuperyCallMethod
	"Could move into compiled return sequence.
											It depends on how message sends end up working."

	| answer activeCntxt |
	self inline: false.
	activeCntxt := activeContext.
	answer := self cCode: '( (int (*)(int))foo->newNativeMethod)(activeCntxt)'.
	self exuperyCompiledReturn: answer.
	^nil! !

!Interpreter methodsFor: '*Exupery-Compiler Support' stamp: 'wbk 4/18/2004 20:58'!
exuperyRegisterReturnMethod: aFunction 
	^self cCode: 'compilerHooks[18] = aFunction'! !

!Interpreter methodsFor: '*Exupery-Compiler Support' stamp: 'wbk 4/18/2004 20:59'!
exuperyTrueObjAddress
	^self cCode: '&foo->trueObj'! !

!Interpreter methodsFor: '*Exupery-override' stamp: 'wbk 4/18/2004 20:57'!
findNewMethodInClass: class 
	"Find the compiled method to be run when the current messageSelector is sent to the given class, setting the values of 'newMethod' and 'primitiveIndex'."

	| ok |
	self inline: false.
	ok := self 
				lookupInMethodCacheSel: messageSelector
				class: class.
	ok ifFalse: 
			["entry was not found in the cache; look it up the hard way"

			self lookupMethodInClass: class.
			lkupClass := class.
			self exuperyLookupMethodHook.
			self addNewMethodToCache]! !

!Interpreter methodsFor: '*Exupery-Compiler Support' stamp: 'wbk 4/18/2004 20:59'!
primitiveUseMethodsToGetThemCompiled
	self exuperyRegisterLookupMethod: '123'.
	self exuperyRegisterRemapObjects: '123'.
	self exuperyRegisterCallMethod: '123'.
	self exuperyTrueObjAddress.
	self exuperyFalseObjAddress.
	self 
		exuperySetupMessage: 1
		Send: 1.
	self exuperySetupMessageSendAddress.
	self exuperyRegisterReturnMethod: 123.
	self exuperySpecialObjectsOopAddress.
	self exuperyAtCacheAddress.
	self exuperyNilObjAddress.
	self exuperyCheckRootTableFor: 123.
	self exuperyYoungStartAddress.
	self exuperyRootTableCountAddress.
	self exuperyRootTableAddress.
	self exuperyRegisterMarkObjects: 123! !

Object subclass: #CompilerToys
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Programmer Tests'!

!CompilerToys methodsFor: 'as yet unclassified' stamp: 'WBK 8/26/2002 16:17'!
simpleMethod2
	^ 1 + 2! !

!CompilerToys methodsFor: 'as yet unclassified' stamp: 'WBK 8/26/2002 16:15'!
simpleMethod
	^ 1! !

!CompilerToys class methodsFor: 'as yet unclassified' stamp: 'wbk 3/4/2004 21:36'!
sal! !

!CompilerToys class methodsFor: 'as yet unclassified' stamp: 'wbk 3/6/2004 20:10'!
sub! !

!CompilerToys methodsFor: 'as yet unclassified' stamp: 'wbk 10/13/2002 19:04'!
nestedConditionals
	^ 1 + (1 <= 3)! !

!CompilerToys methodsFor: 'as yet unclassified' stamp: 'WBK 8/29/2002 18:36'!
iterativeFactorial: n
	|acc|
	acc := 1.
	1
		to: n
		do: [:each| acc := acc * each].
	^ acc! !

!CompilerToys methodsFor: 'as yet unclassified' stamp: 'wbk 9/3/2002 12:09'!
return42
	^ 42! !

!CompilerToys methodsFor: 'as yet unclassified' stamp: 'wbk 10/2/2002 18:04'!
stringConcatenate
	^ 'abc', 'def'! !

!CompilerToys methodsFor: 'as yet unclassified' stamp: 'WBK 8/26/2002 16:20'!
simpleMethod4
	^ 100 + 101! !

!CompilerToys methodsFor: 'as yet unclassified' stamp: 'WBK 8/26/2002 16:18'!
simpleMethod3
	^ 1 + 100! !

!CompilerToys methodsFor: 'as yet unclassified' stamp: 'WBK 8/26/2002 16:32'!
simpleMethod5
	^ 1 + 2 + 3 + 4 + 5 + 6! !

!CompilerToys methodsFor: 'as yet unclassified' stamp: 'wbk 10/14/2002 19:06'!
conditionalJumps
	^ 1 <= 2
		ifTrue: [^ 3]
		ifFalse: [^ 4]! !

!CompilerToys methodsFor: 'as yet unclassified' stamp: 'wbk 10/13/2002 19:02'!
lessThanEquals
	^ 1<=2! !

!CompilerToys methodsFor: 'as yet unclassified' stamp: 'WBK 8/26/2002 18:43'!
simpleMethod6
	^ 100 times: 2 * 3! !

!CompilerToys class methodsFor: 'as yet unclassified' stamp: 'wbk 3/4/2004 20:50'!
sar! !

!CompilerToys class methodsFor: 'as yet unclassified' stamp: 'wbk 3/6/2004 20:10'!
minus! !

Object subclass: #ExuperyStack
	instanceVariableNames: 'PC stack emitter stackHeight'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery'!

!ExuperyStack methodsFor: 'Stack Manipulation' stamp: 'wbk 5/31/2004 23:01'!
isEmpty
	^ stackHeight = 0! !

!ExuperyStack methodsFor: 'Program Counter' stamp: 'wbk 7/28/2003 21:38'!
pc: aSmallInteger 
	PC := aSmallInteger! !

!ExuperyStack methodsFor: 'Program Counter' stamp: 'wbk 7/28/2003 12:34'!
incrementPC
	PC := PC + 1.! !

!ExuperyStack methodsFor: 'Misc' stamp: 'wbk 5/31/2004 22:21'!
initializePC: aSmallInteger emitter: anEmitter
	PC := aSmallInteger.	
	stack := OrderedCollection new.
	emitter := anEmitter.
	stackHeight := 0.! !

!ExuperyStack class methodsFor: 'as yet unclassified' stamp: 'wbk 4/26/2004 22:30'!
newPC: aSmallInteger emitter: anEmitter
	^ self new 
		initializePC: aSmallInteger
		emitter: anEmitter.! !

!ExuperyStack methodsFor: 'Stack Manipulation' stamp: 'wbk 5/31/2004 23:17'!
stackWith: anOrderedCollection 
	^ ((1 to: stackHeight) collect: [:each| emitter stackRegister: each]), anOrderedCollection! !

!ExuperyStack methodsFor: 'Program Counter' stamp: 'wbk 7/28/2003 12:39'!
pc
	^ PC! !

!ExuperyStack methodsFor: 'Stack Manipulation' stamp: 'wbk 6/13/2004 15:06'!
peek
	^ emitter stackRegister: stackHeight! !

!ExuperyStack methodsFor: 'Stack Manipulation' stamp: 'wbk 5/31/2004 23:49'!
pop: aSmallInteger 
	| answer |
	answer := OrderedCollection new.
	1 to: aSmallInteger do: [:each | answer addFirst: self pop].	"Remove arguments from the stack"
	^ answer! !

!ExuperyStack methodsFor: 'Stack Manipulation' stamp: 'wbk 6/13/2004 21:46'!
pop
	| answer |
	stackHeight := stackHeight - 1.
	"stack removeLast."
	answer := emitter stackRegister: stackHeight + 1.
	^ answer! !

ExuperyStack subclass: #TestExuperyStack
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Programmer Tests'!

!TestExuperyStack methodsFor: 'stubbed methods' stamp: 'wbk 4/26/2004 23:29'!
pop
	^stack removeLast! !

!TestExuperyStack methodsFor: 'stubbed methods' stamp: 'wbk 4/26/2004 23:29'!
push: anArray
	stack addLast: anArray! !

!TestExuperyStack methodsFor: 'stubbed methods' stamp: 'wbk 6/13/2004 15:08'!
peek
	^ stack last! !

!ExuperyStack methodsFor: 'Stack Manipulation' stamp: 'wbk 6/14/2004 21:35'!
heightTo: aSmallInteger 
"aSmallInteger > 10 ifTrue: [self halt]."	
	stackHeight := aSmallInteger.! !

!ExuperyStack methodsFor: 'Stack Manipulation' stamp: 'wbk 5/31/2004 23:05'!
stackSize
	^ stackHeight! !

!ExuperyStack methodsFor: 'Stack Manipulation' stamp: 'wbk 5/31/2004 23:49'!
push: anArray
	| stackVariable |
	stackVariable := (emitter stackRegister: stackHeight + 1). 
	emitter 
		emitMoveFrom: anArray
		to: stackVariable.
	stackHeight := stackHeight + 1.! !

Object subclass: #EncodeToAddressingMode
	instanceVariableNames: 'opcode assembler instruction'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery'!

EncodeToAddressingMode subclass: #EncodeFromAddressingMode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery'!

!EncodeFromAddressingMode methodsFor: 'Encoding' stamp: 'wbk 4/6/2003 21:03'!
isFirable
	^ instruction arg2 isRegister & (instruction arg1 isAddressingMode | instruction arg1 isRegister)! !

!EncodeFromAddressingMode methodsFor: 'Encoding' stamp: 'wbk 4/11/2003 18:07'!
fire
	assembler stream nextPutAll: opcode.
	assembler 
		encodeModRm: instruction arg1
		register: instruction arg2	! !

!EncodeToAddressingMode class methodsFor: 'as yet unclassified' stamp: 'wbk 4/18/2003 18:11'!
opcode: aSmallInteger
	^ self new
		initializeOpcodes: (Array with: aSmallInteger)! !

!EncodeToAddressingMode methodsFor: 'misc' stamp: 'wbk 4/18/2003 18:11'!
registerInstruction: anAssembleArithmatic 
	instruction := anAssembleArithmatic.
	assembler := instruction assembler.! !

!EncodeToAddressingMode methodsFor: 'Encoding' stamp: 'wbk 4/6/2003 20:57'!
isFirable
	^ instruction arg1 isRegister & (instruction arg2 isAddressingMode | instruction arg2 isRegister)! !

!EncodeToAddressingMode methodsFor: 'misc' stamp: 'wbk 4/18/2003 18:12'!
initializeOpcodes: aSmallInteger
	opcode := aSmallInteger.
	^ self! !

!EncodeToAddressingMode methodsFor: 'Encoding' stamp: 'wbk 4/11/2003 18:08'!
fire
	assembler stream nextPutAll: opcode.
	assembler 
		encodeModRm: instruction arg2 
		register: instruction arg1	! !

!EncodeToAddressingMode class methodsFor: 'as yet unclassified' stamp: 'wbk 4/18/2003 18:16'!
opcodes: aSmallInteger
	^ self new
		initializeOpcodes: aSmallInteger! !

Object subclass: #LivenessAnalyser
	instanceVariableNames: 'source hasUpdated'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery'!

!LivenessAnalyser methodsFor: 'Analysis Visiting' stamp: 'wbk 11/1/2002 20:55'!
visitJump: aJump
	|newLattice|
	aJump setOut: (aJump out + aJump target in).
	newLattice := aJump out.
	newLattice value size ~= aJump in value size ifTrue: [hasUpdated := true].
	aJump setIn: newLattice! !

!LivenessAnalyser methodsFor: 'Misc' stamp: 'wbk 10/21/2002 19:52'!
initializeGraph
	source instructionsDo:
		[:each| each setIn: Lattice new.
		each setOut: Lattice new].! !

!LivenessAnalyser methodsFor: 'Analysis Visiting' stamp: 'wbk 11/4/2002 15:23'!
visitRet: anAssembly! !

!LivenessAnalyser methodsFor: 'Analysis Visiting' stamp: 'wbk 7/5/2003 15:12'!
visitCall: aMedCall 
	"It might be nessisary to do something more with calls. They could kill registers, I'm not sure"
	self visitAssembly: aMedCall! !

!LivenessAnalyser methodsFor: 'Analysis Visiting' stamp: 'wbk 4/11/2003 11:05'!
visitAssembly: anAssembly
	|newLattice|
	newLattice := (anAssembly registersUsed + (
		anAssembly out - anAssembly registersDefined)).
	newLattice value size ~= anAssembly in value size ifTrue: [hasUpdated := true].
	anAssembly setIn: newLattice! !

!LivenessAnalyser methodsFor: 'Analysis Visiting' stamp: 'wbk 6/23/2003 11:47'!
visitPush: aMedPush 
	^ self visitAssembly: aMedPush	! !

!LivenessAnalyser methodsFor: 'Analysis' stamp: 'wbk 11/3/2002 20:31'!
analyse
	| origional updated |
	hasUpdated := true.
	[hasUpdated] whileTrue:
		[hasUpdated := false.
		source blocksDo: 
			[:eachBlock| eachBlock numberOfExpressions
				to: 1
				by: -1
				do: 
					[:each| each ~= eachBlock numberOfExpressions ifTrue:
						[origional := (eachBlock expressionAt: each) out.
						updated := (eachBlock expressionAt: each + 1) in.
						(eachBlock expressionAt: each) setOut: updated.
						updated size > origional size ifTrue: [hasUpdated := true]].
					(eachBlock expressionAt: each) visitWith: self]]].! !

!LivenessAnalyser methodsFor: 'Unit Testing' stamp: 'wbk 10/24/2002 22:27'!
isLive: anArray block: blockInteger at: anInteger
	^ (source 
		blockAt: blockInteger
		instructionAt: anInteger) in matchesArray: anArray! !

!LivenessAnalyser methodsFor: 'Analysis Visiting' stamp: 'wbk 2/9/2004 20:10'!
visitNegate: aMedNegate 
	self visitAssembly: aMedNegate! !

!LivenessAnalyser methodsFor: 'Analysis Visiting' stamp: 'wbk 1/29/2004 20:20'!
visitDivide: aMedX86Divide 
	self visitAssembly: aMedX86Divide! !

!LivenessAnalyser methodsFor: 'Analysis Visiting' stamp: 'wbk 2/1/2004 22:04'!
visitX86Cdq: aMedX86CDQ 
	self visitAssembly: aMedX86CDQ! !

!LivenessAnalyser methodsFor: 'Analysis' stamp: 'wbk 10/21/2002 12:25'!
run
	self initializeGraph.
	self analyse.
	! !

!LivenessAnalyser methodsFor: 'Unit Testing' stamp: 'wbk 10/22/2002 14:04'!
isLive: anArray at: anInteger
	^ (source 
		blockAt: 1
		instructionAt: anInteger) in matchesArray: anArray! !

!LivenessAnalyser class methodsFor: 'instance creation' stamp: 'wbk 10/20/2002 22:39'!
on: aMethod
	| analyser |
	analyser := self new initializeOn: aMethod.
	analyser run.
	^ analyser! !

!LivenessAnalyser methodsFor: 'Analysis Visiting' stamp: 'wbk 11/4/2002 13:54'!
visitMov: anAssembly
	^ self visitAssembly: anAssembly! !

!LivenessAnalyser methodsFor: 'Misc' stamp: 'wbk 10/20/2002 22:38'!
initializeOn: aMethod
	source := aMethod.
	^ self! !

Object subclass: #SystemInvestigation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Plugin'!

!SystemInvestigation methodsFor: 'Image Experiments' stamp: 'wbk 4/12/2003 22:07'!
countBytecodes
	|bytecodes methods classes|
	" This method doesn't handle methods with no bytecodes, they count as -1 bytes.
	It looks like I'm averaging 70 bytecodes/method, I don't know how reasonable this
	is but the ballpark seems tolerable."
	bytecodes := 0.
	methods := 0.
	classes := 0.
	Smalltalk allClassesDo: 
		[:eachClass| classes := classes + 1.
		eachClass methodsDo:
			[:eachMethod| methods := methods + 1.
			bytecodes := bytecodes + eachMethod endPC + eachMethod initialPC + 1]].
	^ {bytecodes. methods. classes}! !

Object subclass: #WBKToys
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Customer Tests'!

!WBKToys class methodsFor: 'as yet unclassified' stamp: 'wbk 3/22/2004 19:46'!
forBytecodes

| weakRef |
weakRef := WeakValueAssociation new.
Smalltalk garbageCollect. "make it old"
weakRef value: Object new.
Smalltalk garbageCollectMost. "incr. GC"
weakRef value. "and it's still there"! !

!WBKToys methodsFor: 'Toys' stamp: 'wbk 4/7/2003 18:42'!
returnTrue
	^ true! !

!WBKToys methodsFor: 'Toys' stamp: 'wbk 7/31/2003 20:23'!
arithmaticLoop
	| acc |
	acc := 0.
	1
		to: 2000000
		do: [:each| acc := acc + 1].
	^ 5! !

!WBKToys methodsFor: 'Toys' stamp: 'wbk 4/20/2003 21:31'!
senders
	^ self sent! !

!WBKToys methodsFor: 'Toys' stamp: 'wbk 4/20/2003 21:32'!
sent
	|a|
	a := thisContext.
	self halt.
	^ 42! !

!WBKToys class methodsFor: 'as yet unclassified' stamp: 'wbk 3/22/2004 19:13'!
gcTest: weakRef
weakRef value: Object new.! !

!WBKToys methodsFor: 'Refactoring Toys' stamp: 'wbk 7/28/2003 15:29'!
aTest
	| x4 |
	x4 := 10.
	x4 + x4.
	1 + 2 + 3 
		abc: 55
		def: 66
		ghi: 77.
	1 
		abc: 2
		def: 3.
	1 abc: 2! !

!WBKToys methodsFor: 'Toys' stamp: 'wbk 4/7/2003 18:43'!
returnFalse
	^ false! !

Object subclass: #ExuperyBenchmarks
	instanceVariableNames: 'time compiledTime cumulativeTime cumulativeCompiledTime'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Customer Tests'!

!ExuperyBenchmarks methodsFor: 'execution' stamp: 'wbk 7/29/2004 23:39'!
run
	#((arithmaticLoopBenchmark compileArithmaticLoop)
		(bytecodeBenchmark compileBytecodeBenchmark)
		(sendBenchmark compileSendBenchmark)
		(gifConversion compileGifConversion)) do:
			[:each| self
				runBenchmark: (each at: 1)
				compilingWith: (each at: 2)].
			
	Transcript cr.
	time := (cumulativeTime ln / 4) exp. "Calculate the root of 4"
	compiledTime := (cumulativeCompiledTime ln / 4) exp.
	Transcript show: 'Cumulative Time '.
	Transcript show: time.
	Transcript show: ' compiled '.
	Transcript show: compiledTime.
	Transcript show: ' ratio '.
	Transcript show: (time / compiledTime) asFloat.
	Transcript cr.! !

!ExuperyBenchmarks methodsFor: 'benchmarks' stamp: 'wbk 7/21/2004 20:05'!
sendBenchmark
	^ Time millisecondsToRun: [33 benchFib].! !

!ExuperyBenchmarks methodsFor: 'benchmarks' stamp: 'wbk 7/21/2004 19:51'!
compileGifConversion
	Exupery 
		compileMethod: #writeBitData:
		class: GIFReadWriter. ! !

!ExuperyBenchmarks methodsFor: 'benchmarks' stamp: 'wbk 7/21/2004 20:05'!
bytecodeBenchmark
	^ Time millisecondsToRun: [1000 benchmark].! !

!ExuperyBenchmarks methodsFor: 'benchmark methods' stamp: 'wbk 8/2/2004 22:31'!
arithmeticLoop
	| acc |
	acc := 0.
	1
		to: 20000000
		do: [:each| acc := acc + 1].
	^ acc! !

!ExuperyBenchmarks methodsFor: 'benchmarks' stamp: 'wbk 7/21/2004 19:52'!
compileBytecodeBenchmark
	Exupery
		compileMethod: #benchmark
		class: Integer.! !

!ExuperyBenchmarks methodsFor: 'benchmarks' stamp: 'wbk 7/21/2004 20:20'!
arithmaticLoopBenchmark
	^ Time millisecondsToRun: [self arithmeticLoop].! !

!ExuperyBenchmarks methodsFor: 'execution' stamp: 'wbk 8/1/2004 11:44'!
initialize
	cumulativeTime := 1.
	cumulativeCompiledTime := 1.! !

!ExuperyBenchmarks methodsFor: 'execution' stamp: 'wbk 7/21/2004 21:07'!
runBenchmark: benchmarkSymbol compilingWith: compilingSymbol 
	Exupery initialiseExupery.
	Transcript cr.
	Transcript show: benchmarkSymbol.
	Transcript space.
	time := self perform: benchmarkSymbol.
	Transcript show: time.
	Transcript show: ' compiled '.
	self perform: compilingSymbol.
	compiledTime := self perform: benchmarkSymbol.
	Transcript show: compiledTime.
	Transcript show: ' ratio: '.
	Transcript show: (time / compiledTime) asFloat.
	cumulativeTime := cumulativeTime * time.
	cumulativeCompiledTime := cumulativeCompiledTime * compiledTime.! !

!ExuperyBenchmarks methodsFor: 'benchmarks' stamp: 'wbk 7/21/2004 20:25'!
compileSendBenchmark
	Exupery
		compileMethod: #benchFib
		class: Integer.! !

!ExuperyBenchmarks methodsFor: 'benchmarks' stamp: 'wbk 8/2/2004 22:43'!
gifConversion
	"Smalltalk garbageCollect." "To stabilise the benchmark. It generates a lot of garbage
								and so does compiling"
	^ Time millisecondsToRun:
		[GIFReadWriter
			putForm: (Form
				extent: 1000@1000
				depth: 32)
			onStream: (WriteStream on: (ByteArray new: 10000))].! !

!ExuperyBenchmarks methodsFor: 'benchmarks' stamp: 'wbk 7/21/2004 20:20'!
compileArithmaticLoop
	Exupery
		compileMethod: #arithmeticLoop
		class: ExuperyBenchmarks! !

Object subclass: #MockIntermediateEmitter
	instanceVariableNames: 'callPosition callList method expectedRegisteredPC expectedRegisteredBlock registeredPC registeredBlock hasCreatedProlog isAnyOrder expressionsExpected state currentBlock blockList storedExpressions currentExpression realEmitter machine stackSetValue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Programmer Tests'!

!MockIntermediateEmitter methodsFor: 'Mocked Low Level Emission ' stamp: 'wbk 11/21/2003 19:09'!
emitMoveFrom: fromMed to: toMed 
	self checkAndAdd: { 
				#mov.
				self checkMed: fromMed.
				self checkMed: toMed}! !

!MockIntermediateEmitter methodsFor: 'Mocked Low Level Emission ' stamp: 'wbk 11/21/2003 19:08'!
emit: aSmallInteger sal: aMedTemporaryRegister 
	^ self check: {#sal. self checkMed: aSmallInteger. self checkMed: aMedTemporaryRegister}! !

!MockIntermediateEmitter methodsFor: 'Mocked Low Level Emission ' stamp: 'wbk 11/21/2003 19:08'!
emitMem: aMedLiteral 
	^ self check: {#mem. self checkMed: aMedLiteral}.! !

!MockIntermediateEmitter methodsFor: 'Mocked Interface' stamp: 'wbk 10/4/2003 20:13'!
emitNilAddress
	^ self check: #(emitNilAddress)! !

!MockIntermediateEmitter methodsFor: 'Mocked Low Level Emission ' stamp: 'wbk 11/17/2003 21:46'!
jumpType: aSymbol to: aSymbol2 dependingOn: anArray 
	| blockName |
	blockName := aSymbol2 isString
		ifTrue: [aSymbol2]
		ifFalse: [aSymbol2 blockName].
	^ self check: {aSymbol. blockName. anArray}! !

!MockIntermediateEmitter class methodsFor: 'as yet unclassified' stamp: 'wbk 11/17/2003 21:58'!
newWith: aMockExuperyPlugin 
	^ self new initialiseMachine: aMockExuperyPlugin! !

!MockIntermediateEmitter methodsFor: 'Mocked Interface' stamp: 'wbk 7/6/2003 20:07'!
numberOfTemporaries: aSmallInteger 
	! !

!MockIntermediateEmitter methodsFor: 'Mocked Interface' stamp: 'wbk 8/8/2003 21:33'!
emitFetchVariableAddress: anArray ofObject: aSymbol 
	^ self check: {#emitFetchVariableAddress. anArray. aSymbol}! !

!MockIntermediateEmitter methodsFor: 'Mocked Interface' stamp: 'wbk 10/9/2003 22:46'!
emitConvertToSmallInteger: aMed failTo: aLabel 
	^self check: { 
				#emitConvertToSmallInteger.
				aLabel blockName.
				aMed}! !

!MockIntermediateEmitter methodsFor: 'Mocked Interface' stamp: 'wbk 8/8/2003 17:17'!
emitFetchAddress: aSmallInteger ofObject: anArray 
	| index |
	index := (aSmallInteger isKindOf: MedLanguage)
		ifTrue: [aSmallInteger literal]
		ifFalse: [aSmallInteger].
	^ self check: { 
				#emitFetchAddress.
				index.
				anArray}! !

!MockIntermediateEmitter methodsFor: 'Mocked Interface' stamp: 'wbk 2/14/2004 16:53'!
addExpression: aMed
	| correct |
	"Verifies that aMed has been added to the current block. If this fails then check if
	a top level expression is not being added"
	storedExpressions ifNil: [^ self].
	correct := (storedExpressions at: currentExpression).
	self 
		assert: (self asMed: aMed) = correct
		message: 'Wrong expression added to the current block'.
	currentExpression := currentExpression + 1.! !

!MockIntermediateEmitter methodsFor: 'Misc' stamp: 'wbk 8/9/2003 22:22'!
checkAndAdd: anArray 
	self addExpression: anArray.
	self check: anArray.! !

!MockIntermediateEmitter methodsFor: 'Mocked Interface' stamp: 'wbk 7/15/2003 21:30'!
emitLiteralAddress: aSmallInteger 
	^ self check: {#emitLiteralAddress. aSmallInteger}! !

!MockIntermediateEmitter class methodsFor: 'instance creation' stamp: 'wbk 10/14/2002 13:50'!
new
	^ super new initialize! !

!MockIntermediateEmitter methodsFor: 'Misc' stamp: 'wbk 11/17/2003 23:30'!
assert: aBoolean message: aString
	aBoolean ifFalse: [self signalFailure: aString]! !

!MockIntermediateEmitter methodsFor: 'Mocked Interface' stamp: 'wbk 11/20/2003 21:50'!
emitRootTableAddress
	^ self check: #(emitRootTableAddress)! !

!MockIntermediateEmitter methodsFor: 'Mocked Interface' stamp: 'wbk 9/29/2003 20:59'!
emitReceiverAddress
	^self check: #(emitReceiverAddress)! !

!MockIntermediateEmitter methodsFor: 'Mocked Interface' stamp: 'wbk 10/13/2003 23:07'!
emitWithFailTo: aBlockContext failureSpecialSelector: aSmallInteger arguments: anArray
	 | answer |
	answer := {#emitWithFailTo. aBlockContext value: (method newBlock). aSmallInteger} asOrderedCollection.
	answer addAll: (anArray collect: [:each| self asMed: each]).
	^ self check: answer asArray! !

!MockIntermediateEmitter methodsFor: 'Mocked Interface' stamp: 'wbk 11/16/2003 17:57'!
emitBeRoot: anArray ifNeededBy: aSymbol 
	self check: {#emitBeRootIfNeeded. anArray. aSymbol}! !

!MockIntermediateEmitter methodsFor: 'Mocked Interface' stamp: 'wbk 3/7/2004 23:33'!
emit: firstMed multiply: secondMed failTo: aLabel 
	^self check: { 
				#emitMultiply.
				aLabel blockName.
				firstMed.
				secondMed}! !

!MockIntermediateEmitter methodsFor: 'Misc' stamp: 'wbk 8/9/2003 21:44'!
initialize
	| |
	callPosition := 1.
	callList := OrderedCollection new.
	hasCreatedProlog := false.
	isAnyOrder := false.
	method := MedMethod new. 
	method blockNumbered: 1. "Simulate creation of the first block"
	expressionsExpected := Dictionary new.
	blockList := OrderedCollection new.
	currentExpression := 1.
	^ self.! !

!MockIntermediateEmitter methodsFor: 'Set Up' stamp: 'wbk 8/5/2003 21:18'!
createCall: anArray
	2
		to: anArray size
		do: 
			[:each| 
				((anArray at: each) isString | (anArray at: each) isNumber) not
					ifTrue: [self createCall: (anArray at: each)]].
	callList add: anArray.
	blockList add: currentBlock.
	expressionsExpected
		at: anArray
		put: (expressionsExpected
			at: anArray
			ifAbsent: [0]) + 1.! !

!MockIntermediateEmitter methodsFor: 'Mocked Interface' stamp: 'wbk 7/28/2003 13:32'!
state: anExuperyStack 
	! !

!MockIntermediateEmitter methodsFor: 'Mocked Jumps and Conditionals' stamp: 'wbk 1/10/2004 13:09'!
emitConditionalBytecodeArg1: aMedLiteral arg2: aMedLiteral2 withJump: aSymbol failureSelector: aSmallInteger 
	^ self check: {#emitConditionalBytecode. self asMed: aMedLiteral. self asMed: aMedLiteral2. aSymbol. aSmallInteger}! !

!MockIntermediateEmitter methodsFor: 'Mocked Interface' stamp: 'wbk 6/21/2003 21:13'!
emitJumpIfFalseTo: aLabel onBoolean: anExpression
	^ self check: {#emitJumpIfFalse. aLabel. anExpression}! !

!MockIntermediateEmitter methodsFor: 'Mocked Emit Sends' stamp: 'wbk 5/31/2004 23:28'!
emitRestoreContextWithPC: aSmallInteger stack: anObject
	| answer |
	answer := {#emitRestoreContext.
				aSmallInteger} asOrderedCollection.
	answer addAll: (anObject collect: 
		[:each| each isSymbol | each isNumber
			ifTrue: [each] 
			ifFalse: [each name]]).
	self check: answer asArray ! !

!MockIntermediateEmitter methodsFor: 'Mocked Interface' stamp: 'wbk 9/29/2003 20:37'!
emitReceiver
	^ self check: #(emitReceiver)! !

!MockIntermediateEmitter methodsFor: 'Mocked Arithmatic' stamp: 'wbk 2/7/2004 20:52'!
emitMod: anArray with: anArray2 failTo: aMedBlock 
	^ self check: {#emitMod. aMedBlock blockName. anArray. anArray2}! !

!MockIntermediateEmitter methodsFor: 'Mocked Interface' stamp: 'wbk 8/13/2003 11:46'!
emitAtElementAddressFor: aSmallInteger with: aSmallInteger2 failTo: aMedBlock cacheOffset: anObject 
	^self check: { 
				#emitAtElementAddress.
				aSmallInteger.
				aSmallInteger2.
				aMedBlock blockName.
				anObject}! !

!MockIntermediateEmitter methodsFor: 'Misc' stamp: 'wbk 7/15/2003 20:20'!
anyOrder
	isAnyOrder := true.! !

!MockIntermediateEmitter methodsFor: 'Misc' stamp: 'wbk 8/10/2003 11:48'!
currentBlock
	^ currentBlock! !

!MockIntermediateEmitter methodsFor: 'Mocked Interface' stamp: 'wbk 7/6/2003 20:09'!
emitIncrementStackPtrFor: aMockIntermediateEmitter 
! !

!MockIntermediateEmitter methodsFor: 'Mocked Low Level Emission ' stamp: 'wbk 3/7/2004 23:33'!
emit: aMedLiteral sar: aMedLiteral2 
	^self check: { 
				#sar.
				self checkMed: aMedLiteral.
				self checkMed: aMedLiteral2}! !

!MockIntermediateEmitter methodsFor: 'Mocked Interface' stamp: 'wbk 2/14/2004 17:07'!
emitUnconditionalJumpTo: aLabel
	| label |
	label := aLabel isCollection
		ifTrue: [aLabel]
		ifFalse: [aLabel blockName].
	^ self checkAndAdd: {#jmp. label}! !

!MockIntermediateEmitter methodsFor: 'Misc' stamp: 'wbk 10/14/2002 13:40'!
method
	^ method! !

!MockIntermediateEmitter methodsFor: 'Mocked Interface' stamp: 'wbk 11/16/2003 19:06'!
emitCheckIsNotInteger: aSymbol failTo: aSymbol2 
	^ self checkAndAdd: {#emitCheckIsNotInteger. aSymbol. (self asMed: aSymbol2)}! !

!MockIntermediateEmitter methodsFor: 'Misc' stamp: 'wbk 8/5/2003 21:24'!
check: answer 
	|correct remainingExpressions |
	currentBlock ifNotNil: [self assert: (blockList at: callPosition) = currentBlock].
	callList isEmpty ifTrue: [^ self]. "A crude way to avoid this check when there isn't a call	
									list."
  	correct := self nextCallValue.
	isAnyOrder
		ifTrue: 
			[remainingExpressions := expressionsExpected
				at: answer
				put: (expressionsExpected at: answer) - 1.
			self assert: remainingExpressions >= 0.]
		ifFalse: [self assert: correct = answer].
	^ answer! !

!MockIntermediateEmitter methodsFor: 'Mocked Interface' stamp: 'wbk 3/3/2004 23:16'!
emitCheckIsInteger: aSymbol failTo: aSymbol2 
	| blockName |
	blockName := (aSymbol2 isKindOf: MedLanguage)
		ifTrue: [aSymbol2 blockName]
		ifFalse: [aSymbol2].
	^ self checkAndAdd: {#emitCheckIsInteger. aSymbol intermediateForm. blockName}! !

!MockIntermediateEmitter methodsFor: 'Mocked Object Access' stamp: 'wbk 2/15/2004 12:16'!
emitSpecialObject: aSmallInteger 
	^ self check: {#emitSpecialObject. aSmallInteger}! !

!MockIntermediateEmitter methodsFor: 'Misc' stamp: 'wbk 7/15/2003 21:48'!
nextCallValue
	| answer |
	self assert: callPosition <= callList size.
	answer := callList at: callPosition.
	callPosition := callPosition + 1.
	^ answer! !

!MockIntermediateEmitter methodsFor: 'Mocked Object Access' stamp: 'wbk 3/1/2004 20:28'!
emitClassOf: aSymbol 
	^ self check: {#emitClass. aSymbol}! !

!MockIntermediateEmitter methodsFor: 'Mocked Emit Sends' stamp: 'wbk 7/1/2003 16:39'!
emitSetProgramCounter: aMedLiteral 
	self check: {#emitSetProgramCounter. aMedLiteral literal}! !

!MockIntermediateEmitter methodsFor: 'Misc' stamp: 'wbk 11/17/2003 23:31'!
assert: aBoolean 
	self
		assert: aBoolean
		message: 'Assertion failed'! !

!MockIntermediateEmitter methodsFor: 'Set Up' stamp: 'wbk 2/15/2004 12:32'!
expectEmission: anArray 
	| blockName |
	storedExpressions := OrderedCollection new.
	anArray do:
		[:each| blockName := each at: 1.
		currentBlock := blockName.
		2
			to: each size 
			do: 
				[:eachLocation| self addExpectedEmission: (each at: eachLocation).
				"Don't expect sends because they are already fully added. They may
				occur in expression trees (they return a register)."
				((each at: eachLocation) at: 1) = #emitSend ifFalse: 
					[storedExpressions addLast: (each at: eachLocation)]]].
	currentBlock := #block1! !

!MockIntermediateEmitter methodsFor: 'Mocked Jumps and Conditionals' stamp: 'wbk 2/14/2004 12:18'!
emitJumpIfTrueTo: anArray onBoolean: aSymbol 
	^ self check: {#emitJumpIfTrue. anArray. aSymbol}! !

!MockIntermediateEmitter methodsFor: 'Mocked Interface' stamp: 'wbk 6/27/2004 22:47'!
stackRegister: aSmallInteger 
	^ machine registerNamed: ('s', aSmallInteger printString) asSymbol! !

!MockIntermediateEmitter methodsFor: 'Set Up' stamp: 'wbk 8/5/2003 20:35'!
addExpectedEmission: anArray 
	self createCall: anArray! !

!MockIntermediateEmitter methodsFor: 'Misc' stamp: 'wbk 10/13/2003 23:08'!
checkMed: firstMed 
	self assert: (firstMed isKindOf: Array) | firstMed isString | (firstMed isKindOf: MedLanguage).
	^self asMed: firstMed! !

!MockIntermediateEmitter methodsFor: 'Mocked Arithmatic' stamp: 'wbk 1/18/2004 22:46'!
emitDivide: anArray with: anArray2 failTo: aMedBlock 
	^ self check: {#emitDivide. aMedBlock blockName. anArray. anArray2}! !

!MockIntermediateEmitter methodsFor: 'Mocked Interface' stamp: 'wbk 7/6/2003 20:09'!
emitStackFor: aMockIntermediateEmitter at: aMockIntermediateEmitter2 put: aMedTemporaryRegister 
! !

!MockIntermediateEmitter methodsFor: 'Mocked Interface' stamp: 'wbk 8/19/2003 13:55'!
emitTemporaryAddress: anInteger
	^ self check: {#emitTemporaryAddress. anInteger}! !

!MockIntermediateEmitter methodsFor: 'Misc' stamp: 'wbk 11/17/2003 21:59'!
initialiseMachine: aMockExuperyPlugin 
	machine := aMockExuperyPlugin.
	^ self! !

!MockIntermediateEmitter methodsFor: 'Mocked Interface' stamp: 'wbk 8/8/2003 17:23'!
emitAtCacheEntryEntry: aSymbol index: aSymbol2 
	^self check: { 
				#emitAtCacheEntry.
				aSymbol.
				aSymbol2 intermediateForm}! !

!MockIntermediateEmitter methodsFor: 'Misc' stamp: 'wbk 5/30/2004 21:36'!
stackSetValue
	^ stackSetValue! !

!MockIntermediateEmitter methodsFor: 'Mocked Interface' stamp: 'wbk 10/14/2002 13:55'!
newBlock
	^ method newBlock! !

!MockIntermediateEmitter methodsFor: 'Mocked Low Level Emission ' stamp: 'wbk 6/30/2003 22:36'!
emitMoveToEax: aMed 
	self assert: (aMed isKindOf: MedLanguage).
	self check: {#emitMoveToEax. aMed literal}! !

!MockIntermediateEmitter methodsFor: 'Mocked Interface' stamp: 'wbk 7/19/2003 21:56'!
emitTrueAddress
	^ self check: #(emitTrueAddress)! !

!MockIntermediateEmitter methodsFor: 'Mocked Emit Sends' stamp: 'wbk 7/6/2003 20:26'!
registerEntryPointWithPC: aLiteral label: aMedBlock 
	expectedRegisteredPC ifNil: [^self].
	registeredPC := aLiteral.
	registeredBlock := aMedBlock.
	self assert: registeredPC literal = expectedRegisteredPC.
	self assert: registeredBlock = expectedRegisteredBlock.
	self assert: (aLiteral isKindOf: MedLanguage)! !

!MockIntermediateEmitter methodsFor: 'Mocked Emit Sends' stamp: 'wbk 7/14/2003 14:30'!
emitSetUpMessageSendFor: aMedSelectorAddress argumentCount: argumentsLiteral 
	self checkIsMed: argumentsLiteral.
	self check: { 
				#emitSetUpMessageSend.
				aMedSelectorAddress.
				argumentsLiteral literal}! !

!MockIntermediateEmitter methodsFor: 'Mocked Low Level Emission ' stamp: 'wbk 5/30/2004 21:52'!
emitJumpTarget: anInteger stackHeight: secondInteger
	stackSetValue := secondInteger.
	^ self check: {#emitJumpTarget. anInteger. secondInteger}.! !

!MockIntermediateEmitter methodsFor: 'Mocked Interface' stamp: 'wbk 10/18/2003 11:28'!
emitReturnValue: anArray 
	^ self check: {#emitReturnValue. anArray}! !

!MockIntermediateEmitter methodsFor: 'Mocked Interface' stamp: 'wbk 7/6/2003 20:10'!
hasCreatedProlog
	^ hasCreatedProlog! !

!MockIntermediateEmitter methodsFor: 'Mocked Arithmatic' stamp: 'wbk 11/21/2003 19:11'!
emit: aLargePositiveInteger or: aMedTemporaryRegister 
	^ self check: {#or. self checkMed: aLargePositiveInteger. self checkMed: aMedTemporaryRegister}! !

!MockIntermediateEmitter methodsFor: 'Misc' stamp: 'wbk 6/21/2003 20:36'!
checkIsMed: anObject
	^ self assert: (anObject isKindOf: MedLanguage)! !

!MockIntermediateEmitter methodsFor: 'Mocked Interface' stamp: 'wbk 11/17/2003 21:56'!
createTemporaryRegister
	^ machine createTemporaryRegister! !

!MockIntermediateEmitter methodsFor: 'Misc' stamp: 'wbk 8/17/2003 17:00'!
verify
	callPosition = (callList size + 1) ifFalse: [self signalFailure: 'Wrong Number of Calls'].
	expectedRegisteredPC ifNotNil: [self assert: registeredPC isNil not].
	storedExpressions ifNotNil: [self assert: currentExpression = (storedExpressions size + 1)].! !

!MockIntermediateEmitter methodsFor: 'Mocked Low Level Emission ' stamp: 'wbk 11/21/2003 00:07'!
emit: aMedTemporaryRegister and: aLargePositiveInteger 
	^ self check: {#and. self checkMed: aMedTemporaryRegister. self checkMed: aLargePositiveInteger}! !

!MockIntermediateEmitter methodsFor: 'Mocked Low Level Emission ' stamp: 'wbk 5/30/2004 23:05'!
emitJumpTarget: anInteger
	^ self check: {#emitJumpTarget. anInteger}! !

!MockIntermediateEmitter methodsFor: 'Mocked Low Level Emission ' stamp: 'wbk 7/6/2003 16:15'!
emitLabel
	^ self check: #(emitLabel)! !

!MockIntermediateEmitter methodsFor: 'Mocked Low Level Emission ' stamp: 'wbk 11/16/2003 19:17'!
emit: firstMed minus: secondMed 
	| arg2 arg1 |
	arg1 := self checkMed: firstMed.
	arg2 := self checkMed: secondMed.
	^self check: { 
				#sub.
				arg1.
				arg2}! !

!MockIntermediateEmitter methodsFor: 'Mocked Interface' stamp: 'wbk 6/21/2003 21:13'!
emitIntegerValueOf: aFirstObject failTo: overflowBlock
	^ self check: {#emitIntegerValueOf. overflowBlock blockName. aFirstObject intermediateForm}! !

!MockIntermediateEmitter methodsFor: 'Mocked Interface' stamp: 'wbk 6/25/2003 17:02'!
machine
	^ MockExuperyPlugin new! !

!MockIntermediateEmitter methodsFor: 'Mocked Interface' stamp: 'wbk 1/8/2004 23:01'!
emitConvertComparisionToBoolean: aMed jumpType: anObject 
	^self check: { 
				#emitConvertComparisionToBoolean.
				anObject.
				aMed}! !

!MockIntermediateEmitter methodsFor: 'Mocked Low Level Emission ' stamp: 'wbk 6/20/2003 20:21'!
emitRet
	self check: {#emitRet}! !

!MockIntermediateEmitter methodsFor: 'Mocked Arithmatic' stamp: 'wbk 2/9/2004 21:46'!
emit: anArray bitShift: anArray2 failingTo: anObject 
	^self check: { 
				#bitShift.
				anObject blockName.
				anArray.
				anArray2}! !

!MockIntermediateEmitter methodsFor: 'Mocked Interface' stamp: 'wbk 7/6/2003 20:12'!
createProlog
	self assert: hasCreatedProlog not.
	hasCreatedProlog := true.! !

!MockIntermediateEmitter methodsFor: 'Misc' stamp: 'wbk 8/17/2003 17:00'!
signalFailure: anObject 
	TestResult failure sunitSignalWith: anObject! !

!MockIntermediateEmitter methodsFor: 'Misc' stamp: 'wbk 11/16/2003 19:09'!
asMed: aMed 
	(aMed isKindOf: MedBlock) ifTrue: [^ aMed blockName].
	^ (aMed isKindOf: MedLanguage) 
		ifTrue: [aMed intermediateForm]
		ifFalse: [aMed]! !

!MockIntermediateEmitter methodsFor: 'Mocked Low Level Emission ' stamp: 'wbk 8/10/2003 16:07'!
emit: aSymbol add: anArray 
	^ self check: {#add. self checkMed: aSymbol. self checkMed: anArray}! !

!MockIntermediateEmitter methodsFor: 'Mocked Emit Sends' stamp: 'wbk 7/15/2003 21:30'!
emitSpecialSelector: aSmallInteger 
	^ self check: {#emitSpecialSelector. aSmallInteger}! !

!MockIntermediateEmitter methodsFor: 'Mocked Low Level Emission ' stamp: 'wbk 8/17/2003 17:11'!
emitMoveToTemp: anArray 
	^ self check: {#emitMoveToTemp. self checkMed: anArray}! !

!MockIntermediateEmitter methodsFor: 'Mocked Interface' stamp: 'wbk 8/5/2003 21:32'!
currentBlock: aMedBlock 
	currentBlock := aMedBlock blockName! !

!MockIntermediateEmitter methodsFor: 'Set Up' stamp: 'wbk 7/6/2003 15:59'!
expectRegisterEntryPointPC: aSmallInteger blockNumbered: aSmallInteger2 
	expectedRegisteredPC := aSmallInteger.
	expectedRegisteredBlock := aSmallInteger2.! !

!MockIntermediateEmitter methodsFor: 'Mocked Interface' stamp: 'wbk 11/20/2003 21:34'!
emitRootTableCountAddress
	^self check: #(#emitRootTableCountAddress)! !

!MockIntermediateEmitter methodsFor: 'Mocked Interface' stamp: 'wbk 6/21/2003 21:14'!
emitLabelForByteCode: anInteger
	^ self check: {#emitLabelForByteCode. anInteger}! !

!MockIntermediateEmitter methodsFor: 'Mocked Interface' stamp: 'wbk 7/6/2003 20:08'!
emitSendersContext
! !

!MockIntermediateEmitter methodsFor: 'Mocked Emit Sends' stamp: 'wbk 11/21/2003 19:12'!
emitReloadStack: anArray 
	| answer |
	answer := #(#emitReloadStack) asOrderedCollection.
	answer addAll: (anArray collect: 
		[:each| self checkMed: each]).
	self check: answer asArray! !

!MockIntermediateEmitter methodsFor: 'Mocked Arithmatic' stamp: 'wbk 2/5/2004 22:54'!
emitDiv: anArray with: anArray2 failTo: aMedBlock 
	^ self check: {#emitDiv. aMedBlock blockName. anArray. anArray2. }! !

!MockIntermediateEmitter methodsFor: 'Mocked Emit Sends' stamp: 'wbk 2/14/2004 17:09'!
emitSendSelector: anEmitter arguments: aCollection 
	| answer |
	answer := { 
				#emitSend.
				anEmitter} asOrderedCollection.
	answer addAll: (aCollection collect: 
		[:each| (each isKindOf: MedLanguage) 
			ifTrue: [each intermediateForm]
			ifFalse: [each]]).
	^self check: answer asArray! !

!MockIntermediateEmitter methodsFor: 'Mocked Interface' stamp: 'wbk 7/30/2003 18:49'!
emitFalseAddress
	^ self check: #(emitFalseAddress)! !

!MockIntermediateEmitter methodsFor: 'Mocked Interface' stamp: 'wbk 11/16/2003 19:16'!
emitYoungStartAddress
	^ self check: #(emitYoungStartAddress)! !

Object subclass: #EncodeFromLiteral
	instanceVariableNames: 'opcode modRmOpcode assembler instruction'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery'!

!EncodeFromLiteral class methodsFor: 'as yet unclassified' stamp: 'wbk 4/18/2003 18:19'!
opcode: aSmallInteger modRmOpcode: aSmallInteger2
	^ self new
		initializeOpcode: aSmallInteger 
		modRmOpcode: aSmallInteger2 ! !

!EncodeFromLiteral methodsFor: 'misc' stamp: 'wbk 4/18/2003 18:17'!
registerInstruction: anAssembleArithmatic 
	instruction := anAssembleArithmatic.
	assembler := instruction assembler.! !

!EncodeFromLiteral methodsFor: 'misc' stamp: 'wbk 4/18/2003 18:18'!
initializeOpcode: aSmallInteger modRmOpcode: aSmallInteger2
	opcode := aSmallInteger.
	modRmOpcode := aSmallInteger2.	
	^ self.! !

!EncodeFromLiteral methodsFor: 'Encoding' stamp: 'wbk 4/6/2003 21:17'!
isFirable
	^ instruction arg1 isLiteral! !

!EncodeFromLiteral methodsFor: 'Encoding' stamp: 'wbk 4/7/2003 21:12'!
fire
	assembler stream nextPut: opcode.
	assembler 
		encodeModRm: instruction arg2 
		registerOpcode: modRmOpcode.
	assembler encodeImmediate: instruction arg1
	! !

Object subclass: #EncodeFixedRegRm32
	instanceVariableNames: 'registerName opcode rmOpcode instruction'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery'!

!EncodeFixedRegRm32 methodsFor: 'as yet unclassified' stamp: 'wbk 2/8/2004 21:39'!
initialiseFixedRegister: aSymbol fixedOpcode: opcodeInteger fixedModRm: rmInteger 
	registerName := aSymbol.
	opcode := opcodeInteger.
	rmOpcode := rmInteger! !

!EncodeFixedRegRm32 methodsFor: 'as yet unclassified' stamp: 'wbk 2/8/2004 21:53'!
registerInstruction: anAssembleArithmatic 
	instruction := anAssembleArithmatic! !

!EncodeFixedRegRm32 methodsFor: 'as yet unclassified' stamp: 'wbk 2/8/2004 21:53'!
isFirable
	instruction arg1 isRegister ifFalse: [^false].
	^instruction arg1 name = registerName! !

!EncodeFixedRegRm32 methodsFor: 'as yet unclassified' stamp: 'wbk 2/8/2004 21:53'!
fire
	instruction assembler stream nextPut: opcode.
	instruction assembler 
		encodeModRm: instruction arg2
		registerOpcode: rmOpcode! !

!EncodeFixedRegRm32 class methodsFor: 'as yet unclassified' stamp: 'wbk 2/8/2004 21:36'!
fixedRegister: aSymbol fixedOpcode: anUndefinedObject fixedModRm: anUndefinedObject3 
	^ self new
		initialiseFixedRegister: aSymbol 
		fixedOpcode: anUndefinedObject 
		fixedModRm: anUndefinedObject3 ! !

Object subclass: #ColouringRegisterAllocator
	instanceVariableNames: 'source result machine interferenceGraph registerStack registerFile registerTable spiltRegisters hasSpilt coloursUsed simplifyWorklist spillWorklist moveWorklist coalescedMoves'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery'!

!ColouringRegisterAllocator methodsFor: 'Allocation' stamp: 'wbk 6/2/2004 22:53'!
assignmentDictionary
	| assignments |
	assignments := Dictionary new.
	interferenceGraph do: 
			[:each | 
			assignments 
				at: each register
				put: each currentVersion colour].
	^assignments! !

!ColouringRegisterAllocator methodsFor: 'Allocation' stamp: 'wbk 10/23/2002 14:02'!
analyseLiveness
	LivenessAnalyser on: source.! !

!ColouringRegisterAllocator methodsFor: 'Unit Testing' stamp: 'wbk 11/2/2002 15:50'!
interferenceGraph
	^ interferenceGraph! !

!ColouringRegisterAllocator methodsFor: 'Select Registers' stamp: 'wbk 6/2/2004 22:48'!
assignColourTo: aNode 
	| colour |
	self clearRegisterTable.
	coloursUsed := 0.
	aNode neighboursDo: [:each | self markRegisterUsedFor: each].
	colour := self 
				firstFreeRegisterFor: aNode
				ifAbsent: [^self spillFor: aNode].
	aNode colour: colour.! !

!ColouringRegisterAllocator methodsFor: 'Simplify Graph' stamp: 'wbk 5/29/2004 15:22'!
gatherSimplifyableNodes
	| toSimplify |
	toSimplify := spillWorklist select: [:each | each currentSize < machine numberOfColours].
	spillWorklist removeAll: toSimplify.
	simplifyWorklist addAll: toSimplify! !

!ColouringRegisterAllocator methodsFor: 'Unit Testing' stamp: 'wbk 10/28/2002 10:25'!
stackSize
	^ registerStack size! !

!ColouringRegisterAllocator methodsFor: 'Unit Testing' stamp: 'wbk 11/1/2002 23:09'!
registerStack: aCollection
	registerStack := aCollection collect: [:each| interferenceGraph at: (machine registerNamed: each)] ! !

!ColouringRegisterAllocator methodsFor: 'Misc' stamp: 'wbk 5/29/2004 16:04'!
initialiseSource: aMethod machine: aMachine
	source := aMethod.
	machine := aMachine.
	interferenceGraph := Dictionary new.
	registerStack := OrderedCollection new.
	registerFile := aMachine useableRegisters.
	spiltRegisters := OrderedCollection new.
	hasSpilt := Set new.
	simplifyWorklist := OrderedCollection new.
	spillWorklist := OrderedCollection new.
	moveWorklist := OrderedCollection new.
	coalescedMoves := OrderedCollection new.
	^ self! !

!ColouringRegisterAllocator methodsFor: 'Unit Testing' stamp: 'wbk 11/2/2002 17:02'!
result
	^ result! !

!ColouringRegisterAllocator methodsFor: 'Move Coalescing' stamp: 'wbk 6/24/2003 13:28'!
isCoalescableMove: aMove 
	(aMove isMov and: [aMove to isRegister & aMove from isRegister]) ifFalse: [^ false].
	(machine isSpecialRegister: aMove from) | (machine isSpecialRegister: aMove to)
		ifTrue: [^ false]. "Copied from ColouringRegisterAllocator>>addInterferenceEdge:to:"
	^ (self
		interferes: aMove to
		with: aMove from) not! !

!ColouringRegisterAllocator methodsFor: 'Unit Testing' stamp: 'wbk 11/3/2002 12:20'!
registerStack
	^ registerStack! !

!ColouringRegisterAllocator methodsFor: 'Misc' stamp: 'wbk 5/26/2004 23:56'!
registerIsSpilled: aMedTemporaryRegister 
	hasSpilt add: aMedTemporaryRegister! !

!ColouringRegisterAllocator methodsFor: 'Unit Testing' stamp: 'wbk 10/28/2002 21:36'!
source
	^ source! !

!ColouringRegisterAllocator methodsFor: 'Interference Graph' stamp: 'wbk 8/2/2004 21:24'!
buildInterferenceGraph
	interferenceGraph := Dictionary new.
	source registersDo: 
			[:each | 
			(machine isSpecialRegister: each) not ifTrue: 
					[interferenceGraph 
						at: each
						ifAbsentPut: 
							[InterferenceNode 
								for: each
								with: machine
								interferenceGraph: interferenceGraph]]].
	source instructionsDo: [:each | each buildInterferenceWith: self]! !

!ColouringRegisterAllocator methodsFor: 'Simplify Graph' stamp: 'wbk 11/5/2002 13:30'!
registersToSimplify
	^ spillWorklist isEmpty not | simplifyWorklist isEmpty not | moveWorklist isEmpty not! !

!ColouringRegisterAllocator methodsFor: 'Simplify Graph' stamp: 'wbk 8/2/2004 21:13'!
simplifyAndSpill
	[self registersToSimplify] whileTrue: [self processWorkLists]! !

!ColouringRegisterAllocator methodsFor: 'Unit Testing' stamp: 'wbk 11/5/2002 10:40'!
simplifyWorklist
	^ simplifyWorklist! !

!ColouringRegisterAllocator methodsFor: 'Select Registers' stamp: 'wbk 11/3/2002 14:52'!
spillFor: aNode 
	spiltRegisters add: aNode register.
	hasSpilt add: aNode register! !

!ColouringRegisterAllocator methodsFor: 'Unit Testing' stamp: 'wbk 10/23/2002 21:59'!
interferenceNode: aRegister
	^ interferenceGraph
		at: aRegister ! !

!ColouringRegisterAllocator methodsFor: 'Unit Testing' stamp: 'wbk 10/28/2002 19:29'!
spiltRegisters: aCollection
	spiltRegisters := aCollection! !

!ColouringRegisterAllocator methodsFor: 'Move Coalescing' stamp: 'wbk 6/20/2004 10:53'!
coalesce
	| toCoalesce |
	toCoalesce := moveWorklist 
		detect: [:each | each isCoalescable]
		ifNone: [^false].
	self coalesceNode: toCoalesce.
	moveWorklist copy do: 
		[:each | (each doesInterfere) ifTrue: [self freezeMove: each]].
	^true! !

!ColouringRegisterAllocator methodsFor: 'Allocation' stamp: 'wbk 10/23/2002 18:08'!
clearRegisterTable
	registerTable := registerFile collect: [:each| false].! !

!ColouringRegisterAllocator methodsFor: 'Misc' stamp: 'wbk 5/26/2004 22:28'!
hasSpill: aMedTemporaryRegister 
	^ hasSpilt includes: aMedTemporaryRegister! !

!ColouringRegisterAllocator methodsFor: 'Unit Testing' stamp: 'wbk 10/23/2002 22:35'!
stackIncludes: aRegister
	^ registerStack includes: (interferenceGraph at: aRegister).! !

!ColouringRegisterAllocator methodsFor: 'Simplify Graph' stamp: 'wbk 10/23/2002 17:18'!
createWorkingEdges
	interferenceGraph do: [:each| each createWorkingEdges]! !

!ColouringRegisterAllocator methodsFor: 'Unit Testing' stamp: 'wbk 6/21/2004 22:16'!
getMoveFrom: aSymbol to: aSymbol2 
	^ moveWorklist detect: 
		[:each| each fromNode register name = aSymbol & (each toNode register name = aSymbol2)]! !

!ColouringRegisterAllocator methodsFor: 'Unit Testing' stamp: 'wbk 11/5/2002 10:34'!
moveWorklist
	^ moveWorklist! !

!ColouringRegisterAllocator methodsFor: 'Simplify Graph' stamp: 'wbk 8/2/2004 22:02'!
findNodeToSpill
	| spillable |
	"This is just a basic heuristic, spill the register that interferes with the most
	other registers. It is possible to do a lot better. 
	The heuristic should concider how much each register is used while it is alive"
	spillable := spillWorklist select: [:each | (self hasSpill: each register) not].
	spillable := spillable asSortedCollection: [:a :b| a spillWeight > b spillWeight].
	^ spillable first! !

!ColouringRegisterAllocator methodsFor: 'Unit Testing' stamp: 'wbk 10/28/2002 17:58'!
spiltRegisters
	^ spiltRegisters! !

!ColouringRegisterAllocator methodsFor: 'Unit Testing' stamp: 'wbk 11/5/2002 13:16'!
coalescedMoves
	^ coalescedMoves! !

!ColouringRegisterAllocator methodsFor: 'Simplify Graph' stamp: 'wbk 8/2/2004 21:18'!
setUp
	self analyseLiveness.
	self buildInterferenceGraph.
	registerStack := OrderedCollection new.
	self createWorkingEdges.
	self createWorklists.
	self calculateStatistics.! !

!ColouringRegisterAllocator methodsFor: 'Unit Testing' stamp: 'wbk 6/2/2004 22:54'!
registerAssignments
	^ self assignmentDictionary! !

!ColouringRegisterAllocator methodsFor: 'Unit Testing' stamp: 'wbk 7/25/2004 16:34'!
verifyCoalescableNodesNotSimplified
	moveWorklist do:
		[:each| self assert: each fromNode currentVersion isSimplified not.
		self assert: each toNode currentVersion isSimplified not]! !

!ColouringRegisterAllocator methodsFor: 'Simplify Graph' stamp: 'wbk 11/7/2002 15:38'!
processWorkLists
	simplifyWorklist isEmpty ifFalse: [^ self simplify].
	self coalesce ifTrue: [^ self].
	self freeze ifTrue: [^ self].
	spillWorklist isEmpty ifFalse: [^ self spillRegister].
	self spillMove! !

!ColouringRegisterAllocator methodsFor: 'Select Registers' stamp: 'wbk 6/2/2004 22:48'!
select
	spiltRegisters := OrderedCollection new.
	registerStack reverseDo: [:each | self assignColourTo: each]! !

!ColouringRegisterAllocator methodsFor: 'Simplify Graph' stamp: 'wbk 5/29/2004 16:05'!
spillRegister
	| toSpill |
	toSpill := self findNodeToSpill.
	registerStack addLast: toSpill.
	toSpill simplify.
	toSpill markAsSpilled.
	spillWorklist remove: toSpill.
	self gatherSimplifyableNodes.
	! !

!ColouringRegisterAllocator methodsFor: 'Move Coalescing' stamp: 'wbk 7/25/2004 18:11'!
coalesceNode: node 
	| fromNode toNode temporaryNode |
	fromNode := node fromCurrentNode.
	toNode := node toCurrentNode.
	fromNode register isMachineRegister ifTrue:
		[temporaryNode := fromNode.
		fromNode := toNode.
		toNode := temporaryNode].
	fromNode decrementCurrentMoves.
	toNode addInterferenceEdgesFrom: fromNode.
	toNode = fromNode ifFalse:
		[toNode incrementCurrentMovesBy: fromNode currentMoves.
		fromNode simplify].
	fromNode currentVersion: toNode.
	self queueNode: toNode.
	coalescedMoves add: node.
	moveWorklist remove: node.! !

!ColouringRegisterAllocator methodsFor: 'Allocation' stamp: 'wbk 6/2/2004 22:53'!
assignRegisters
	"coalescedMoves
		do: [:t1 | (registerAssignments includesKey: t1 from)
				ifFalse: [registerAssignments 
					at: t1 from 
					put: (interferenceGraph at: t1 from) currentVersion colour]]."

	| assignments |
	assignments := self assignmentDictionary.
	self assignRegisters: assignments! !

!ColouringRegisterAllocator methodsFor: 'Move Coalescing' stamp: 'wbk 6/21/2004 22:11'!
freezeMove: move 
	| fromNode toNode |
	moveWorklist remove: move.
	fromNode := move fromCurrentNode.
	toNode :=  move toCurrentNode.
	self queueNode: fromNode.
	self queueNode: toNode! !

!ColouringRegisterAllocator methodsFor: 'Unit Testing' stamp: 'wbk 7/25/2004 16:00'!
verifyInterferenceGraph
	"Check that all machine registers are at the top of the merge trees"
	interferenceGraph do:
		[:each| each register isMachineRegister ifTrue:
			[self assert: each = each  currentVersion]].! !

!ColouringRegisterAllocator methodsFor: 'Unit Testing' stamp: 'wbk 7/25/2004 16:26'!
verify
	"Copied from ColouringRegisterAllocatorTests>>verifyAllocationCounts. 	verifyAllocationMoveCounds should be modified to use this in the future."

	self verifyMoveCounts.
	self verifyInterferenceGraph.
	self verifyCoalescableNodesNotSimplified.! !

!ColouringRegisterAllocator methodsFor: 'Simplify Graph' stamp: 'wbk 8/2/2004 21:29'!
calculateStatistics
	source registersDo: 
		[:each| (machine isSpecialRegister: each) ifFalse: 
			[(interferenceGraph at: each) incrementRegisterCount]].! !

!ColouringRegisterAllocator methodsFor: 'Interference Graph' stamp: 'wbk 11/2/2002 16:15'!
addInterferenceEdge: firstRegister to: secondRegister
	| firstNode secondNode |
	firstRegister = secondRegister ifTrue: [^ self]. "Arcs to ourself are meaningless, they also allow 
													collections to be modified inside iterations"
	(machine isSpecialRegister: firstRegister) | (machine isSpecialRegister: secondRegister)
		ifTrue: [^ self]. "Special registers do not interfere with colourable registers"
	firstNode := interferenceGraph at: firstRegister.
	secondNode := interferenceGraph at: secondRegister.
	firstNode addEdgeTo: secondNode.
	secondNode addEdgeTo: firstNode! !

!ColouringRegisterAllocator methodsFor: 'Allocation' stamp: 'wbk 8/2/2004 21:13'!
run
	| hadSpills |
	hadSpills := true.
	[hadSpills] whileTrue: 
			[self setUp.
			self simplifyAndSpill.
			self select.
			hadSpills := spiltRegisters size ~= 0.
			hadSpills 
				ifTrue: [self insertSpills]
				ifFalse: [self assignRegisters]]! !

!ColouringRegisterAllocator methodsFor: 'Move Coalescing' stamp: 'wbk 11/7/2002 15:52'!
spillMove
	self freezeMove: moveWorklist first! !

!ColouringRegisterAllocator methodsFor: 'Select Registers' stamp: 'wbk 11/4/2002 16:56'!
firstFreeRegisterFor: aNode ifAbsent: aBlock
	| index |
	coloursUsed >= registerFile size & aNode isSpilled ifTrue: aBlock.
	index := registerTable indexOf: false.
	^ registerFile at: index! !

!ColouringRegisterAllocator class methodsFor: 'instance creation' stamp: 'wbk 10/23/2002 13:47'!
on: aMethod for: aMachine
	| allocator |
	allocator := self new
		initialiseSource: aMethod
		machine: aMachine.
	allocator run.
	^ allocator! !

!ColouringRegisterAllocator methodsFor: 'Select Registers' stamp: 'wbk 11/4/2002 17:04'!
markRegisterUsedFor: aNode 
	aNode isSpilled ifTrue: [^ self].
	coloursUsed := coloursUsed + 1.
	aNode hasColour ifFalse: [^ self].
	registerTable 
		at: (registerFile indexOf: aNode colour) 
		put: true! !

!ColouringRegisterAllocator methodsFor: 'Move Coalescing' stamp: 'wbk 8/2/2004 22:24'!
freeze
	| moves |
	moveWorklist isEmpty ifTrue: [^false].
	moves := moveWorklist 
		select: 
			[:each |  each fromNode currentSize < machine numberOfColours |
	 			( each toNode currentSize < machine numberOfColours)].
	moves ifEmpty: [^ false].
	moves := moves asSortedCollection: [:a :b| a freezeWeight > b freezeWeight].
	"self halt."
	self freezeMove: moves first.
	^true! !

!ColouringRegisterAllocator methodsFor: 'Allocation' stamp: 'wbk 5/29/2004 14:03'!
insertSpills
	source := SpillInserter
		spiltRegisters: spiltRegisters
		method: source
		for: machine
		allocator: self! !

!ColouringRegisterAllocator methodsFor: 'Unit Testing' stamp: 'wbk 5/22/2004 22:15'!
assert: aBoolean
	aBoolean ifFalse: [TestResult failure sunitSignalWith: 'Verification failed'].! !

!ColouringRegisterAllocator methodsFor: 'Unit Testing' stamp: 'wbk 10/23/2002 22:12'!
intermediateForm
	^ self result intermediateForm! !

!ColouringRegisterAllocator methodsFor: 'Move Coalescing' stamp: 'wbk 6/21/2004 22:25'!
queueNode: aNode 
	aNode decrementCurrentMoves.
	aNode isCurrentlyInvolvedInMoves ifTrue: [^self].
	aNode currentSize < machine numberOfColours 
		ifTrue: [simplifyWorklist add: aNode.]
		ifFalse: [spillWorklist add: aNode]! !

!ColouringRegisterAllocator methodsFor: 'Allocation' stamp: 'wbk 6/2/2004 21:30'!
assignRegisters: assignments 
	result := RegisterReassigner 
				assignments: assignments
				method: source
				for: machine! !

!ColouringRegisterAllocator methodsFor: 'Simplify Graph' stamp: 'wbk 5/29/2004 16:03'!
simplify
	simplifyWorklist do: 
			[:each | 
			registerStack addLast: each.
			each simplify].
	simplifyWorklist := OrderedCollection new.
	self gatherSimplifyableNodes! !

!ColouringRegisterAllocator methodsFor: 'Unit Testing' stamp: 'wbk 7/25/2004 15:54'!
verifyMoveCounts
	| moveCount |
	moveCount := Dictionary new.
	moveWorklist do: 
			[:each | 
			moveCount 
				at: each fromCurrentNode
				put: (moveCount 
						at: each fromCurrentNode
						ifAbsent: [0]) + 1.
			moveCount 
				at: each toCurrentNode
				put: (moveCount 
						at: each toCurrentNode
						ifAbsent: [0]) + 1].
	interferenceGraph do: 
			[:each | 
			self assert: each currentVersion currentMoves = (moveCount 
								at: each currentVersion
								ifAbsent: [0])]! !

!ColouringRegisterAllocator methodsFor: 'Unit Testing' stamp: 'wbk 10/27/2002 21:27'!
unallocated
	| answer |
	answer := OrderedCollection new.
	interferenceGraph do: [:each| each isSelected ifFalse: [answer add: each]].
	^ answer! !

!ColouringRegisterAllocator methodsFor: 'Unit Testing' stamp: 'wbk 11/7/2002 15:35'!
interferes: firstRegister with: secondRegister 
	^(interferenceGraph at: firstRegister) 
		interferesWith: (interferenceGraph at: secondRegister)! !

!ColouringRegisterAllocator methodsFor: 'Simplify Graph' stamp: 'wbk 6/20/2004 10:50'!
createWorklists
	source instructionsDo: 
			[:each | 
			(self isCoalescableMove: each) ifTrue: 
				[moveWorklist add: (MoveNode 
					move: each
					withGraph: interferenceGraph
					maxColours: machine numberOfColours).]].
	interferenceGraph do: 
		[:each | 
		each isMoveRelated ifFalse: 
			[each currentSize < machine numberOfColours & each isSelected not 
				ifTrue: [simplifyWorklist add: each]
				ifFalse: [spillWorklist add: each]]]! !

!ColouringRegisterAllocator methodsFor: 'Unit Testing' stamp: 'wbk 8/2/2004 21:24'!
hasNoTemporaries
	result registersDo: [:each| each isMachineRegister ifFalse: [^false]].
	^ true.! !

!ColouringRegisterAllocator methodsFor: 'Unit Testing' stamp: 'wbk 11/5/2002 11:04'!
spillWorklist
	^ spillWorklist! !

Object subclass: #InstructionSelector
	instanceVariableNames: 'source result machine currentBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery'!

!InstructionSelector methodsFor: 'Instruction Selection' stamp: 'wbk 11/9/2002 14:57'!
buildArithmaticOperator: operator arg1: arg1 arg2: arg2 
	| destReg |
	destReg := machine createTemporaryRegister.
	currentBlock add: (MedMov 
		from: arg2 
		to: destReg).
	currentBlock add: (MedAssembly 
		name: operator
		arguments: {arg1. destReg}).
	^destReg! !

!InstructionSelector methodsFor: 'as yet unclassified' stamp: 'wbk 2/9/2004 20:56'!
visitNegate: aMedNegate 
	| destReg |
	destReg := machine createTemporaryRegister.
	currentBlock add: (MedMov 
		from: (self getRegFor: aMedNegate argument) 
		to: destReg).
	currentBlock add: (MedNegate argument: destReg).
	^ destReg! !

!InstructionSelector methodsFor: 'Instruction Selection' stamp: 'wbk 3/6/2004 19:01'!
matchShift: anArithmatic 
	| shiftAmnt shiftAmount |
	shiftAmnt := self getRegOrLiteralFor: anArithmatic arg2.
	shiftAmount := shiftAmnt isRegister 
				ifTrue: 
					[currentBlock add: (MedMov 
								from: shiftAmnt
								to: (machine registerNamed: #ecx)).
					machine registerNamed: #ecx]
				ifFalse: [shiftAmnt].
	^self 
		buildArithmaticOperator: anArithmatic operator
		arg1: shiftAmount
		arg2: (self getRegFor: anArithmatic arg1)! !

!InstructionSelector methodsFor: 'Instruction Selection' stamp: 'wbk 10/6/2002 17:15'!
getRegOrLiteralFor: aMed
	aMed isLiteral ifTrue: [^ aMed].
	^ self getRegFor: aMed! !

!InstructionSelector methodsFor: 'Instruction Selection' stamp: 'wbk 11/5/2002 14:38'!
getRegFor: aMed
	|reg|
	aMed isRegister ifTrue: [^ aMed].
	aMed isLiteral ifTrue:
		[reg := machine createTemporaryRegister.
		currentBlock add: (MedMov
			from: aMed
			to: reg).
		^ reg].
	^ aMed visitWith: self
		! !

!InstructionSelector methodsFor: 'Instruction Selection' stamp: 'wbk 10/6/2002 16:57'!
run
	result := MedMethod from: source.
	source blocksDo: [:each| each visitWith: self].
	^ result! !

!InstructionSelector methodsFor: 'Selection Visiting' stamp: 'wbk 11/9/2002 15:21'!
visitRet: aRet
	currentBlock add: MedRet new.
	^ nil.! !

!InstructionSelector methodsFor: 'Instruction Selection' stamp: 'wbk 11/9/2002 15:02'!
buildMoveFrom: from to: to 
	| instr |
	instr := MedMov 
		from: from 
		to: to.
	currentBlock add: instr.
	^ to! !

!InstructionSelector methodsFor: 'Selection Visiting' stamp: 'wbk 7/6/2003 20:44'!
visitBlock: aBlock
	|block|
	block := result blockNumbered: aBlock blockNumber.
	currentBlock := block.
	aBlock do: [:each| each visitWith: self].
	currentBlock := nil.
	^ block! !

!InstructionSelector methodsFor: 'Instruction Selection' stamp: 'wbk 4/11/2003 13:33'!
getAddressingModeFor: aNode	
	| answer address |
	(aNode address isAdd and: [aNode address arg2 isMachineInteger])
		ifTrue: 
			[answer := MedAddressingMode
				offset: aNode address arg2 literal
				base: (self getRegFor: aNode address arg1)]
		ifFalse: 
			[address := self getRegFor: aNode address.
			answer := MedAddressingMode indirectRegister: address].
	^ answer! !

!InstructionSelector methodsFor: 'Instruction Selection' stamp: 'wbk 11/9/2002 14:59'!
matchArithmaticArg1Address: anArithmatic 
	^ self 
		buildArithmaticOperator: anArithmatic operator
		arg1: (self getAddressingModeFor: anArithmatic arg1)
		arg2: (self getRegFor: anArithmatic arg2)! !

!InstructionSelector methodsFor: 'Instruction Selection' stamp: 'wbk 11/9/2002 14:58'!
matchBasicArithmatic: anArithmatic 
	^ self 
		buildArithmaticOperator: anArithmatic operator
		arg1: (self getRegOrLiteralFor: anArithmatic arg1)
		arg2: (self getRegFor: anArithmatic arg2)! !

!InstructionSelector methodsFor: 'Selection Visiting' stamp: 'wbk 3/6/2004 21:15'!
matchArithmatic: anArithmatic 
	anArithmatic arg1 isMem ifTrue: [^self matchArithmaticArg1Address: anArithmatic].
	^self matchBasicArithmatic: anArithmatic! !

!InstructionSelector methodsFor: 'Instruction Selection' stamp: 'wbk 11/9/2002 15:05'!
matchMoveToAddress: aMed
	^ self
		buildMoveFrom: (self getRegOrLiteralFor: aMed from)
		to: (self getAddressingModeFor: aMed to)! !

!InstructionSelector methodsFor: 'Selection Visiting' stamp: 'wbk 11/9/2002 15:17'!
visitMem: aMem
	^ self 
		buildMoveFrom: (self getAddressingModeFor: aMem)
		to: (machine createTemporaryRegister)! !

!InstructionSelector methodsFor: 'Instruction Selection' stamp: 'wbk 11/9/2002 15:04'!
matchMoveFromAddress: aMed
	^ self
		buildMoveFrom: (self getAddressingModeFor: aMed from)
		to: (self getRegFor: aMed to)! !

!InstructionSelector methodsFor: 'Selection Visiting' stamp: 'wbk 3/6/2004 21:17'!
visitArithmatic: anArithmatic 
	| instruction |
	(#(#sal #sar) includes: anArithmatic operator) ifTrue: [^self matchShift: anArithmatic].
	instruction := anArithmatic operator = #sub
		ifTrue:
			[MedArithmatic
				operator: #sub
				arg1: anArithmatic arg2
				arg2: anArithmatic arg1]
		ifFalse: [anArithmatic].
	^self matchArithmatic: instruction! !

!InstructionSelector methodsFor: 'unit testing' stamp: 'wbk 2/9/2004 20:59'!
writtenResult
	^ result intermediateForm! !

!InstructionSelector methodsFor: 'misc' stamp: 'wbk 3/17/2003 18:24'!
initializeMed: aMed for: aMachine
	source := aMed.
 	machine := aMachine.
	result := OrderedCollection new.
	^ self	! !

!InstructionSelector methodsFor: 'misc' stamp: 'wbk 9/11/2002 21:25'!
result
	^ result! !

!InstructionSelector methodsFor: 'Selection Visiting' stamp: 'wbk 10/14/2002 16:09'!
visitJump: aJump
	| instructionReg |
	instructionReg := aJump instruction isNil
		ifTrue: [nil]
		ifFalse: [self getRegFor: aJump instruction].
	currentBlock add: (MedJump
		type: aJump type
		block: (result newBlockFor: aJump target)).
	^ instructionReg.
		! !

!InstructionSelector methodsFor: 'Selection Visiting' stamp: 'wbk 11/8/2002 21:35'!
visitMov: aMov
	aMov to isMem ifTrue: [^ self matchMoveToAddress: aMov].
	aMov from isMem ifTrue: [ ^ self matchMoveFromAddress: aMov].
	^ self matchBasicMove: aMov! !

!InstructionSelector methodsFor: 'Selection Visiting' stamp: 'wbk 6/21/2003 17:17'!
visitCall: aMedCall 
	currentBlock add: (MedCall function: (aMedCall function))! !

!InstructionSelector methodsFor: 'Selection Visiting' stamp: 'wbk 6/21/2003 17:19'!
visitPush: aMedPush 
	currentBlock add: (MedPush argument: (self getRegFor: aMedPush argument))! !

!InstructionSelector class methodsFor: 'instance creation' stamp: 'WBK 8/28/2002 20:13'!
on: aMed for: aMachine
	|selector|
	selector := self new 
		initializeMed: aMed
		for: aMachine.
	selector run.
	^ selector! !

!InstructionSelector methodsFor: 'Instruction Selection' stamp: 'wbk 11/9/2002 15:03'!
matchBasicMove: aMed 
	^ self 
		buildMoveFrom: (self getRegOrLiteralFor: aMed from)
		to: (self getRegFor: aMed to)! !

!InstructionSelector methodsFor: 'Selection Visiting' stamp: 'wbk 2/1/2004 22:16'!
visitDivide: aMedDivide 
	|answer arg1 arg2 |
	answer := machine createTemporaryRegister.
	arg1 := self getRegFor: aMedDivide arg1.
	arg2 := self getRegFor: aMedDivide arg2.
	currentBlock add: (MedMov
		from: arg1
		to: (machine registerNamed: #eax)).
	currentBlock add: (MedX86CDQ 
		eax: (machine registerNamed: #eax)
		edx: (machine registerNamed: #edx)).
	currentBlock add: (MedX86Divide 
		register: arg2
		eax: (machine registerNamed: #eax)
		edx: (machine registerNamed: #edx)).
	currentBlock add: (MedMov
		from: (machine registerNamed: #eax)
		to: answer).
	currentBlock add: (MedMov
		from: (machine registerNamed: #edx)
		to: aMedDivide remainder).
	^ answer
		! !

Object subclass: #IntermediateGenerator
	instanceVariableNames: 'emitter jumpTargets'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery'!

!IntermediateGenerator methodsFor: 'Byte Codes - Comparision' stamp: 'wbk 1/12/2004 21:58'!
prim: firstMed greaterThan: secondMed 
	^ emitter
		emitConditionalBytecodeArg1: firstMed
		arg2: secondMed
		withJump: #jle
		failureSelector: 3.! !

!IntermediateGenerator methodsFor: 'Unit Testing' stamp: 'wbk 10/14/2002 13:52'!
intermediateString
	^ emitter method intermediateForm! !

!IntermediateGenerator methodsFor: 'Byte Codes - Arithmatic' stamp: 'wbk 2/8/2004 16:20'!
generate: firstMed subtract: secondMed 
	^self 
		emitWithIntegers: 
			[:arg1 :arg2 :overflowBlock | 
			emitter 
				emit: arg1
				minus: arg2]
		arg1: firstMed
		arg2: secondMed
		failToSpecialSelector: 1! !

!IntermediateGenerator methodsFor: 'Byte Codes - Comparision' stamp: 'wbk 1/14/2004 21:25'!
prim: firstMed greaterThanEqual: secondMed
	^ emitter
		emitConditionalBytecodeArg1: firstMed
		arg2: secondMed
		withJump: #jl
		failureSelector: 5.! !

!IntermediateGenerator methodsFor: 'Misc' stamp: 'wbk 10/15/2002 18:39'!
jumpTargets
	^ jumpTargets! !

!IntermediateGenerator methodsFor: 'Byte Codes - Arithmatic' stamp: 'wbk 2/8/2004 16:17'!
generate: aFirstObject add: aSecondObject 
	^self 
		emitWithIntegers: 
			[:arg1 :arg2 :overflowBlock | 
			emitter 
				emit: arg1
				add: arg2]
		arg1: aFirstObject
		arg2: aSecondObject
		failToSpecialSelector: 0! !

!IntermediateGenerator methodsFor: 'Byte Codes - Arithmatic' stamp: 'wbk 2/7/2004 20:50'!
generate: firstMed mod: secondMed 
	^self 
		emitWithIntegers: 
			[:arg1 :arg2 :overflowBlock | 
			emitter 
				emitMod: arg1
				with: arg2
				failTo: overflowBlock]
		arg1: firstMed
		arg2: secondMed
		failToSpecialSelector: 10! !

!IntermediateGenerator methodsFor: 'Byte Codes - Stack' stamp: 'wbk 8/19/2003 14:02'!
pushTempAt: anInteger
	^ emitter emitMoveToTemp: (emitter emitTemporaryAddress: anInteger)! !

!IntermediateGenerator methodsFor: 'Byte Codes - Return' stamp: 'wbk 10/18/2003 11:35'!
returnTop: aMed 
	^ emitter emitReturnValue: aMed! !

!IntermediateGenerator methodsFor: 'Byte Codes - Return' stamp: 'wbk 11/27/2003 21:23'!
returnFalse
	emitter emitReturnValue: emitter emitFalseAddress! !

!IntermediateGenerator methodsFor: 'Misc' stamp: 'wbk 10/14/2002 13:38'!
method
	^ emitter method! !

!IntermediateGenerator methodsFor: 'Byte Codes - Stack' stamp: 'wbk 10/4/2003 20:05'!
pushNil
	^ emitter emitMoveToTemp: (emitter emitNilAddress)! !

!IntermediateGenerator methodsFor: 'Byte Codes - Arithmatic' stamp: 'wbk 2/28/2004 16:54'!
generate: aMedLiteral equivilent: aMedLiteral2 
	^ emitter
		emitConvertComparisionToBoolean: (emitter
			emit: aMedLiteral
			minus: aMedLiteral2)
		jumpType: #jne! !

!IntermediateGenerator methodsFor: 'Byte Codes - Jumps' stamp: 'wbk 10/14/2002 20:42'!
jumpIfFalse: aMed to: anInteger
	emitter 
		emitJumpIfFalseTo: (emitter emitLabelForByteCode: anInteger)
		onBoolean: aMed! !

!IntermediateGenerator methodsFor: 'Misc' stamp: 'wbk 10/14/2002 13:37'!
emitter
	^ emitter! !

!IntermediateGenerator methodsFor: 'Unit Testing' stamp: 'wbk 10/14/2002 13:08'!
currentBlock
	^ emitter currentBlock! !

!IntermediateGenerator methodsFor: 'Misc' stamp: 'wbk 7/4/2003 12:32'!
numberOfTemporaries: anInteger 
	emitter numberOfTemporaries: anInteger! !

!IntermediateGenerator methodsFor: 'Byte Codes - Return' stamp: 'wbk 10/18/2003 11:27'!
returnSelf
	emitter emitReturnValue: (emitter emitReceiverAddress)! !

!IntermediateGenerator class methodsFor: 'instance creation' stamp: 'wbk 5/30/2004 22:43'!
for: aMachine jumpTargets: aCollection stackHeights: heightsCollection
	^ self new 
		initializeMachine: aMachine
		jumpTargets: aCollection! !

!IntermediateGenerator methodsFor: 'Byte Codes - Comparision' stamp: 'wbk 1/14/2004 21:43'!
prim: firstMed equals: secondMed
	^ emitter
		emitConditionalBytecodeArg1: firstMed
		arg2: secondMed
		withJump: #jne
		failureSelector: 6.! !

!IntermediateGenerator methodsFor: 'Byte Codes - Stack' stamp: 'wbk 8/17/2003 17:10'!
pushFalse
	^ emitter emitMoveToTemp: emitter emitFalseAddress.! !

!IntermediateGenerator methodsFor: 'Byte Codes - Stack' stamp: 'wbk 11/16/2003 17:56'!
storeAndPopReceiverVariableIndex: aSymbol value: aSymbol2 
	emitter
		emitBeRoot: emitter emitReceiverAddress
		ifNeededBy: aSymbol2.
	emitter
		emitMoveFrom: aSymbol2
		to: (self instanceVariableAddress: aSymbol)! !

!IntermediateGenerator methodsFor: 'Byte Codes - Stack' stamp: 'wbk 8/19/2003 14:19'!
pushTrue
	^ emitter emitMoveToTemp: (emitter emitTrueAddress)! !

!IntermediateGenerator methodsFor: 'Byte Codes - Arithmatic' stamp: 'wbk 2/8/2004 16:17'!
generate: firstMed bitAnd: secondMed 
	^self 
		emitWithIntegers: 
			[:arg1 :arg2 :overflowBlock | 
			emitter 
				emit: arg1
				and: arg2]
		arg1: firstMed
		arg2: secondMed
		failToSpecialSelector: 14! !

!IntermediateGenerator methodsFor: 'Byte Codes - Comparision' stamp: 'wbk 1/10/2004 13:10'!
prim: firstMed lessThan: secondMed
	^ emitter
		emitConditionalBytecodeArg1: firstMed
		arg2: secondMed
		withJump: #jge
		failureSelector: 2.! !

!IntermediateGenerator methodsFor: 'Byte Codes' stamp: 'wbk 11/24/2003 21:40'!
sendAtPutTo: objectMed location: indexMed value: valueMed 
	emitter
		emitBeRoot: objectMed
		ifNeededBy: valueMed.
	^ emitter
		emitWithFailTo:
			[:failBlock| emitter 
				emitMoveFrom: valueMed
				to: (emitter 
					emitAtElementAddressFor: objectMed
					with: indexMed
					failTo: failBlock
					cacheOffset: 32).
			valueMed]
		failureSpecialSelector: 17
		arguments: {objectMed. indexMed. valueMed}! !

!IntermediateGenerator methodsFor: 'Byte Codes - Common Sends' stamp: 'wbk 3/1/2004 20:29'!
generateClass: aMedLiteral 
	^ emitter emitClassOf: aMedLiteral! !

!IntermediateGenerator methodsFor: 'Misc' stamp: 'wbk 5/30/2004 22:44'!
initializeMachine: aMachine jumpTargets: aCollection
	emitter := IntermediateEmitter 
		machine: aMachine 
		jumpTargets: aCollection.
	jumpTargets := aCollection.
	^self! !

!IntermediateGenerator methodsFor: 'Byte Codes - Stack' stamp: 'wbk 10/17/2002 22:48'!
popIntoTemp: aMed slot: anInteger
	^ emitter 
		emitPopIntoTemp: aMed
		slot: anInteger! !

!IntermediateGenerator methodsFor: 'Byte Codes - Arithmatic' stamp: 'wbk 2/5/2004 20:49'!
generate: aFirstObject bitOr: aSecondObject 
	^ self
		emitWithIntegers:
			[:arg1 :arg2 :overflowBlock| emitter
				emit: arg1
				or: arg2]
		arg1: aFirstObject
		arg2: aSecondObject
		failToSpecialSelector: 15
! !

!IntermediateGenerator methodsFor: 'Byte Codes' stamp: 'wbk 10/13/2003 22:22'!
sendAtTo: aMedMem with: aMedLiteral 
	^ emitter 
		emitWithFailTo: 
			[:failBlock | 
			emitter 
				emitAtElementAddressFor: aMedMem
				with: aMedLiteral
				failTo: failBlock
				cacheOffset: 0]
		failureSpecialSelector: 16
		arguments: {aMedMem. aMedLiteral}! !

!IntermediateGenerator methodsFor: 'Byte Codes - Stack' stamp: 'wbk 9/29/2003 20:56'!
pushSelf
	^emitter emitMoveToTemp: emitter emitReceiverAddress! !

!IntermediateGenerator methodsFor: 'Byte Codes - Comparision' stamp: 'wbk 1/17/2004 22:15'!
prim: firstMed lessThanEquals: secondMed 
	^ emitter 
		emitConditionalBytecodeArg1: firstMed
		arg2: secondMed
		withJump: #jg
		failureSelector: 4! !

!IntermediateGenerator methodsFor: 'Byte Codes - Stack' stamp: 'wbk 10/4/2003 18:04'!
pushInstanceVariable: aSmallInteger 
	^emitter emitMoveToTemp: (self instanceVariableAddress: aSmallInteger)! !

!IntermediateGenerator methodsFor: 'Byte Codes - Arithmatic' stamp: 'wbk 2/9/2004 21:44'!
generate: firstMed bitShift: secondMed 
	^self 
		emitWithIntegers: 
			[:arg1 :arg2 :overflowBlock | 
			emitter 
				emit: arg1
				bitShift: arg2
				failingTo: overflowBlock]
		arg1: firstMed
		arg2: secondMed
		failToSpecialSelector: 12! !

!IntermediateGenerator methodsFor: 'Byte Codes - Common Sends' stamp: 'wbk 2/13/2004 20:39'!
generate: aMedLiteral makePoint: aMedLiteral2 
	^ emitter 
		emitSendSelector: (emitter emitSpecialSelector: 11)
		arguments: { 
				aMedLiteral.
				aMedLiteral2}! !

!IntermediateGenerator methodsFor: 'Byte Codes - Stack' stamp: 'wbk 4/24/2004 13:08'!
pushConstant: aLiteral slot: aNumber
	aLiteral class = SmallInteger ifTrue: [^MedLiteral smallInteger: aLiteral].
	^emitter emitLiteralAddress: aNumber! !

!IntermediateGenerator methodsFor: 'Byte Codes - Stack' stamp: 'wbk 7/12/2003 22:04'!
pushLiteralVariable: aReadOnlyVariableBinding slot: aSmallInteger 
	| answer |
	answer := emitter machine createTemporaryRegister.
	emitter
		emitMoveFrom: (emitter
			emitFetchAddress: (MedLiteral literal: 1) "Access the value but fetch address is 0 offset"
			ofObject: (emitter emitLiteralAddress: aSmallInteger))
		to: answer.
	^ answer! !

!IntermediateGenerator methodsFor: 'Byte Codes - Common Sends' stamp: 'wbk 2/22/2004 15:46'!
generateBinarySelector: anObject receiver: receiverMed argument: argumentMed 
	^emitter 
		emitSendSelector: (emitter emitSpecialSelector: anObject)
		arguments: {receiverMed. argumentMed}! !

!IntermediateGenerator methodsFor: 'Misc' stamp: 'wbk 7/28/2003 13:30'!
state: anExuperyStack 
	emitter state: anExuperyStack! !

!IntermediateGenerator methodsFor: 'Helper Methods' stamp: 'wbk 10/4/2003 18:04'!
instanceVariableAddress: aSmallInteger 
	^emitter 
		emitFetchAddress: (MedLiteral literal: aSmallInteger)
		ofObject: emitter emitReceiverAddress! !

!IntermediateGenerator methodsFor: 'Misc' stamp: 'wbk 10/14/2002 14:04'!
machine
	^ emitter machine! !

!IntermediateGenerator methodsFor: 'Byte Codes - Arithmatic' stamp: 'wbk 3/7/2004 23:33'!
generate: firstMed multiply: secondMed 
	^self 
		emitWithIntegers: 
			[:arg1 :arg2 :overflowBlock | 
			emitter 
				emit: arg1
				multiply: arg2
				failTo: overflowBlock]
		arg1: firstMed
		arg2: secondMed
		failToSpecialSelector: 8! !

!IntermediateGenerator methodsFor: 'Byte Codes - Jumps' stamp: 'wbk 10/17/2002 18:25'!
unconditionalJumpTo: anInteger
	emitter emitUnconditionalJumpTo: (emitter emitLabelForByteCode: anInteger)! !

!IntermediateGenerator methodsFor: 'Misc' stamp: 'wbk 7/6/2003 20:16'!
finish
	emitter createProlog! !

!IntermediateGenerator class methodsFor: 'instance creation' stamp: 'wbk 5/30/2004 18:22'!
for: aMachine
	^ self 
		for: aMachine
		jumpTargets: #()
		stackHeights: #()! !

!IntermediateGenerator methodsFor: 'Byte Codes' stamp: 'wbk 7/29/2003 12:22'!
sendSelector: aSymbol inSlot: selectorInteger arguments: someArguments 
	| selector |
	selector := emitter emitLiteralAddress: selectorInteger.
	^emitter 
		emitSendSelector: selector
		arguments: someArguments! !

!IntermediateGenerator methodsFor: 'Byte Codes - Stack' stamp: 'wbk 7/31/2003 17:11'!
popStack: aMedTemporaryRegister 
! !

!IntermediateGenerator methodsFor: 'Misc' stamp: 'wbk 5/30/2004 21:46'!
jumpTargets: aCollection 
	jumpTargets := aCollection! !

!IntermediateGenerator methodsFor: 'Byte Codes - Arithmatic' stamp: 'wbk 2/8/2004 16:18'!
generate: firstMed divide: secondMed 
	^self 
		emitWithIntegers: 
			[:arg1 :arg2 :overflowBlock | 
			emitter 
				emitDivide: arg1
				with: arg2
				failTo: overflowBlock]
		arg1: firstMed
		arg2: secondMed
		failToSpecialSelector: 9! !

!IntermediateGenerator methodsFor: 'Byte Codes - Return' stamp: 'wbk 10/18/2003 13:50'!
returnNil
	emitter emitReturnValue: (emitter emitNilAddress)! !

!IntermediateGenerator methodsFor: 'Byte Codes - Common Sends' stamp: 'wbk 2/22/2004 14:03'!
generateUnarySelector: aSmallInteger receiver: aMedMem 
	^ emitter 
		emitSendSelector: (emitter emitSpecialSelector: aSmallInteger)
		arguments: { aMedMem}! !

!IntermediateGenerator methodsFor: 'Byte Codes - Arithmatic' stamp: 'wbk 2/5/2004 22:53'!
generate: firstMed div: secondMed
	^self 
		emitWithIntegers: 
			[:arg1 :arg2 :overflowBlock | 
			emitter 
				emitDiv: arg1
				with: arg2
				failTo: overflowBlock]
		arg1: firstMed
		arg2: secondMed
		failToSpecialSelector: 13! !

!IntermediateGenerator methodsFor: 'Byte Codes' stamp: 'wbk 5/30/2004 22:41'!
byteCodeAddress: anInteger 
	(jumpTargets includes: anInteger) 
		ifTrue: [emitter emitJumpTarget: anInteger]! !

!IntermediateGenerator methodsFor: 'Byte Codes - Arithmatic' stamp: 'wbk 2/4/2004 23:18'!
emitWithIntegers: aBlock arg1: aFirstObject arg2: aSecondObject failToSpecialSelector: anInteger
	| expression |
	^ emitter
		emitWithFailTo: 
			[:overflowBlock | 
			expression := aBlock
				value:	(emitter
					emitIntegerValueOf: aFirstObject
					failTo: overflowBlock)
				value: (emitter
					emitIntegerValueOf: aSecondObject
					failTo: overflowBlock)
				value: overflowBlock.
			emitter 
				emitConvertToSmallInteger: expression
				failTo: overflowBlock]
		failureSpecialSelector: anInteger
		arguments: { 
				aFirstObject.
				aSecondObject}! !

!IntermediateGenerator methodsFor: 'Byte Codes - Jumps' stamp: 'wbk 2/14/2004 12:17'!
jumpIfTrue: aMed to: anInteger 
	emitter 
		emitJumpIfTrueTo: (emitter emitLabelForByteCode: anInteger)
		onBoolean: aMed! !

!IntermediateGenerator methodsFor: 'Byte Codes - Comparision' stamp: 'wbk 1/17/2004 19:15'!
prim: firstMed notEquals: secondMed
	^ emitter
		emitConditionalBytecodeArg1: firstMed
		arg2: secondMed
		withJump: #je
		failureSelector: 7.! !

!IntermediateGenerator methodsFor: 'Byte Codes - Return' stamp: 'wbk 11/27/2003 19:51'!
returnTrue
	emitter emitReturnValue: emitter emitTrueAddress! !

!IntermediateGenerator methodsFor: 'Unit Testing' stamp: 'wbk 10/14/2002 13:56'!
emitter: anEmitter
	emitter := anEmitter.! !

!IntermediateGenerator class methodsFor: 'instance creation' stamp: 'wbk 5/30/2004 22:44'!
for: aMachine jumpTargets: aCollection
	^ self new 
		initializeMachine: aMachine
		jumpTargets: aCollection! !

Object subclass: #JumpTargetRecorder
	instanceVariableNames: 'targets stackTrace stack'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery'!

!JumpTargetRecorder methodsFor: 'misc' stamp: 'wbk 4/26/2004 22:55'!
stackRegister: aSmallInteger 
	^ nil! !

!JumpTargetRecorder methodsFor: 'Sends' stamp: 'wbk 6/6/2004 17:10'!
generateBinarySelector: anObject receiver: aRecordJumpTargets argument: aNumber 
	self sendSize: 2
	! !

!JumpTargetRecorder methodsFor: 'misc' stamp: 'wbk 7/4/2003 12:28'!
numberOfTemporaries: aSmallInteger 
	! !

!JumpTargetRecorder methodsFor: 'Stack' stamp: 'wbk 5/29/2004 22:20'!
pushNil
	self push.! !

!JumpTargetRecorder methodsFor: 'Jumps' stamp: 'wbk 6/14/2004 21:37'!
jumpIfTrue: aRecordJumpTargets to: aTarget 
	self addJumpTo: aTarget! !

!JumpTargetRecorder methodsFor: 'Stack' stamp: 'wbk 5/29/2004 22:20'!
storeAndPopReceiverVariableIndex: aSmallInteger value: aSymbol 
	self pop.! !

!JumpTargetRecorder methodsFor: 'Operation' stamp: 'wbk 6/14/2004 21:37'!
push! !

!JumpTargetRecorder methodsFor: 'Arithmatic' stamp: 'wbk 5/29/2004 22:19'!
generate: aRecordJumpTargets bitShift: aRecordJumpTargets2 
	self binaryOperation.! !

!JumpTargetRecorder methodsFor: 'misc' stamp: 'wbk 6/14/2004 21:09'!
state: anExuperyStack 
 	stack := anExuperyStack
	! !

!JumpTargetRecorder methodsFor: 'Stack' stamp: 'wbk 5/29/2004 22:21'!
pushTempAt: anInteger
	self push.! !

!JumpTargetRecorder methodsFor: 'Jumps' stamp: 'wbk 6/14/2004 21:37'!
jumpIfFalse: aBoolean to: aTarget 
	self addJumpTo: aTarget! !

!JumpTargetRecorder methodsFor: 'Stack' stamp: 'wbk 5/29/2004 22:20'!
pushConstant: aLiteral slot: aNumber
	self push.! !

!JumpTargetRecorder methodsFor: 'Arithmatic' stamp: 'wbk 5/29/2004 22:18'!
generate: aRecordJumpTargets bitAnd: aRecordJumpTargets2 
	self binaryOperation.! !

!JumpTargetRecorder methodsFor: 'misc' stamp: 'wbk 7/6/2003 20:17'!
finish
! !

!JumpTargetRecorder methodsFor: 'Sends' stamp: 'wbk 5/29/2004 22:22'!
bytecodePrimSendNewWithArg: anOrderedCollection receiver: aRecordJumpTargets size: aNumber
	self sendSize: aNumber
	! !

!JumpTargetRecorder methodsFor: 'Comparision' stamp: 'wbk 5/29/2004 23:45'!
prim: firstMed lessThanEquals: secondMed 	
	self binaryOperation
	! !

!JumpTargetRecorder methodsFor: 'Operation' stamp: 'wbk 6/14/2004 21:36'!
binaryOperation! !

!JumpTargetRecorder methodsFor: 'Return' stamp: 'wbk 5/29/2004 23:50'!
returnTop: aMed
	self return! !

!JumpTargetRecorder methodsFor: 'Return' stamp: 'wbk 5/29/2004 23:50'!
returnNil
	
	self return! !

!JumpTargetRecorder methodsFor: 'Sends' stamp: 'wbk 5/29/2004 22:25'!
sendSelector: aSymbol inSlot: aSmallInteger arguments: anObject 
	self sendSize: anObject size
	! !

!JumpTargetRecorder methodsFor: 'Return' stamp: 'wbk 5/29/2004 23:50'!
returnFalse
	self return
	! !

!JumpTargetRecorder methodsFor: 'Comparision' stamp: 'wbk 5/29/2004 23:45'!
prim: firstMed greaterThan: secondMed	
	self binaryOperation
	! !

!JumpTargetRecorder methodsFor: 'Operation' stamp: 'wbk 6/14/2004 21:38'!
sendSize: aSmallInteger ! !

!JumpTargetRecorder methodsFor: 'Sends' stamp: 'wbk 5/29/2004 22:23'!
generateUnarySelector: aSmallInteger receiver: aRecordJumpTargets 
	self sendSize: 1
! !

!JumpTargetRecorder methodsFor: 'Stack' stamp: 'wbk 5/29/2004 22:02'!
stackTrace
	^ stackTrace! !

!JumpTargetRecorder methodsFor: 'Arithmatic' stamp: 'wbk 5/29/2004 22:19'!
generate: firstMed subtract: secondMed 
	self binaryOperation.! !

!JumpTargetRecorder methodsFor: 'Stack' stamp: 'wbk 5/29/2004 22:20'!
popStack: aRecordJumpTargets 
	self pop! !

!JumpTargetRecorder methodsFor: 'misc' stamp: 'wbk 10/15/2002 14:05'!
targets
	^ targets! !

!JumpTargetRecorder class methodsFor: 'instance creation' stamp: 'wbk 6/13/2004 23:45'!
new
	^ super new initialize! !

!JumpTargetRecorder methodsFor: 'Sends' stamp: 'wbk 5/29/2004 22:24'!
sendAtTo: aRecordJumpTargets with: aRecordJumpTargets2  
	self sendSize: 2
! !

!JumpTargetRecorder methodsFor: 'Stack' stamp: 'wbk 5/29/2004 22:20'!
pushInstanceVariable: aSmallInteger 
	self push.
	! !

!JumpTargetRecorder methodsFor: 'Arithmatic' stamp: 'wbk 5/29/2004 22:19'!
generate: firstMed multiply: secondMed 
	self binaryOperation.! !

!JumpTargetRecorder methodsFor: 'Jumps' stamp: 'wbk 6/14/2004 21:26'!
addJumpTo: aTarget 
	targets add: aTarget.
	stackTrace add: stack stackSize! !

!JumpTargetRecorder methodsFor: 'Arithmatic' stamp: 'wbk 5/29/2004 22:19'!
generate: aRecordJumpTargets makePoint: aRecordJumpTargets2 
	self binaryOperation.! !

!JumpTargetRecorder methodsFor: 'Comparision' stamp: 'wbk 5/29/2004 23:45'!
prim: firstMed greaterThanEqual: secondMed	
	self binaryOperation
! !

!JumpTargetRecorder methodsFor: 'Stack' stamp: 'wbk 5/29/2004 22:20'!
pushLiteralVariable: aReadOnlyVariableBinding slot: aSmallInteger 
	self push.! !

!JumpTargetRecorder methodsFor: 'Comparision' stamp: 'wbk 5/29/2004 23:45'!
prim: firstMed equals: secondMed		
	self binaryOperation! !

!JumpTargetRecorder methodsFor: 'Arithmatic' stamp: 'wbk 5/29/2004 22:19'!
generate: aRecordJumpTargets divide: aRecordJumpTargets2 
	self binaryOperation.! !

!JumpTargetRecorder methodsFor: 'Return' stamp: 'wbk 5/29/2004 23:50'!
returnSelf
	self return
! !

!JumpTargetRecorder methodsFor: 'Stack' stamp: 'wbk 5/29/2004 22:21'!
pushTrue
	self push.! !

!JumpTargetRecorder methodsFor: 'Stack' stamp: 'wbk 5/29/2004 22:21'!
pushSelf
	self push.! !

!JumpTargetRecorder methodsFor: 'Arithmatic' stamp: 'wbk 5/29/2004 22:19'!
generate: aRecordJumpTargets mod: aRecordJumpTargets2 
	self binaryOperation.! !

!JumpTargetRecorder methodsFor: 'Operation' stamp: 'wbk 6/14/2004 21:37'!
pop! !

!JumpTargetRecorder methodsFor: 'Comparision' stamp: 'wbk 5/29/2004 23:45'!
prim: firstMed lessThan: secondMed
		
	self binaryOperation! !

!JumpTargetRecorder methodsFor: 'Arithmatic' stamp: 'wbk 5/29/2004 22:18'!
generate: firstMed add: secondMed 
	self binaryOperation.
	! !

!JumpTargetRecorder methodsFor: 'misc' stamp: 'wbk 6/14/2004 21:37'!
initialize
	targets := OrderedCollection new.
	stackTrace := OrderedCollection new.! !

!JumpTargetRecorder methodsFor: 'Arithmatic' stamp: 'wbk 5/29/2004 22:19'!
generate: aRecordJumpTargets div: aRecordJumpTargets2 
	self binaryOperation.! !

!JumpTargetRecorder methodsFor: 'Sends' stamp: 'wbk 5/29/2004 22:22'!
generateClass: aJumpTargetRecorder 
	self sendSize: 1
! !

!JumpTargetRecorder methodsFor: 'Comparision' stamp: 'wbk 5/29/2004 23:45'!
prim: firstMed notEquals: secondMed	
	self binaryOperation
! !

!JumpTargetRecorder methodsFor: 'misc' stamp: 'wbk 4/26/2004 22:56'!
emitMoveFrom: aJumpTargetRecorder to: anUndefinedObject 
	! !

!JumpTargetRecorder methodsFor: 'Arithmatic' stamp: 'wbk 5/29/2004 22:19'!
generate: aJumpTargetRecorder equivilent: aJumpTargetRecorder2 
	self binaryOperation.! !

!JumpTargetRecorder methodsFor: 'Operation' stamp: 'wbk 6/14/2004 21:38'!
return! !

!JumpTargetRecorder methodsFor: 'Sends' stamp: 'wbk 7/6/2003 17:34'!
sendRentryWithStack: anOrderedCollection atPC: aSmallInteger 
	! !

!JumpTargetRecorder methodsFor: 'misc' stamp: 'wbk 4/26/2004 22:54'!
emitter
	^ self! !

!JumpTargetRecorder methodsFor: 'Return' stamp: 'wbk 5/29/2004 23:50'!
returnTrue
	self return
	! !

!JumpTargetRecorder methodsFor: 'Stack' stamp: 'wbk 5/29/2004 22:19'!
popIntoTemp: aMed slot: anInteger
	self pop! !

!JumpTargetRecorder methodsFor: 'misc' stamp: 'wbk 6/14/2004 21:37'!
byteCodeAddress: anInteger 
	(targets includes: anInteger) ifTrue: 
			[stack heightTo: (stackTrace at: (targets indexOf: anInteger))]! !

!JumpTargetRecorder methodsFor: 'Arithmatic' stamp: 'wbk 5/29/2004 22:18'!
generate: aRecordJumpTargets bitOr: aRecordJumpTargets2 
	self binaryOperation.! !

!JumpTargetRecorder methodsFor: 'Sends' stamp: 'wbk 5/29/2004 22:23'!
sendAtPutTo: aRecordJumpTargets location: aRecordJumpTargets2 value: aRecordJumpTargets22 
	self sendSize: 3
! !

!JumpTargetRecorder methodsFor: 'Jumps' stamp: 'wbk 5/29/2004 22:10'!
unconditionalJumpTo: aTarget
	self addJumpTo: aTarget! !

!JumpTargetRecorder methodsFor: 'Sends' stamp: 'wbk 5/29/2004 22:23'!
generateNew: aRecordJumpTargets 

	self sendSize: 1
! !

!JumpTargetRecorder methodsFor: 'Stack' stamp: 'wbk 5/29/2004 22:20'!
pushFalse
	self push.! !

Object subclass: #MedMethod
	instanceVariableNames: 'blocks nextBlockNumber prolog'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Intermediate'!

!MedMethod class methodsFor: 'Unit Testing' stamp: 'wbk 10/5/2002 18:38'!
createAssembly: anArray for: aMachine
	^ IntermediateCreator
		createAssembly: anArray
		for: aMachine! !

!MedMethod class methodsFor: 'instance creation' stamp: 'wbk 10/3/2002 20:10'!
from: aMedMethod
	^ super new initializeFrom: aMedMethod! !

!MedMethod methodsFor: 'Misc' stamp: 'wbk 7/6/2003 19:02'!
prolog
	| number |
	prolog ifNotNil: [^ prolog].
	number := nextBlockNumber.
	nextBlockNumber := nextBlockNumber + 1.
	prolog := MedBlock number: number.
	blocks addFirst: prolog.
	^ prolog
	! !

!MedMethod methodsFor: 'Misc' stamp: 'wbk 3/10/2003 10:48'!
visitWith: aVisitor
	^ aVisitor visitMethod: self! !

!MedMethod methodsFor: 'Misc' stamp: 'wbk 10/5/2002 21:15'!
addBlock: aMedBlock
	blocks add: aMedBlock! !

!MedMethod methodsFor: 'Unit Testing' stamp: 'wbk 10/21/2002 21:26'!
blockAt: blockInteger instructionAt: instructionInteger
	^ (blocks at: blockInteger) instructionAt: instructionInteger! !

!MedMethod methodsFor: 'Misc' stamp: 'wbk 10/3/2002 20:26'!
newBlockFor: aMedBlock
	^ self blockNumbered: aMedBlock blockNumber! !

!MedMethod class methodsFor: 'instance creation' stamp: 'wbk 10/14/2002 13:38'!
new
	^ super new initialize! !

!MedMethod methodsFor: 'Unit Testing' stamp: 'wbk 7/6/2003 19:01'!
intermediateForm
	|answer|
	answer := blocks collect: [:each| each intermediateForm].
	^ answer asArray! !

!MedMethod methodsFor: 'Misc' stamp: 'wbk 7/6/2003 20:49'!
blocksCollect: aBlock
	^ blocks collect: aBlock! !

!MedMethod methodsFor: 'Misc' stamp: 'wbk 10/21/2002 11:15'!
instructionsDo: aBlock
	self blocksDo: [:each| each expressionsDo: aBlock]! !

!MedMethod methodsFor: 'Misc' stamp: 'wbk 10/3/2002 20:17'!
newBlock
	| number newBlock |
	number := nextBlockNumber.
	nextBlockNumber := nextBlockNumber + 1.
	newBlock := MedBlock number: number.
	self addBlock: newBlock.
	^ newBlock! !

!MedMethod class methodsFor: 'Unit Testing' stamp: 'wbk 10/5/2002 13:37'!
createIntermediate: anArray for: aMachine
	^ IntermediateCreator
		createIntermediate: anArray
		for: aMachine! !

!MedMethod methodsFor: 'Misc' stamp: 'WBK 8/28/2002 16:13'!
blocksDo: aBlock
	blocks do: aBlock! !

!MedMethod methodsFor: 'Debugging' stamp: 'wbk 7/11/2004 18:23'!
inspect
	ExuperyMethodInspector inspect: self.! !

!MedMethod methodsFor: 'Misc' stamp: 'wbk 7/11/2004 18:43'!
blockAt: aNumber
	^ blocks at: aNumber! !

!MedMethod methodsFor: 'Unit Testing' stamp: 'wbk 10/2/2002 17:59'!
numberOfBlocks
	^ blocks size.! !

!MedMethod methodsFor: 'Misc' stamp: 'wbk 10/23/2002 22:10'!
registersDo: aBlock
	self instructionsDo: [:each| each registersDo: aBlock].! !

!MedMethod methodsFor: 'Misc' stamp: 'wbk 7/6/2003 20:48'!
initializeFrom: aMedMethod
	self initialize.
	blocks := aMedMethod blocksCollect: [:each| MedBlock number: each blockNumber].
	nextBlockNumber := aMedMethod numberOfBlocks + 1.! !

!MedMethod methodsFor: 'Misc' stamp: 'wbk 10/2/2002 17:49'!
initialize
	blocks := OrderedCollection new.
	nextBlockNumber := 2.
	^ self! !

!MedMethod methodsFor: 'Misc' stamp: 'wbk 10/3/2002 16:51'!
blockNumbered: anInteger
	^blocks
		detect:  [:each| each blockNumber = anInteger]
		ifNone: 
			[|newBlock|
			newBlock := MedBlock number: anInteger.
			self addBlock: newBlock.
			^ newBlock]! !

Object subclass: #MachineX86
	instanceVariableNames: 'machineRegisters nextRegister registerFile spillSlots nextSpillSlot temporaryRegisters'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery'!

!MachineX86 methodsFor: 'Primitives - Code Cache' stamp: 'wbk 4/18/2003 15:51'!
trueObjAddress
	<primitive: 'trueObjAddress' module: 'ExuperyPlugin'>
	TestFailure signal! !

!MachineX86 methodsFor: 'Misc' stamp: 'wbk 7/9/2004 00:02'!
machineRegister: aSymbol 
	^machineRegisters 
		at: aSymbol
		ifAbsentPut: 
			[self makeMachineRegister: aSymbol]! !

!MachineX86 methodsFor: 'Misc' stamp: 'wbk 9/12/2002 16:44'!
newSpillSlot
	|answer|
	answer := nextSpillSlot.
	nextSpillSlot := nextSpillSlot -4.
	^ answer! !

!MachineX86 methodsFor: 'Misc' stamp: 'wbk 7/9/2004 00:04'!
stackRegister:  aSmallInteger 
	 | registerName register |
	registerName := (#s, aSmallInteger printString) asSymbol.
	^ temporaryRegisters
		at: registerName
		ifAbsent:
			[register := self makeTemporaryRegister: registerName.
			temporaryRegisters
				at: registerName
				put: register.
			^ register]! !

!MachineX86 methodsFor: 'Intermediate Generation' stamp: 'wbk 7/24/2004 11:14'!
currentContext
	^ currentContext! !

!MachineX86 methodsFor: 'Misc' stamp: 'wbk 11/1/2002 12:52'!
isSpecialRegister: aRegister 
	| name |
	name := aRegister name.
	^self isSpecialRegisterName: name! !

!MachineX86 methodsFor: 'Register Allocation' stamp: 'wbk 11/4/2002 16:07'!
reloadRegister: aReg usingMap: aDictionary into: aMedBlock
	|slot instruction |
	slot := spillSlots
		at: aReg
		ifAbsent: [^ self].
	instruction := MedMov
		from: (MedAddressingMode
			offset: slot
			base: (self machineRegister: #ebp))
		to: (aDictionary at: aReg).
	aMedBlock add: instruction! !

!MachineX86 methodsFor: 'Register Allocation' stamp: 'wbk 9/17/2002 13:34'!
spillSlotFor: aRegister
	^ spillSlots
		at: aRegister
		ifAbsentPut: [self newSpillSlot]! !

!MachineX86 methodsFor: 'Register Allocation' stamp: 'wbk 10/23/2002 17:21'!
numberOfColours
	^ 6! !

!MachineX86 methodsFor: 'Primitives - Memory Testing' stamp: 'wbk 11/21/2003 22:36'!
rootTableAddress
	<primitive: 'rootTableAddress' module: 'ExuperyPlugin'>
	TestFailure signal! !

MachineX86 subclass: #MockExuperyPlugin
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Programmer Tests'!

!MockExuperyPlugin methodsFor: 'as yet unclassified' stamp: 'wbk 4/11/2003 16:16'!
falseObjAddress
	^ 16r41133557! !

!MockExuperyPlugin methodsFor: 'as yet unclassified' stamp: 'wbk 4/10/2003 14:21'!
trueObjAddress
	^ 16r40123456! !

!MockExuperyPlugin methodsFor: 'as yet unclassified' stamp: 'wbk 6/21/2003 17:29'!
addressOf: aMedLiteral 
	aMedLiteral literal = #trueObj ifTrue: [^ self trueObjAddress].
	aMedLiteral literal = #falseObj ifTrue: [^ self falseObjAddress].
	aMedLiteral literal = #exuperySetupMessageSend ifTrue: [^ MedLiteral literal: #exuperySetupMessageSend].
	Error signal. "Unrecognised Constant"! !

!MachineX86 methodsFor: 'Primitives - Memory Testing' stamp: 'wbk 11/21/2003 22:32'!
rootTableCountAddress
	<primitive: 'rootTableCountAddress' module: 'ExuperyPlugin'>
	TestFailure signal! !

!MachineX86 methodsFor: 'Primitives - Code Cache' stamp: 'wbk 11/21/2003 22:35'!
addressOf: aMedLiteral 
	aMedLiteral literal = #trueObj ifTrue: [^ self trueObjAddress * 2].
	aMedLiteral literal = #falseObj ifTrue: [^ self falseObjAddress * 2].
	aMedLiteral literal = #exuperySetupMessageSend ifTrue: [^ MedLiteral literal: self setupMessageSendAddress * 2].
	aMedLiteral literal = #specialObjectsOop ifTrue: [^ self specialObjectsOopAddress * 2].
	aMedLiteral literal = #atCache ifTrue: [^ self atCacheAddress * 2].
	aMedLiteral literal = #nilObj ifTrue: [^ self nilObjAddress *2].
	aMedLiteral literal = #youngStart ifTrue: [^ self youngStartAddress * 2].
	aMedLiteral literal = #rootTableCount ifTrue: [^ self rootTableCountAddress * 2].
	aMedLiteral literal = #rootTable ifTrue: [^ self rootTableAddress * 2].

	self error: 'Address of Unknown Literal'.! !

!MachineX86 methodsFor: 'Primitives - Code Cache' stamp: 'wbk 6/30/2003 18:31'!
setupMessageSendAddress
	<primitive: 'setupMessageSendAddress' module: 'ExuperyPlugin'>
	TestFailure signal! !

!MachineX86 methodsFor: 'Register Allocation' stamp: 'wbk 11/4/2002 16:08'!
saveRegister: aReg usingMap: aDictionary into: aMedBlock
	|instruction aNumber |
	aNumber := (self spillSlotFor: aReg).
	instruction := MedMov
		 	from: (aDictionary at: aReg)
			to: (MedAddressingMode
				offset: aNumber
				base: (self machineRegister: #ebp)).
	aMedBlock add: instruction! !

!MachineX86 methodsFor: 'Misc' stamp: 'wbk 7/9/2004 20:37'!
makeMachineRegister: name 
	| register |
	register := MedMachineRegister name: name.
	^register! !

!MachineX86 methodsFor: 'Misc' stamp: 'wbk 7/9/2004 20:37'!
makeTemporaryRegister: name 
	| register |
	register := MedTemporaryRegister name: name.
	^register! !

!MachineX86 methodsFor: 'Misc' stamp: 'wbk 11/2/2002 16:14'!
isSpecialRegisterName: name 
	^ name = #ebp | (name = #esp)! !

!MachineX86 methodsFor: 'Primitives - Code Cache' stamp: 'wbk 10/4/2003 21:12'!
nilObjAddress
	<primitive: 'nilObjAddress' module: 'ExuperyPlugin'>
	TestFailure signal! !

!MachineX86 methodsFor: 'Misc' stamp: 'wbk 7/24/2004 15:00'!
initialize
	|registerNames reg|
	machineRegisters := Dictionary new.
	registerFile := OrderedCollection new.
	temporaryRegisters := Dictionary new.
	spillSlots := Dictionary new.
	nextRegister := 1.
	nextSpillSlot := -16.
	registerNames := #(eax ebx ecx edx esi edi).
	registerNames do: [:each| 
		reg := self machineRegister: each.
		registerFile add: reg].
	currentContext := self makeTemporaryRegister: #currentContext.
	^ self! !

!MachineX86 methodsFor: 'Misc' stamp: 'wbk 4/29/2004 21:24'!
temporaryNamed: aSymbol
	^ temporaryRegisters
		at: aSymbol
		ifAbsent: [self newTemporaryNamed: aSymbol]! !

!MachineX86 methodsFor: 'Primitives - Memory Testing' stamp: 'wbk 11/21/2003 20:01'!
youngStartAddress
	<primitive: 'youngStartAddress' module: 'ExuperyPlugin'>
	TestFailure signal! !

!MachineX86 methodsFor: 'Misc' stamp: 'wbk 7/9/2004 00:03'!
newTemporaryNamed: aSymbol
	|number register|
	number := (aSymbol copyFrom: 2 to: aSymbol size) asNumber.
	register := self makeTemporaryRegister: aSymbol.
	number >= nextRegister ifTrue: [nextRegister := number + 1].
	temporaryRegisters
		at: aSymbol
		put: register.
	^ register! !

!MachineX86 methodsFor: 'Misc' stamp: 'WBK 8/28/2002 22:50'!
useableRegisters
	^ registerFile! !

!MachineX86 methodsFor: 'Primitives - Code Cache' stamp: 'wbk 8/9/2003 12:11'!
atCacheAddress
	<primitive: 'atCacheAddress' module: 'ExuperyPlugin'>
	TestFailure signal! !

!MachineX86 methodsFor: 'Primitives - Code Cache' stamp: 'wbk 7/17/2003 12:44'!
specialObjectsOopAddress
	<primitive: 'specialObjectsOopAddress' module: 'ExuperyPlugin'>
	TestFailure signal! !

!MachineX86 methodsFor: 'Misc' stamp: 'wbk 11/1/2002 12:53'!
registerNamed: aSymbol
	^ machineRegisters
		at: aSymbol
		ifAbsent:
			[
				(self isSpecialRegisterName: aSymbol) ifTrue:
					[^ self machineRegister: aSymbol].
				^ self temporaryNamed: aSymbol]! !

!MachineX86 methodsFor: 'Misc' stamp: 'wbk 7/8/2004 23:58'!
createTemporaryRegister
	| name register |
	name := 't' , nextRegister asString asSymbol.
	nextRegister := nextRegister + 1.
	register := self makeTemporaryRegister: name.
	temporaryRegisters 
		at: name
		put: register.
	^register! !

!MachineX86 methodsFor: 'Misc' stamp: 'wbk 6/28/2004 22:47'!
registerAt: aSmallInteger 
	machineRegisters do: [:each| each index = aSmallInteger ifTrue: [^ each]].
	temporaryRegisters do: [:each| each index = aSmallInteger ifTrue: [^ each]].
	Error signal: 'Register not found'! !

!MachineX86 methodsFor: 'Primitives - Code Cache' stamp: 'wbk 4/18/2003 15:51'!
falseObjAddress
	<primitive: 'falseObjAddress' module: 'ExuperyPlugin'>
	TestFailure signal! !

!MachineX86 class methodsFor: 'instance creation' stamp: 'WBK 8/28/2002 20:00'!
new
	^ super new initialize! !

Object subclass: #NodeLattice
	instanceVariableNames: 'set'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery'!

!NodeLattice methodsFor: 'Proxied - remove later' stamp: 'wbk 6/23/2004 22:17'!
asSet
	^ set copy! !

!NodeLattice methodsFor: 'Proxied - remove later' stamp: 'wbk 6/27/2004 19:05'!
addNode: anInterferenceNode 
	set add: anInterferenceNode! !

!NodeLattice methodsFor: 'Misc' stamp: 'wbk 6/27/2004 23:13'!
initialiseSet: aSet
	set := aSet.! !

!NodeLattice methodsFor: 'Proxied - remove later' stamp: 'wbk 6/26/2004 00:25'!
nodesDo: aBlockContext 
	^ set do: aBlockContext! !

!NodeLattice methodsFor: 'Misc' stamp: 'wbk 6/27/2004 23:18'!
initialize
	set := Set new! !

!NodeLattice methodsFor: 'Misc' stamp: 'wbk 6/25/2004 23:37'!
set
	^ set! !

!NodeLattice methodsFor: 'Proxied - remove later' stamp: 'wbk 6/23/2004 22:16'!
size
	^ set size! !

!NodeLattice methodsFor: 'Operations' stamp: 'wbk 6/25/2004 23:36'!
+ aNodeLattice
	| newSet |
	newSet := set copy.
	newSet addAll: aNodeLattice set.
	^ self class value: newSet! !

!NodeLattice class methodsFor: 'instance creation' stamp: 'wbk 6/25/2004 23:16'!
value: aSet
	^ self new initialiseSet: aSet! !

!NodeLattice methodsFor: 'Proxied - remove later' stamp: 'wbk 6/26/2004 00:31'!
includesNode: anInterferenceNode 
	^ set includes: anInterferenceNode! !

Object subclass: #AssembleInstruction
	instanceVariableNames: 'stream assembler instruction name encodingRules'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery'!

!AssembleInstruction methodsFor: 'Assembling' stamp: 'wbk 4/7/2003 14:21'!
run
	| rule |
	rule := encodingRules detect: [:each| each isFirable].
	rule fire.! !

!AssembleInstruction methodsFor: 'misc' stamp: 'wbk 3/16/2003 21:08'!
arg2
	^ instruction to! !

AssembleInstruction subclass: #AssembleArithmatic
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery'!

!AssembleArithmatic methodsFor: 'misc' stamp: 'wbk 3/16/2003 21:07'!
arg2
	^ instruction arg2! !

!AssembleArithmatic methodsFor: 'misc' stamp: 'wbk 3/16/2003 21:07'!
arg1
	^ instruction arg1! !

!AssembleInstruction methodsFor: 'misc' stamp: 'wbk 4/4/2003 17:30'!
assembler
	^ assembler! !

!AssembleInstruction class methodsFor: 'instance creation' stamp: 'wbk 4/7/2003 14:25'!
name: aSymbol assembler: anAssemblerExupery 
	^ self new
		initializeName: aSymbol 
		assembler: anAssemblerExupery! !

AssembleInstruction subclass: #AssembleJump
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery'!

!AssembleJump methodsFor: 'Assembling' stamp: 'wbk 4/11/2003 15:58'!
run
	self encodeOpcode.
	self encodeTarget.! !

!AssembleJump methodsFor: 'misc' stamp: 'wbk 4/18/2003 16:16'!
initialiseInstruction: aMedMov assembler: anAssembler 
	instruction := aMedMov.
	assembler := anAssembler.
	stream := assembler stream.
	encodingRules := OrderedCollection new.! !

!AssembleJump methodsFor: 'Assembling' stamp: 'wbk 4/11/2003 15:58'!
encodeTarget
	stream nextPut: 0.
	stream nextPut: 0.
	stream nextPut: 0.
	stream nextPut: 0.
	assembler patchJumpTo: instruction target! !

!AssembleJump methodsFor: 'Assembling' stamp: 'wbk 1/14/2004 22:03'!
encodeOpcode
	instruction type = #jz | (instruction type = #je) ifTrue:
		[stream nextPut: 15.
		^ stream nextPut: 132].
	instruction type = #jg ifTrue:
		[stream nextPut: 15.
		^ stream nextPut: 16r8F].
	instruction type = #jo ifTrue:
		[stream nextPut: 15.
		^ stream nextPut: 16r80].
	instruction type = #jmp ifTrue:
		[^ stream nextPut: 16rE9].
	instruction type = #jnz | (instruction type = #jne) ifTrue:
		[stream nextPut: 15.
		^ stream nextPut: 16r85].
	instruction type = #jl ifTrue:
		[stream nextPut: 15.
		^ stream nextPut: 16r8C].
	instruction type = #jle ifTrue:
		[stream nextPut: 15.
		^ stream nextPut: 16r8E].
	instruction type = #jge ifTrue:
		[stream nextPut: 15.
		^ stream nextPut: 16r8D].

	self error: 'Unknown jump type'.! !

!AssembleInstruction methodsFor: 'misc' stamp: 'wbk 4/18/2003 16:17'!
initializeName: aSymbol assembler: anAssemblerExupery
	name := aSymbol.
	assembler := anAssemblerExupery.
	stream := assembler stream.
	encodingRules := OrderedCollection new.
	anAssemblerExupery 
		addInstruction: self
		named: name.! !

!AssembleInstruction class methodsFor: 'instance creation' stamp: 'wbk 4/7/2003 14:25'!
instruction: aMedMov assembler: anAssembler
	|assembler|
	assembler := self new 
		initialiseInstruction: aMedMov
		assembler: anAssembler.
	assembler run.! !

!AssembleInstruction methodsFor: 'Assembling' stamp: 'wbk 4/4/2003 17:10'!
encode: aMedAssembly 
	instruction := aMedAssembly.
	self run.! !

!AssembleInstruction methodsFor: 'misc' stamp: 'wbk 4/18/2003 18:06'!
addEncoding: anEncoder
	encodingRules add: anEncoder.
	anEncoder registerInstruction: self.! !

!AssembleInstruction methodsFor: 'misc' stamp: 'wbk 3/16/2003 21:08'!
arg1
	^ instruction from! !

Object subclass: #MedLanguage
	instanceVariableNames: 'in out'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Intermediate'!

!MedLanguage methodsFor: 'Dataflow Analysis' stamp: 'wbk 10/21/2002 11:55'!
setOut: aLattice
	out := aLattice! !

!MedLanguage methodsFor: 'testing' stamp: 'WBK 8/27/2002 20:16'!
isMov
	^ false! !

!MedLanguage methodsFor: 'testing' stamp: 'wbk 11/8/2002 14:39'!
isMachineInteger
	^ false! !

MedLanguage subclass: #MedPush
	instanceVariableNames: 'argument'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Intermediate'!

!MedPush methodsFor: 'Dataflow Analysis' stamp: 'wbk 6/23/2003 11:54'!
registersUsed
	^ argument registersUsed! !

!MedPush methodsFor: 'Dataflow Analysis' stamp: 'wbk 6/23/2003 11:55'!
registersDefined
	^ Lattice new! !

!MedPush methodsFor: 'Misc' stamp: 'wbk 6/21/2003 16:13'!
argument
	^ argument! !

!MedPush class methodsFor: 'as yet unclassified' stamp: 'wbk 6/21/2003 19:12'!
argument: aSmallInteger 
	^ self new initializeArgument: aSmallInteger! !

!MedPush methodsFor: 'Misc' stamp: 'wbk 6/21/2003 15:47'!
visitWith: anInstructionSelector 
	^ anInstructionSelector visitPush: self! !

!MedPush methodsFor: 'Misc' stamp: 'wbk 6/21/2003 17:30'!
intermediateForm
	^ {#push. argument intermediateForm}! !

!MedPush methodsFor: 'Register Allocation' stamp: 'wbk 7/5/2003 15:26'!
buildInterferenceWith: anAllocator ! !

!MedPush methodsFor: 'Misc' stamp: 'wbk 6/20/2003 20:41'!
initializeArgument: aSmallInteger 
	argument := aSmallInteger.
	^ self! !

!MedPush methodsFor: 'Misc' stamp: 'wbk 6/24/2003 10:30'!
registersDo: aBlockContext 
	argument registersDo: aBlockContext! !

!MedLanguage methodsFor: 'Misc' stamp: 'wbk 11/4/2002 14:26'!
registersIn: aCollection
	|answer|
	answer := OrderedCollection new.
	self registersDo: [:each| (aCollection includes: each) ifTrue: [answer add: each]].
	^ answer! !

!MedLanguage methodsFor: 'testing' stamp: 'wbk 9/11/2002 23:19'!
isAddressingMode
	^ false! !

!MedLanguage methodsFor: 'testing' stamp: 'WBK 8/27/2002 20:42'!
isRegister
	^ false! !

MedLanguage subclass: #MedNegate
	instanceVariableNames: 'argument'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Intermediate'!

!MedNegate methodsFor: 'as yet unclassified' stamp: 'wbk 2/9/2004 20:19'!
buildInterferenceWith: aColouringRegisterAllocator 	
	out do:
		[:each| aColouringRegisterAllocator
			addInterferenceEdge: argument
			to: each]! !

!MedNegate methodsFor: 'as yet unclassified' stamp: 'wbk 2/9/2004 20:43'!
visitWith: anInstructionSelector 
	^ anInstructionSelector visitNegate: self! !

!MedNegate methodsFor: 'as yet unclassified' stamp: 'wbk 2/9/2004 20:10'!
registersUsed
	^ Lattice with: argument! !

!MedNegate methodsFor: 'as yet unclassified' stamp: 'wbk 2/9/2004 19:10'!
initialiseArgument: aMedLiteral 
	argument := aMedLiteral! !

!MedNegate methodsFor: 'as yet unclassified' stamp: 'wbk 2/9/2004 19:54'!
argument
	^ argument! !

!MedNegate methodsFor: 'as yet unclassified' stamp: 'wbk 2/9/2004 20:17'!
registersDo: aBlockContext 
	aBlockContext value: argument! !

!MedNegate methodsFor: 'as yet unclassified' stamp: 'wbk 2/9/2004 19:12'!
intermediateForm
	^{#neg. argument intermediateForm}! !

!MedNegate class methodsFor: 'as yet unclassified' stamp: 'wbk 2/9/2004 19:11'!
argument: aMedLiteral 
	^ self new initialiseArgument: aMedLiteral! !

!MedNegate methodsFor: 'as yet unclassified' stamp: 'wbk 2/9/2004 20:11'!
registersDefined
	^ Lattice with: argument! !

MedLanguage subclass: #MedAddressingMode
	instanceVariableNames: 'base offset'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Intermediate'!

!MedAddressingMode methodsFor: 'as yet unclassified' stamp: 'wbk 4/11/2003 14:00'!
hasOffset
	^ offset isNil not! !

!MedAddressingMode class methodsFor: 'instance creation' stamp: 'wbk 9/12/2002 17:01'!
offset: aNumber base: aRegister
	^ self new 
		initializeOffset: aNumber
		base: aRegister! !

!MedAddressingMode methodsFor: 'Dataflow Analysis' stamp: 'wbk 4/11/2003 12:53'!
registersUsed
	^ Lattice with: base! !

!MedAddressingMode methodsFor: 'misc' stamp: 'wbk 3/14/2003 14:33'!
offset
	^ offset! !

!MedAddressingMode class methodsFor: 'instance creation' stamp: 'wbk 9/11/2002 13:53'!
indirectRegister: aRegister
	^ self new initializeIndirectRegister: aRegister! !

!MedAddressingMode methodsFor: 'misc' stamp: 'wbk 11/1/2002 16:34'!
registersDo: aBlock
	aBlock value: base ! !

!MedAddressingMode methodsFor: 'Code Emission' stamp: 'wbk 9/15/2002 21:30'!
emitCodeOn: aStream
	offset isNil ifFalse: [offset printOn: aStream].
	aStream nextPut: $(.
	base emitCodeOn: aStream.
	aStream nextPut: $).! !

!MedAddressingMode methodsFor: 'misc' stamp: 'wbk 9/12/2002 17:13'!
initialize
	base := nil.! !

!MedAddressingMode methodsFor: 'misc' stamp: 'wbk 9/12/2002 17:02'!
initializeIndirectRegister: aRegister
	self initialize.
	base := aRegister.
	^ self! !

!MedAddressingMode methodsFor: 'testing' stamp: 'wbk 9/11/2002 23:20'!
isAddressingMode
	^ true! !

!MedAddressingMode methodsFor: 'misc' stamp: 'wbk 9/12/2002 16:59'!
address
	^ base! !

!MedAddressingMode methodsFor: 'misc' stamp: 'wbk 3/14/2003 14:33'!
base
	^ base! !

!MedAddressingMode methodsFor: 'misc' stamp: 'wbk 9/12/2002 17:02'!
initializeOffset: aNumber base: aRegister
	self initialize.
	offset := aNumber.
	base := aRegister.
	^ self! !

!MedAddressingMode methodsFor: 'misc' stamp: 'wbk 10/5/2002 21:44'!
visitWith: anObject
	^ anObject visitAddressingMode: self! !

!MedAddressingMode class methodsFor: 'instance creation' stamp: 'wbk 9/11/2002 17:23'!
address: aSimpleMed
	^ self indirectRegister: aSimpleMed! !

!MedAddressingMode methodsFor: 'Unit Testing' stamp: 'wbk 9/12/2002 17:13'!
intermediateForm
	|answer|
	answer := OrderedCollection new.
	offset ~= nil ifTrue: [answer add: offset].
	answer add: base intermediateForm.
	^ answer asArray! !

!MedAddressingMode methodsFor: 'printing' stamp: 'wbk 10/18/2002 17:39'!
printOn: aStream
	"Append to the argument, aStream, a sequence of characters that  
	identifies the receiver."

	| title |
	title _ self class name.
	aStream
		nextPutAll: (title first isVowel ifTrue: ['an '] ifFalse: ['a ']);
		nextPutAll: title! !

!MedLanguage methodsFor: 'Dataflow Analysis' stamp: 'wbk 10/21/2002 11:55'!
setIn: aLattice
	in := aLattice! !

MedLanguage subclass: #MedMachineRegister
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Intermediate'!

!MedMachineRegister methodsFor: 'Dataflow Analysis' stamp: 'wbk 10/23/2002 12:09'!
registersUsed
	^ Lattice with: self! !

!MedMachineRegister methodsFor: 'Unit testing' stamp: 'wbk 9/13/2002 22:55'!
printOn: aStream
	self printRegTypeOn: aStream.
	aStream nextPutAll: ' ['.
	aStream nextPutAll: name.
	aStream nextPutAll: ']'.! !

!MedMachineRegister methodsFor: 'Misc' stamp: 'wbk 11/4/2002 13:40'!
registersDo: aBlock
	aBlock value: self! !

!MedMachineRegister class methodsFor: 'instance creation' stamp: 'wbk 7/9/2004 20:06'!
name: aSymbol 
	^ self new 
		initializeName: aSymbol! !

!MedMachineRegister methodsFor: 'Testing' stamp: 'WBK 8/28/2002 21:25'!
isMachineRegister
	^ true! !

!MedMachineRegister methodsFor: 'Unit testing' stamp: 'WBK 8/27/2002 15:00'!
intermediateForm
	^ name! !

!MedMachineRegister methodsFor: 'Misc' stamp: 'wbk 10/5/2002 21:49'!
visitWith: anObject
	^ anObject visitMachineRegister: self! !

!MedMachineRegister methodsFor: 'Testing' stamp: 'wbk 4/11/2003 14:00'!
hasOffset
	^ false! !

!MedMachineRegister methodsFor: 'Misc' stamp: 'wbk 7/9/2004 20:06'!
initializeName: aSymbol
	name := aSymbol.
	^ self! !

!MedMachineRegister methodsFor: 'Misc' stamp: 'WBK 8/28/2002 23:24'!
name
	^ name! !

!MedMachineRegister methodsFor: 'Code Emission' stamp: 'wbk 9/15/2002 21:29'!
emitCodeOn: aStream
	aStream nextPut: $%.
	aStream nextPutAll: name.
	! !

MedMachineRegister subclass: #MedTemporaryRegister
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Intermediate'!

!MedTemporaryRegister methodsFor: 'misc' stamp: 'wbk 10/5/2002 21:54'!
visitWith: anObject
	^ anObject visitTemporaryRegister: self! !

!MedTemporaryRegister methodsFor: 'testing' stamp: 'wbk 9/13/2002 22:55'!
printRegTypeOn: aStream
	aStream nextPutAll: 'temp'.! !

!MedTemporaryRegister methodsFor: 'testing' stamp: 'WBK 8/28/2002 21:26'!
isMachineRegister
	^ false! !

!MedMachineRegister methodsFor: 'Unit testing' stamp: 'wbk 9/13/2002 22:56'!
printRegTypeOn: aStream
	aStream nextPutAll: 'reg'.! !

!MedMachineRegister methodsFor: 'Testing' stamp: 'WBK 8/27/2002 20:42'!
isRegister
	^ true! !

MedLanguage subclass: #MedArithmatic
	instanceVariableNames: 'operator arg1 arg2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Intermediate'!

!MedArithmatic methodsFor: 'accessing' stamp: 'WBK 8/28/2002 15:01'!
operator
	^ operator! !

!MedArithmatic methodsFor: 'unit testing' stamp: 'wbk 3/6/2004 20:12'!
intermediateForm
	^ {operator. arg1 intermediateForm. arg2 intermediateForm}! !

!MedArithmatic methodsFor: 'accessing' stamp: 'WBK 8/28/2002 09:46'!
arg2
	^ arg2! !

!MedArithmatic methodsFor: 'accessing' stamp: 'WBK 8/28/2002 09:46'!
arg1
	^ arg1! !

!MedArithmatic class methodsFor: 'instance creation' stamp: 'wbk 3/6/2004 19:55'!
operator: aSymbol arg1: firstMed arg2: secondMed
	^ self new 
		initializeOperator: aSymbol
		arg1: firstMed
		arg2: secondMed! !

!MedArithmatic methodsFor: 'misc' stamp: 'wbk 10/6/2002 11:30'!
visitWith: aVisitor
	^ aVisitor visitArithmatic: self! !

!MedArithmatic methodsFor: 'initialization' stamp: 'WBK 8/27/2002 12:47'!
initializeOperator: aSymbol arg1: firstMed arg2: secondMed
	operator := aSymbol.
	arg1 := firstMed.
	arg2 := secondMed.
	^ self! !

!MedArithmatic methodsFor: 'testing' stamp: 'wbk 11/8/2002 14:20'!
isAdd
	^ operator = #add! !

MedLanguage subclass: #MedDivide
	instanceVariableNames: 'remander arg1 arg2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Intermediate'!

!MedDivide methodsFor: 'as yet unclassified' stamp: 'wbk 1/28/2004 23:25'!
arg1
	^ arg1! !

!MedDivide methodsFor: 'as yet unclassified' stamp: 'wbk 1/24/2004 12:55'!
intermediateForm
	^ {#div. arg1 literal. arg2 literal. remander name}! !

!MedDivide class methodsFor: 'as yet unclassified' stamp: 'wbk 1/28/2004 23:02'!
register: aMedTemporaryRegister 
	^ self
		emit: nil
		divide: nil
		remander: aMedTemporaryRegister! !

!MedDivide methodsFor: 'as yet unclassified' stamp: 'wbk 1/28/2004 23:27'!
remainder
	^ remander! !

!MedDivide methodsFor: 'as yet unclassified' stamp: 'wbk 1/26/2004 22:53'!
visitWith: aVisitor
	^ aVisitor visitDivide: self! !

!MedDivide methodsFor: 'as yet unclassified' stamp: 'wbk 1/28/2004 23:01'!
arg2
	^ arg2! !

!MedDivide methodsFor: 'as yet unclassified' stamp: 'wbk 1/24/2004 12:45'!
initialiseArg1: aMedLiteral arg2: aMedLiteral2 remainder: aMedTemporaryRegister 
	arg1 := aMedLiteral.
	arg2 := aMedLiteral2.
	remander := aMedTemporaryRegister! !

!MedDivide class methodsFor: 'as yet unclassified' stamp: 'wbk 1/24/2004 12:45'!
emit: aMedLiteral divide: aMedLiteral2 remander: aMedTemporaryRegister 
	^ self new
		initialiseArg1: aMedLiteral
		arg2: aMedLiteral2
		remainder: aMedTemporaryRegister! !

MedLanguage subclass: #MedLiteral
	instanceVariableNames: 'literal'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Intermediate'!

!MedLiteral class methodsFor: 'instance creation' stamp: 'wbk 9/3/2002 14:09'!
literal: anInteger
	^ self new initialize: anInteger! !

!MedLiteral methodsFor: 'testing' stamp: 'WBK 8/28/2002 14:49'!
isLiteral
	^ true! !

!MedLiteral methodsFor: 'testing' stamp: 'wbk 11/8/2002 14:34'!
isMachineInteger
	^ literal isInteger! !

!MedLiteral methodsFor: 'Code Emission' stamp: 'wbk 10/14/2002 18:00'!
emitCodeOn: aStream
	literal isString ifTrue: [^ aStream nextPutAll: literal].
	aStream nextPut: $$.
	literal printOn: aStream.! !

!MedLiteral class methodsFor: 'instance creation' stamp: 'wbk 9/18/2002 16:57'!
smallInteger: aNumber
	^ self literal: aNumber * 2 + 1! !

!MedLiteral methodsFor: 'initialization' stamp: 'WBK 8/27/2002 12:26'!
initialize: anInteger
	literal := anInteger! !

!MedLiteral methodsFor: 'Dataflow Analysis' stamp: 'wbk 10/23/2002 12:29'!
registersUsed
	^ Lattice new! !

!MedLiteral methodsFor: 'misc' stamp: 'wbk 11/8/2002 14:37'!
literal
	^ literal! !

!MedLiteral methodsFor: 'misc' stamp: 'wbk 10/5/2002 21:56'!
visitWith: aVisitor
	^ aVisitor visitLiteral: self! !

!MedLiteral methodsFor: 'Unit Testing' stamp: 'wbk 10/18/2002 17:56'!
printOn: aStream
	aStream nextPutAll: 'literal ['.
	literal printOn: aStream.
	aStream nextPut: $].! !

!MedLiteral methodsFor: 'misc' stamp: 'wbk 8/2/2004 21:25'!
registersDo: aBlock! !

!MedLiteral methodsFor: 'Unit Testing' stamp: 'WBK 8/27/2002 15:03'!
intermediateForm
	^ literal! !

!MedLanguage methodsFor: 'testing' stamp: 'wbk 11/8/2002 14:19'!
isAdd
	^ false! !

MedLanguage subclass: #MedMem
	instanceVariableNames: 'address'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Intermediate'!

!MedMem methodsFor: 'misc' stamp: 'wbk 10/6/2002 11:24'!
visitWith: aVisitor
	^ aVisitor visitMem: self! !

!MedMem methodsFor: 'testing' stamp: 'wbk 9/3/2002 16:51'!
isMem
	^ true! !

!MedMem methodsFor: 'misc' stamp: 'wbk 9/11/2002 13:51'!
address
	^ address! !

!MedMem class methodsFor: 'instance creation' stamp: 'wbk 9/3/2002 14:13'!
address: aMed
	^ self new initializeAddress: aMed! !

!MedMem methodsFor: 'misc' stamp: 'wbk 9/3/2002 14:18'!
initializeAddress: aMed
	address := aMed.
	^ self! !

!MedMem methodsFor: 'Unit Testing' stamp: 'wbk 9/3/2002 15:04'!
intermediateForm
	^ {#mem. address intermediateForm}! !

!MedLanguage methodsFor: 'Dataflow Analysis' stamp: 'wbk 10/21/2002 21:27'!
in 
	^ in! !

!MedLanguage methodsFor: 'Unit Testing' stamp: 'wbk 10/18/2002 17:39'!
printOn: aStream
	aStream nextPutAll: self intermediateForm asString! !

!MedLanguage methodsFor: 'Dataflow Analysis' stamp: 'wbk 10/21/2002 18:22'!
out
	^ out! !

!MedLanguage methodsFor: 'testing' stamp: 'wbk 9/11/2002 23:08'!
isMachineRegister
	^ false! !

MedLanguage subclass: #MedBlock
	instanceVariableNames: 'expressions blockNumber'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Intermediate'!

!MedBlock methodsFor: 'Dataflow Analysis' stamp: 'wbk 3/17/2003 18:28'!
in
	expressions isEmpty ifTrue: [^ Lattice new].
	^ (expressions at: 1) in! !

!MedBlock methodsFor: 'misc' stamp: 'wbk 10/31/2002 18:23'!
add: aMed
	aMed isNil ifTrue: [^ self]. "Nil means there wasn't really an instruction"
	expressions add: aMed! !

!MedBlock methodsFor: 'Unit Testing' stamp: 'WBK 8/27/2002 15:16'!
intermediateForm
	|expr|
	expr := OrderedCollection with: #block with: blockNumber.

     expr addAll: (expressions collect: [:each| each intermediateForm]).
	^ expr asArray ! !

!MedBlock methodsFor: 'misc' stamp: 'wbk 10/2/2002 17:40'!
initializeNumber: anInteger
	blockNumber := anInteger.
	expressions := OrderedCollection new.
	^ self! !

!MedBlock methodsFor: 'misc' stamp: 'WBK 8/29/2002 17:30'!
registersDo: aBlock
	expressions do: [:each| each registersDo: aBlock]! !

!MedBlock class methodsFor: 'instance creation' stamp: 'wbk 10/3/2002 22:46'!
number: anInteger
	^ super new initializeNumber: anInteger.! !

!MedBlock methodsFor: 'misc' stamp: 'WBK 8/28/2002 23:02'!
expressionsDo: aBlock
	expressions do: aBlock! !

!MedBlock methodsFor: 'misc' stamp: 'WBK 8/27/2002 19:31'!
do: aBlock
	^ expressions do: aBlock! !

!MedBlock methodsFor: 'misc' stamp: 'wbk 9/15/2002 21:59'!
expressionAt: aNumber
	^ expressions at: aNumber! !

!MedBlock methodsFor: 'misc' stamp: 'WBK 8/27/2002 19:32'!
blockNumber
	^ blockNumber! !

!MedBlock methodsFor: 'Unit Testing' stamp: 'wbk 10/2/2002 17:34'!
blockName
	^ 'block', blockNumber asString! !

!MedBlock methodsFor: 'misc' stamp: 'wbk 10/22/2002 10:52'!
numberOfExpressions
	^ expressions size! !

!MedBlock methodsFor: 'Unit Testing' stamp: 'wbk 10/21/2002 21:25'!
instructionAt: anInteger
	^ expressions at: anInteger! !

!MedBlock methodsFor: 'misc' stamp: 'wbk 10/5/2002 23:01'!
visitWith: aVisitor
	^ aVisitor visitBlock: self.! !

!MedLanguage methodsFor: 'Testing' stamp: 'wbk 7/10/2004 18:30'!
isJump
	^ false! !

MedLanguage subclass: #MedAssembly
	instanceVariableNames: 'name arguments'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Intermediate'!

!MedAssembly methodsFor: 'Dataflow Analysis' stamp: 'wbk 3/17/2003 18:28'!
registersUsed
	^(arguments first) registersUsed + (arguments at: 2) registersUsed! !

!MedAssembly methodsFor: 'Unit Testing' stamp: 'WBK 8/28/2002 15:42'!
intermediateForm
	|args answer|
	answer := OrderedCollection with: name.
	args := arguments collect: [:each| each intermediateForm].
	answer addAll: args.
	^ answer asArray! !

!MedAssembly methodsFor: 'misc' stamp: 'wbk 10/5/2002 22:30'!
visitWith: aVisitor
	^ aVisitor visitAssembly: self! !

!MedAssembly methodsFor: 'Testing' stamp: 'wbk 8/1/2004 14:52'!
isRegisterRead: aMedTemporaryRegister 
	arguments do: [:each| each = aMedTemporaryRegister ifTrue: [^ true]].
	arguments do: 
		[:each| each isAddressingMode ifTrue: 
			[each registersDo: 
				[:eachRegister| eachRegister = aMedTemporaryRegister ifTrue: 
					[^true]]]].
	^ false! !

!MedAssembly class methodsFor: 'instance creation' stamp: 'wbk 11/5/2002 14:42'!
name: aSymbol arguments: aCollection
"aSymbol = #mov ifTrue: [self halt]."
	^ self new
		initializeName: aSymbol
		arguments: aCollection! !

!MedAssembly methodsFor: 'Testing' stamp: 'wbk 7/31/2004 11:50'!
isRegisterWritten: aMedTemporaryRegister 
	^ (arguments at: 2) = aMedTemporaryRegister! !

!MedAssembly methodsFor: 'Dataflow Analysis' stamp: 'wbk 11/4/2002 16:00'!
registersDefined
	(arguments at: 2) isAddressingMode ifTrue: [^ Lattice new].
	^ Lattice with: (arguments at: 2)! !

!MedAssembly methodsFor: 'misc' stamp: 'WBK 8/28/2002 21:22'!
name
	^ name! !

!MedAssembly methodsFor: 'misc' stamp: 'wbk 11/4/2002 16:52'!
registersDo: aBlock
	arguments do: [:each| each registersDo: aBlock]! !

!MedAssembly methodsFor: 'misc' stamp: 'WBK 8/27/2002 20:13'!
initializeName: aSymbol arguments: aCollection
	name := aSymbol.
	arguments := aCollection.
	^ self! !

!MedAssembly methodsFor: 'misc' stamp: 'WBK 8/28/2002 21:23'!
argumentsDo: aBlock
	arguments do: aBlock! !

!MedAssembly methodsFor: 'misc' stamp: 'wbk 3/14/2003 17:48'!
arg2
	^ arguments at: 2! !

!MedAssembly methodsFor: 'misc' stamp: 'wbk 3/17/2003 18:28'!
arg1
	^arguments first! !

!MedAssembly methodsFor: 'Register Allocation' stamp: 'wbk 1/31/2004 14:51'!
buildInterferenceWith: anAllocator
	| defined |
	(arguments at: 2) isAddressingMode ifTrue: [^ self].
	defined := self registersDefined register.
	out do: 
		[:each | anAllocator 
			addInterferenceEdge: defined 
			to: each]! !

MedLanguage subclass: #MedJump
	instanceVariableNames: 'type target instruction'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Intermediate'!

!MedJump class methodsFor: 'instance creation' stamp: 'wbk 10/2/2002 17:29'!
type: aSymbol block: aMedBlock instruction: aMed
	^ self new
		initializeType:  aSymbol 
		block: aMedBlock 
		instruction: aMed! !

!MedJump methodsFor: 'Register Allocation' stamp: 'wbk 11/4/2002 16:35'!
buildInterferenceWith: anAllocator! !

!MedJump methodsFor: 'misc' stamp: 'wbk 10/3/2002 17:17'!
type
	^ type! !

!MedJump methodsFor: 'misc' stamp: 'wbk 10/2/2002 17:31'!
initializeType:  aSymbol block: aMedBlock instruction: aMed
	type := aSymbol.
	target := aMedBlock.
	instruction := aMed.
	^ self! !

!MedJump methodsFor: 'misc' stamp: 'wbk 10/3/2002 17:18'!
target
	^ target! !

!MedJump class methodsFor: 'instance creation' stamp: 'wbk 10/3/2002 22:24'!
type: aSymbol target: aMedBlock
	^ self 
		type:  aSymbol 
		block: aMedBlock ! !

!MedJump methodsFor: 'misc' stamp: 'wbk 10/3/2002 17:16'!
instruction
	^ instruction! !

!MedJump methodsFor: 'misc' stamp: 'wbk 10/3/2002 21:15'!
registersDo: aBlock! !

!MedJump methodsFor: 'misc' stamp: 'wbk 10/5/2002 22:41'!
visitWith: aVisitor
	^ aVisitor visitJump: self! !

!MedJump class methodsFor: 'instance creation' stamp: 'wbk 10/17/2002 11:27'!
type: aSymbol target: aMedBlock instruction: aMed
	^ self new
		initializeType:  aSymbol 
		block: aMedBlock 
		instruction: aMed! !

!MedJump methodsFor: 'misc' stamp: 'wbk 10/24/2002 11:13'!
name
	"Used in ColouringRegisterAllocator>>buildInstruction"
	^ type! !

!MedJump methodsFor: 'Unit Testing' stamp: 'wbk 10/3/2002 22:28'!
intermediateForm
	|answer|
	answer := OrderedCollection 
		with: type 
		with: target blockName asSymbol.
	instruction isNil ifFalse: [answer addLast: instruction intermediateForm].
	^ answer asArray! !

!MedJump class methodsFor: 'instance creation' stamp: 'wbk 10/3/2002 20:27'!
type: aSymbol block: aMedBlock
	^ self new
		initializeType:  aSymbol 
		block: aMedBlock 
		instruction: nil! !

!MedJump methodsFor: 'Testing' stamp: 'wbk 7/10/2004 18:30'!
isJump
	^ true! !

MedLanguage subclass: #MedX86CDQ
	instanceVariableNames: 'eax edx'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Intermediate'!

!MedX86CDQ methodsFor: 'as yet unclassified' stamp: 'wbk 2/1/2004 22:03'!
visitWith: anAnalyser 
	anAnalyser visitX86Cdq: self
! !

!MedX86CDQ methodsFor: 'as yet unclassified' stamp: 'wbk 2/2/2004 20:41'!
buildInterferenceWith: aColouringRegisterAllocator 
	out do:
		[:each| aColouringRegisterAllocator
			addInterferenceEdge: edx
			to: each]
	! !

!MedX86CDQ methodsFor: 'as yet unclassified' stamp: 'wbk 2/1/2004 22:19'!
registersUsed
	^ Lattice with: eax! !

!MedX86CDQ methodsFor: 'as yet unclassified' stamp: 'wbk 2/1/2004 22:18'!
initialiseEax: aMedMachineRegister edx: aMedMachineRegister2 
	eax := aMedMachineRegister.
	edx := aMedMachineRegister2.! !

!MedX86CDQ class methodsFor: 'as yet unclassified' stamp: 'wbk 2/1/2004 22:18'!
eax: eaxRegister edx: edxRegister
	^ self new						"WBK, change super back to self after the old call has
										been removed"
		initialiseEax: eaxRegister
		edx: edxRegister! !

!MedX86CDQ methodsFor: 'as yet unclassified' stamp: 'wbk 1/31/2004 20:07'!
intermediateForm
	^ #(cdq)! !

!MedX86CDQ methodsFor: 'as yet unclassified' stamp: 'wbk 2/2/2004 19:31'!
registersDo: aBlockContext 
	aBlockContext value: eax.
	aBlockContext value: edx.! !

!MedX86CDQ methodsFor: 'as yet unclassified' stamp: 'wbk 2/1/2004 22:23'!
registersDefined
	^ Lattice with: edx! !

MedLanguage subclass: #MedX86Divide
	instanceVariableNames: 'argument eax edx'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Intermediate'!

!MedX86Divide methodsFor: 'as yet unclassified' stamp: 'wbk 1/31/2004 15:32'!
register
	^ argument! !

!MedX86Divide methodsFor: 'as yet unclassified' stamp: 'wbk 1/31/2004 15:08'!
buildInterferenceWith: anAllocator 
	{eax. edx} do:
		[:eachDefine| out do:
			[:eachUse| anAllocator
				addInterferenceEdge: eachDefine
				to: eachUse]]
	! !

!MedX86Divide methodsFor: 'as yet unclassified' stamp: 'wbk 1/31/2004 15:11'!
visitWith: anAnalyser 
	^ anAnalyser visitDivide: self! !

!MedX86Divide methodsFor: 'as yet unclassified' stamp: 'wbk 1/29/2004 22:05'!
registersDefined
	^ Lattice
		with: eax
		with: edx! !

!MedX86Divide methodsFor: 'as yet unclassified' stamp: 'wbk 1/29/2004 21:41'!
initializeArgument: aMedTemporaryRegister eax: eaxRegister edx: edxRegister
	argument := aMedTemporaryRegister.
	eax := eaxRegister.
	edx := edxRegister.
	^ self! !

!MedX86Divide class methodsFor: 'as yet unclassified' stamp: 'wbk 1/29/2004 21:35'!
register: argumentRegister eax: eaxRegister edx: edxRegister
	^ self new
		initializeArgument: argumentRegister
		eax: eaxRegister
		edx: edxRegister! !

!MedX86Divide methodsFor: 'as yet unclassified' stamp: 'wbk 1/31/2004 12:42'!
registersDo: aBlockContext 
	aBlockContext value: argument.
	aBlockContext value: eax.
	aBlockContext value: edx! !

!MedX86Divide methodsFor: 'as yet unclassified' stamp: 'wbk 1/28/2004 23:31'!
intermediateForm
	^ {#div. argument name}! !

!MedX86Divide methodsFor: 'as yet unclassified' stamp: 'wbk 1/29/2004 20:59'!
registersUsed
	^ Lattice
		with: eax
		with: edx
		with: argument! !

!MedX86Divide methodsFor: 'as yet unclassified' stamp: 'wbk 1/31/2004 15:49'!
argument
	^ argument! !

!MedLanguage methodsFor: 'testing' stamp: 'WBK 8/28/2002 14:49'!
isLiteral	
	^ false! !

!MedLanguage methodsFor: 'testing' stamp: 'wbk 9/3/2002 16:51'!
isMem
	^ false! !

!MedLanguage methodsFor: 'testing' stamp: 'wbk 7/11/2004 21:51'!
isReturn
	^ false! !

MedLanguage subclass: #MedCall
	instanceVariableNames: 'function'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Intermediate'!

!MedCall methodsFor: 'Misc' stamp: 'wbk 6/21/2003 23:15'!
visitWith: aVisitor 
	^aVisitor visitCall: self! !

!MedCall methodsFor: 'Dataflow Analysis' stamp: 'wbk 7/5/2003 15:12'!
registersUsed
	^ function registersUsed! !

!MedCall class methodsFor: 'as yet unclassified' stamp: 'wbk 6/20/2003 20:51'!
function: aSymbol 
	^ self new initializeFunction: aSymbol "Really an address"! !

!MedCall methodsFor: 'Dataflow Analysis' stamp: 'wbk 7/5/2003 15:11'!
registersDefined
	^ Lattice new! !

!MedCall methodsFor: 'Misc' stamp: 'wbk 6/21/2003 17:18'!
function
	^ function
! !

!MedCall methodsFor: 'Misc' stamp: 'wbk 6/20/2003 20:51'!
initializeFunction: aSymbol 
	function := aSymbol.
	^ self! !

!MedCall methodsFor: 'Misc' stamp: 'wbk 6/24/2003 11:35'!
registersDo: aBlockContext 
	function registersDo: aBlockContext! !

!MedCall methodsFor: 'Misc' stamp: 'wbk 6/21/2003 17:24'!
intermediateForm
	^ {#call. function intermediateForm}! !

!MedCall methodsFor: 'Register Allocation' stamp: 'wbk 6/24/2003 11:36'!
buildInterferenceWith: anAllocator 
	! !

MedLanguage subclass: #MedMov
	instanceVariableNames: 'to from'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Intermediate'!

!MedMov class methodsFor: 'instance creation' stamp: 'wbk 9/11/2002 19:09'!
from: fromMed to: toMed 
	^ self new 
		initializeTo: toMed 
		from: fromMed! !

!MedMov methodsFor: 'accessing' stamp: 'WBK 8/27/2002 20:17'!
from
	^ from! !

!MedMov methodsFor: 'misc' stamp: 'WBK 8/27/2002 13:19'!
initializeTo: toMed from: fromMed
	to := toMed.
	from := fromMed.
	^ self! !

!MedMov methodsFor: 'Testing' stamp: 'wbk 8/1/2004 14:58'!
isRegisterRead: aMedTemporaryRegister 
	from = aMedTemporaryRegister ifTrue: [^true].
	from isAddressingMode ifTrue:
		[from registersDo: [:each| each = aMedTemporaryRegister ifTrue: [^ true]]].
	to isAddressingMode ifTrue:
		[to registersDo: [:each| each = aMedTemporaryRegister ifTrue: [^ true]]].
	^ false! !

!MedMov methodsFor: 'Testing' stamp: 'wbk 7/31/2004 11:40'!
isRegisterWritten: aMedTemporaryRegister 
	^ to = aMedTemporaryRegister! !

!MedMov methodsFor: 'testing' stamp: 'WBK 8/27/2002 20:16'!
isMov
	^ true! !

!MedMov methodsFor: 'accessing' stamp: 'WBK 8/27/2002 20:17'!
to
	^ to! !

!MedMov methodsFor: 'unit testing' stamp: 'WBK 8/30/2002 15:32'!
intermediateForm
	^ {#mov. from intermediateForm. to intermediateForm}! !

!MedMov methodsFor: 'Dataflow Analysis' stamp: 'wbk 11/4/2002 13:58'!
registersUsed
	to isAddressingMode ifTrue:
		[^ to registersUsed + from registersUsed].
	^ from registersUsed! !

!MedMov methodsFor: 'misc' stamp: 'wbk 11/4/2002 13:38'!
registersDo: aBlock
	from registersDo: aBlock.
	to registersDo: aBlock! !

!MedMov methodsFor: 'Register Allocation' stamp: 'wbk 7/5/2003 15:28'!
buildInterferenceWith: anAllocator
	| defined |
	to isAddressingMode ifTrue: [^ self].
	defined := self registersDefined register.
	^ out do: 
		[:eachRegister | 
		eachRegister = from ifFalse: 
			[anAllocator 
				addInterferenceEdge: defined 
				to: eachRegister]]! !

!MedMov methodsFor: 'misc' stamp: 'wbk 10/6/2002 11:32'!
visitWith: aVisitor
	^ aVisitor visitMov: self! !

!MedMov methodsFor: 'Dataflow Analysis' stamp: 'wbk 11/4/2002 13:59'!
registersDefined
	to isAddressingMode ifTrue: [^ Lattice new].
	^ Lattice with: to! !

!MedMov methodsFor: 'misc' stamp: 'wbk 11/4/2002 14:29'!
name
	"Used for a type test"
	^ #mov! !

MedLanguage subclass: #MedRet
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Intermediate'!

!MedRet methodsFor: 'Misc' stamp: 'wbk 10/6/2002 11:26'!
visitWith: aVisitor
	^ aVisitor visitRet: self! !

!MedRet methodsFor: 'Testing' stamp: 'wbk 7/11/2004 21:51'!
isReturn
	^ true! !

!MedRet methodsFor: 'Register Allocation' stamp: 'wbk 11/4/2002 16:35'!
buildInterferenceWith: anAllocator! !

!MedRet methodsFor: 'Unit testing' stamp: 'WBK 8/27/2002 15:08'!
intermediateForm
	^ #(ret)! !

!MedRet methodsFor: 'Misc' stamp: 'wbk 11/4/2002 15:17'!
registersDo: aBlock! !

!MedRet methodsFor: 'Misc' stamp: 'wbk 11/4/2002 15:23'!
name 
	^ #ret! !

!MedRet methodsFor: 'Misc' stamp: 'wbk 11/4/2002 15:20'!
argumentsDo: aBlock! !

Object subclass: #Lattice
	instanceVariableNames: 'value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery'!

!Lattice methodsFor: 'misc' stamp: 'wbk 10/23/2002 14:29'!
register
	value size ~= 1 ifTrue: [Error signal].
	value do: [:each| ^ each].
	! !

!Lattice methodsFor: 'Unit Testing' stamp: 'wbk 10/21/2002 21:31'!
matchesArray: anArray
	|registerNames|
	anArray size = value size ifFalse: [^ false].
	registerNames := value collect: [:each| each name].
	anArray do: [:each| (registerNames includes: each) ifFalse: [^ false]].
	^ true! !

!Lattice class methodsFor: 'instance creation' stamp: 'wbk 10/21/2002 19:55'!
with: firstRegister with: secondRegister
	^ super new initializeValue: (Set
			with: firstRegister
			with: secondRegister)! !

!Lattice methodsFor: 'Unit Testing' stamp: 'wbk 11/1/2002 19:54'!
includesAllOf: anArray
	|registerNames|
	registerNames := value collect: [:each| each name].
	anArray do: [:each| (registerNames includes: each) ifFalse: [^ false]].
	^ true! !

!Lattice methodsFor: 'misc' stamp: 'wbk 10/23/2002 14:10'!
do: aBlock
	value do: aBlock! !

!Lattice methodsFor: 'misc' stamp: 'wbk 10/21/2002 21:40'!
value
	^ value! !

!Lattice methodsFor: 'as yet unclassified' stamp: 'wbk 6/24/2003 10:35'!
isEmpty
	^ value isEmpty! !

!Lattice methodsFor: 'misc' stamp: 'wbk 10/24/2002 19:05'!
size
	^ value size! !

!Lattice class methodsFor: 'instance creation' stamp: 'wbk 10/21/2002 19:57'!
with: firstRegister
	^ super new initializeValue: (Set with: firstRegister)! !

!Lattice class methodsFor: 'as yet unclassified' stamp: 'wbk 1/29/2004 21:00'!
with: anUndefinedObject with: anUndefinedObject2 with: aMedTemporaryRegister 
	^ (Lattice
		with: anUndefinedObject
		with: anUndefinedObject2) +
		(Lattice with: aMedTemporaryRegister)! !

!Lattice methodsFor: 'misc' stamp: 'wbk 10/21/2002 19:56'!
initializeValue: aSet
	value := aSet.
	^ self! !

!Lattice methodsFor: 'Operations' stamp: 'wbk 3/17/2003 18:14'!
+ aLattice
	| newSet |
	newSet := value copy.
	newSet addAll: aLattice value.
	^ self class value: newSet! !

!Lattice class methodsFor: 'instance creation' stamp: 'wbk 10/21/2002 21:34'!
value: aSet
	^ super new initializeValue: aSet! !

!Lattice methodsFor: 'Operations' stamp: 'wbk 3/17/2003 18:14'!
- aLattice
	| newSet |
	newSet := value copy.
	newSet addAll: aLattice value. "Add the values so that removing them will not cause an error"
	newSet removeAll: aLattice value.
	^ self class value: newSet! !

!Lattice class methodsFor: 'instance creation' stamp: 'wbk 10/21/2002 21:39'!
new
	^ super new initializeValue: (Set new)! !

Object subclass: #RegisterReassigner
	instanceVariableNames: 'source result machine assignments newBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery'!

!RegisterReassigner class methodsFor: 'instance creation' stamp: 'wbk 10/23/2002 19:09'!
assignments: aDictionary method: aMethod for: aMachine
	| assigner |
	assigner := self new
		initializeAssignments: aDictionary 
		method: aMethod 
		for: aMachine.
	assigner run.
	^ assigner result! !

!RegisterReassigner methodsFor: 'misc' stamp: 'wbk 10/31/2002 18:04'!
run
	source blocksDo: [:each| each visitWith: self]! !

!RegisterReassigner methodsFor: 'Assignment Visiting' stamp: 'wbk 6/25/2003 15:42'!
visitPush: aMedPush 
	| argument |
	argument :=(aMedPush argument visitWith: self).
	 ^ MedPush argument: argument.! !

!RegisterReassigner methodsFor: 'Assignment Visiting' stamp: 'wbk 10/23/2002 19:07'!
visitLiteral: aLiteral
	^ aLiteral! !

!RegisterReassigner methodsFor: 'Assignment Visiting' stamp: 'wbk 11/3/2002 13:34'!
visitAddressingMode: anAddressingMode
	^ MedAddressingMode
		offset: anAddressingMode offset 
		base: (anAddressingMode address visitWith: self).! !

!RegisterReassigner methodsFor: 'Assignment Visiting' stamp: 'wbk 10/23/2002 19:06'!
visitBlock: aMedBlock
	newBlock := result blockNumbered: aMedBlock blockNumber.
	aMedBlock expressionsDo: [:each| newBlock add: (each visitWith: self)].
	^ newBlock! !

!RegisterReassigner methodsFor: 'misc' stamp: 'wbk 7/6/2003 21:15'!
initializeAssignments: aDictionary method: aMethod for: aMachine
	assignments := aDictionary.
	source := aMethod.
	machine := aMachine.
	result _ MedMethod from: aMethod.
	^ self! !

RegisterReassigner subclass: #SpillInserter
	instanceVariableNames: 'spiltRegisters spillMap spillVersions registerAllocator'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery'!

!SpillInserter methodsFor: 'Visiting' stamp: 'wbk 8/1/2004 14:47'!
visitAssembly: anAssembly 
	| spillRegs |
	spillRegs := self createSpillMap: anAssembly.
	self 
		loadSpiltRegisters: spillRegs
		forInstruction: anAssembly.
	newBlock add: (super visitAssembly: anAssembly).
	self 
		saveSpiltRegisters: spillRegs
		forInstruction: anAssembly.
	^nil! !

!SpillInserter methodsFor: 'Visiting' stamp: 'wbk 7/31/2004 11:44'!
saveSpiltRegisters: spillRegs forInstruction: anAssembly 
	spillRegs do: 
			[:each | 
			(anAssembly isRegisterWritten: each) ifTrue: 
					[machine 
						saveRegister: each
						usingMap: spillMap
						into: newBlock]]! !

!SpillInserter methodsFor: 'Visiting' stamp: 'wbk 8/1/2004 14:46'!
loadSpiltRegisters: spillRegs forInstruction: anAssembly 
	spillRegs do: 
			[:each | 
			(anAssembly isRegisterRead: each) ifTrue: 
					[machine 
						reloadRegister: each
						usingMap: spillMap
						into: newBlock]]! !

!SpillInserter methodsFor: 'Visiting' stamp: 'wbk 11/2/2002 12:35'!
createSpillMap: anAssembly 
	| spillRegisters |
	spillMap := Dictionary new.
	spillRegisters := (anAssembly registersIn: spiltRegisters).
	spillRegisters do: 
		[:each| spillMap
			at: each
			put: (self newRegisterFor: each)].
	^ spillRegisters! !

!SpillInserter methodsFor: 'Visiting' stamp: 'wbk 11/2/2002 12:57'!
visitTemporaryRegister: aReg
	spillMap isNil ifTrue: [^ aReg].
	^ spillMap
		at: aReg
		ifAbsent: [aReg]! !

!SpillInserter methodsFor: 'Visiting' stamp: 'wbk 8/1/2004 14:46'!
visitMov: anAssembly 
	| spillRegs |
	spillRegs := self createSpillMap: anAssembly.
	self 
		loadSpiltRegisters: spillRegs
		forInstruction: anAssembly.
	newBlock add: (super visitMov: anAssembly).
	self 
		saveSpiltRegisters: spillRegs
		forInstruction: anAssembly.
	^nil! !

!SpillInserter methodsFor: 'Visiting' stamp: 'wbk 5/26/2004 23:54'!
newRegisterFor: aRegister
	| newVersion oldVersion answer |
	oldVersion := spillVersions
		at: aRegister
		ifAbsent: [0].
	newVersion := oldVersion + 1.
	spillVersions
		at: aRegister
		put: newVersion.
	answer := machine registerNamed: (aRegister name, 'v', newVersion asString) asSymbol.
	registerAllocator registerIsSpilled: answer.
	^ answer! !

!SpillInserter class methodsFor: 'instance creation' stamp: 'wbk 5/26/2004 23:50'!
spiltRegisters: someRegisters method: aMethod for: aMachine allocator: anAllocator
	| assigner |
	assigner := self new
		initializeSpills: someRegisters 
		method: aMethod 
		for: aMachine
		allocator: anAllocator.
	assigner run.
	^ assigner result! !

!SpillInserter methodsFor: 'misc' stamp: 'wbk 5/26/2004 23:52'!
initializeSpills: someRegisters method: aMethod for: aMachine allocator: anAllocator.
	source := aMethod.
	machine := aMachine.
	registerAllocator := anAllocator.
	result := MedMethod from: aMethod.
	spillVersions := Dictionary new.
	spiltRegisters := someRegisters asSet.
	someRegisters do: [:each| machine spillSlotFor: each].
	^ self! !

!RegisterReassigner methodsFor: 'Assignment Visiting' stamp: 'wbk 2/9/2004 20:43'!
visitNegate: aMedNegate 
	^ MedNegate argument: (aMedNegate argument visitWith: self)! !

!RegisterReassigner methodsFor: 'Assignment Visiting' stamp: 'wbk 11/5/2002 13:43'!
visitMov: anAssembly
	| fromRegister toRegister |
	fromRegister :=(anAssembly from visitWith: self).
	toRegister := (anAssembly to visitWith: self).
	fromRegister = toRegister ifTrue: [^ nil]. "This move has been coalesced"
	 ^ MedMov
		from: fromRegister
		to: toRegister! !

!RegisterReassigner methodsFor: 'Assignment Visiting' stamp: 'wbk 11/1/2002 21:14'!
visitJump: aJump 
	^ MedJump
		type: aJump type
		target: (result blockNumbered: aJump target blockNumber)! !

!RegisterReassigner methodsFor: 'Assignment Visiting' stamp: 'wbk 6/25/2003 15:47'!
visitCall: aMedCall 
	| function |
	function := aMedCall function visitWith: self.
	^ MedCall function: function! !

!RegisterReassigner methodsFor: 'misc' stamp: 'wbk 10/23/2002 19:09'!
result
	^ result! !

!RegisterReassigner methodsFor: 'Assignment Visiting' stamp: 'wbk 11/4/2002 15:25'!
visitRet: aRet
	 ^ MedRet new! !

!RegisterReassigner methodsFor: 'Assignment Visiting' stamp: 'wbk 2/2/2004 21:17'!
visitX86Cdq: aMedX86CDQ 
	^ aMedX86CDQ! !

!RegisterReassigner methodsFor: 'Assignment Visiting' stamp: 'wbk 1/31/2004 15:32'!
visitDivide: aDivide 
	^ MedX86Divide
		register: (aDivide register visitWith: self)
		eax: (machine registerNamed: #eax)
		edx: (machine registerNamed: #edx)! !

!RegisterReassigner methodsFor: 'Assignment Visiting' stamp: 'wbk 10/23/2002 19:07'!
visitAssembly: anAssembly
	| newArgs |
	newArgs := OrderedCollection new.
	anAssembly argumentsDo: [:each| newArgs add: (each visitWith: self)].
	 ^ MedAssembly
		name: anAssembly name
		arguments: newArgs! !

!RegisterReassigner methodsFor: '-- all --' stamp: 'wbk 10/23/2002 19:08'!
visitTemporaryRegister: aReg
	| answer |
	answer := assignments at: aReg.
	^ answer! !

!RegisterReassigner methodsFor: 'Assignment Visiting' stamp: 'wbk 10/23/2002 21:31'!
visitMachineRegister: aVisitor
	^ aVisitor! !

Object subclass: #MethodEntryPoint
	instanceVariableNames: 'address label'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery'!

!MethodEntryPoint class methodsFor: 'as yet unclassified' stamp: 'wbk 7/6/2003 18:27'!
address: aSmallInteger label: aSymbol 
	^ self new 
		initializeAddress: aSmallInteger 
		label: aSymbol ! !

!MethodEntryPoint methodsFor: 'as yet unclassified' stamp: 'wbk 7/6/2003 18:47'!
address
	^ address! !

!MethodEntryPoint methodsFor: 'as yet unclassified' stamp: 'wbk 7/6/2003 18:28'!
initializeAddress: aSmallInteger label: aSymbol 
	address := aSmallInteger.
	label := aSymbol.! !

!MethodEntryPoint methodsFor: 'as yet unclassified' stamp: 'wbk 7/6/2003 18:47'!
label
	^ label! !

Object subclass: #ByteCodeReader
	instanceVariableNames: 'method generator stack stackHeights jumpTargets'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery'!

!ByteCodeReader methodsFor: 'Stack' stamp: 'wbk 7/8/2004 22:24'!
extendedPopAndStore
	| answer |
	answer := self extendedStore.
	stack pop.
	^ answer

	! !

!ByteCodeReader methodsFor: 'Jumps' stamp: 'wbk 7/28/2003 13:03'!
longUnconditionalJump
	| target |
	target := stack pc + (((self currentByteCode bitAnd: 7) - 4) * 256) 
				+ self fetchByte + 2.
	generator unconditionalJumpTo: target! !

!ByteCodeReader methodsFor: 'Common Sends' stamp: 'wbk 2/7/2004 20:39'!
sendAtPut
	| value location receiver sendResult |
	value := stack pop.
	location := stack pop.
	receiver := stack pop.
	sendResult := generator 
				sendAtPutTo: receiver
				location: location
				value: value.
	stack push: sendResult! !

!ByteCodeReader methodsFor: 'Stack' stamp: 'wbk 2/7/2004 20:39'!
pushInstanceVariable
	| position answer |
	position := self currentByteCode bitAnd: 15.
	answer := generator pushInstanceVariable: position.
	stack push: answer! !

!ByteCodeReader methodsFor: 'scanning' stamp: 'wbk 5/31/2004 18:57'!
processByteCode: anInteger 
	self byteCodeAddressing: stack pc.
	^self byteCodeActionFor: anInteger! !

!ByteCodeReader methodsFor: 'Comparision' stamp: 'wbk 2/7/2004 20:39'!
lessThanEquals
	| first second |
	second := stack pop.
	first := stack pop.
	stack push: (generator 
				prim: first
				lessThanEquals: second)! !

!ByteCodeReader methodsFor: 'scanning' stamp: 'wbk 5/31/2004 20:25'!
byteCodeAddressing: anInteger
	| jumpIndex |
	generator byteCodeAddress: anInteger.
	jumpIndex := jumpTargets 
		indexOf: anInteger
		ifAbsent: [^ self].
	stack heightTo: (stackHeights at: jumpIndex) ! !

!ByteCodeReader methodsFor: 'Stack' stamp: 'wbk 2/7/2004 20:39'!
pushTrue
	| answer |
	answer := generator pushTrue.
	stack push: answer! !

!ByteCodeReader methodsFor: 'Stack' stamp: 'wbk 6/12/2004 22:02'!
storeAndPopReceiverVariable
	generator 
		storeAndPopReceiverVariableIndex: (self currentByteCode bitAnd: 7)
		value: stack pop! !

!ByteCodeReader methodsFor: 'Comparision' stamp: 'wbk 2/7/2004 20:39'!
greaterThanEqual
	| secondMed firstMed |
	secondMed := stack pop.
	firstMed := stack pop.
	stack push: (generator 
				prim: firstMed
				greaterThanEqual: secondMed)! !

!ByteCodeReader class methodsFor: 'reading' stamp: 'wbk 5/30/2004 23:29'!
newMethod: aMethod using: aGenerator stack: aStack
	^ (self new
		initialiseMethod: aMethod
		using: aGenerator
		stack: aStack
		jumpTargets: #()
		stackHeights: #()) run! !

!ByteCodeReader methodsFor: 'Comparision' stamp: 'wbk 2/7/2004 20:39'!
notEquals
	| second first |
	second := stack pop.
	first := stack pop.
	stack push: (generator 
				prim: first
				notEquals: second)! !

!ByteCodeReader methodsFor: 'Returns' stamp: 'wbk 11/27/2003 21:17'!
returnFalse
	generator returnFalse! !

!ByteCodeReader methodsFor: 'Stack' stamp: 'wbk 6/14/2004 22:41'!
extendedStore
	| argument variableType variableIndex |
	argument := self fetchByte.
	variableType := (argument >> 6) bitAnd: 16r3.
	variableIndex := argument bitAnd: 16r3F.
	
	variableType = 0 ifTrue:
		[^ generator
			storeAndPopReceiverVariableIndex: variableIndex
			value: stack peek]. 
	variableType = 1 ifTrue:
		[^ generator
			popIntoTemp: stack peek
			slot: variableIndex].
	
	Error signal: 'Not Handled Yet'.
	! !

!ByteCodeReader methodsFor: 'Arithmatic' stamp: 'wbk 2/8/2004 16:23'!
add
	| second first |
	second := stack pop.
	first := stack pop.
	stack push: (generator 
				generate: first
				add: second)! !

!ByteCodeReader methodsFor: 'Stack' stamp: 'wbk 2/7/2004 20:39'!
pushLiteralVariable: aLiteral slot: aSmallInteger 
	| answer |
	answer := generator 
				pushLiteralVariable: aLiteral
				slot: aSmallInteger.
	stack push: answer.
	^answer! !

!ByteCodeReader methodsFor: 'Comparision' stamp: 'wbk 2/7/2004 20:39'!
greaterThan
	| second first |
	second := stack pop.
	first := stack pop.
	stack push: (generator 
				prim: first
				greaterThan: second)! !

!ByteCodeReader methodsFor: 'Comparision' stamp: 'wbk 2/7/2004 20:39'!
equals
	| secondMed firstMed |
	secondMed := stack pop.
	firstMed := stack pop.
	stack push: (generator 
				prim: firstMed
				equals: secondMed)! !

!ByteCodeReader methodsFor: 'scanning' stamp: 'wbk 7/28/2003 13:04'!
run
	method primitive ~= 0 ifTrue: [generator setPrimitive: method primitive].
	generator numberOfTemporaries: method numTemps.
	[stack pc <= method endPC] whileTrue: 
			[self processByteCode: (method at: stack pc).
			stack incrementPC].
	generator finish! !

!ByteCodeReader methodsFor: 'Arithmatic' stamp: 'wbk 2/7/2004 20:39'!
div
	| second first |
	second := stack pop.
	first := stack pop.
	stack push: (generator 
				generate: first
				div: second)! !

!ByteCodeReader methodsFor: 'Arithmatic' stamp: 'wbk 2/8/2004 16:18'!
divide
	| second first |
	second := stack pop.
	first := stack pop.
	stack push: (generator 
				generate: first
				divide: second)! !

!ByteCodeReader methodsFor: 'Jumps' stamp: 'wbk 2/28/2004 15:58'!
shortUnconditionalJump
	| target |
	target := stack pc + (self currentByteCode bitAnd: 7) + 2.
	generator unconditionalJumpTo: target! !

!ByteCodeReader methodsFor: 'Stack' stamp: 'wbk 2/7/2004 20:39'!
pushFalse
	stack push: generator pushFalse! !

!ByteCodeReader methodsFor: 'Jumps' stamp: 'wbk 2/14/2004 11:50'!
longJumpIfTrue
	| boolean target |
	boolean := stack pop.
	target := stack pc + ((self currentByteCode bitAnd: 3) * 256) + self fetchByte + 2.
	generator 
		jumpIfTrue: boolean
		to: target! !

!ByteCodeReader methodsFor: 'Sends' stamp: 'wbk 2/7/2004 20:39'!
sendLiteralSelector
	| selectorPosition argumentCount sendResult arguments |
	selectorPosition := self currentByteCode bitAnd: 15.
	argumentCount := (self currentByteCode >> 4 bitAnd: 3) - 1.
	arguments := stack pop: argumentCount + 1.
	sendResult := generator 
				sendSelector: (method literalAt: selectorPosition + 1)
				inSlot: selectorPosition
				arguments: arguments.
	stack push: sendResult! !

!ByteCodeReader methodsFor: 'Stack' stamp: 'wbk 9/18/2002 22:18'!
pushLiteralConstant
	|position|
	position := self currentByteCode bitAnd: 16r1F.
	self 
		pushConstant: (method literalAt: position + 1)
		slot: position
	! !

!ByteCodeReader methodsFor: 'Returns' stamp: 'wbk 10/18/2003 12:53'!
returnNil
	generator returnNil! !

!ByteCodeReader methodsFor: 'Arithmatic' stamp: 'wbk 2/7/2004 20:39'!
bitOr
	| second first |
	second := stack pop.
	first := stack pop.
	stack push: (generator 
				generate: first
				bitOr: second)! !

!ByteCodeReader methodsFor: 'Returns' stamp: 'wbk 11/27/2003 19:38'!
returnTrue
	generator returnTrue! !

!ByteCodeReader methodsFor: 'misc' stamp: 'wbk 5/31/2004 20:21'!
initialiseMethod: aMethod using: aGenerator stack: aStack jumpTargets: jumpArray stackHeights: heightArray
	method := aMethod.
	generator := aGenerator.
	stack := aStack.
	generator state: stack.
	stackHeights := heightArray.
	jumpTargets := jumpArray.! !

!ByteCodeReader methodsFor: 'Common Sends' stamp: 'wbk 2/27/2004 21:25'!
equivilent
	| second first |
	second := stack pop.
	first := stack pop.
	stack push: (generator
		generate: first
		equivilent: second).! !

!ByteCodeReader methodsFor: 'Jumps' stamp: 'wbk 2/7/2004 20:38'!
shortConditionalJump
	| boolean destination |
	boolean := stack pop.
	destination := stack pc + (self currentByteCode bitAnd: 7) + 1 + 1.
	generator 
		jumpIfFalse: boolean
		to: destination! !

!ByteCodeReader methodsFor: 'Common Sends' stamp: 'wbk 2/7/2004 20:39'!
sendAt
	| argument receiver sendResult |
	argument := stack pop.
	receiver := stack pop.
	sendResult := generator 
				sendAtTo: receiver
				with: argument.
	stack push: sendResult! !

!ByteCodeReader methodsFor: 'scanning' stamp: 'wbk 7/28/2003 13:03'!
fetchByte
	stack incrementPC.
	^method at: stack pc! !

!ByteCodeReader methodsFor: 'Stack' stamp: 'wbk 2/7/2004 20:39'!
pushNil
	stack push: generator pushNil! !

!ByteCodeReader methodsFor: 'Stack' stamp: 'wbk 2/7/2004 20:38'!
popStack
	^generator popStack: stack pop! !

!ByteCodeReader class methodsFor: 'reading' stamp: 'wbk 5/30/2004 23:34'!
newMethod: aMethod using: aGenerator jumpTargets: jumpArray stackHeights: stackArray
	^ (self new
		initialiseMethod: aMethod
		using: aGenerator
		stack: (ExuperyStack 
			newPC: aMethod initialPC
			emitter: aGenerator emitter)
		jumpTargets: jumpArray
		stackHeights: stackArray) run	! !

!ByteCodeReader methodsFor: 'Jumps' stamp: 'wbk 2/7/2004 20:38'!
longJumpIfFalse
	| boolean target |
	boolean := stack pop.
	target := stack pc + ((self currentByteCode bitAnd: 3) * 256) + self fetchByte + 2.
	generator 
		jumpIfFalse: boolean
		to: target! !

!ByteCodeReader methodsFor: 'misc' stamp: 'wbk 5/30/2004 23:09'!
stackHeights
	^ stackHeights! !

!ByteCodeReader methodsFor: 'Sends' stamp: 'wbk 6/16/2004 22:38'!
extendedSend
	| argument selectorIndex argumentCount sendResult |
	argument := self fetchByte.
	selectorIndex := argument bitAnd: 16r1F.
	argumentCount := argument >> 5.
	sendResult := generator
		sendSelector: (method literalAt: selectorIndex +1)
		inSlot: selectorIndex
		arguments: (stack pop: argumentCount + 1).
	stack push: sendResult! !

!ByteCodeReader methodsFor: 'Arithmatic' stamp: 'wbk 2/8/2004 16:17'!
bitAnd
	| second first |
	second := stack pop.
	first := stack pop.
	stack push: (generator 
				generate: first
				bitAnd: second)! !

!ByteCodeReader methodsFor: 'Common Sends' stamp: 'wbk 3/1/2004 19:47'!
sendClass
	stack push: (generator generateClass: stack pop)! !

!ByteCodeReader methodsFor: 'Arithmatic' stamp: 'wbk 2/8/2004 19:08'!
bitShift
	| second first |
	second := stack pop.
	first := stack pop.
	stack push: (generator
		generate: first
		bitShift: second)! !

!ByteCodeReader methodsFor: 'Arithmatic' stamp: 'wbk 2/8/2004 16:24'!
subtract
	| second first |
	second := stack pop.
	first := stack pop.
	stack push: (generator 
				generate: first
				subtract: second)! !

!ByteCodeReader methodsFor: 'Common Sends' stamp: 'wbk 2/22/2004 15:48'!
binarySendWithSpecialSelector: anObject 
	| sendResult receiver argument |
	argument := stack pop.
	receiver := stack pop.	"Remove the two arguments"
	sendResult := generator 
				generateBinarySelector: anObject
				receiver: receiver
				argument: argument.
	stack push: sendResult! !

!ByteCodeReader methodsFor: 'Comparision' stamp: 'wbk 2/7/2004 20:39'!
lessThan
	| second first |
	second := stack pop.
	first := stack pop.
	stack push: (generator 
				prim: first
				lessThan: second)! !

!ByteCodeReader methodsFor: 'Stack' stamp: 'wbk 2/7/2004 20:39'!
pushSelf
	| answer |
	answer := generator pushSelf.
	stack push: answer.
	^answer! !

!ByteCodeReader methodsFor: 'Stack' stamp: 'wbk 2/7/2004 20:39'!
pushTemp
	| answer |
	answer := generator pushTempAt: (self currentByteCode bitAnd: 15).
	stack push: answer.
	^answer! !

!ByteCodeReader methodsFor: 'Stack' stamp: 'wbk 4/23/2004 22:31'!
pushConstant: aLiteral slot: aNumber 
	| answer |
	answer := generator 
				pushConstant: aLiteral
				slot: aNumber.
	stack push: answer.
	^answer! !

!ByteCodeReader methodsFor: 'Stack' stamp: 'wbk 6/13/2004 12:36'!
extendedPushBytecode
	| argument variableType variableIndex answer |
	argument := self fetchByte.
	variableType := (argument >> 6) bitAnd: 16r3.
	variableIndex := argument bitAnd: 16r3F.
	
	variableType = 0 ifTrue: 
		[answer := generator pushInstanceVariable: variableIndex.
		^ stack push: answer].
	variableType = 1 ifTrue:
		[answer := generator pushTempAt: variableIndex.
		^ stack push: answer].
	
	Error signal: 'Not Yet Handled'.! !

!ByteCodeReader methodsFor: 'Common Sends' stamp: 'wbk 2/22/2004 13:27'!
unarySendWithSelector: aSmallInteger 
	| argument |
	argument := stack pop.
	stack push: (generator 
		generateUnarySelector: aSmallInteger
		receiver: argument)! !

!ByteCodeReader methodsFor: 'Arithmatic' stamp: 'wbk 2/7/2004 20:39'!
mod
	| second first |
	second := stack pop.
	first := stack pop.
	stack push: (generator 
				generate: first
				mod: second)! !

!ByteCodeReader methodsFor: 'Returns' stamp: 'wbk 10/4/2003 00:04'!
returnSelf
	generator returnSelf.! !

!ByteCodeReader methodsFor: 'Common Sends' stamp: 'wbk 2/13/2004 20:30'!
makePoint
	| second first |
	second := stack pop.
	first := stack pop.
	stack push: 
		(generator 
			generate: first
			makePoint: second).! !

!ByteCodeReader methodsFor: 'Arithmatic' stamp: 'wbk 2/8/2004 16:27'!
multiply
	| second first |
	second := stack pop.
	first := stack pop.
	stack push: (generator 
				generate: first
				multiply: second)! !

!ByteCodeReader methodsFor: 'Returns' stamp: 'wbk 2/28/2004 15:45'!
returnTop
	generator returnTop: stack pop.
	"self assert: [stack isEmpty]" "This isn't always true, the problem is demonstrated with the
									shortUnconditionalJumpTests. There they push a return value
									onto the stack to be used if the block is not evaluated."! !

!ByteCodeReader methodsFor: 'scanning' stamp: 'wbk 7/28/2003 13:03'!
currentByteCode
	^method at: stack pc! !

!ByteCodeReader methodsFor: 'Stack' stamp: 'wbk 7/12/2003 10:05'!
pushConstantVariable
	|position|
	position := self currentByteCode bitAnd: 16r1F.
	self 
		pushLiteralVariable: (method literalAt: position + 1)
		slot: position! !

!ByteCodeReader methodsFor: 'Common Sends' stamp: 'wbk 2/14/2004 15:19'!
sendNew
	| argument |
	argument := stack pop.
	stack push: (generator generateNew: argument)! !

!ByteCodeReader methodsFor: 'Stack' stamp: 'wbk 2/7/2004 20:38'!
popIntoTemp
	generator 
		popIntoTemp: stack pop
		slot: self currentByteCode - 104! !

!ByteCodeReader methodsFor: 'scanning' stamp: 'wbk 6/16/2004 22:31'!
byteCodeActionFor: anInteger 
	anInteger = 118 ifTrue: [^self pushConstant: 1 slot: -1].
	anInteger = 119 ifTrue: [^self pushConstant: 2 slot: -1].
	anInteger = 176 ifTrue: [^self add].
	anInteger = 124 ifTrue: [^self returnTop].
	anInteger >= 32 & (anInteger <= 63) ifTrue: [^self pushLiteralConstant].
	anInteger >= 104 & (anInteger <= 111) ifTrue: [^self popIntoTemp].
	anInteger = 120 ifTrue: [^self returnSelf].
	anInteger >= 16 & (anInteger <= 31) ifTrue: [^self pushTemp].
	anInteger = 180 ifTrue: [^self lessThanEquals].
	anInteger >= 152 & (anInteger <= 159) ifTrue: [^self shortConditionalJump].
	anInteger >= 172 & (anInteger <= 175) ifTrue: [^self longJumpIfFalse].
	anInteger = 184 ifTrue: [^self multiply].
	anInteger >= 160 & (anInteger <= 167) 
		ifTrue: [^self longUnconditionalJump].
	anInteger = 177 ifTrue: [^self subtract].
	anInteger = 112 ifTrue: [^self pushSelf].
	anInteger >= 208 & (anInteger <= 255) ifTrue: [^self sendLiteralSelector].
	anInteger = 117 ifTrue: [^self pushConstant: 0 slot: -1].
	anInteger >= 64 & (anInteger <= 95) ifTrue: [^self pushConstantVariable].
	anInteger = 205 ifTrue: [^self binarySendWithSpecialSelector: 29].
	anInteger = 113 ifTrue: [^self pushTrue].
	anInteger = 192 ifTrue: [^self sendAt].
	anInteger = 114 ifTrue: [^self pushFalse].
	anInteger = 193 ifTrue: [^self sendAtPut].
	anInteger = 135 ifTrue: [^self popStack].
	anInteger >= 0 & (anInteger <= 15) ifTrue: [^self pushInstanceVariable].
	anInteger >= 96 & (anInteger <= 103) 
		ifTrue: [^self storeAndPopReceiverVariable].
	anInteger = 116 ifTrue: [^self pushConstant: -1 slot: -1].
	anInteger = 115 ifTrue: [^self pushNil].
	anInteger = 123 ifTrue: [^self returnNil].
	anInteger = 121 ifTrue: [^self returnTrue].
	anInteger = 122 ifTrue: [^self returnFalse].
	anInteger = 178 ifTrue: [^self lessThan].
	anInteger = 179 ifTrue: [^self greaterThan].
	anInteger = 181 ifTrue: [^self greaterThanEqual].
	anInteger = 182 ifTrue: [^self equals].
	anInteger = 183 ifTrue: [^self notEquals].
	anInteger = 185 ifTrue: [^self divide].
	anInteger = 190 ifTrue: [^self bitAnd].
	anInteger = 191 ifTrue: [^self bitOr].
	anInteger = 189 ifTrue: [^self div].
	anInteger = 186 ifTrue: [^self mod].
	anInteger = 188 ifTrue: [^self bitShift].
	anInteger = 187 ifTrue: [^self makePoint].
	anInteger >= 168 & (anInteger <= 171) ifTrue: [^self longJumpIfTrue].
	anInteger = 204 ifTrue: [^self unarySendWithSelector: 28].
	anInteger = 194 ifTrue: [^self unarySendWithSelector: 18].
	anInteger = 195 ifTrue: [^self unarySendWithSelector: 19].
	anInteger = 196 ifTrue: [^self binarySendWithSpecialSelector: 20].
	anInteger = 197 ifTrue: [^self unarySendWithSelector: 21].
	anInteger = 198 ifTrue: [^self equivilent].
	anInteger >= 144 & (anInteger <= 151) 
		ifTrue: [^self shortUnconditionalJump].
	anInteger = 206 ifTrue: [^self unarySendWithSelector: 30].
	anInteger = 207 ifTrue: [^self unarySendWithSelector: 31].
	anInteger = 199 ifTrue: [^self sendClass].
	anInteger = 130 ifTrue: [^self extendedPopAndStore].
	anInteger = 128 ifTrue: [^self extendedPushBytecode].
	anInteger = 129 ifTrue: [^self extendedStore].
	anInteger = 131 ifTrue: [^self extendedSend].
	
	generator addUnknownByteCode! !

!ByteCodeReader methodsFor: 'misc' stamp: 'wbk 5/31/2004 20:20'!
stackHeight
	^ stack stackSize! !

Object subclass: #MoveNode
	instanceVariableNames: 'to from maxColours'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery'!

!MoveNode methodsFor: 'Misc' stamp: 'wbk 6/21/2004 22:18'!
initialiseMove: aMedMov withGraph: anInteferenceGraph maxColours: aNumber
	maxColours := aNumber.
	self 
		markAsMoveRelated: aMedMov to
		withGraph: anInteferenceGraph.
	self markAsMoveRelated: aMedMov from
		withGraph: anInteferenceGraph.
	from := anInteferenceGraph at: aMedMov from.
	to := anInteferenceGraph at: aMedMov to.
	^ self! !

!MoveNode methodsFor: 'Move Coalescing' stamp: 'wbk 6/21/2004 20:25'!
isCoalescable
	| edges |
	"A quick fast check for the easy common cases"
	from currentEdges size > maxColours | (to currentEdges size > maxColours) ifTrue: [^ false].
	from currentEdges size + to currentEdges size <= maxColours ifTrue: [^ true].
	"The actual check"
	edges := from currentEdges copy asSet.
	edges addAll: to currentEdges.
	^ edges size < maxColours.! !

!MoveNode methodsFor: 'Misc' stamp: 'wbk 6/19/2004 23:32'!
markAsMoveRelated: aRegister withGraph: anInterferenceGraph
	| node |
	node := (anInterferenceGraph at: aRegister).
	node markAsMoveRelated.
	node incrementCurrentMoves.! !

!MoveNode methodsFor: 'Misc' stamp: 'wbk 6/21/2004 22:07'!
fromCurrentNode
	^ from currentVersion! !

!MoveNode methodsFor: 'Misc' stamp: 'wbk 6/19/2004 23:42'!
toNode
	^ to! !

!MoveNode class methodsFor: 'creation' stamp: 'wbk 6/20/2004 10:49'!
move: aMedMov withGraph: anInterferenceGraph maxColours: aNumber
	^ self new 
		initialiseMove: aMedMov
		withGraph: anInterferenceGraph
		maxColours: aNumber! !

!MoveNode methodsFor: 'Move Coalescing' stamp: 'wbk 6/20/2004 10:22'!
doesInterfere
	^ (from interferesWith: to) ! !

!MoveNode methodsFor: 'Misc' stamp: 'wbk 6/21/2004 22:08'!
toCurrentNode
	^ to currentVersion! !

!MoveNode methodsFor: 'Misc' stamp: 'wbk 6/19/2004 23:41'!
fromNode
	^ from ! !

!MoveNode methodsFor: 'Misc' stamp: 'wbk 8/2/2004 22:22'!
freezeWeight
	| weight |
	weight := 0.
	from currentSize < maxColours ifTrue:
		[weight := weight + (from currentSize / from currentMoves)].
	to currentSize < maxColours ifTrue:
		[weight := weight + (to currentSize / to currentMoves)].
	^ weight! !

Object subclass: #Exupery
	instanceVariableNames: 'method assembly machine instructions allocated functionName generator byteCodes'
	classVariableNames: 'Methods'
	poolDictionaries: ''
	category: 'Exupery'!

!Exupery class methodsFor: 'code cache' stamp: 'wbk 4/15/2004 22:02'!
initialiseExupery: aDictionary
	"Don't call this method directly, use initialiseExupery. The argument is just to pass
	a dictionary into the VM. The dictionary will then be used to find compiled code for
	methods"
	<primitive: 'initialiseExupery' module: 'ExuperyPlugin'>
	TestFailure signal! !

!Exupery methodsFor: 'Compilation' stamp: 'wbk 9/16/2002 22:33'!
selectInstructions
	| selector |
	selector := InstructionSelector 
		on: method
		for: machine.
	instructions := selector result.! !

!Exupery methodsFor: 'Compilation' stamp: 'wbk 4/18/2003 15:51'!
assemble
	byteCodes := AssemblerExupery 
		assemble: allocated
		withPlugin: machine! !

!Exupery class methodsFor: 'compiling' stamp: 'wbk 7/25/2004 18:42'!
compileMethod: aSymbol into: aSymbol2 forClass: aClass 
	| method bytes code |
	method := aClass compiledMethodAt: aSymbol.
	bytes := self 
				compileMethod: method.
	"Load the compiled method into the code cache"
	code := self loadCode: bytes.
	self
		register: code
		method: (aClass compiledMethodAt: aSymbol2).
	aSymbol2 flushCache.! !

!Exupery class methodsFor: 'code cache' stamp: 'wbk 4/15/2004 21:39'!
loadCode: anArray
	<primitive: 'loadCode' module: 'ExuperyPlugin'>
	TestFailure signal! !

!Exupery methodsFor: 'misc' stamp: 'wbk 3/17/2003 14:32'!
byteCodes
	^ byteCodes! !

!Exupery methodsFor: 'Compilation' stamp: 'wbk 8/1/2004 23:10'!
run
	self generateIntermediate.
	self selectInstructions.
	self allocateRegisters.
	self assemble.! !

!Exupery methodsFor: 'misc' stamp: 'wbk 9/16/2002 15:54'!
assembly
	^ assembly! !

!Exupery class methodsFor: 'instance creation' stamp: 'wbk 7/15/2004 23:32'!
compileMethod: aCompiledMethod 
	| compiler |
	compiler := self new 
				initializeMethod: aCompiledMethod
				functionName: nil.
	compiler run.
	^compiler byteCodes! !

!Exupery class methodsFor: 'compiling' stamp: 'wbk 7/25/2004 19:38'!
compileMethod: aSymbol class: aClass 
	self 
		compileMethod: aSymbol
		into: aSymbol
		forClass: aClass! !

!Exupery methodsFor: 'Compilation' stamp: 'wbk 5/30/2004 23:39'!
generateIntermediate
	| jumpFinder reader |
	jumpFinder := JumpTargetRecorder new.
	ByteCodeReader 
		newMethod: method
		using: jumpFinder
		jumpTargets: #()
		stackHeights: #().
	generator := IntermediateGenerator 
				for: machine
				jumpTargets: jumpFinder targets.
	reader := ByteCodeReader 
		newMethod: method
		using: generator
		jumpTargets: jumpFinder targets
		stackHeights: jumpFinder stackTrace.
	method := generator method.
	^ reader! !

!Exupery class methodsFor: 'code cache' stamp: 'wbk 7/16/2004 22:21'!
register: aSmallInteger method: aMethod
	"<primitive: 'registerCompiledMethod' module: 'ExuperyPlugin'>
	TestFailure signal"
	Methods
		at: aMethod
		put: aSmallInteger.! !

!Exupery class methodsFor: 'code cache' stamp: 'wbk 7/8/2004 22:11'!
initialiseExupery
	"This dictionary must be of size zero, this allows us to replace a divsion with a
	bit mask. This is also true for classes method dictionaries."
	Methods := (ExuperyMethodDictionary new).
	self initialiseExupery: Methods.! !

!Exupery methodsFor: 'misc' stamp: 'wbk 10/15/2002 18:39'!
generator
	^ generator! !

!Exupery methodsFor: 'Compilation' stamp: 'wbk 10/24/2002 13:42'!
allocateRegisters
	| withRegisters |
	withRegisters := ColouringRegisterAllocator 
		on: instructions
		for: machine.
	allocated := withRegisters result.! !

!Exupery class methodsFor: 'instance creation' stamp: 'wbk 9/18/2002 16:50'!
compileMethod: aCompiledMethod intoFile: aString functionName: aNameString
	|compiler file|
	compiler := self new 
		initializeMethod: aCompiledMethod
		functionName: aNameString.
	compiler run.
	file := CrLfFileStream fileNamed: aString.
	file nextPutAll: compiler assembly.
	file close.! !

!Exupery methodsFor: 'misc' stamp: 'wbk 9/18/2002 16:47'!
initializeMethod: aCompiledMethod functionName: aString
	method := aCompiledMethod.
	functionName := aString.
	assembly := ''.
	machine :=  MachineX86 new.
	^ self! !

Object subclass: #OffsetPatcher
	instanceVariableNames: 'target location assembler'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery'!

!OffsetPatcher methodsFor: 'as yet unclassified' stamp: 'wbk 6/30/2003 22:49'!
patch
	|targetAddress offset |
	targetAddress := assembler addressFor: target.
	offset := targetAddress - location.
	assembler
		patchByteAt: location - 3
		with: (offset bitAnd: 255).
	assembler
		patchByteAt: location - 2
		with: ((offset bitShift: -8) bitAnd: 255).
	assembler
		patchByteAt: location - 1
		with: ((offset bitShift: -16) bitAnd: 255).
	assembler
		patchByteAt: location
		with: ((offset bitShift: -24) bitAnd: 255).
! !

!OffsetPatcher methodsFor: 'as yet unclassified' stamp: 'wbk 4/3/2003 20:29'!
initializeTarget: aMedBlock location: anInteger assembler: anAssembler
	target := aMedBlock.
	location := anInteger.
	assembler := anAssembler.
	^ self! !

!OffsetPatcher class methodsFor: 'as yet unclassified' stamp: 'wbk 4/3/2003 20:30'!
target: aMedBlock location: aSmallInteger assembler: anAssemblerExupery 
	^ self new
		initializeTarget: aMedBlock 
		location: aSmallInteger 
		assembler: anAssemblerExupery! !

Object subclass: #ExuperyInstanceVariables
	instanceVariableNames: 'a b i3 i4 i5 i6 i7 i8 i9 i10 i11 i12 i13 i14 i15 i16 i17 i18'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Customer Tests'!

!ExuperyInstanceVariables methodsFor: 'accessing' stamp: 'wbk 10/3/2003 23:56'!
a: firstObject
	a := firstObject.! !

!ExuperyInstanceVariables methodsFor: 'accessing' stamp: 'wbk 6/13/2004 13:53'!
storeInstanceExtended2
 ^ (true ifTrue: [i16:= 10]) + i16.! !

!ExuperyInstanceVariables methodsFor: 'accessing' stamp: 'wbk 6/12/2004 18:01'!
i18
	^ i18 + 0! !

!ExuperyInstanceVariables methodsFor: 'accessing' stamp: 'wbk 6/12/2004 18:00'!
i16
	^ i16 + 0! !

!ExuperyInstanceVariables methodsFor: 'accessing' stamp: 'wbk 6/14/2004 22:36'!
storeTempExtended2
	|t1 t2 t3 t4 t5 t6 t7 t8 t9 t10 t11 t12 t13 t14 t15 t16 t17 t18|	
 	^ true ifTrue: [t16:= 15].! !

!ExuperyInstanceVariables methodsFor: 'accessing' stamp: 'wbk 6/12/2004 18:00'!
i17
	^ i17 + 0! !

!ExuperyInstanceVariables methodsFor: 'accessing' stamp: 'wbk 6/14/2004 22:31'!
storeTempExtended
	|t1 t2 t3 t4 t5 t6 t7 t8 t9 t10 t11 t12 t13 t14 t15 t16 t17 t18|	
 	^ (true ifTrue: [t16:= 15]) + t16.! !

!ExuperyInstanceVariables methodsFor: 'accessing' stamp: 'wbk 8/30/2003 20:29'!
a
	"Adding zero to avoid a primitive shortcut"
	^ a + 0! !

!ExuperyInstanceVariables methodsFor: 'Experiments' stamp: 'wbk 6/12/2004 18:17'!
iNNN: anObject
	i9 := anObject
	! !

!ExuperyInstanceVariables methodsFor: 'Temporary Variables' stamp: 'wbk 6/13/2004 12:16'!
basicTemps
	|t1 t2 t3 t4 t5 t6 t7 t8 t9 t10 t11 t12 t13 t14 t15 t16 t17 t18|
	t7 := 7.
	t8 := 8.
	t17 := 17.
	t18 := 18.
	^ t17 + t18.! !

!ExuperyInstanceVariables methodsFor: 'accessing' stamp: 'wbk 6/12/2004 18:18'!
i8
	^ i8 + 0! !

!ExuperyInstanceVariables methodsFor: 'accessing' stamp: 'wbk 6/12/2004 18:02'!
i18: anObject
	i18 := anObject! !

!ExuperyInstanceVariables methodsFor: 'Temporary Variables' stamp: 'wbk 6/13/2004 12:24'!
loadExtendedTemp
	|t1 t2 t3 t4 t5 t6 t7 t8 t9 t10 t11 t12 t13 t14 t15 t16 t17 t18|
	^ t17! !

!ExuperyInstanceVariables methodsFor: 'accessing' stamp: 'wbk 8/30/2003 20:28'!
b
	"Adding zero to avoid a primitive short-cut"
	^ b + 0! !

!ExuperyInstanceVariables methodsFor: 'accessing' stamp: 'wbk 6/12/2004 18:01'!
i16: anObject
	i16 := anObject! !

!ExuperyInstanceVariables methodsFor: 'accessing' stamp: 'wbk 11/22/2003 16:48'!
getB
	^ b! !

!ExuperyInstanceVariables methodsFor: 'accessing' stamp: 'wbk 11/22/2003 16:47'!
getA
	^ a! !

!ExuperyInstanceVariables methodsFor: 'Temporary Variables' stamp: 'wbk 6/13/2004 12:23'!
storeExtendedTemp
	|t1 t2 t3 t4 t5 t6 t7 t8 t9 t10 t11 t12 t13 t14 t15 t16 t17 t18|
	t17 := 17.! !

!ExuperyInstanceVariables methodsFor: 'accessing' stamp: 'wbk 6/12/2004 18:01'!
i17: anObject
	i17 := anObject! !

!ExuperyInstanceVariables methodsFor: 'accessing' stamp: 'wbk 6/12/2004 18:18'!
i8: anObject
	i8 := anObject.! !

!ExuperyInstanceVariables methodsFor: 'accessing' stamp: 'wbk 6/13/2004 13:43'!
storeInstanceExtended
 ^ true ifTrue: [i16:= 10].! !

!ExuperyInstanceVariables methodsFor: 'accessing' stamp: 'wbk 11/16/2003 17:51'!
a: firstObject b: secondObject
	a := firstObject.
	b := secondObject.
	^ 5 "Because Exupery doesn't handle returnSelf yet"! !

Object subclass: #EncodeFromLiteralToRegister
	instanceVariableNames: 'opcode assembler instruction'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery'!

!EncodeFromLiteralToRegister methodsFor: 'misc' stamp: 'wbk 4/18/2003 18:20'!
registerInstruction: anAssembleInstruction 
	instruction := anAssembleInstruction.
	assembler := instruction assembler.! !

!EncodeFromLiteralToRegister methodsFor: 'Encoding' stamp: 'wbk 4/7/2003 14:15'!
isFirable
	^ instruction arg2 isRegister & instruction arg1 isLiteral! !

!EncodeFromLiteralToRegister methodsFor: 'misc' stamp: 'wbk 4/18/2003 18:21'!
initializeOpcode: aSmallInteger
	opcode := aSmallInteger.
	^ self! !

!EncodeFromLiteralToRegister class methodsFor: 'as yet unclassified' stamp: 'wbk 4/18/2003 18:21'!
opcode: aSmallInteger
	^ self new
		initializeOpcode: aSmallInteger ! !

!EncodeFromLiteralToRegister methodsFor: 'Encoding' stamp: 'wbk 4/7/2003 14:18'!
fire
	assembler stream nextPut: opcode + (assembler registerEncoding: instruction arg2).
	assembler encodeImmediate: instruction arg1.! !

Object subclass: #InterferenceNode
	instanceVariableNames: 'register edges currentEdges colour isSelected isSpilled isMoveRelated currentMoves currentVersion registerCount'
	classVariableNames: 'CountCurrentEdges CountEdges'
	poolDictionaries: ''
	category: 'Exupery'!

!InterferenceNode methodsFor: 'misc' stamp: 'wbk 11/3/2002 12:25'!
markAsSpilled
	isSpilled := true.! !

!InterferenceNode methodsFor: 'misc' stamp: 'wbk 11/5/2002 16:54'!
currentEdgesDo: aBlock
	currentEdges do: aBlock! !

!InterferenceNode methodsFor: 'as yet unclassified' stamp: 'wbk 6/25/2004 23:36'!
edges
	^ edges! !

!InterferenceNode methodsFor: 'Move Coalescing' stamp: 'wbk 11/6/2002 17:09'!
currentMoves
	^ currentMoves! !

!InterferenceNode methodsFor: 'misc' stamp: 'wbk 11/5/2002 10:59'!
markAsMoveRelated
	isMoveRelated := true! !

!InterferenceNode methodsFor: 'misc' stamp: 'wbk 6/23/2004 22:16'!
createWorkingEdges
	currentEdges := edges asSet! !

!InterferenceNode class methodsFor: 'as yet unclassified' stamp: 'wbk 6/22/2004 23:15'!
initialize
	CountCurrentEdges := Dictionary new.
	CountEdges := Dictionary new.! !

!InterferenceNode methodsFor: 'misc' stamp: 'wbk 8/2/2004 21:07'!
registerCount
	^ registerCount! !

!InterferenceNode methodsFor: 'misc' stamp: 'wbk 6/28/2004 22:36'!
addInterferenceEdgesFrom: aNode
	aNode currentEdgesDo:
		[:each| currentEdges add: each.
		each addBackCurrentInterferenceEdge: self].
	edges := edges + aNode edges.
	aNode neighboursDo: 
		[:each| each addBackInterferenceEdge: self].! !

!InterferenceNode methodsFor: 'misc' stamp: 'wbk 5/17/2004 21:28'!
currentVersion: anInterferenceNode 
	anInterferenceNode = self currentVersion ifTrue: [^ self].
	currentVersion := anInterferenceNode! !

!InterferenceNode methodsFor: 'misc' stamp: 'wbk 6/25/2004 23:30'!
addEdgeTo: aRegister
	edges addNode: aRegister! !

!InterferenceNode methodsFor: 'misc' stamp: 'wbk 7/25/2004 16:34'!
isSimplified
	^ currentEdges class = Array! !

!InterferenceNode methodsFor: 'misc' stamp: 'wbk 10/23/2002 17:37'!
removeEdgeTo: aNode
	currentEdges remove: aNode! !

!InterferenceNode methodsFor: 'misc' stamp: 'wbk 8/2/2004 21:07'!
initializeFor: aRegister with: aMachine interferenceGraph: aGraph 
	register := aRegister.
	"edges := NodeLattice 
				newWith: aMachine
				interferenceGraph: aGraph.	"
	edges := NodeLattice new.
	isSelected := false.
	isSpilled := false.
	isMoveRelated := false.
	currentMoves := 0.
	registerCount := 0.
	^self! !

!InterferenceNode methodsFor: 'misc' stamp: 'wbk 10/23/2002 22:39'!
currentSize
	^ currentEdges size! !

!InterferenceNode methodsFor: 'misc' stamp: 'wbk 10/23/2002 18:14'!
colour: aRegister
	colour := aRegister! !

!InterferenceNode methodsFor: 'misc' stamp: 'wbk 6/26/2004 00:31'!
basicInterferesWith: aRegister 
	^ edges includesNode: aRegister! !

!InterferenceNode methodsFor: 'Move Coalescing' stamp: 'wbk 11/6/2002 17:13'!
incrementCurrentMoves
	currentMoves := currentMoves + 1! !

!InterferenceNode methodsFor: 'misc' stamp: 'wbk 11/5/2002 11:03'!
isMoveRelated
	^ isMoveRelated! !

!InterferenceNode methodsFor: 'misc' stamp: 'wbk 6/25/2004 23:47'!
addBackInterferenceEdge: aNode
	edges addNode: aNode.! !

!InterferenceNode methodsFor: 'misc' stamp: 'wbk 10/23/2002 18:14'!
register
	^ register! !

!InterferenceNode methodsFor: 'misc' stamp: 'wbk 11/2/2002 18:44'!
isSpilled
	^ isSpilled! !

!InterferenceNode methodsFor: 'misc' stamp: 'wbk 5/2/2004 18:12'!
colour
	register isMachineRegister ifTrue: [^ register].
	^ colour! !

!InterferenceNode methodsFor: 'Move Coalescing' stamp: 'wbk 5/22/2004 21:51'!
decrementCurrentMoves
	currentMoves := currentMoves - 1! !

!InterferenceNode methodsFor: 'misc' stamp: 'wbk 5/16/2004 17:26'!
currentVersion
	currentVersion ifNotNil: [^ currentVersion currentVersion].
	^ self! !

!InterferenceNode methodsFor: 'Unit Testing' stamp: 'wbk 10/23/2002 17:32'!
printOn: aStream
	aStream nextPutAll: 'Node ['.
	register printOn: aStream.
	aStream nextPut: $].! !

!InterferenceNode methodsFor: 'misc' stamp: 'wbk 5/2/2004 18:18'!
hasColour
	register isMachineRegister ifTrue: [^ true].
	^ colour isNil not! !

!InterferenceNode methodsFor: 'misc' stamp: 'wbk 11/5/2002 18:48'!
addBackCurrentInterferenceEdge: aNode
	currentEdges add: aNode.! !

!InterferenceNode methodsFor: 'misc' stamp: 'wbk 10/23/2002 20:43'!
isSelected
	^ isSelected! !

!InterferenceNode methodsFor: 'misc' stamp: 'wbk 5/15/2004 20:22'!
simplify
	currentEdges do: [:each | each removeEdgeTo: self].
	currentEdges := #().
	isSelected := true! !

!InterferenceNode methodsFor: 'misc' stamp: 'wbk 11/6/2002 13:36'!
currentEdges
	^ currentEdges ! !

!InterferenceNode methodsFor: 'misc' stamp: 'wbk 6/26/2004 00:26'!
neighboursDo: aBlock
	"Could be obselete soon"
	edges nodesDo: aBlock! !

!InterferenceNode methodsFor: 'Move Coalescing' stamp: 'wbk 11/6/2002 17:24'!
isCurrentlyInvolvedInMoves
	^ currentMoves > 0! !

!InterferenceNode methodsFor: 'misc' stamp: 'wbk 8/2/2004 21:22'!
incrementRegisterCount
	registerCount := registerCount + 1! !

!InterferenceNode methodsFor: 'misc' stamp: 'wbk 6/27/2004 22:08'!
index
	^ register index! !

!InterferenceNode methodsFor: 'misc' stamp: 'wbk 5/15/2004 15:20'!
interferesWith: aRegister 
	^ self currentVersion basicInterferesWith: aRegister currentVersion! !

!InterferenceNode methodsFor: 'misc' stamp: 'wbk 8/2/2004 21:53'!
spillWeight
	^ self currentSize - (registerCount / 100)! !

!InterferenceNode class methodsFor: 'instance creation' stamp: 'wbk 7/1/2004 21:12'!
for: aRegister with: aMachine interferenceGraph: aGraph
	^self new 
		initializeFor: aRegister
		with: aMachine
		interferenceGraph: aGraph! !

!InterferenceNode methodsFor: 'Move Coalescing' stamp: 'wbk 5/22/2004 21:59'!
incrementCurrentMovesBy: aSmallInteger 
	currentMoves := currentMoves + aSmallInteger! !

Object subclass: #MockIntermediateGenerator
	instanceVariableNames: 'byteCodes primitive stackString doEmitAddresses callList callPosition expectedTemporaries isTemporariesSet isCheckingSendRentry sendPosition rentryStack reentryPC stackSizeOnSend state'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Programmer Tests'!

!MockIntermediateGenerator methodsFor: 'Mocked Byte Codes' stamp: 'wbk 10/4/2003 19:42'!
pushSelf
	byteCodes add: { 
				#pushSelf}.
	^self check: { 
				#pushSelf}! !

!MockIntermediateGenerator methodsFor: 'Mocked Jumps' stamp: 'wbk 2/28/2004 16:07'!
unconditionalJumpTo: anInteger 
	byteCodes add: { 
				#jumpTo.
				anInteger}.
	^ self check: {#jumpTo. anInteger}.! !

!MockIntermediateGenerator methodsFor: 'Mocked Byte Codes' stamp: 'wbk 7/11/2003 22:36'!
addUnknownByteCode
	self error: 'Unknown bytecode'.! !

!MockIntermediateGenerator methodsFor: 'accessing' stamp: 'WBK 8/26/2002 18:23'!
numberOfBytecodes
	^ byteCodes size! !

!MockIntermediateGenerator methodsFor: 'Primitives' stamp: 'wbk 2/28/2004 16:09'!
pushNil
	byteCodes add: #pushNil.
	^self check: #(#pushNil)! !

!MockIntermediateGenerator methodsFor: 'Mocked Byte Codes' stamp: 'wbk 10/4/2003 19:42'!
pushTempAt: anInteger 
	byteCodes add: { 
				#pushTemp.
				anInteger}.
	^self check: { 
				#pushTemp.
				anInteger}! !

!MockIntermediateGenerator methodsFor: 'Comparision' stamp: 'wbk 1/14/2004 21:36'!
prim: anArray equals: anArray2 
	^ self check: {#equals. anArray. anArray2}! !

!MockIntermediateGenerator methodsFor: 'Arithmatic' stamp: 'wbk 2/8/2004 16:17'!
generate: anArray bitAnd: anArray2 
	^self check: { 
				#bitAnd.
				anArray.
				anArray2}! !

!MockIntermediateGenerator methodsFor: 'return bytecodes' stamp: 'wbk 10/18/2003 12:54'!
returnNil
	^ self check: #(returnNil)! !

!MockIntermediateGenerator methodsFor: 'misc' stamp: 'wbk 10/15/2002 14:41'!
recordByteCodeNumbers
	doEmitAddresses := true.! !

!MockIntermediateGenerator methodsFor: 'Mocked Jumps' stamp: 'wbk 2/14/2004 11:54'!
jumpIfTrue: anArray to: aSmallInteger 
	^ self check: {#jumpIfTrue. anArray. aSmallInteger}! !

!MockIntermediateGenerator methodsFor: 'Mocked Byte Codes' stamp: 'wbk 2/28/2004 15:35'!
jumpIfFalse: aMed to: anInteger 
	byteCodes add: { 
				#jumpFalse.
				anInteger}.
	^self check: { 
				#jumpFalse.
				aMed.
				anInteger}! !

!MockIntermediateGenerator methodsFor: 'Mocked Stack Registers' stamp: 'wbk 6/27/2004 22:56'!
emitter
	^ MockIntermediateEmitter newWith: MachineX86 new.! !

!MockIntermediateGenerator methodsFor: 'Mocked Arithmatic' stamp: 'wbk 2/5/2004 22:06'!
generate: anArray div: anArray2 
	^ self check: {#div. anArray. anArray2}! !

!MockIntermediateGenerator methodsFor: 'Checking Expected Calls' stamp: 'wbk 7/15/2003 13:09'!
checkStackSizeOnSend: aSmallInteger 
	stackSizeOnSend := aSmallInteger! !

!MockIntermediateGenerator methodsFor: 'Primitives' stamp: 'wbk 10/4/2003 19:42'!
sendAtTo: anArray with: anArray2 
	^self check: { 
				'sendAt'.
				anArray.
				anArray2}! !

!MockIntermediateGenerator methodsFor: 'Checking Expected Calls' stamp: 'wbk 10/4/2003 19:42'!
check: anArray 
	| rightAnswer |
	callList isNil ifTrue: [^anArray].
	rightAnswer := self nextCall.
	rightAnswer = anArray ifFalse: [self failure].
	^anArray! !

!MockIntermediateGenerator methodsFor: 'misc' stamp: 'wbk 7/4/2003 12:17'!
assert: aBoolean
	aBoolean ifFalse: [TestResult failure sunitSignalWith: 'Assertion Failed']! !

!MockIntermediateGenerator methodsFor: 'Comparision' stamp: 'wbk 1/17/2004 22:13'!
prim: firstObject lessThanEquals: secondObject 
	byteCodes add: 'sendLessThanEquals'.
	^self check: { 
				#sendLessThanEquals.
				firstObject.
				secondObject}! !

!MockIntermediateGenerator methodsFor: 'Misc Mocked Methods' stamp: 'wbk 7/6/2003 20:17'!
finish
! !

!MockIntermediateGenerator methodsFor: 'return bytecodes' stamp: 'wbk 11/27/2003 21:20'!
returnFalse
	self check: #(returnFalse)! !

!MockIntermediateGenerator methodsFor: 'Primitives' stamp: 'wbk 6/13/2004 16:05'!
storeAndPopReceiverVariableIndex: aSymbol value: aSymbol2 
	byteCodes add: {#storeIntoReceiver. aSymbol}.
	self check: { 
				#storeAndPopReceiverVariable.
				aSymbol.
				aSymbol2}! !

!MockIntermediateGenerator methodsFor: 'Primitives' stamp: 'wbk 10/4/2003 19:42'!
pushInstanceVariable: aSmallInteger 
	^self check: { 
				#pushInstanceVariable.
				aSmallInteger}! !

!MockIntermediateGenerator methodsFor: 'Checking Expected Calls' stamp: 'wbk 10/20/2002 16:19'!
createExpectedCall: anArray
	2
		to: anArray size
		do:
			[:each| ((anArray at: each) isString | (anArray at: each) isNumber) not ifTrue: 
				[self createExpectedCall: (anArray at: each)]].
	callList addLast: anArray! !

!MockIntermediateGenerator methodsFor: 'Mocked Common Sends' stamp: 'wbk 2/22/2004 13:28'!
generateUnarySelector: aSmallInteger receiver: anArray 
	^ self check: {#sendUnarySelector. aSmallInteger. anArray}! !

!MockIntermediateGenerator methodsFor: 'Mocked Common Sends' stamp: 'wbk 3/1/2004 19:48'!
generateClass: anArray 
	^ self check: {#class. anArray}! !

!MockIntermediateGenerator methodsFor: 'Mocked Byte Codes' stamp: 'wbk 2/22/2004 16:36'!
generateBinarySelector: anObject receiver: receiverMed argument: argumentMed 
	stackSizeOnSend ifNotNil: [self assert: state stackSize = stackSizeOnSend].
	^self check: { 
				#binarySendWithSpecialSelector.
				anObject.
				receiverMed.
				argumentMed}! !

!MockIntermediateGenerator methodsFor: 'accessing' stamp: 'WBK 8/26/2002 18:40'!
primitiveNumber
	^ primitive! !

!MockIntermediateGenerator methodsFor: 'Arithmatic' stamp: 'wbk 2/8/2004 16:18'!
generate: anArray divide: anArray2 
	^self check: { 
				#divide.
				anArray.
				anArray2}! !

!MockIntermediateGenerator methodsFor: 'Checking Expected Calls' stamp: 'wbk 10/20/2002 16:25'!
setExpectedBytecodes: anArray
	callPosition := 1.
	callList := OrderedCollection new.
	anArray do: [:each| self createExpectedCall: each].! !

!MockIntermediateGenerator methodsFor: 'Comparision' stamp: 'wbk 2/8/2004 16:19'!
generate: firstObject multiply: secondObject 
	byteCodes add: 'sendMultiply'.
	^self check: { 
				#sendMultiply.
				firstObject.
				secondObject}! !

!MockIntermediateGenerator methodsFor: 'misc' stamp: 'wbk 7/29/2003 12:10'!
state: anExuperyStack 
	state := anExuperyStack
	! !

!MockIntermediateGenerator methodsFor: 'misc' stamp: 'wbk 10/18/2003 13:48'!
verify
	expectedTemporaries ifNotNil: [self assert: isTemporariesSet].
	isCheckingSendRentry ifTrue: [self assert: sendPosition isNil].
	callList ifNotNil: [self assert: callList size + 1 = callPosition]! !

!MockIntermediateGenerator methodsFor: 'Comparision' stamp: 'wbk 2/8/2004 16:20'!
generate: firstObject subtract: secondObject 
	byteCodes add: 'sendMultiply'.
	^self check: { 
				#sendMinus.
				firstObject.
				secondObject}! !

!MockIntermediateGenerator methodsFor: 'Comparision' stamp: 'wbk 1/6/2004 23:21'!
prim: anArray lessThan: anArray2 
	^ self check: {#lessThan. anArray. anArray2}! !

!MockIntermediateGenerator methodsFor: 'Mocked Byte Codes' stamp: 'wbk 6/13/2004 15:59'!
pushTrue
	byteCodes add: 'pushTrue'.
	^self check: { 
				#pushTrue}! !

!MockIntermediateGenerator methodsFor: 'misc' stamp: 'wbk 6/13/2004 16:00'!
pushFalse
	byteCodes add: 'pushFalse'.
	^self check: #(#pushFalse)! !

!MockIntermediateGenerator methodsFor: 'Primitives' stamp: 'wbk 10/4/2003 19:42'!
sendAtPutTo: anArray location: anArray2 value: anArray22 
	^self check: { 
				#sendAtPut.
				anArray.
				anArray2.
				anArray22}! !

!MockIntermediateGenerator methodsFor: 'Primitives' stamp: 'wbk 10/4/2003 19:42'!
popStack: aMed 
	^self check: { 
				#popStack.
				aMed}! !

!MockIntermediateGenerator methodsFor: 'accessing' stamp: 'WBK 8/26/2002 20:12'!
byteCodeString
	|answer|
	answer := ''.
	byteCodes do: [:each| each isString 
		ifTrue: [answer := answer , ' ', each]
		ifFalse: [answer := answer, ' ', (each at: 1), ' ', (each at: 2) asString]].
	^ answer 
		copyFrom: 2 
		to: answer size! !

!MockIntermediateGenerator methodsFor: 'Mocked Arithmatic' stamp: 'wbk 2/5/2004 20:44'!
generate: anArray bitOr: anArray2 
	^ self check: {#bitOr. anArray. anArray2}! !

!MockIntermediateGenerator methodsFor: 'Checking Expected Calls' stamp: 'wbk 7/4/2003 12:11'!
setExpectedTemporaries: aSmallInteger 
	expectedTemporaries := aSmallInteger! !

!MockIntermediateGenerator methodsFor: 'Mocked Byte Codes' stamp: 'wbk 10/4/2003 19:42'!
popIntoTemp: aValue slot: anInteger 
	byteCodes add: { 
				#popIntoTemp.
				anInteger}.
	self check: { 
				#popIntoTemp.
				anInteger.
				aValue}! !

!MockIntermediateGenerator methodsFor: 'return bytecodes' stamp: 'wbk 11/27/2003 19:49'!
returnTrue
	^ self check: #(returnTrue)! !

!MockIntermediateGenerator methodsFor: 'accessing' stamp: 'WBK 8/26/2002 21:57'!
stackString
	^ stackString
! !

!MockIntermediateGenerator methodsFor: 'return bytecodes' stamp: 'wbk 10/4/2003 19:42'!
returnSelf
	byteCodes add: 'returnSelf'.
	self check: { 
				#returnSelf}! !

!MockIntermediateGenerator methodsFor: 'Comparision' stamp: 'wbk 1/12/2004 21:50'!
prim: anArray greaterThan: anArray2 
	^ self check: {#greaterThan. anArray. anArray2}! !

!MockIntermediateGenerator class methodsFor: 'instance creation' stamp: 'WBK 8/26/2002 18:19'!
new
	^ super new initialize! !

!MockIntermediateGenerator methodsFor: 'Mocked Byte Codes' stamp: 'wbk 10/4/2003 19:42'!
pushConstant: aLiteral slot: aNumber 
	byteCodes add: { 
				'pushConstant'.
				aLiteral}.
	^self check: { 
				#pushConstant.
				aLiteral}! !

!MockIntermediateGenerator methodsFor: 'Arithmatic' stamp: 'wbk 2/8/2004 16:17'!
generate: firstObject add: secondObject 
	byteCodes add: 'sendPlus'.
	^self check: { 
				#sendPlus.
				firstObject.
				secondObject}! !

!MockIntermediateGenerator methodsFor: 'Comparision' stamp: 'wbk 1/14/2004 21:19'!
prim: anArray greaterThanEqual: anArray2 
	^ self check: {#greaterThanEqual. anArray. anArray2}! !

!MockIntermediateGenerator methodsFor: 'Mocked Arithmatic' stamp: 'wbk 2/7/2004 20:36'!
generate: anArray mod: anArray2 
	^ self check: {#mod.  anArray.  anArray2}! !

!MockIntermediateGenerator methodsFor: 'Mocked Arithmatic' stamp: 'wbk 2/27/2004 21:25'!
generate: anArray equivilent: anArray2 
	^ self check: {#equivilent. anArray. anArray2}! !

!MockIntermediateGenerator methodsFor: 'Mocked Byte Codes' stamp: 'wbk 10/15/2002 14:38'!
byteCodeAddress: anInteger
	doEmitAddresses ifTrue: [byteCodes add: {#byteCode. anInteger}]! !

!MockIntermediateGenerator methodsFor: 'Misc Mocked Methods' stamp: 'wbk 7/4/2003 12:20'!
numberOfTemporaries: anInteger
	expectedTemporaries ifNil: [^ self].
	self assert: anInteger = expectedTemporaries.
	isTemporariesSet := true.! !

!MockIntermediateGenerator methodsFor: 'Comparision' stamp: 'wbk 1/17/2004 19:04'!
prim: anArray notEquals: anArray2 
	^ self check: {#notEquals. anArray. anArray2}! !

!MockIntermediateGenerator methodsFor: 'Primitives' stamp: 'WBK 8/26/2002 18:39'!
setPrimitive: anInteger
	primitive := anInteger! !

!MockIntermediateGenerator methodsFor: 'Checking Expected Calls' stamp: 'wbk 10/20/2002 16:17'!
nextCall
	| answer |
	answer := callList at: callPosition.
	callPosition := callPosition + 1.
	^ answer! !

!MockIntermediateGenerator methodsFor: 'Mocked Common Sends' stamp: 'wbk 2/13/2004 20:30'!
generate: anArray makePoint: anArray2 
	^ self check: {#makePoint. anArray. anArray2}! !

!MockIntermediateGenerator methodsFor: 'Mocked Byte Codes' stamp: 'wbk 10/4/2003 19:42'!
sendSelector: aSymbol inSlot: selectorInteger arguments: someArguments 
	| answer |
	stackSizeOnSend ifNotNil: [self assert: state stackSize = stackSizeOnSend].
	answer := { 
				#send.
				aSymbol} asOrderedCollection.
	"aStack size - argumentInteger to: aStack size
		do: [:each | answer addLast: (aStack at: each)]."
	someArguments do: [:each | answer addLast: each].
	byteCodes add: answer.
	isCheckingSendRentry ifTrue: [sendPosition := callPosition].
	^self check: answer asArray! !

!MockIntermediateGenerator methodsFor: 'return bytecodes' stamp: 'wbk 10/4/2003 19:42'!
returnTop: anObject 
	byteCodes add: 'returnTop'.
	^self check: { 
				#returnTop.
				anObject}! !

!MockIntermediateGenerator methodsFor: 'Mocked Common Sends' stamp: 'wbk 2/14/2004 15:21'!
generateNew: anArray 
	^ self check: {#sendNew. anArray}! !

!MockIntermediateGenerator methodsFor: 'Checking Expected Calls' stamp: 'wbk 10/20/2002 16:34'!
failure
	TestResult failure sunitSignalWith: 'Assertion Failed'! !

!MockIntermediateGenerator methodsFor: 'misc' stamp: 'wbk 7/6/2003 17:13'!
initialize
	byteCodes := OrderedCollection new.
	stackString := ''.
	doEmitAddresses := false.
	primitive := 0.
	isTemporariesSet := false.
	isCheckingSendRentry := false.! !

!MockIntermediateGenerator methodsFor: 'Mocked Byte Codes' stamp: 'wbk 10/4/2003 19:42'!
pushLiteralVariable: aReadOnlyVariableBinding slot: aSmallInteger 
	byteCodes add: { 
				'pushLiteralVariable'.
				aSmallInteger}.
	^self check: { 
				#pushLiteralVariable.
				aSmallInteger}! !

!MockIntermediateGenerator methodsFor: 'Mocked Arithmatic' stamp: 'wbk 2/8/2004 19:09'!
generate: anArray bitShift: anArray2 
	^ self check: {#bitShift. anArray. anArray2}! !

Object subclass: #IntermediateEmitter
	instanceVariableNames: 'currentBlock method machine jumpTargets numberOfTemporaries entryPoints emitter stack'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery'!

!IntermediateEmitter methodsFor: 'Emit - Memory Access' stamp: 'wbk 11/20/2003 23:59'!
emitRootTableAddress
	^ MedLiteral literal: #rootTable! !

!IntermediateEmitter methodsFor: 'Emit - Memory Access' stamp: 'wbk 3/17/2003 16:38'!
emitIncrementStackPtrFor: aContext
	|newStackPtr instr2 instr3 |
	newStackPtr := machine createTemporaryRegister.
	instr2 := MedMov
		from: (MedArithmatic
			operator: #add
			arg1: (MedMem address: (MedArithmatic
				operator: #add
				arg1: aContext
				arg2: (MedLiteral literal: 12))) 
			arg2: (MedLiteral literal: 2))
		to: newStackPtr.
	currentBlock add: instr2.
	instr3 := MedMov
		from: newStackPtr
		to: (MedMem address: (MedArithmatic
			operator: #add
			arg1: aContext
			arg2: (MedLiteral literal: 12))).
	currentBlock add: instr3.
	^ newStackPtr! !

!IntermediateEmitter methodsFor: 'Emit - Arithmatic' stamp: 'wbk 11/21/2003 00:01'!
emit: aSmallInteger sal: aMedTemporaryRegister 
	^ MedArithmatic
		operator: #sal
		arg1: aSmallInteger
		arg2: aMedTemporaryRegister! !

!IntermediateEmitter methodsFor: 'Emit - Type Tags' stamp: 'wbk 1/8/2004 22:32'!
emitConvertComparisionToBoolean: aMed jumpType: aSymbol 
	| answer falseLabel nextLabel |
	answer := machine createTemporaryRegister.
	falseLabel := method newBlock.
	nextLabel := method newBlock.
	currentBlock add: (MedJump 
				type: aSymbol
				block: falseLabel
				instruction: aMed).
	currentBlock add: (MedMov 
				from: self emitTrueAddress
				to: answer).
	currentBlock add: (MedJump 
				type: #jmp
				block: nextLabel).
	falseLabel add: (MedMov 
				from: (MedMem address: (MedLiteral literal: #falseObj))
				to: answer).
	falseLabel add: (MedJump 
				type: #jmp
				block: nextLabel).
	currentBlock := nextLabel.
	^answer! !

!IntermediateEmitter methodsFor: 'Emit - Memory Access' stamp: 'wbk 11/20/2003 23:38'!
emitRootTableCountAddress
	^ MedLiteral literal: #rootTableCount! !

!IntermediateEmitter methodsFor: 'Emit - Sends and Return' stamp: 'wbk 7/24/2004 10:43'!
emitReloadStack: aStack
	| currentContext stackPosition|
	currentContext := self emitCurrentContextRegister.
	stackPosition := 0.
	aStack do: 
			[:each | 
			currentBlock add: (MedMov 
				from: (self 
					emitStackAddressAt: stackPosition 
					context: currentContext)
				to: each).
			stackPosition := stackPosition + 1]! !

!IntermediateEmitter methodsFor: 'Emit - Jump Bytecodes' stamp: 'wbk 5/30/2004 22:45'!
emitJumpTarget: anInteger
	| targetLabel |
	targetLabel := jumpTargets at: anInteger.
	currentBlock add: (MedJump
		type: #jmp
		target: targetLabel). 
	currentBlock := targetLabel! !

!IntermediateEmitter methodsFor: 'Emit - Addresses' stamp: 'wbk 1/31/2003 16:48'!
emitSendersContext
	|sendersContext instr1 |
	sendersContext := machine createTemporaryRegister.
	instr1 := MedMov
		from: (MedMem address: 
			(MedArithmatic
				operator: #add
				arg1: (machine currentContext)
				arg2: (MedLiteral literal: 4)))
		to: sendersContext.
	currentBlock add: instr1.
	^ sendersContext! !

!IntermediateEmitter methodsFor: 'Emit - Misc' stamp: 'wbk 10/17/2002 22:48'!
emitPopIntoTemp: aMed slot: anInteger
	currentBlock add:  (MedMov
		from: aMed
		to: (self emitTemporaryAddress: anInteger))! !

!IntermediateEmitter methodsFor: 'Emit - Arithmatic' stamp: 'wbk 11/21/2003 00:03'!
emit: aMedTemporaryRegister or: aLargePositiveInteger 
	^ MedArithmatic
		operator: #or
		arg1: aMedTemporaryRegister
		arg2: aLargePositiveInteger! !

!IntermediateEmitter methodsFor: 'Emit - Arithmatic' stamp: 'wbk 3/7/2004 23:33'!
emit: firstMed multiply: secondMed failTo: aLabel 
	^MedJump 
		type: #jo
		target: aLabel
		instruction: (MedArithmatic 
				operator: #mul
				arg1: firstMed
				arg2: secondMed)! !

!IntermediateEmitter methodsFor: 'Emit - Sends and Return' stamp: 'wbk 10/18/2003 11:35'!
emitReturnValue: aMed
	| sendersContext newStackPtr |
	sendersContext := emitter emitSendersContext.
	newStackPtr := emitter emitIncrementStackPtrFor: sendersContext.
	emitter 
		emitStackFor: sendersContext
		at: newStackPtr
		put: aMed.
	emitter emitMoveToEax: (MedLiteral literal: 1).
	emitter emitRet.
	^aMed! !

!IntermediateEmitter methodsFor: 'Emit - Addresses' stamp: 'wbk 7/6/2003 17:59'!
emitStackAddressAt: stackPosition context: currentContext 
	^MedMem address: (MedArithmatic 
				operator: #add
				arg1: currentContext
				arg2: (MedLiteral 
						literal: 28 + (stackPosition * 4) + (numberOfTemporaries * 4)))! !

!IntermediateEmitter methodsFor: 'Emit - Addresses' stamp: 'wbk 7/19/2003 21:59'!
emitTrueAddress
	^MedMem address: (MedLiteral literal: #trueObj)! !

!IntermediateEmitter methodsFor: 'Emit - Memory Access' stamp: 'wbk 7/2/2003 13:02'!
emitCurrentContextsStack
	^MedMem address: (MedArithmatic 
				operator: #add
				arg1: machine currentContext
				arg2: (MedLiteral literal: 4 * 3))! !

!IntermediateEmitter methodsFor: 'Emit - Addresses' stamp: 'wbk 9/29/2003 20:44'!
emitReceiver
	self shouldBeImplemented! !

!IntermediateEmitter methodsFor: 'misc' stamp: 'wbk 10/14/2002 14:04'!
machine
	^ machine! !

!IntermediateEmitter methodsFor: 'Emit - Addresses' stamp: 'wbk 10/4/2003 20:18'!
emitNilAddress
	^ MedMem address: (MedLiteral literal: #nilObj)! !

!IntermediateEmitter methodsFor: 'Emit - Addresses' stamp: 'wbk 7/30/2003 18:51'!
emitFalseAddress
	^ MedMem address: (MedLiteral literal: #falseObj)! !

!IntermediateEmitter methodsFor: 'Emit - Sends and Return' stamp: 'wbk 2/15/2004 12:18'!
emitSpecialObject: anObject 
	^emitter 
		emitFetchAddress: (MedLiteral literal: anObject)
		ofObject: (emitter emitMem: (MedLiteral literal: #specialObjectsOop))! !

!IntermediateEmitter methodsFor: 'Emit - Type Tags' stamp: 'wbk 8/8/2003 18:26'!
emitCheckIsNotInteger: aMedMem failTo: aMedBlock 
	| check |
	check := MedJump 
				type: #jnz
				block: aMedBlock
				instruction: (MedArithmatic 
						operator: #and
						arg1: (MedLiteral literal: 1)
						arg2: aMedMem).
	currentBlock add: check! !

!IntermediateEmitter methodsFor: 'Emit - Division' stamp: 'wbk 2/8/2004 16:14'!
emitDiv: firstMed with: secondMed failTo: aMedBlock 
	| result remander nextBlock |
	result := machine createTemporaryRegister.
	remander := machine createTemporaryRegister.
	nextBlock := emitter newBlock.
	self 
		emitDivide: firstMed
		by: secondMed
		into: result
		remainder: remander
		failingTo: aMedBlock.
	self 
		emitCheckRoundingNeedsAdjustingFor: result
		remainder: remander
		failingTo: nextBlock.
	self 
		emitMoveFrom: (self 
			emit: result
			minus: (MedLiteral literal: 1))
		to: result.
	self emitUnconditionalJumpTo: nextBlock.
	self currentBlock: nextBlock.
	^result! !

!IntermediateEmitter methodsFor: 'Emit - Addresses' stamp: 'wbk 3/7/2004 11:55'!
emitLiteralAddress: aNumber 
	| compiledMethod field |
	compiledMethod := MedMem address: (MedArithmatic 
		operator: #add
		arg1: machine currentContext
		arg2: (MedLiteral literal: 16)).
	field := MedLiteral literal: aNumber + 1.	"Add the method header"
	^self 
		emitFetchAddress: field 
		ofObject: compiledMethod	"4 is object header"! !

!IntermediateEmitter methodsFor: 'Emit - Memory Access' stamp: 'wbk 7/6/2003 17:57'!
emitCurrentContextRegister
	| currentContext |
	currentContext := machine createTemporaryRegister.
	currentBlock add: (MedMov from: machine currentContext to: currentContext).
	^currentContext! !

!IntermediateEmitter methodsFor: 'Emit - Sends and Return' stamp: 'wbk 7/6/2003 19:14'!
emitRestoreContextWithPC: aSmallInteger stack: aStack 
	| currentContext stackPosition |
	currentBlock add: (MedMov from: (MedLiteral smallInteger: aSmallInteger)
				to: self emitCurrentContextsPC).
	currentBlock add: (MedMov 
				from: (MedLiteral smallInteger: aStack size + numberOfTemporaries)
				to: self emitCurrentContextsStack).
	currentContext := self emitCurrentContextRegister.
	stackPosition := 0.
	aStack do: 
			[:each | 
			currentBlock add: (MedMov 
				from: each
				to: (self 
					emitStackAddressAt: stackPosition 
					context: currentContext)).
			stackPosition := stackPosition + 1]! !

!IntermediateEmitter methodsFor: 'misc' stamp: 'wbk 8/8/2003 22:26'!
currentBlock: aMedBlock 
	currentBlock := aMedBlock! !

!IntermediateEmitter methodsFor: 'Emit - Sends and Return' stamp: 'wbk 6/14/2004 18:48'!
state: anExuperyStack 
	stack := anExuperyStack! !

!IntermediateEmitter methodsFor: 'Emit - Division' stamp: 'wbk 2/8/2004 16:11'!
emitDivide: firstMed with: secondMed failTo: aMedBlock 
	| result remander |
	result := machine createTemporaryRegister.
	remander := machine createTemporaryRegister.
	self 
		emitDivide: firstMed
		by: secondMed
		into: result
		remainder: remander
		failingTo: aMedBlock.
	self 
		emitIfNotZero: remander
		jumpTo: aMedBlock.
	^result! !

!IntermediateEmitter methodsFor: 'Emit - Arithmatic' stamp: 'wbk 3/6/2004 21:09'!
emit: firstMed minus: secondMed
	^ MedArithmatic
		operator: #sub
		arg1: firstMed
		arg2: secondMed! !

!IntermediateEmitter methodsFor: 'Emit - Low Level Moves' stamp: 'wbk 7/12/2003 21:25'!
emitMoveFrom: aMedMem to: aMedTemporaryRegister 
	currentBlock add: (MedMov
		from: aMedMem
		to: aMedTemporaryRegister)! !

!IntermediateEmitter methodsFor: 'Emit - Addresses' stamp: 'wbk 11/8/2002 17:47'!
emitTemporaryAddress: anInteger
	^ MedMem address: (MedArithmatic
			operator: #add
			arg1: (machine currentContext)
			arg2: (MedLiteral literal: 4 * ( 7 + anInteger)))! !

!IntermediateEmitter methodsFor: 'Emit - Memory Access' stamp: 'wbk 3/6/2004 18:56'!
emitBeRoot: parentObject ifNeededBy: childObject 
	| nextBlock header rootTableCount |
	nextBlock := emitter newBlock.
	emitter 
		emitCheckIsNotInteger: childObject
		failTo: nextBlock.
	emitter addExpression: (emitter 
				jumpType: #jl
				to: nextBlock
				dependingOn: (emitter 
						emit: childObject
						minus: (emitter emitMem: emitter emitYoungStartAddress))).
	emitter addExpression: (emitter 
				jumpType: #jge
				to: nextBlock
				dependingOn: (emitter 
						emit: parentObject
						minus: (emitter emitMem: emitter emitYoungStartAddress))).
	header := emitter createTemporaryRegister.
	emitter 
		emitMoveFrom: (emitter emitMem: parentObject)
		to: header.
	emitter addExpression: (emitter 
				jumpType: #jnz
				to: nextBlock
				dependingOn: (emitter 
						emit: header
						and: (MedLiteral literal: 16r40000000) "root flag in header")).
	rootTableCount := emitter createTemporaryRegister.
	emitter 
		emitMoveFrom: (emitter 
				emit: (MedLiteral literal: 1)
				add: (emitter emitMem: emitter emitRootTableCountAddress))
		to: rootTableCount.
	emitter
		emitMoveFrom: rootTableCount
		to: (emitter emitMem: (emitter emitRootTableCountAddress)).
	emitter
		emitMoveFrom: parentObject
		to: (emitter emitMem: (emitter
			emit: (emitter emitRootTableAddress)
			add: (emitter 
				emit: rootTableCount
				sal: (MedLiteral literal: 2) ))).
	emitter
		emitMoveFrom: (emitter 
			emit: header
			or: (MedLiteral literal: 16r40000000))
		to: (emitter emitMem: parentObject).

	emitter emitUnconditionalJumpTo: nextBlock.

	emitter currentBlock: nextBlock! !

!IntermediateEmitter methodsFor: 'misc' stamp: 'wbk 10/14/2002 13:54'!
newBlock
	^ method newBlock! !

!IntermediateEmitter methodsFor: 'Emit - Low level Jumps' stamp: 'wbk 2/15/2004 13:05'!
emitJumpTo: labelMed if: booleanMed equals: anObject 
	emitter addExpression: (emitter 
				jumpType: #je
				to: labelMed
				dependingOn: (emitter 
						emit: booleanMed
						minus: anObject))! !

!IntermediateEmitter methodsFor: 'Emit - Sends and Return' stamp: 'wbk 2/15/2004 12:18'!
emitSpecialSelector: aSmallInteger 
	^emitter 
		emitFetchAddress: (MedLiteral literal: aSmallInteger * 2)
		ofObject: (self emitSpecialObject: 23)! !

!IntermediateEmitter methodsFor: 'Emit - Memory Access' stamp: 'wbk 3/6/2004 18:59'!
emitAtCacheEntryEntry: anInteger index: aMed 
	^MedMem address: (MedArithmatic 
				operator: #add
				arg1: (MedLiteral literal: #atCache)
				arg2: (MedArithmatic 
						operator: #sal
						arg1: (MedArithmatic 
								operator: #add
								arg1: (MedLiteral literal: anInteger)
								arg2: aMed)
						arg2: (MedLiteral literal: 2)))! !

!IntermediateEmitter methodsFor: 'Emit - Addresses' stamp: 'wbk 3/7/2004 11:54'!
emitCurrentContextsPC
	^ MedMem address: (MedArithmatic 
		operator: #add
		arg1: machine currentContext
		arg2: (MedLiteral literal: 4 * 2))! !

!IntermediateEmitter methodsFor: 'Emit - Jump Bytecodes' stamp: 'wbk 1/10/2004 13:00'!
emitConditionalBytecodeArg1: firstMed arg2: secondMed withJump: aSymbol failureSelector: aNumber
	| subtract |
	^emitter 
		emitWithFailTo: 
			[:overflowBlock | 
			subtract := emitter 
						emit: (emitter 
								emitIntegerValueOf: firstMed
								failTo: overflowBlock)
						minus: (emitter 
								emitIntegerValueOf: secondMed
								failTo: overflowBlock).
			emitter 
				emitConvertComparisionToBoolean: subtract
				jumpType: aSymbol]
		failureSpecialSelector: aNumber
		arguments: { 
				firstMed.
				secondMed}! !

!IntermediateEmitter methodsFor: 'misc' stamp: 'wbk 10/14/2002 13:24'!
method
	^ method! !

!IntermediateEmitter methodsFor: 'Emit - Low Level Moves' stamp: 'wbk 6/30/2003 21:48'!
emitMoveToEax: aMedLiteral 
	currentBlock add: (MedMov
		from: aMedLiteral
		to: (machine registerNamed: #eax))! !

!IntermediateEmitter methodsFor: 'Emit - Sends and Return' stamp: 'wbk 7/24/2004 11:00'!
createProlog
	| prolog  pc address |
	prolog := method prolog.
	currentBlock := prolog.
	"Load the current context, or get the context into registers"
	emitter 
		emitMoveFrom: 
			(MedMem address: (MedArithmatic
				operator: #add
				arg1: (machine machineRegister: #ebp)
				arg2: (MedLiteral literal: 8)))
		to: machine currentContext.
	"Add any entry points needed"
	entryPoints isEmpty ifTrue: [^ self].
	pc := machine createTemporaryRegister.
    	currentBlock add: (MedMov
		from: self emitCurrentContextsPC
		to: pc).
	entryPoints do: 
		[:each|
		address := machine createTemporaryRegister.
		currentBlock add: (MedMov
			from: each address
			to: address).
		currentBlock add: (MedJump
			type: #jz
			block: each label
			instruction: (MedArithmatic
				operator: #sub
				arg1: address
				arg2: pc))].! !

!IntermediateEmitter methodsFor: 'Emit - Division' stamp: 'wbk 2/8/2004 16:14'!
emitMod: firstMed with: secondMed failTo: aMedBlock 
	| result remander nextBlock |
	result := machine createTemporaryRegister.
	remander := machine createTemporaryRegister.
	nextBlock := emitter newBlock.
	self 
		emitDivide: firstMed
		by: secondMed
		into: result
		remainder: remander
		failingTo: aMedBlock.
	self 
		emitCheckRoundingNeedsAdjustingFor: result
		remainder: remander
		failingTo: nextBlock.
	self 
		emitMoveFrom: (self 
			emit: remander
			add: secondMed)
		to: remander.
	self emitUnconditionalJumpTo: nextBlock.
	emitter currentBlock: nextBlock.
	^ remander! !

!IntermediateEmitter methodsFor: 'Emit - Memory Access' stamp: 'wbk 3/7/2004 23:33'!
emitAtElementAddressFor: objectMed with: indexMed failTo: aMedBlock cacheOffset: anObject 
	| atIndex |
	emitter 
		emitCheckIsNotInteger: objectMed
		failTo: aMedBlock.
	emitter 
		emitCheckIsInteger: indexMed
		failTo: aMedBlock.
	atIndex := emitter machine createTemporaryRegister.
	emitter 
		emitMoveFrom: (emitter 
				emit: (emitter 
						emit: objectMed
						and: (MedLiteral literal: 28))
				add: (MedLiteral literal: anObject))
		to: atIndex.
	emitter addExpression: (emitter 
				jumpType: #jnz
				to: aMedBlock
				dependingOn: (emitter 
						emit: objectMed
						minus: (emitter 
								emitAtCacheEntryEntry: 1
								index: atIndex))).
	emitter addExpression: (emitter 
				jumpType: #jl
				to: aMedBlock
				dependingOn: (emitter 
						emit: (emitter 
								emitAtCacheEntryEntry: 2
								index: atIndex)
						minus: (emitter 
								emit: indexMed
								sar: (MedLiteral literal: 1)))).
	emitter addExpression: (emitter 
				jumpType: #jg
				to: aMedBlock
				dependingOn: (emitter 
						emit: (emitter 
								emitAtCacheEntryEntry: 3
								index: atIndex)
						minus: (MedLiteral literal: 4))).
	^emitter 
		emitFetchVariableAddress: (emitter 
				emit: (emitter 
						emit: (emitter 
								emit: indexMed
								sar: (MedLiteral literal: 1))
						add: (emitter 
								emitAtCacheEntryEntry: 4
								index: atIndex))
				minus: (MedLiteral literal: 1))
		ofObject: objectMed! !

!IntermediateEmitter methodsFor: 'Emit Intermediate' stamp: 'wbk 10/13/2003 22:18'!
emitWithFailTo: aBlock failureSpecialSelector: aNumber arguments: someObjects 
	| overflowBlock answer nextBlock |
	overflowBlock := emitter newBlock.
	nextBlock := emitter newBlock.
	answer := emitter machine createTemporaryRegister.
	emitter 
		emitMoveFrom: (aBlock value: overflowBlock)
		to: answer.
	emitter emitUnconditionalJumpTo: nextBlock.
	emitter currentBlock: overflowBlock.
	emitter 
		emitMoveFrom: (emitter 
				emitSendSelector: (emitter emitSpecialSelector: aNumber)
				arguments: someObjects)
		to: answer.
	emitter emitUnconditionalJumpTo: nextBlock.
	emitter currentBlock: nextBlock.
	^answer! !

!IntermediateEmitter methodsFor: 'Emit - Sends and Return' stamp: 'wbk 7/14/2003 14:31'!
emitSetUpMessageSendFor: aMedMem argumentCount: aSmallInteger2 
	| functionAddress |
	currentBlock add: (MedPush argument: aSmallInteger2).
	currentBlock add: (MedPush argument: aMedMem).
	functionAddress := machine createTemporaryRegister.
	currentBlock add: (MedMov 
				from: (machine addressOf: (MedLiteral literal: #exuperySetupMessageSend))
				to: functionAddress).
	currentBlock add: (MedCall function: functionAddress).
	currentBlock 
		add: (MedMov 
			from: (MedArithmatic 
				operator: #add
				arg1: (MedLiteral literal: 8)
				arg2: (machine registerNamed: #esp))
			to: (machine registerNamed: #esp))! !

!IntermediateEmitter methodsFor: 'Emit - Jump Bytecodes' stamp: 'wbk 2/15/2004 13:06'!
emitConditionalJumpTo: labelMed onBoolean: booleanMed ifBooleanIs: anObject OrFailIfBooleanNot: anObject1 
	| notBooleanBlock nextBlock |
	notBooleanBlock := emitter newBlock.
	nextBlock := emitter newBlock.
	self 
		emitJumpTo: labelMed
		if: booleanMed
		equals: (emitter emitMem: (MedLiteral literal: anObject)).
	self 
		emitJumpTo: notBooleanBlock
		if: booleanMed
		notEquals: (emitter emitMem: (MedLiteral literal: anObject1)).
	emitter emitUnconditionalJumpTo: nextBlock.
	emitter currentBlock: notBooleanBlock.
	emitter 
		emitSendSelector: (emitter emitSpecialObject: 25)
		arguments: {booleanMed}.
	emitter emitUnconditionalJumpTo: nextBlock.
	emitter currentBlock: nextBlock! !

!IntermediateEmitter methodsFor: 'Emit - Low level Jumps' stamp: 'wbk 3/7/2004 00:08'!
emitIfZero: secondMed jumpTo: aMedBlock 
	emitter addExpression: (emitter 
		jumpType: #je
		to: aMedBlock
		dependingOn: (emitter 
			emit: (MedLiteral literal: 0)
			minus: secondMed))! !

!IntermediateEmitter methodsFor: 'Emit Intermediate' stamp: 'wbk 7/4/2003 12:43'!
numberOfTemporaries: anInteger 
	numberOfTemporaries := anInteger
	! !

!IntermediateEmitter methodsFor: 'misc' stamp: 'wbk 7/6/2003 18:26'!
registerEntryPointWithPC: aSmallInteger label: anIntermediateEmitter 
	entryPoints add: (MethodEntryPoint
		address: aSmallInteger
		label: anIntermediateEmitter).! !

!IntermediateEmitter methodsFor: 'Emit - Sends and Return' stamp: 'wbk 7/16/2003 15:29'!
emitMem: aMedLiteral 
	^ MedMem address: aMedLiteral! !

!IntermediateEmitter methodsFor: 'Emit - Arithmatic' stamp: 'wbk 2/4/2004 23:38'!
emit: aMedMem and: aSmallInteger 
	^ MedArithmatic
		operator: #and
		arg1: aMedMem
		arg2: aSmallInteger! !

!IntermediateEmitter methodsFor: 'Emit - Jump Bytecodes' stamp: 'wbk 2/15/2004 12:42'!
emitJumpIfTrueTo: labelMed onBoolean: booleanMed
	self 
		emitConditionalJumpTo: labelMed
		onBoolean: booleanMed
		ifBooleanIs: #trueObj
		OrFailIfBooleanNot: #falseObj! !

!IntermediateEmitter methodsFor: 'misc' stamp: 'wbk 7/16/2003 15:13'!
initializeMachine: aMachine jumpTargets: aCollection
	numberOfTemporaries := 0.
	method := MedMethod new.
	machine := aMachine.
	entryPoints := OrderedCollection new.
	currentBlock := method blockNumbered: 1.
	emitter := self.
	jumpTargets := Dictionary new.
	aCollection do:
		[:each| jumpTargets
			at: each
			put: method newBlock].
	^self! !

!IntermediateEmitter methodsFor: 'Emit - Memory Access' stamp: 'wbk 3/7/2004 12:56'!
emitClassOf: aMedLiteral 
	| result notInteger nextBlock classHeader classIndex |
	result := emitter createTemporaryRegister.
	classIndex := emitter createTemporaryRegister.
	notInteger := emitter newBlock.
	classHeader := emitter newBlock.
	nextBlock := emitter newBlock.

	emitter 
		emitCheckIsInteger: aMedLiteral
		failTo: notInteger.
	emitter 
		emitMoveFrom: (emitter emitSpecialObject: 5)
		to: result.
	emitter emitUnconditionalJumpTo: nextBlock.

	emitter currentBlock: notInteger.
	emitter 
		emitMoveFrom: (emitter 
			emit: (MedLiteral literal: 31)
			and: (emitter 
				emit: (emitter emitMem: aMedLiteral)
				sar: (MedLiteral literal: 12)))
		to: classIndex.
	self
		emitIfZero: classIndex
		jumpTo: classHeader.
	emitter 
		emitMoveFrom: (emitter
			emitFetchVariableAddress: (emitter
				emit: classIndex
				minus: (MedLiteral literal: 1))
			ofObject: (emitter emitSpecialObject: 28))
		to: result.
	emitter emitUnconditionalJumpTo: nextBlock.
	
	emitter currentBlock: classHeader.
	emitter
		emitMoveFrom: (emitter
			emit: (MedLiteral literal: 4294967292)
			and: (emitter emitMem: (emitter
				emit: aMedLiteral
				minus: (MedLiteral literal: 4))))
		to: result.
	emitter emitUnconditionalJumpTo: nextBlock.
	
	emitter currentBlock: nextBlock.
	^result! !

!IntermediateEmitter methodsFor: 'Emit - Sends and Return' stamp: 'wbk 10/14/2002 13:17'!
emitRet
	currentBlock add: MedRet new! !

!IntermediateEmitter methodsFor: 'Emit - Jump Bytecodes' stamp: 'wbk 10/17/2002 19:03'!
emitLabelForByteCode: anInteger
	^ jumpTargets at: anInteger! !

!IntermediateEmitter methodsFor: 'Emit - Arithmatic' stamp: 'wbk 8/8/2003 20:36'!
emit: aMedLiteral add: aMedMem 
	^ MedArithmatic
		operator: #add
		arg1: aMedLiteral
		arg2: aMedMem! !

!IntermediateEmitter methodsFor: 'Emit - Type Tags' stamp: 'wbk 3/6/2004 18:59'!
emitConvertToSmallInteger: aMedObject failTo: aMedBlock 
	^MedArithmatic 
		operator: #add
		arg1: (MedLiteral literal: 1)
		arg2: (MedJump 
				type: #jo
				block: aMedBlock
				instruction: (MedArithmatic 
						operator: #sal
						arg1: aMedObject
						arg2: (MedLiteral literal: 1)))! !

!IntermediateEmitter methodsFor: 'Emit - Arithmatic' stamp: 'wbk 5/28/2004 22:18'!
emit: firstMed bitShift: secondMed failingTo: aBlock 
	| result negativeBlock nextBlock |
	result := machine createTemporaryRegister.
	negativeBlock := emitter newBlock.
	nextBlock := emitter newBlock.
	self addExpression: (emitter 
				jumpType: #jl
				to: negativeBlock
				dependingOn: (self 
						emit: secondMed
						minus: (MedLiteral literal: 0))).
	self addExpression: (emitter
		jumpType: #jl
		to: aBlock
		dependingOn: (self
			emit: (MedLiteral literal: 31)
			minus: secondMed)).
	emitter 
		emitMoveFrom: (emitter 
				emit: firstMed
				sal: secondMed)
		to: result.
	self addExpression: (emitter 
				jumpType: #jnz
				to: aBlock
				dependingOn: (self 
						emit: firstMed
						minus: (emitter 
								emit: result
								sar: secondMed))).
	emitter emitUnconditionalJumpTo: nextBlock.
	emitter currentBlock: negativeBlock.
	self addExpression: (emitter 
				jumpType: #jl
				to: aBlock
				dependingOn: (emitter 
						emit: secondMed
						minus: (MedLiteral literal: -31))).
	self 
		emitMoveFrom: (emitter 
				emit: firstMed
				sar: (MedNegate argument: secondMed))
		to: result.
	emitter emitUnconditionalJumpTo: nextBlock.
	emitter currentBlock: nextBlock.
	^result! !

!IntermediateEmitter methodsFor: 'Emit - Memory Access' stamp: 'wbk 11/20/2003 23:25'!
emitYoungStartAddress
	^ MedLiteral literal: #youngStart! !

!IntermediateEmitter methodsFor: 'Unit Testing' stamp: 'wbk 8/17/2003 18:30'!
verify
	" Currently just a stub. The mock contains tests to make sure that the test succeeded here.
	It might be a good idea to have some basic verification tests on the real objects but this
	isn't done yet."! !

!IntermediateEmitter methodsFor: 'Emit - Misc' stamp: 'wbk 11/20/2003 23:26'!
createTemporaryRegister
	^ machine createTemporaryRegister! !

!IntermediateEmitter methodsFor: 'Emit - Division' stamp: 'wbk 2/8/2004 16:14'!
emitDivide: firstMed by: secondMed into: result remainder: remander failingTo: aMedBlock 
	self 
		emitIfZero: secondMed
		jumpTo: aMedBlock.
	self 
		emitMoveFrom: (MedDivide 
			emit: firstMed
			divide: secondMed
			remander: remander)
		to: result! !

!IntermediateEmitter methodsFor: 'Emit - Division' stamp: 'wbk 2/8/2004 16:12'!
emitCheckRoundingNeedsAdjustingFor: result remainder: remander failingTo: nextBlock 
	self addExpression: (self 
		jumpType: #jge
		to: nextBlock
		dependingOn: (self 
			emit: result
			minus: (MedLiteral literal: 0))).
	self 
		emitIfZero: remander
		jumpTo: nextBlock! !

!IntermediateEmitter methodsFor: 'misc' stamp: 'wbk 8/9/2003 22:51'!
addExpression: aMedJump 
	currentBlock add: aMedJump! !

!IntermediateEmitter methodsFor: 'Emit - Memory Access' stamp: 'wbk 3/7/2004 12:27'!
emitFetchAddress: field ofObject: compiledMethod 
	^ MedMem address: (MedArithmatic 
		operator: #add
		arg1: compiledMethod
		arg2: (MedLiteral literal: 4 * field literal + 4))! !

!IntermediateEmitter methodsFor: 'Emit - Jump Bytecodes' stamp: 'wbk 5/30/2004 21:45'!
emitJumpTarget: anInteger stackHeight: secondInteger
	| targetLabel |
	targetLabel := jumpTargets at: anInteger.
	currentBlock add: (MedJump
		type: #jmp
		target: targetLabel). 
	currentBlock := targetLabel! !

!IntermediateEmitter methodsFor: 'Unit Testing' stamp: 'wbk 7/16/2003 15:12'!
emitter: aMockIntermediateEmitter 
	emitter := aMockIntermediateEmitter! !

!IntermediateEmitter methodsFor: 'Emit - Low level Jumps' stamp: 'wbk 2/15/2004 13:05'!
emitJumpTo: notBooleanBlock if: booleanMed notEquals: anObject1 
	emitter addExpression: (emitter 
				jumpType: #jne
				to: notBooleanBlock
				dependingOn: (emitter 
						emit: booleanMed
						minus: anObject1))! !

!IntermediateEmitter methodsFor: 'Emit - Low Level Moves' stamp: 'wbk 8/17/2003 18:25'!
emitMoveToTemp: aMedMem 
	| answer |
	answer := machine createTemporaryRegister.
	currentBlock add: (MedMov
		from: aMedMem
		to: answer).
	^ answer! !

!IntermediateEmitter methodsFor: 'Unit Testing' stamp: 'wbk 10/14/2002 14:17'!
currentBlock
	^ currentBlock! !

!IntermediateEmitter methodsFor: 'Emit - Arithmatic' stamp: 'wbk 3/7/2004 23:33'!
emit: aMedLiteral sar: aMedLiteral2 
	^MedArithmatic 
		operator: #sar
		arg1: aMedLiteral
		arg2: aMedLiteral2! !

!IntermediateEmitter methodsFor: 'Emit - Memory Access' stamp: 'wbk 3/6/2004 19:00'!
emitFetchVariableAddress: indexMed ofObject: objectMed 
	^MedMem address: (MedArithmatic 
				operator: #add
				arg1: objectMed
				arg2: (MedArithmatic 
						operator: #add
						arg1: (MedArithmatic 
								operator: #sal
								arg1: indexMed
								arg2:  (MedLiteral literal: 2))
						arg2: (MedLiteral literal: 4)))! !

!IntermediateEmitter methodsFor: 'Emit - Sends and Return' stamp: 'wbk 6/14/2004 18:48'!
emitSendSelector: selector arguments: someArguments 
	| nextPC result label |
	nextPC := stack pc + 1.	"Set the PC to the next instruction"
	emitter 
		emitRestoreContextWithPC: nextPC
		stack: (stack stackWith: someArguments).
	emitter 
		emitSetUpMessageSendFor: selector
		argumentCount: (MedLiteral literal: someArguments size - 1).
	emitter emitMoveToEax: (MedLiteral literal: 0).
	emitter emitRet.
	result := emitter machine createTemporaryRegister.
	nextPC := stack pc + 1.
	label := emitter emitLabel.
	emitter emitReloadStack: (stack stackWith: (Array with: result)).
	emitter 
		registerEntryPointWithPC: (MedLiteral smallInteger: nextPC)
		label: label.
	^result	"This should be initialised when we re-enter the method after
										the message has returned. i.e. it should be initialised in the
										re-entry header for this PC value."! !

!IntermediateEmitter methodsFor: 'Emit - Low level Jumps' stamp: 'wbk 8/8/2003 20:26'!
jumpType: aSymbol to: aMedBlock dependingOn: aMedArithmatic 
	^ MedJump
		type: aSymbol
		block: aMedBlock
		instruction: aMedArithmatic! !

!IntermediateEmitter methodsFor: 'Emit - Low level Jumps' stamp: 'wbk 3/7/2004 23:58'!
emitIfNotZero: remander jumpTo: aMedBlock 
	emitter addExpression: (self 
		jumpType: #jne
		to: aMedBlock
		dependingOn: (self 
			emit: (MedLiteral literal: 0)
			minus: remander))! !

!IntermediateEmitter methodsFor: 'Emit - Low level Jumps' stamp: 'wbk 8/9/2003 22:27'!
emitUnconditionalJumpTo: aLabel
	emitter addExpression: (MedJump
		type: #jmp
		target: aLabel)! !

!IntermediateEmitter class methodsFor: 'instance creation' stamp: 'wbk 10/15/2002 17:46'!
machine: aMachine jumpTargets: aCollection
	^self new 
		initializeMachine: aMachine
		jumpTargets: aCollection! !

!IntermediateEmitter methodsFor: 'Emit - Memory Access' stamp: 'wbk 3/6/2004 19:55'!
emitStackFor: aContext at: newStackPtr put: aMed 
	| instr4 |
	instr4 := MedMov 
		from: aMed
		to: (MedMem address: (MedArithmatic 
			operator: #add
			arg1: (MedArithmatic 
			 	operator: #add
				arg1: aContext
				arg2: (MedArithmatic 
					operator: #sal
					arg1: newStackPtr
					arg2: (MedLiteral literal: 1)))
			arg2: (MedLiteral literal: 22))).
	currentBlock add: instr4! !

!IntermediateEmitter methodsFor: 'Emit - Addresses' stamp: 'wbk 9/29/2003 21:01'!
emitReceiverAddress
	^ MedMem address: (MedArithmatic 
		operator: #add
		arg1: machine currentContext
		arg2: (MedLiteral literal: 24))! !

!IntermediateEmitter methodsFor: 'Emit - Jump Bytecodes' stamp: 'wbk 2/15/2004 12:41'!
emitJumpIfFalseTo: labelMed onBoolean: booleanMed 
	self 
		emitConditionalJumpTo: labelMed
		onBoolean: booleanMed
		ifBooleanIs: #falseObj
		OrFailIfBooleanNot: #trueObj! !

!IntermediateEmitter methodsFor: 'Emit Intermediate' stamp: 'wbk 7/1/2003 16:40'!
emitSetProgramCounter: aMedLiteral 
	self shouldBeImplemented! !

!IntermediateEmitter methodsFor: 'Emit - Misc' stamp: 'wbk 4/29/2004 21:04'!
stackRegister: aSmallInteger 
	^ machine stackRegister: aSmallInteger! !

!IntermediateEmitter methodsFor: 'Emit - Type Tags' stamp: 'wbk 3/4/2004 21:25'!
emitIntegerValueOf: aMed failTo: aLabel 
	self 
		emitCheckIsInteger: aMed
		failTo: aLabel.
	^MedArithmatic 
		operator: #sar
		arg1: aMed
		arg2: (MedLiteral literal: 1)! !

!IntermediateEmitter methodsFor: 'Emit - Jump Bytecodes' stamp: 'wbk 7/6/2003 18:22'!
emitLabel
	| newBlock |
	newBlock := self newBlock.
	self emitUnconditionalJumpTo: newBlock.
	currentBlock := newBlock.
	^ newBlock
! !

!IntermediateEmitter methodsFor: 'Emit - Type Tags' stamp: 'wbk 8/6/2003 13:04'!
emitCheckIsInteger: aMed failTo: aLabel 
	| check |
	check := MedJump 
				type: #jz
				block: aLabel
				instruction: (MedArithmatic 
						operator: #and
						arg1: (MedLiteral literal: 1)
						arg2: aMed).
	currentBlock add: check! !

Object subclass: #IntermediateCreator
	instanceVariableNames: 'method machine'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Programmer Tests'!

!IntermediateCreator methodsFor: 'Intermediate Creation' stamp: 'wbk 10/22/2002 15:36'!
isRegister: anObject 
	^(self isMachineRegister: anObject) 
		| (anObject isString and: [(anObject at: 2) isDigit])! !

!IntermediateCreator methodsFor: 'Intermediate Creation' stamp: 'wbk 10/5/2002 20:32'!
createMem: anArray
	|address|
	address := self createExpression: (anArray at: 2).
	^ MedMem
		address: address! !

!IntermediateCreator methodsFor: 'Intermediate Creation' stamp: 'wbk 10/24/2002 11:41'!
createJump: anArray
	|testInstruction target blockNumber |
	testInstruction := anArray size = 3 
		ifTrue:
			[self createExpression: (anArray at: 3)]
		ifFalse: [nil].
	blockNumber := ((anArray at: 2)
		copyFrom: 6
		to: (anArray at: 2) size) asInteger.
	target := method blockNumbered: blockNumber. 
	^ MedJump
		type: (anArray at: 1)
		block: target
		instruction: testInstruction! !

!IntermediateCreator methodsFor: 'Intermediate Creation' stamp: 'wbk 1/26/2004 22:49'!
createArithmatic: anArray
	|arg1 arg2|
	arg1 := self createExpression: (anArray at: 2).
	arg2 := self createExpression: (anArray at: 3).
	^ MedArithmatic
		operator: (anArray at: 1)
		arg1: arg1
		arg2: arg2! !

!IntermediateCreator methodsFor: 'Intermediate Creation' stamp: 'wbk 10/24/2002 11:36'!
createAssemblyBlock: anArray
	|blockNumber block|
	self assert: [(anArray at: 1) = #block].
	blockNumber := anArray at: 2.
	block := method blockNumbered: blockNumber.
	3 to: anArray size do: [:each| block add: (self 
		createAssemblyInstr: (anArray at: each))].
	^ block	! !

!IntermediateCreator methodsFor: 'Intermediate Creation' stamp: 'wbk 7/6/2003 21:30'!
createAssembly: anArray for: aMachine
	machine := aMachine.
	method := MedMethod new.
	anArray do: [:each| (self createJustTheBlocks: each)].
	anArray do: [:each|  (self createAssemblyBlock: each)].
	^ method


! !

!IntermediateCreator methodsFor: 'Intermediate Creation' stamp: 'wbk 2/9/2004 19:29'!
createExpression: anObject
	|operator|
	(self isBasicType: anObject) ifTrue: [^ self createBasicType: anObject].
	operator := anObject at: 1.
	operator = #ret ifTrue: [^ MedRet new].
	operator = #mov ifTrue: [^ self createMove: anObject].
	operator = #mem ifTrue: [^ self createMem: anObject].
	operator = #push ifTrue: [^ MedPush argument: (self createExpression: (anObject at: 2))].
	operator = #call ifTrue: [^ MedCall function: (self createExpression: (anObject at: 2))].
	operator = #div ifTrue: 
		[^ MedDivide
			emit: (self createExpression: (anObject at: 2))
			divide: (self createExpression: (anObject at:3))
			remander: (self createExpression: (anObject at: 4))].
	(self isJump: anObject) ifTrue: [^ self createJump: anObject].
	operator = #neg ifTrue: [^ MedNegate argument: (self createExpression: (anObject at: 2))].
	^ self createArithmatic: anObject! !

!IntermediateCreator methodsFor: 'Intermediate Creation' stamp: 'wbk 1/14/2004 22:02'!
isJump: anObject
	anObject isCollection ifFalse: [^ false].
	^ #(jo jz jg jle jl jge je jmp jnz jne) includes: (anObject at: 1)
! !

!IntermediateCreator methodsFor: 'Intermediate Creation' stamp: 'wbk 7/6/2003 21:30'!
createJustTheBlocks: anArray
	|blockNumber block|
	self assert: [(anArray at: 1) = #block].
	blockNumber := anArray at: 2.
	block := method blockNumbered: blockNumber.
	^ block	! !

!IntermediateCreator methodsFor: 'Intermediate Creation' stamp: 'wbk 2/9/2004 20:09'!
createAssemblyInstr: anArray
 	|arguments instruction|
	instruction := anArray at: 1.
	(self isJump: anArray) ifTrue: [^ self createJump: anArray].
	(instruction = #ret) ifTrue: [^ MedRet new].
	arguments := OrderedCollection new.
	2
		to: anArray size
		do: [:each| arguments add: (self createExpression: (anArray at: each))].
	instruction = #mov ifTrue: 
		[^ MedMov
			from: (arguments at: 1)
			to: (arguments at: 2)].
	instruction = #call ifTrue:
		[^ MedCall function: (arguments at: 1)].
	instruction = #push ifTrue: [^ MedPush argument: (arguments at: 1)].
	instruction = #div ifTrue: 
		[^ MedX86Divide 
			register: (arguments at: 1)
			eax: (machine registerNamed: #eax)
			edx: (machine registerNamed: #edx)].
	instruction = #cdq ifTrue: [^ MedX86CDQ 
		eax: (machine registerNamed: #eax)
		edx: (machine registerNamed: #edx)].
	instruction = #neg ifTrue: [^ MedNegate argument: (arguments at: 1)].
	^ MedAssembly
		name: instruction
		arguments: arguments
! !

!IntermediateCreator methodsFor: 'Intermediate Creation' stamp: 'wbk 10/22/2002 15:22'!
isMachineRegister: anObject 
	(#(#eax #ebx #ecx #edx #esi #edi #ebp #esp) includes: anObject) 
		ifTrue: [^true].
	"(anObject isString and: [(anObject at: 1) = $t]) ifTrue: [^ true]."
	^false! !

!IntermediateCreator methodsFor: 'Intermediate Creation' stamp: 'wbk 10/5/2002 20:33'!
createMove: anArray
	|arg1 arg2|
	arg1 := self createExpression: (anArray at: 2).
	arg2 := self createExpression: (anArray at: 3).
	^ MedMov
		from: arg1
		to: arg2! !

!IntermediateCreator methodsFor: 'Intermediate Creation' stamp: 'wbk 10/24/2002 11:32'!
createBlock: anArray
	|blockNumber block|
	self assert: [(anArray at: 1) = #block].
	blockNumber := anArray at: 2.
	block := method blockNumbered: blockNumber.
	3 to: anArray size do: [:each| block add: (self createExpression: (anArray at: each))].
	^ block	! !

!IntermediateCreator class methodsFor: 'Intermediate Creation' stamp: 'wbk 10/5/2002 18:36'!
createIntermediate: anArray for: aMachine
	^ self new
		createIntermediate: anArray
		for: aMachine! !

!IntermediateCreator class methodsFor: 'Intermediate Creation' stamp: 'wbk 10/5/2002 18:37'!
createAssembly: anArray for: aMachine
	^ self new
		createAssembly: anArray
		for: aMachine! !

!IntermediateCreator methodsFor: 'Intermediate Creation' stamp: 'wbk 10/22/2002 15:34'!
isBasicType: anObject 
	| operator |
	anObject isInteger | anObject isString ifTrue: [^true].
	operator := anObject at: 1.
	operator isNumber | (self isMachineRegister: operator) ifTrue: [^true].
	(anObject isCollection and: [self isRegister: (anObject at: 1)]) ifTrue: [^true].
	^false! !

!IntermediateCreator methodsFor: 'Intermediate Creation' stamp: 'wbk 4/11/2003 09:32'!
createBasicType: anObject 
	| operator |
	anObject isInteger ifTrue: [^MedLiteral literal: anObject].
	anObject isString 
		ifTrue: 
			[(self isMachineRegister: anObject) 
				ifTrue: [^machine machineRegister: anObject].
			(anObject at: 2) isDigit ifTrue: [^machine temporaryNamed: anObject].
			^MedLiteral literal: anObject].
	operator := anObject at: 1.
	anObject size = 2
		ifTrue: 
			[^MedAddressingMode 
				offset: operator
				base: (machine registerNamed: (anObject at: 2))].
	^MedAddressingMode address: (self createExpression: operator)! !

!IntermediateCreator methodsFor: 'Intermediate Creation' stamp: 'wbk 10/5/2002 20:32'!
createIntermediate: anArray for: aMachine
	method := MedMethod new.
	machine := aMachine.
	anArray do: [:each| (self createBlock: each)].
	^ method! !

Object subclass: #EncodeImm8Rm32
	instanceVariableNames: 'instructionByte modRmValue assembler instruction'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery'!

!EncodeImm8Rm32 methodsFor: 'misc' stamp: 'wbk 4/18/2003 18:23'!
registerInstruction: anAssembleArithmatic 
	instruction := anAssembleArithmatic .
	assembler := instruction assembler.! !

!EncodeImm8Rm32 methodsFor: 'Encoding' stamp: 'wbk 2/8/2004 21:52'!
fire
	assembler stream nextPut: instructionByte.
	assembler 
		encodeModRm: instruction arg2 
		registerOpcode: modRmValue.
	assembler stream nextPut: instruction arg1 literal! !

!EncodeImm8Rm32 methodsFor: 'Encoding' stamp: 'wbk 4/4/2003 17:28'!
isFirable
	^ instruction arg1 isLiteral & instruction arg2 isRegister! !

!EncodeImm8Rm32 methodsFor: 'misc' stamp: 'wbk 4/18/2003 18:23'!
initializeFirstByte: aSmallInteger modRmValue: aSmallInteger2
	instructionByte :=  aSmallInteger.
	modRmValue := aSmallInteger2.
	^ self! !

!EncodeImm8Rm32 class methodsFor: 'as yet unclassified' stamp: 'wbk 4/18/2003 18:24'!
firstByte: aSmallInteger modRmValue: aSmallInteger2
	^ self new
		initializeFirstByte: aSmallInteger 
		modRmValue: aSmallInteger2! !

Object subclass: #AssemblerExupery
	instanceVariableNames: 'stream blockAddresses jumpOffsets bytecodes instructionEncoders plugin'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery'!

!AssemblerExupery methodsFor: 'Addressing Modes' stamp: 'wbk 6/2/2004 22:07'!
encodeModRm: modRmMed registerOpcode: anInteger 
	| mod rm result |
	modRmMed isLiteral 
		ifTrue: 
			[mod := 0.
			rm := 2r101]
		ifFalse:
			[modRmMed isAddressingMode 
				ifTrue: 
					[modRmMed hasOffset 
						ifTrue: [modRmMed offset <= 127
							ifTrue: [mod := 1]
							ifFalse: [mod := 2r10]] 
				ifFalse: [mod := 0].
			rm := self registerEncoding: modRmMed base]
		ifFalse: 
			[mod := 3.
			rm := self registerEncoding: modRmMed]].
	result := (mod bitShift: 6) + (anInteger bitShift: 3) + rm.
	stream nextPut: result.
	modRmMed isLiteral ifTrue: [^ self encodeImmediate: modRmMed.].
	modRmMed hasOffset ifTrue: 
		[modRmMed offset >= 0
			ifTrue:
				[modRmMed offset <= 127
					ifTrue: [stream nextPut: modRmMed offset]
					ifFalse: [self encodeImmediate: (MedLiteral literal: modRmMed offset)]]
			ifFalse:
				[modRmMed offset >= -128
					ifTrue: [stream nextPut: 256 + modRmMed offset]
					ifFalse: [Error signal: 'NOT YET IMPLEMENTED']]].! !

!AssemblerExupery methodsFor: 'misc' stamp: 'wbk 4/18/2003 18:34'!
initializeArithmaticInstructionNamed: nameSymbol toAddressingCode: toInteger fromAddressingCode: fromInteger fromImmediateCode: fromImmediateInteger fromImmediateModRmCode: fromImmediateToModRmInteger 
	| instruction |
	instruction := AssembleArithmatic 
		name: nameSymbol 
		assembler: self.
	instruction addEncoding: (EncodeToAddressingMode opcode: toInteger).
	instruction addEncoding: (EncodeFromAddressingMode opcode: fromInteger).
	instruction addEncoding: (EncodeFromLiteral 
				opcode: fromImmediateInteger
				modRmOpcode: fromImmediateToModRmInteger).! !

!AssemblerExupery methodsFor: 'misc' stamp: 'wbk 4/18/2003 16:19'!
addInstruction: anInstruction named: aSymbol
	instructionEncoders 
		at: aSymbol 
		put: anInstruction.! !

!AssemblerExupery methodsFor: 'Visiting' stamp: 'wbk 3/31/2003 21:33'!
visitJump: aMedJump 
	AssembleJump
		instruction: aMedJump
		assembler: self! !

!AssemblerExupery methodsFor: 'Addressing Modes' stamp: 'wbk 4/18/2003 16:10'!
registerEncoding: aRegister
	aRegister name = #eax ifTrue: [^ 2r000].
	aRegister name = #ebx ifTrue: [^ 2r011].
	aRegister name = #ecx ifTrue: [^ 2r001].
	aRegister name = #edx ifTrue: [^ 2r010].

	aRegister name = #esi ifTrue: [^ 2r110].
	aRegister name = #edi ifTrue: [^ 2r111].

	aRegister name = #esp ifTrue: [^ 2r100].
	aRegister name = #ebp ifTrue: [^ 2r101].

	self error: ' Unrecognised register'.! !

!AssemblerExupery methodsFor: 'misc' stamp: 'wbk 4/18/2003 18:34'!
initializeMulInstruction
	| instruction aSymbol |
	aSymbol := #mul.
	instruction := (AssembleArithmatic
			name: aSymbol
			assembler: self).
	instruction addEncoding: (EncodeFromAddressingMode opcodes: #(16r0F 16rAF)).! !

!AssemblerExupery class methodsFor: 'as yet unclassified' stamp: 'wbk 4/8/2003 12:47'!
assemble: aMedMethod withPlugin: aPlugin
	| assembler |
	assembler := self new initializePlugin: aPlugin.
	assembler preamble.
	aMedMethod visitWith: assembler.
	^assembler byteCodes! !

!AssemblerExupery methodsFor: 'misc' stamp: 'wbk 2/8/2004 21:35'!
initializeShiftInstructionName: aSymbol firstByte: firstByte modRmOpcode: modRmInteger fixedRegiser: registerSymbol fixedOpcode: fixedOpcodeInteger fixedModRm: fixedModRmInteger 
	| instruction |
	instruction := AssembleArithmatic 
				name: aSymbol
				assembler: self.
	instruction addEncoding: (EncodeImm8Rm32 
				firstByte: firstByte
				modRmValue: modRmInteger).
	instruction addEncoding: (EncodeFixedRegRm32
		fixedRegister: registerSymbol
		fixedOpcode: fixedOpcodeInteger
		fixedModRm: fixedModRmInteger).! !

!AssemblerExupery methodsFor: 'misc' stamp: 'wbk 2/8/2004 22:12'!
initializeEncodingRules
	self 
		initializeShiftInstructionName: #sar
		firstByte: 193
		modRmOpcode: 7
		fixedRegiser: #ecx
		fixedOpcode: 16rD3
		fixedModRm: 7.
	self 
		initializeShiftInstructionName: #sal
		firstByte: 193
		modRmOpcode: 4
		fixedRegiser: #ecx
		fixedOpcode: 16rD3
		fixedModRm: 4.
	self 
		initializeArithmaticInstructionNamed: #add
		toAddressingCode: 1
		fromAddressingCode: 3
		fromImmediateCode: 129
		fromImmediateModRmCode: 0.
	self 
		initializeArithmaticInstructionNamed: #and
		toAddressingCode: 33
		fromAddressingCode: 35
		fromImmediateCode: 129
		fromImmediateModRmCode: 4.
	self initializeMoveInstruction.
	self 
		initializeArithmaticInstructionNamed: #sub
		toAddressingCode: 41
		fromAddressingCode: 43
		fromImmediateCode: 129
		fromImmediateModRmCode: 5.
	self initializeMulInstruction.
	self 
		initializeArithmaticInstructionNamed: #or
		toAddressingCode: 9
		fromAddressingCode: 11
		fromImmediateCode: 129
		fromImmediateModRmCode: 1! !

!AssemblerExupery class methodsFor: 'as yet unclassified' stamp: 'wbk 4/8/2003 12:44'!
basicAssemble: aMedMethod withPlugin: aPlugin
	| assembler |
	assembler := self new initializePlugin: aPlugin.
	aMedMethod visitWith: assembler.
	^assembler byteCodes! !

!AssemblerExupery methodsFor: 'Visiting' stamp: 'wbk 1/31/2004 18:32'!
visitDivide: aMedDivide 
		stream nextPut: 16rF7.
	self 
		encodeModRm: aMedDivide argument
		registerOpcode: 7.! !

!AssemblerExupery methodsFor: 'Addressing Modes' stamp: 'wbk 3/16/2003 21:05'!
encodeModRm: modRmMed register: registerMed 
	^ self 
		encodeModRm: modRmMed 
		registerOpcode: (self registerEncoding: registerMed)! !

!AssemblerExupery methodsFor: 'misc' stamp: 'wbk 4/3/2003 20:53'!
byteCodes
	^ bytecodes! !

!AssemblerExupery methodsFor: 'Visiting' stamp: 'wbk 2/9/2004 21:13'!
visitNegate: aMedNegate 
	stream nextPut: 16rF7.
	self
		encodeModRm: aMedNegate argument
		registerOpcode: 3
	! !

!AssemblerExupery methodsFor: 'Visiting' stamp: 'wbk 4/3/2003 20:52'!
visitMethod: aMedMethod 
	aMedMethod blocksDo: [:each| each visitWith: self].
	bytecodes := stream contents.
	jumpOffsets do: [:each| each patch].! !

!AssemblerExupery methodsFor: 'Encoding' stamp: 'wbk 7/29/2004 22:18'!
preamble
	stream nextPutAll: #(16r55 16r89 16rE5 16r53 16r56 16r57 16r83 16rEC 64)! !

!AssemblerExupery methodsFor: 'Visiting' stamp: 'wbk 6/30/2003 20:28'!
visitCall: aMedCall 
	stream nextPut: 16rFF.
	self 
		encodeModRm: aMedCall function
		registerOpcode: 2.! !

!AssemblerExupery methodsFor: 'Encoding' stamp: 'wbk 4/3/2003 20:21'!
patchJumpTo: aMedBlock 
	jumpOffsets add: (OffsetPatcher
		target: aMedBlock
		location: stream position
		assembler: self)! !

!AssemblerExupery methodsFor: 'Visiting' stamp: 'wbk 4/7/2003 14:55'!
visitMov: aMedMov 
	self visitAssembly: aMedMov! !

!AssemblerExupery methodsFor: 'Encoding' stamp: 'wbk 4/11/2003 16:13'!
encodeImmediate: aLiteral
	| value |
	value := aLiteral literal isSymbol
		ifTrue: [plugin addressOf: aLiteral]
		ifFalse: [aLiteral literal].
	stream nextPut: (value bitAnd: 255).
	stream nextPut: ((value bitShift: -8) bitAnd: 255).
	stream nextPut: ((value bitShift: -16) bitAnd: 255).
	stream nextPut: ((value bitShift: -24) bitAnd: 255).! !

!AssemblerExupery methodsFor: 'misc' stamp: 'wbk 4/18/2003 18:34'!
initializeMoveInstruction
	| instruction |
	instruction := (AssembleInstruction
			name: #mov
			assembler: self).
	instruction addEncoding: (EncodeToAddressingMode opcode: 137).
	instruction addEncoding: (EncodeFromAddressingMode opcode: 139).
	instruction addEncoding: (EncodeFromLiteralToRegister opcode: 184).
	instruction addEncoding: (EncodeFromLiteral
		opcode: 199
		modRmOpcode: 0).! !

!AssemblerExupery methodsFor: 'Encoding' stamp: 'wbk 4/3/2003 20:36'!
addressFor: aMedBlock 
	^ blockAddresses at: aMedBlock blockNumber! !

!AssemblerExupery methodsFor: 'Visiting' stamp: 'wbk 4/3/2003 20:15'!
visitBlock: aMedBlock 
	blockAddresses
		at: aMedBlock blockNumber
		put: stream position.
	aMedBlock expressionsDo: [:each| each visitWith: self].! !

!AssemblerExupery methodsFor: 'Visiting' stamp: 'wbk 6/25/2003 16:36'!
visitPush: aMedPush 
	"This will probably need to be refactored. Possilby adding a class AssembleUnaryInstruction that assembles
	instructions with just one argument, it should be possible to stub out the other argument for mod/rm 
 	instructions. Single register instructions may be a little harder, the encoder for single registers also
	adds a literal, see EncodeFromLiteralToRegister."
	stream nextPut: 16r50 + (self registerEncoding: aMedPush argument).! !

!AssemblerExupery methodsFor: 'Encoding' stamp: 'wbk 4/3/2003 23:17'!
patchByteAt: locationInteger with: valueInteger 
	bytecodes
		at: locationInteger
		put: valueInteger! !

!AssemblerExupery methodsFor: 'misc' stamp: 'wbk 3/16/2003 18:34'!
stream
	^ stream! !

!AssemblerExupery methodsFor: 'Visiting' stamp: 'wbk 4/6/2003 21:24'!
visitAssembly: aMed 
	| encoder |
	encoder := instructionEncoders at: aMed name.
	encoder encode: aMed
! !

!AssemblerExupery methodsFor: 'Visiting' stamp: 'wbk 2/2/2004 21:25'!
visitX86Cdq: aMedX86CDQ 
	stream nextPut: 16r99! !

!AssemblerExupery methodsFor: 'Visiting' stamp: 'wbk 7/29/2004 22:28'!
visitRet: aMedRet 
	"The postamble. This is the C return sequence"
	stream nextPutAll: #( 16r83 16rC4 64 16r5F 16r5E 16r5B 16r89 16rEC 16r5D 16rC3)! !

!AssemblerExupery methodsFor: 'misc' stamp: 'wbk 4/8/2003 12:45'!
initializePlugin: aPlugin
	plugin := aPlugin.
	stream := WriteStream on: (ByteArray new).
	blockAddresses := Dictionary new.
	jumpOffsets := OrderedCollection new.
	instructionEncoders := Dictionary new.
	self initializeEncodingRules.
	^ self! !

MethodContext variableSubclass: #CompiledMethodContext
	instanceVariableNames: 'compiledCode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Plugin'!

Exception subclass: #ExuperyTestException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Customer Tests'!

InterpreterPlugin subclass: #ExuperyPlugin
	instanceVariableNames: 'codeCache nextMethodAddress methods'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Plugin'!

!ExuperyPlugin methodsFor: 'Primitives' stamp: 'wbk 4/18/2004 20:56'!
atCacheAddress
	| address |
	self export: true.
	address := self exuperyAtCacheAddress.
	interpreterProxy 
		pop: 1
		thenPush: address + 1! !

!ExuperyPlugin class methodsFor: 'Hacky Hacks' stamp: 'wbk 7/16/2004 20:52'!
declareCVarsIn: codeGenerator
	"Only methodCache is really a bad hack"
	"Method cache should be removed, it's not used"
	"codeGenerator 
		var: 'methodCache'
		declareC: 'extern int * methodCache'."
	codeGenerator
		var: #codeCache
		declareC: 'unsigned char * codeCache'.
	codeGenerator
		var: #nextMethodAddress
		declareC: 'unsigned char * nextMethodAddress'.
	codeGenerator addHeaderFile: '<unistd.h>'.
	codeGenerator addHeaderFile: '<sys/mman.h>'.
! !

!ExuperyPlugin methodsFor: 'Primitives' stamp: 'wbk 7/18/2004 14:14'!
initialiseModule
	| cacheSize |
	self export: true.
	cacheSize := self codeCacheSize.
	codeCache := self cCode: 'mmap(0, cacheSize,
                PROT_READ|PROT_WRITE|PROT_EXEC,
                MAP_PRIVATE|MAP_ANONYMOUS, -1, 0)'.
	nextMethodAddress := 0.
	^ true! !

!ExuperyPlugin methodsFor: 'Primitives' stamp: 'wbk 11/21/2003 22:37'!
rootTableAddress
	| address |
	self export: true.
	address := self exuperyRootTableAddress.
	interpreterProxy 
		pop: 1
		thenPush: address + 1! !

!ExuperyPlugin methodsFor: 'Primitives' stamp: 'wbk 10/4/2003 20:51'!
nilObjAddress
	|address|
	self export: true.

	address := self exuperyNilObjAddress.
	interpreterProxy 
		pop: 1 
		thenPush: address + 1! !

!ExuperyPlugin methodsFor: 'Test Primitives' stamp: 'wbk 11/22/2003 17:25'!
checkIsRootObject
	| object objectPtr |
	self export: true.
	objectPtr := interpreterProxy stackValue: 0.
	object := interpreterProxy longAt: objectPtr. "The header"
	"Check object is in the cache"
	"First check the header is tagged"
	(object bitAnd: 16r40000000) = 0 ifTrue: 
		[interpreterProxy primitiveFail.
		^ 0].
	"Then check there is an entry in the remembered set"
	(self exuperyCheckRootTableFor: objectPtr) ifFalse: 
		[interpreterProxy primitiveFail.
		^ 0].

	interpreterProxy pop: 1! !

!ExuperyPlugin methodsFor: 'Primitives' stamp: 'wbk 7/18/2004 14:15'!
codeCacheSize
	^ 100000! !

!ExuperyPlugin methodsFor: 'VM Callbacks' stamp: 'wbk 4/17/2004 20:52'!
lookupMethod: aMethod
	"This method lookup tolerates integers as Dictionary keys to support
	execution of images in which Symbols have been compacted out"
 	| length index mask wrapAround nextSelector methodArray selectorStart answer hashBits |
	selectorStart := 2.
	length _ self fetchWordLengthOf: methods.
	mask _ length - selectorStart - 1.
	hashBits := ((self cCode: '*(int *)aMethod') >> 17) bitAnd: 16rFFF.
	index _ (mask bitAnd: hashBits) + selectorStart.
	"It is assumed that there are some nils in this dictionary, and search will
	stop when one is encountered.  However, if there are no nils, then wrapAround
	will be detected the second time the loop gets to the end of the table."
	wrapAround _ false.
	[true] whileTrue:
		[nextSelector _ self 
			fetchPointer: index
			ofObject: methods.
		nextSelector= interpreterProxy nilObject ifTrue: [^ nil].
		nextSelector=aMethod ifTrue: [
			methodArray _ self 
				fetchPointer: 1 "MethodArrayIndex"
				ofObject: methods.
			answer _ self 
				fetchPointer:  index - selectorStart
				ofObject: methodArray.
			^ answer - 1 "Subtract one to detag the integer"
		].
		index _ index + 1.
		index = length ifTrue: 
			[wrapAround ifTrue: [^ nil].
			wrapAround _ true.
			index _ selectorStart]]! !

!ExuperyPlugin methodsFor: 'VM Callbacks' stamp: 'wbk 4/17/2004 22:23'!
lookupReturnMethod: aContext
	| methodLocal |
	self
		var: #aContext
		declareC: 'int *aContext'.
	methodLocal := (aContext at: 4).
	(methodLocal bitAnd: 1) = 1 ifTrue: [^ nil]. "It's a BlockContext which isn't currently handled."
	^ self lookupMethod: methodLocal.! !

!ExuperyPlugin methodsFor: 'Primitives' stamp: 'wbk 4/18/2004 20:58'!
initialiseExupery
	self export: true.
	self exuperyRegisterLookupMethod: (self cCode: 'lookupMethod').
	self exuperyRegisterRemapObjects: (self cCode: 'remapObjects').
	self exuperyRegisterMarkObjects: (self cCode: 'markObjects').
	self exuperyRegisterReturnMethod: (self cCode: '(int) lookupReturnMethod').
	nextMethodAddress := codeCache.
	methods := interpreterProxy stackValue: 0.
	interpreterProxy pop: 1! !

!ExuperyPlugin methodsFor: 'Primitives' stamp: 'wbk 7/18/2003 10:14'!
specialObjectsOopAddress
	|address|
	self export: true.

	address := self exuperySpecialObjectsOopAddress.
	interpreterProxy 
		pop: 1 
		thenPush: address + 1! !

!ExuperyPlugin methodsFor: 'Primitives' stamp: 'wbk 11/21/2003 22:33'!
rootTableCountAddress
	| address |
	self export: true.
	address := self exuperyRootTableCountAddress.
	interpreterProxy 
		pop: 1
		thenPush: address + 1! !

!ExuperyPlugin methodsFor: 'VM Callbacks' stamp: 'wbk 12/27/2002 23:00'!
nullFunction! !

!ExuperyPlugin methodsFor: 'Primitives' stamp: 'wbk 7/18/2004 14:17'!
loadCode
	| array arraySize byteValue bytes i methodAddress|
	self export: true.

	self
		var: #bytes
		declareC: 'unsigned char * bytes'.

	array := interpreterProxy stackValue: 0.

	(interpreterProxy isBytes: array) & (nextMethodAddress ~= 0) ifFalse: 
		[^self primitiveFail].
	
	arraySize := interpreterProxy stSizeOf: array.
	
	nextMethodAddress + arraySize > (codeCache + self codeCacheSize) ifTrue:
		[^self primitiveFail].


	bytes := interpreterProxy firstIndexableField: array.
	
	i := 0.
	[i < arraySize] whileTrue:
		[byteValue := bytes at: i.
		nextMethodAddress
			at: i
			put: byteValue.
		i := i + 1.].

	methodAddress := nextMethodAddress.
	nextMethodAddress := nextMethodAddress + arraySize.
	
	"Make sure nextMethodAddress is word aligned"
	nextMethodAddress := (((self cCode: '(int) nextMethodAddress') - 1) bitOr: 3) + 1.

	self 
		pop: 2
		thenPush: (self cCode: '(int) methodAddress + 1').! !

!ExuperyPlugin methodsFor: 'Primitives' stamp: 'wbk 4/18/2004 20:59'!
trueObjAddress
	| address |
	self export: true.
	address := self exuperyTrueObjAddress.
	interpreterProxy 
		pop: 1
		thenPush: address + 1! !

!ExuperyPlugin methodsFor: 'Primitives' stamp: 'wbk 6/30/2003 17:43'!
setupMessageSendAddress
	|address|
	self export: true.

	address := self exuperySetupMessageSendAddress.
	interpreterProxy 
		pop: 1 
		thenPush: address + 1! !

!ExuperyPlugin methodsFor: 'Primitives' stamp: 'wbk 11/21/2003 20:02'!
youngStartAddress
	|address|
	self export: true.

	address := self exuperyYoungStartAddress.
	interpreterProxy 
		pop: 1 
		thenPush: address + 1! !

!ExuperyPlugin methodsFor: 'Unit Tests' stamp: 'wbk 1/30/2003 19:57'!
pointerToReturn42
	self export: true.
	interpreterProxy 
		pop: 1
		thenPush: (self cCode: '((int) return42Context + 1)')! !

!ExuperyPlugin methodsFor: 'VM Callbacks' stamp: 'wbk 4/17/2004 23:23'!
markObjects
	self markAndTrace: methods.! !

!ExuperyPlugin methodsFor: 'Unit Tests' stamp: 'wbk 3/2/2003 13:52'!
return42Context: aContext
	|sender oldStackPtr newStackPtr |
	self export: true.
	sender := self cCode: '((int *) aContext) [1]'.
	oldStackPtr := self cCode: '*(int *) (sender + 12)' .
	newStackPtr := oldStackPtr + 2.
	self cCode: '*(int *) (sender + 12) = newStackPtr'.
	self cCode: '((int *) sender) [ 6 + (newStackPtr >> 1)] = 83'. ! !

!ExuperyPlugin methodsFor: 'VM Callbacks' stamp: 'wbk 4/17/2004 23:23'!
remapObjects
	methods := self remap: methods.! !

!ExuperyPlugin methodsFor: 'Primitives' stamp: 'wbk 4/18/2004 20:57'!
falseObjAddress
	| address |
	self export: true.
	address := self exuperyFalseObjAddress.
	interpreterProxy 
		pop: 1
		thenPush: address + 1! !

PasteUpMorph subclass: #ExuperyMethodInspector
	instanceVariableNames: 'blocks edges method drawing text isAnimating'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Inspectors'!

!ExuperyMethodInspector methodsFor: 'Misc' stamp: 'wbk 7/11/2004 21:54'!
colorNodes
	"Color the switch node and the first node"
	(blocks at: (method blockAt: 1) blockName) backgroundColor: Color green.
	(blocks at: (method blockAt: 2) blockName) backgroundColor: Color green.
	
	method blocksDo:
		[:eachBlock| eachBlock expressionsDo:
			[:eachExpression| eachExpression isReturn ifTrue:
				[(blocks at: eachBlock blockName) backgroundColor: Color red]]].! !

!ExuperyMethodInspector methodsFor: 'Animation' stamp: 'wbk 7/11/2004 16:58'!
springsMove
	| blockPosition delta edgePosition distance unitDistance |
	blocks do:
		[:eachBlock| 
		blockPosition := eachBlock position.
		delta := 0@0.
		(edges at: eachBlock) do:
			[:eachEdge| 
			edgePosition := eachEdge position.
			distance := blockPosition dist: edgePosition.
			distance = 0
				ifTrue: 
					[unitDistance := Point
						r: 1
						degrees: 360 atRandom]
				ifFalse: [unitDistance := (blockPosition - edgePosition) / distance].
			distance > 70
				ifTrue: [delta := delta - (unitDistance)].
			distance > 150
				ifTrue: [delta := delta - (unitDistance * 2)].
			distance > 300
				ifTrue: [delta := delta - (unitDistance * 4)]].
		eachBlock position: blockPosition + delta].! !

!ExuperyMethodInspector methodsFor: 'Animation' stamp: 'wbk 8/1/2004 11:46'!
step
	"blocks do:
		[:eachBlock| eachBlock position: eachBlock position + ((3 atRandom - 2) @ (3 atRandom - 2))]."
	isAnimating ifFalse: [^self stopStepping].
	self springsMove.
	self repulsiveMove.
	self stayInsideWalls.
	
			
! !

!ExuperyMethodInspector methodsFor: 'Misc' stamp: 'wbk 7/11/2004 21:32'!
aMouseEnter: block node: event block: node
	| stream |
	stream := WriteStream on: String new.
	
	block blockName printOn: stream.
	stream cr.
	block expressionsDo:
		[:each| stream nextPutAll: each printString.
		stream cr].
	
	text setText: stream contents.! !

!ExuperyMethodInspector methodsFor: 'Misc' stamp: 'wbk 7/25/2004 22:33'!
createEdges
	| connection to from |
	method blocksDo: 
			[:eachBlock | 
			eachBlock expressionsDo: 
					[:eachExpression | 
					eachExpression isJump ifTrue: 
							[from := blocks at: eachBlock blockName.
							to := blocks at: eachExpression target blockName.
							eachBlock = (method blockAt: 1) 
								ifTrue: [to backgroundColor: Color green]
								ifFalse: "Not to an entry point"
									[connection := NCAAConnectorMorph 
										fromMorph: from
										toMorph: to.
									connection line makeForwardArrow.
									drawing addMorph: connection.(edges at: from) add: to.
									(edges at: to) add: from]]]]! !

!ExuperyMethodInspector methodsFor: 'Animation' stamp: 'wbk 7/11/2004 11:07'!
stayInsideWalls
	blocks do:
		[:each| 
		each left < drawing left ifTrue: [each left: drawing left + 20].
		each top < drawing top ifTrue: [each top: drawing top + 20].
		each right > drawing right ifTrue: [each right: drawing right - 20].
		each bottom > drawing bottom ifTrue: [each bottom: drawing bottom -20] ]! !

!ExuperyMethodInspector class methodsFor: 'instance creation' stamp: 'wbk 7/11/2004 11:35'!
inspect: aMethod
	self new inspect: aMethod! !

!ExuperyMethodInspector methodsFor: 'Misc' stamp: 'wbk 7/11/2004 21:47'!
createNodes
	| blockMorph exuperyBlockMorph |
	method blocksDo: 
			[:each | 
			exuperyBlockMorph := NCTextRectangleMorph new.
			blockMorph := exuperyBlockMorph 
				setTextAt: 1
				to: each blockNumber asString.
			blockMorph 
				on: #mouseEnter  
				send: #aMouseEnter:node:block:
				to: self
				withValue: each.
			blockMorph borderWidth: 2.
			drawing addMorph: blockMorph.
			blockMorph position: drawing center.
			blockMorph extent: 20 @ 20.
			blocks 
				at: each blockName
				put: blockMorph.
			edges 
				at: blockMorph
				put: OrderedCollection new].! !

!ExuperyMethodInspector methodsFor: 'Misc' stamp: 'wbk 8/1/2004 11:47'!
stop
	isAnimating := false.
	drawing stopStepping.! !

!ExuperyMethodInspector methodsFor: 'Animation' stamp: 'wbk 7/11/2004 11:04'!
stepTime
	^ 200
! !

!ExuperyMethodInspector methodsFor: 'Misc' stamp: 'wbk 8/1/2004 11:47'!
start
	isAnimating := true.
	drawing startStepping.
	! !

!ExuperyMethodInspector methodsFor: 'Misc' stamp: 'wbk 8/1/2004 11:49'!
createWindow
	| window |
	window := SystemWindow new.
	drawing := self.
	window 
		addMorph: drawing
		frame: (0 @ 0 corner: 0.85 @ 1).
	text := PluggableTextMorph new.
	text setText: ''.
	window 
		addMorph: text
		frame: (0.85 @ 0.05 corner: 1 @ 1).
		
	"Add the buttons"
	window
		addMorph: (SimpleButtonMorph new
			target: self;
			label: 'Start';
			actionSelector: #start)
		frame: (0.85@0 corner: 0.92@0.05).
	window
		addMorph: (SimpleButtonMorph new
			target: self;
			label: 'Stop';
			actionSelector: #stop)
		frame: (0.92@0 corner: 1@0.05).
		
	window openInWorld.
	self startStepping.! !

!ExuperyMethodInspector methodsFor: 'Misc' stamp: 'wbk 8/1/2004 11:45'!
inspect: aMethod 
	isAnimating := true.
	self createWindow.
	method := aMethod.
	self drawGraph! !

!ExuperyMethodInspector methodsFor: 'Misc' stamp: 'wbk 7/11/2004 20:54'!
drawGraph
	blocks := Dictionary new.
	edges := Dictionary new.
	self createNodes.
	self createEdges.
	self colorNodes.! !

!ExuperyMethodInspector methodsFor: 'Animation' stamp: 'wbk 7/11/2004 16:56'!
repulsiveMove
	| blockPosition delta edgePosition distance unitDistance |
	blocks do:
		[:eachBlock| 
		blockPosition := eachBlock position.
		delta := 0@0.
		blocks do:
			[:eachOther| 
			edgePosition := eachOther position.
			distance := blockPosition dist: edgePosition.
			distance = 0
				ifTrue: 
					[unitDistance := Point
						r: 1
						degrees: 360 atRandom]
				ifFalse: [unitDistance := (blockPosition - edgePosition) / distance].
			"delta := delta + unitDistance /10."
			distance < 150 ifTrue: [delta := delta + unitDistance].
			distance < 100 ifTrue: [delta := delta + (unitDistance * 3)].
			distance < 40 ifTrue: [delta := delta + (unitDistance * 10)]].
		eachBlock position: blockPosition + delta].! !

MethodDictionary variableSubclass: #ExuperyMethodDictionary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery'!

!ExuperyMethodDictionary methodsFor: 'Overridden methods' stamp: 'wbk 7/8/2004 22:10'!
at: key put: value
	"Set the value at key to be value."
	| index |
	index := self findElementOrNil: key.
	(self basicAt: index) == nil
		ifTrue: 
			[tally := tally + 1.
			self basicAt: index put: key].
	array at: index put: value.
	self fullCheck.
	^ value! !
InterferenceNode initialize!
